/**
 * $Id: atlantis.java.stub,v 1.9 1998/10/02 12:08:39 descarte Exp descarte $
 *
 * Copyright (c)1997-1998 Arcane Technologies Ltd. <http://www.arcana.co.uk>
 *
 * Atlantis stub thingummy
 *
 * $Log: atlantis.java.stub,v $
 * Revision 1.9  1998/10/02 12:08:39  descarte
 * Changed GLComponentListener to GLEventListener
 * Altered arguments to reshape() method
 *
 * Revision 1.8  1998/06/07 13:54:02  descarte
 * Converted from COM.hermetica.* to com.hermetica.* hierarchy.
 *
 * Revision 1.7  1998/04/21 14:01:42  descarte
 * Added WindowListener methods
 * Added demoTemplate methods ( getName(), setExit() )
 * Added stand-alone handling.
 *
 * Revision 1.6  1998/03/30 01:08:53  descarte
 * Added applet resource handling.
 *
 * Revision 1.5  1998/03/28 14:44:01  descarte
 * Upgraded demo to Java 1.1 listeners.
 * Upgraded to GLComponentFactory.
 *
 * Revision 1.4  1998/03/24 15:59:34  descarte
 * Converted to new GLDrawable interface.
 *
 * Revision 1.3  1998/03/19 21:59:05  descarte
 * Added getGL() method.
 *
 * Revision 1.2  1998/02/23 21:53:10  descarte
 * Converted demo to new beta 4 GLComponent structure.
 *
 * Revision 1.1  1998/01/04 17:30:15  descarte
 * Initial revision
 *
 * Revision 1.9  1997/11/05 18:57:13  descarte
 * Upgraded demo to Magician beta 2 syntax.
 *
 * Revision 1.8  1997/09/02 22:39:11  descarte
 * Added GLContextException traps.
 *
 * Revision 1.7  1997/08/31 11:04:40  descarte
 * Added 'destroyContext()' call.
 *
 * Revision 1.6  1997/08/26 16:55:13  descarte
 * Moved demo to demoTemplate structure.
 *
 * Revision 1.5  1997/08/15 20:06:40  descarte
 * Another couple of miscellaneous tidy-ups.
 *
 * Revision 1.3  1997/08/11 17:21:47  descarte
 * Removed 'constrain' methods and moved them to a new utility class,
 * com.hermetica.util3d.constrain.
 *
 * Revision 1.2  1997/08/07 23:16:21  descarte
 * Reasonably complete implementation of atlantis. The sharks are behaving
 * oddly but the dolphin and whales are fine.
 *
 */

package com.hermetica.magician.demos.atlantis;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import com.hermetica.magician.*;
import com.hermetica.vecmath.*;
import com.hermetica.util3d.*;
import com.hermetica.util3d.*;

public class atlantis extends Frame implements demoTemplate, GLEventListener, ActionListener, WindowListener {

    /** The OpenGL state machine */
    GL gl_ = null;
    GLU glu_ = null;
    CoreGL coregl_ = new CoreGL();
    CoreGLU coreglu_ = new CoreGLU();

    /** The OpenGL Component to draw to */
    GLComponent glc = null;

    /** Dimensions of the component */
    public static final int WIDTH = 500,
                            HEIGHT = 250;

    /** Some miscellaneous definitions reused in other classes */
    public static final double RAD = 57.295;
    public static final double RRAD = 0.01745;
    public static final int RAND_MAX = 2147483647;

    /** Number of sharks in the animation */
    public static final int NUM_SHARKS = 4;

    /** The big whale */
    public whale bigWhale = null;

    /** The baby whale */
    public whale babyWhale = null;

    /** The dolphin */
    public dolphin dolph = null;

    /** An array of sharks! */
    protected shark[] sharks = new shark[NUM_SHARKS];

    /** The checkboxes to select which fishes get drawn or not */
    Checkbox sharkCheckbox = new Checkbox( "Sharks" );
    Checkbox dolphinCheckbox = new Checkbox( "Dolphin" );
    Checkbox whalesCheckbox = new Checkbox( "Whales" );

    /** The unprojected coordinates of the viewport */
    double[][] win = null;

    /** Texture objects for the porthole image and the stencil */
//    Texture portholeTexture = null;
//    boolean portholeTextureCreated = false;

    /** The dismiss button */
    Button dismissButton = new Button( "Dismiss" );

    /** Frame rate sampler */
    FrameRateComponent frc = new FrameRateComponent();

    /** Regulates the calling of System.exit() */
    private boolean callExit = true;

    public static void main( String argv[] ) {
        atlantis d = new atlantis();
        d.setTitle( d.getName() );
        System.err.println( "\n" + d.getName() + " -- " + d.getOriginalAuthor() );
        for ( int i = 0 ; i < ( d.getName().length() + d.getOriginalAuthor().length() + 4 ) ; i++ ) {
            System.err.print( "=" );
          }
        System.err.println( "\n" );
        System.err.println( d.getDescription() + "\n" );
        d.startDemo();
      }

    public atlantis() {
        /**#start */
      }

    /** Set to false if the demo is to call System.exit() */
    public void setExit( boolean state ) {
        callExit = state;
      }

    /** Returns the name of the demo */
    public String getName() {
        return new String( "Atlantis" );
      }

    /** Returns the version information for this demo */
    public String getVersion() {
        return new String( "$Id: atlantis.java.stub,v 1.9 1998/10/02 12:08:39 descarte Exp descarte $" );
      }

    /** Returns a description for this demo */
    public String getDescription() {
        StringBuffer sb = new StringBuffer();
        sb.append( "This demonstration shows quite a few OpenGL things running!\n" );
        sb.append( "You may select whether or not you wish to render various fish\n" );
        sb.append( "in the scene, and you may also wish to render a cheesy porthole\n" );
        sb.append( "effect onto the screen, which stencils out all but the ``glass''\n" );
        sb.append( "of the porthole. Clicking on the shark button pops up a subframe\n" );
        sb.append( "( or as many subframes as times you click ) which spins a shark\n" );
        sb.append( "in close-up.\n\n" );
        sb.append( "This demo is primarily interesting in that it is multi-threadedly\n" );
        sb.append( "rendering the scene in such a way that unleashes the power of\n" );
        sb.append( "Java's simple, but powerful, multi-thread model with OpenGL\n\n" );
        sb.append( "Click the ``Dismiss'' button to quit this application" );
        return new String( sb );
      }

    /** Returns the width of the demo */
    public int getWidth() {
        return WIDTH + 100;
      }

    /** Returns the height of the demo */
    public int getHeight() {
        return HEIGHT + 50;
      }

    /** Returns the original author of this demo */
    public String getOriginalAuthor() {
        return new String( "Unknown" );
      }

    public void startDemo() {

        /** Set the OpenGL pipeline to the default */
        gl_ = coregl_;
        glu_ = coreglu_;

        /** Set the layout manager for this frame */
        setLayout( new GridBagLayout() );
        setBackground( Color.white );

        /** Add a title bar */
        Label titleLabel = new Label( "Atlantis" );
        Font times14 = new Font( "TimesRoman", Font.BOLD, 18 );
        titleLabel.setFont( times14 );

        /** Set the initial state of the checkboxes, ie, we render everything */
        sharkCheckbox.setState( true );
        dolphinCheckbox.setState( true );
        whalesCheckbox.setState( true );

        /** Create a panel with selection boxes */
        Panel commandPanel = new Panel();
        commandPanel.setLayout( new GridBagLayout() );
        constrain.constrain( commandPanel, sharkCheckbox, 0, 0, 1, 1 );
        constrain.constrain( commandPanel, dolphinCheckbox, 0, 1, 1, 1 );
        constrain.constrain( commandPanel, whalesCheckbox, 0, 2, 1, 1 );
//        constrain.constrain( commandPanel, portholeCheckbox, 0, 3, 1, 1 );

        /** Create a new OpenGL Component */
        glc = GLComponentFactory.createGLComponent( WIDTH, HEIGHT );

        /** Add some temporary buttons */
        Panel buttonPanel = new Panel();
        Button sharkButton = new Button( "Shark" );
        Button whaleButton = new Button( "Whale" );
        buttonPanel.setLayout( new GridBagLayout() );
        constrain.constrain( buttonPanel, sharkButton, 0, 0, 1, 1,
                             GridBagConstraints.HORIZONTAL,
                             GridBagConstraints.CENTER,
                             1.0, 1.0, 0, 0, 0, 0 );
        constrain.constrain( buttonPanel, whaleButton, 0, 1, 1, 1,
                             GridBagConstraints.HORIZONTAL,
                             GridBagConstraints.CENTER,
                             1.0, 1.0, 0, 0, 0, 0 );

        /** Pack all the panels into the frame */
        constrain.constrain( this, titleLabel, 0, 0, 2, 1,
                             GridBagConstraints.NONE, GridBagConstraints.CENTER,
                             1.0, 1.0, 0, 0, 0, 0 );
        constrain.constrain( this, glc, 0, 1, 1, 2 );
        constrain.constrain( this, commandPanel, 1, 1, 1, 1 );
        constrain.constrain( this, buttonPanel, 1, 2, 1, 1,
                             GridBagConstraints.HORIZONTAL, 
                             GridBagConstraints.CENTER,
                             1.0, 1.0, 0, 0, 0, 0 );
        constrain.constrain( this, dismissButton, 0, 3, 2, 1,
                             GridBagConstraints.HORIZONTAL,
                             GridBagConstraints.CENTER,
                             1, 1, 0, 0, 0, 0 );

        /** Add the component to the Frame, then pack and show it */
        pack(); show();

        /** Setup the context capabilities */
        GLCapabilities cap = glc.getContext().getCapabilities();
        cap.setDepthBits( 12 );
        cap.setPixelType( GLCapabilities.RGBA );
        cap.setColourBits( 24 );
        cap.setDoubleBuffered( GLCapabilities.DOUBLEBUFFER );

        /** Register the GLEventListener with the GLComponent */
        glc.addGLEventListener( this );

        /** Register the keyboard and action event listeners */
        sharkButton.addActionListener( this );
        whaleButton.addActionListener( this );
        dismissButton.addActionListener( this );
        this.addWindowListener( this );

        /** Tell the component to start processing events with refresh */
        glc.initialize();
        glc.start();
      }

    /** Initializes the application */
    public void initialize( GLDrawable component ) {

        float[] ambient = {0.1f, 0.1f, 0.1f, 1.0f};
        float[] diffuse = {1.0f, 1.0f, 1.0f, 1.0f};
        float[] position = {0.0f, 1.0f, 0.0f, 0.0f};
        float[] mat_shininess = {90.0f};
        float[] mat_specular = {0.8f, 0.8f, 0.8f, 1.0f};
        float[] mat_diffuse = {0.46f, 0.66f, 0.795f, 1.0f};
        float[] mat_ambient = {0.0f, 0.1f, 0.2f, 1.0f};
        float[] lmodel_ambient = {0.4f, 0.4f, 0.4f, 1.0f};
        float[] lmodel_localviewer = {0.0f};

        /** Set the frame rate sampler to summarise only */
        frc.setSummaryOnly( true );

        try {
            /** Locate the corners of the viewport.... */
            double[] modelViewMatrix = new double[16];
            double[] projectionMatrix = new double[16];
            int[] viewport = new int[4];
            win = new double[4][3];

            gl_.glGetDoublev( GL.GL_MODELVIEW_MATRIX,
                             modelViewMatrix );
            gl_.glGetDoublev( GL.GL_PROJECTION_MATRIX,
                                         projectionMatrix );
            gl_.glGetIntegerv( GL.GL_VIEWPORT, viewport );
    
            /** Unproject the corners of the viewport */
            glu_.gluUnProject( viewport[0], viewport[1],
                              0, modelViewMatrix,
                              projectionMatrix,
                              viewport, win[0] );
            glu_.gluUnProject( viewport[2] - 1, viewport[1],
                              0, modelViewMatrix,
                              projectionMatrix, viewport, win[1] );
            glu_.gluUnProject( viewport[2] - 1, viewport[3] - 1,
                              0, modelViewMatrix,
                              projectionMatrix, viewport, win[2] );
            glu_.gluUnProject( viewport[0], viewport[3] - 1,
                              0, modelViewMatrix,
                              projectionMatrix, viewport, win[3] );

            /** Miscellaneous setup */
            gl_.glFrontFace(GL.GL_CW);
            gl_.glDepthFunc(GL.GL_LEQUAL);
            gl_.glEnable(GL.GL_DEPTH_TEST);
    
            gl_.glLightfv(GL.GL_LIGHT0, GL.GL_AMBIENT, ambient);
            gl_.glLightfv(GL.GL_LIGHT0, GL.GL_DIFFUSE, diffuse);
            gl_.glLightfv(GL.GL_LIGHT0, GL.GL_POSITION, position);
            gl_.glLightModelfv(GL.GL_LIGHT_MODEL_AMBIENT, lmodel_ambient);
            gl_.glLightModelfv(GL.GL_LIGHT_MODEL_LOCAL_VIEWER, lmodel_localviewer);
            gl_.glEnable(GL.GL_LIGHTING);
            gl_.glEnable(GL.GL_LIGHT0);
    
            gl_.glMaterialfv(GL.GL_FRONT_AND_BACK, GL.GL_SHININESS, mat_shininess);
            gl_.glMaterialfv(GL.GL_FRONT_AND_BACK, GL.GL_SPECULAR, mat_specular);
            gl_.glMaterialfv(GL.GL_FRONT_AND_BACK, GL.GL_DIFFUSE, mat_diffuse);
            gl_.glMaterialfv(GL.GL_FRONT_AND_BACK, GL.GL_AMBIENT, mat_ambient);
    
            initializeFish();
//            initializeStencil();
    
            gl_.glClearColor(0.0f, 0.5f, 0.9f, 0.0f);
          } catch ( OpenGLException e ) {
            e.printStackTrace();
          }
      }

    /** Handles viewport resizing */
    public void reshape( GLDrawable component, int x, int y, int width, int height ) {
        /** Setup the viewport */
        gl_.glViewport( component, x, y, width, height );
        gl_.glMatrixMode( GL.GL_PROJECTION );
        gl_.glLoadIdentity();
        glu_.gluPerspective( 400.0f, 2.0f, 10000.0f, 400000.0f );
        gl_.glMatrixMode( GL.GL_MODELVIEW );
        gl_.glLoadIdentity();
      }

    /** Initializes the stencil buffer for the porthole effect */
    public void initializeStencil() {

        /** Create the texture objects for the porthole */
/*        try {
            Image portholeImage,
                  portholeStencilImage;

            portholeImage =
                Toolkit.getDefaultToolkit().getImage( "porthole.gif" );
            portholeTexture = new Texture( portholeImage, Texture.SCALE_DONT );
          } catch ( Exception e ) {
            e.printStackTrace();
          }  */
      }

    /** Initializes the fish */
    public void initializeFish() {

        int i;

        /** Initialize the sharks */
        for ( i = 0 ; i < NUM_SHARKS ; i++ ) {
            sharks[i] = new shark( gl_, glu_ );
            sharks[i].position.x = 70000.0f + (float)( (int)( Math.random() * RAND_MAX ) % 6000 );
            sharks[i].position.y = (float)( (int)( Math.random() * RAND_MAX ) % 6000 );
            sharks[i].position.z = (float)( (int)( Math.random() * RAND_MAX ) % 6000 );
            sharks[i].psi = (float)( (int)( Math.random() * RAND_MAX ) % 360 ) - 180.0f;
            sharks[i].v = 1.0f;
          }

        /** Initialize the big whale */
        bigWhale = new whale( gl_, glu_ );
        bigWhale.position = new Vec3f( 70000.0f, 0.0f, 0.0f );
        bigWhale.psi = 90.0f;
        bigWhale.theta = 0.0f;
        bigWhale.v = 3.0f;

        /** Initialize the baby whale */
        babyWhale = new whale( gl_, glu_ );
        babyWhale.position = new Vec3f( 60000.0f, -2000.0f, -2000.0f );
        babyWhale.psi = 90.0f;
        babyWhale.theta = 0.0f;
        babyWhale.v = 3.0f;

        /** Initialize the dolphin */
        dolph = new dolphin( gl_, glu_ );
        dolph.position = new Vec3f( 30000.0f, 0.0f, 6000.0f );
        dolph.psi = 90.0f;
        dolph.theta = 0.0f;
        dolph.v = 3.0f;
      }

    /** Main display routine */
    public void display( GLDrawable component ) {

        int i;

        /** Start the frame rate sampler! */
        frc.startSample();

        try {
            /** Clear the frame and depth buffers */
            gl_.glClear( GL.GL_COLOR_BUFFER_BIT | GL.GL_DEPTH_BUFFER_BIT );

            /** Draw the sharks! */
            if ( sharkCheckbox.getState() ) {
                for ( i = 0 ; i < NUM_SHARKS ; i++ ) {
                    gl_.glPushMatrix();
                    sharks[i].pilot();
                    sharks[i].miss( i, sharks );
                    sharks[i].transform();
                    sharks[i].draw();
                    gl_.glPopMatrix();
                  }
              }

            /** Draw the whales.... */
            if ( whalesCheckbox.getState() ) {
                /** Draw the big whale */
                gl_.glPushMatrix();
                bigWhale.pilot();
                bigWhale.phi++;
                bigWhale.transform();
                bigWhale.draw();
                gl_.glPopMatrix();

                /** Draw the baby whale */
                gl_.glPushMatrix();
                babyWhale.pilot();
                babyWhale.phi++;
                babyWhale.transform();
                gl_.glScalef( 0.45f, 0.45f, 0.3f );
                babyWhale.draw();
                gl_.glPopMatrix();
              }

            /** Draw the dolphin */
            if ( dolphinCheckbox.getState() ) {
                gl_.glPushMatrix();
                dolph.pilot();
                dolph.phi++;
                dolph.transform();
                dolph.draw();
                gl_.glPopMatrix();
              }

            /** Draw the porthole, if we want it.... */
//            if ( portholeCheckbox.getState() ) {
                /** Check that the texture is valid, of course! */
//                if ( portholeTexture.isValid() ) {

                    /** Disable the depth buffer and enable alpha */
/*                    gl_.glDisable( GL.GL_DEPTH_TEST );
                    gl_.glAlphaFunc( GL.GL_GREATER, 0.0f );
                    gl_.glEnable( GL.GL_ALPHA_TEST );

                    gl_.glRasterPos3d( win[0][0], win[0][1], win[0][2] );
                    gl_.glDrawPixels( portholeTexture.getWidth(),
                                     portholeTexture.getHeight(),
                                     GL.GL_RGBA,
                                     GL.GL_UNSIGNED_BYTE,
                                     portholeTexture.getTexture() );

                    gl_.glDisable( GL.GL_ALPHA_TEST );
                    gl_.glEnable( GL.GL_DEPTH_TEST );
                  }
              } */
          } catch ( OpenGLException e ) {
            e.printStackTrace();
          }

        /** Finish the frame rate sampler */
        frc.stopSample();
      }

    /** Returns a GL pipeline to GLEventListener */
    public GL getGL() {
        return gl_;
      }

    /** Handles action events..... */
    public void actionPerformed( ActionEvent evt ) {
        if ( evt.getActionCommand().equals( "Shark" ) ) {
            sharkFrame sf = new sharkFrame( gl_, glu_ );
            return;
          }
        if ( evt.getActionCommand().equals( "Whale" ) ) {
            whaleFrame wf = new whaleFrame( gl_, glu_ );
            return;
          }
        if ( evt.getActionCommand().equals( "Dismiss" ) ) {
            glc.destroy();
            dispose();
        if ( callExit ) {
            System.exit( 0 );
          }

            return;
          }
      }

    /** WindowListener methods */
    public void windowActivated( WindowEvent evt ) {
      }

    public void windowClosed( WindowEvent evt ) {
      }

    public void windowClosing( WindowEvent evt ) {
        glc.destroy();
        dispose();
        if ( callExit ) {
            System.exit( 0 );
          }

      }

    public void windowDeactivated( WindowEvent evt ) {
      }

    public void windowDeiconified( WindowEvent evt ) {
        if ( glc.isRunning() ) {
            glc.resume();
          }
      }

    public void windowIconified( WindowEvent evt ) {
        if ( glc.isRunning() ) {
            glc.suspend();
          }
      }

    public void windowOpened( WindowEvent evt ) {
      }
    /** Applet only */
    public void stop() {
//        System.err.println( "stop() called" );
        /** Suspend the GL component only if it's driving an event loop */
        if ( glc.isRunning() ) {
            glc.suspend();
          }
      }

    /** Applet only */
    public void start() {
//        System.err.println( "start()" );
        /** Restart the GL component only if it's driving an event loop */
        if ( glc.isRunning() ) {
            glc.resume();
          }
      }

    /** Applet only */
    public void destroy() {
//        System.err.println( "destroy() called" );
        /** Destroy the GL component to free up the resources */
        glc.destroy();
      }
  }
