/**
 * (c) Copyright 1993, 1994, Silicon Graphics, Inc.
 * ALL RIGHTS RESERVED
 * Permission to use, copy, modify, and distribute this software for
 * any purpose and without fee is hereby granted, provided that the above
 * copyright notice appear in all copies and that both the copyright notice
 * and this permission notice appear in supporting documentation, and that
 * the name of Silicon Graphics, Inc. not be used in advertiMath.sing
 * or publicity pertaining to distribution of the software without specific,
 * written prior permission.
 *
 * THE MATERIAL EMBODIED ON THIS SOFTWARE IS PROVIDED TO YOU "AS-IS"
 * AND WITHOUT WARRANTY OF ANY KIND, EXPRESS, IMPLIED OR OTHERWISE,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF MERCHANTABILITY OR
 * FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT SHALL SILICON
 * GRAPHICS, INC.  BE LIABLE TO YOU OR ANYONE ELSE FOR ANY DIRECT,
 * SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY
 * KIND, OR ANY DAMAGES WHATSOEVER, INCLUDING WITHOUT LIMITATION,
 * LOSS OF PROFIT, LOSS OF USE, SAVINGS OR REVENUE, OR THE CLAIMS OF
 * THIRD PARTIES, WHETHER OR NOT SILICON GRAPHICS, INC.  HAS BEEN
 * ADVISED OF THE POSSIBILITY OF SUCH LOSS, HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE
 * POSSESSION, USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * US Government Users Restricted Rights
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions set forth in FAR 52.227.19(c)(2) or subparagraph
 * (c)(1)(ii) of the Rights in Technical Data and Computer Software
 * clause at DFARS 252.227-7013 and/or in similar or successor
 * clauses in the FAR or the DOD or NASA FAR Supplement.
 * Unpublished-- rights reserved under the copyright laws of the
 * United States.  Contractor/manufacturer is Silicon Graphics,
 * Inc., 2011 N.  Shoreline Blvd., Mountain View, CA 94039-7311.
 *
 * OpenGL(TM) is a trademark of Silicon Graphics, Inc.
 */

/**
 * $Id: dolphin.java,v 1.4 1998/10/19 10:40:33 descarte Exp descarte $
 *
 * Magician conversion Copyright (c)1997-1998 Arcane Technologies Ltd. <http://www.arcana.co.uk>
 *
 * $Log: dolphin.java,v $
 * Revision 1.4  1998/10/19 10:40:33  descarte
 * Made JDK-1.1 compliant by removing deprecated methods. Updated copyright.
 *
 * Revision 1.3  1998/06/07 13:53:54  descarte
 * Converted from COM.hermetica.* to com.hermetica.* hierarchy
 *
 * Revision 1.2  1998/03/30 01:08:49  descarte
 * Made draw() method public instead of private. This fouled up applets.
 *
 * Revision 1.1  1998/01/04 17:30:48  descarte
 * Initial revision
 *
 */

package com.hermetica.magician.demos.atlantis;

import com.hermetica.magician.*;
import com.hermetica.vecmath.*;

public class dolphin extends fish {

    /** The OpenGL state machine */
//    GL gl_ = new GL();

    static double[] N001 = {-0.005937 ,-0.101998 ,-0.994767};
    static double[] N002 = {0.936780 ,-0.200803 ,0.286569};
    static double[] N003 = {-0.233062 ,0.972058 ,0.028007};
    static double[] N005 = {0.898117 ,0.360171 ,0.252315};
    static double[] N006 = {-0.915437 ,0.348456 ,0.201378};
    static double[] N007 = {0.602263 ,-0.777527 ,0.180920};
    static double[] N008 = {-0.906912 ,-0.412015 ,0.088061};
    static double[] N012 = {0.884408 ,-0.429417 ,-0.182821};
    static double[] N013 = {0.921121 ,0.311084 ,-0.234016};
    static double[] N014 = {0.382635 ,0.877882 ,-0.287948};
    static double[] N015 = {-0.380046 ,0.888166 ,-0.258316};
    static double[] N016 = {-0.891515 ,0.392238 ,-0.226607};
    static double[] N017 = {-0.901419 ,-0.382002 ,-0.203763};
    static double[] N018 = {-0.367225 ,-0.911091 ,-0.187243};
    static double[] N019 = {0.339539 ,-0.924846 ,-0.171388};
    static double[] N020 = {0.914706 ,-0.378617 ,-0.141290};
    static double[] N021 = {0.950662 ,0.262713 ,-0.164994};
    static double[] N022 = {0.546359 ,0.801460 ,-0.243218};
    static double[] N023 = {-0.315796 ,0.917068 ,-0.243431};
    static double[] N024 = {-0.825687 ,0.532277 ,-0.186875};
    static double[] N025 = {-0.974763 ,-0.155232 ,-0.160435};
    static double[] N026 = {-0.560596 ,-0.816658 ,-0.137119};
    static double[] N027 = {0.380210 ,-0.910817 ,-0.160786};
    static double[] N028 = {0.923772 ,-0.358322 ,-0.135093};
    static double[] N029 = {0.951202 ,0.275053 ,-0.139859};
    static double[] N030 = {0.686099 ,0.702548 ,-0.188932};
    static double[] N031 = {-0.521865 ,0.826719 ,-0.210220};
    static double[] N032 = {-0.923820 ,0.346739 ,-0.162258};
    static double[] N033 = {-0.902095 ,-0.409995 ,-0.134646};
    static double[] N034 = {-0.509115 ,-0.848498 ,-0.144404};
    static double[] N035 = {0.456469 ,-0.880293 ,-0.129305};
    static double[] N036 = {0.873401 ,-0.475489 ,-0.105266};
    static double[] N037 = {0.970825 ,0.179861 ,-0.158584};
    static double[] N038 = {0.675609 ,0.714187 ,-0.183004};
    static double[] N039 = {-0.523574 ,0.830212 ,-0.191360};
    static double[] N040 = {-0.958895 ,0.230808 ,-0.165071};
    static double[] N041 = {-0.918285 ,-0.376803 ,-0.121542};
    static double[] N042 = {-0.622467 ,-0.774167 ,-0.114888};
    static double[] N043 = {0.404497 ,-0.908807 ,-0.102231};
    static double[] N044 = {0.930538 ,-0.365155 ,-0.027588};
    static double[] N045 = {0.921920 ,0.374157 ,-0.100345};
    static double[] N046 = {0.507346 ,0.860739 ,0.041562};
    static double[] N047 = {-0.394646 ,0.918815 ,-0.005730};
    static double[] N048 = {-0.925411 ,0.373024 ,-0.066837};
    static double[] N049 = {-0.945337 ,-0.322309 ,-0.049551};
    static double[] N050 = {-0.660437 ,-0.750557 ,-0.022072};
    static double[] N051 = {0.488835 ,-0.871950 ,-0.027261};
    static double[] N052 = {0.902599 ,-0.421397 ,0.087969};
    static double[] N053 = {0.938636 ,0.322606 ,0.122020};
    static double[] N054 = {0.484605 ,0.871078 ,0.079878};
    static double[] N055 = {-0.353607 ,0.931559 ,0.084619};
    static double[] N056 = {-0.867759 ,0.478564 ,0.134054};
    static double[] N057 = {-0.951583 ,-0.296030 ,0.082794};
    static double[] N058 = {-0.672355 ,-0.730209 ,0.121384};
    static double[] N059 = {0.528336 ,-0.842452 ,0.105525};
    static double[] N060 = {0.786913 ,-0.564760 ,0.248627};
    static double[] N062 = {0.622098 ,0.765230 ,0.165584};
    static double[] N063 = {-0.631711 ,0.767816 ,0.106773};
    static double[] N064 = {-0.687886 ,0.606351 ,0.398938};
    static double[] N065 = {-0.946327 ,-0.281623 ,0.158598};
    static double[] N066 = {-0.509549 ,-0.860437 ,0.002776};
    static double[] N067 = {0.462594 ,-0.876692 ,0.131977};
    static double[] N071 = {0.000000 ,1.000000 ,0.000000};
    static double[] N077 = {-0.880770 ,0.461448 ,0.106351};
    static double[] N078 = {-0.880770 ,0.461448 ,0.106351};
    static double[] N079 = {-0.880770 ,0.461448 ,0.106351};
    static double[] N080 = {-0.880770 ,0.461448 ,0.106351};
    static double[] N081 = {-0.571197 ,0.816173 ,0.087152};
    static double[] N082 = {-0.880770 ,0.461448 ,0.106351};
    static double[] N083 = {-0.571197 ,0.816173 ,0.087152};
    static double[] N084 = {-0.571197 ,0.816173 ,0.087152};
    static double[] N085 = {-0.880770 ,0.461448 ,0.106351};
    static double[] N086 = {-0.571197 ,0.816173 ,0.087152};
    static double[] N087 = {-0.880770 ,0.461448 ,0.106351};
    static double[] N088 = {-0.880770 ,0.461448 ,0.106351};
    static double[] N089 = {-0.880770 ,0.461448 ,0.106351};
    static double[] N090 = {-0.880770 ,0.461448 ,0.106351};
    static double[] N091 = {0.000000 ,1.000000 ,0.000000};
    static double[] N092 = {0.000000 ,1.000000 ,0.000000};
    static double[] N093 = {0.000000 ,1.000000 ,0.000000};
    static double[] N094 = {1.000000 ,0.000000 ,0.000000};
    static double[] N095 = {-1.000000 ,0.000000 ,0.000000};
    static double[] N097 = {-0.697296 ,0.702881 ,0.140491};
    static double[] N098 = {0.918864 ,0.340821 ,0.198819};
    static double[] N099 = {-0.932737 ,0.201195 ,0.299202};
    static double[] N100 = {0.029517 ,0.981679 ,0.188244};
    static double[] N102 = {0.813521 ,-0.204936 ,0.544229};
    static double[] N110 = {-0.781480 ,-0.384779 ,0.491155};
    static double[] N111 = {-0.722243 ,0.384927 ,0.574627};
    static double[] N112 = {-0.752278 ,0.502679 ,0.425901};
    static double[] N113 = {0.547257 ,0.367910 ,0.751766};
    static double[] N114 = {0.725949 ,-0.232568 ,0.647233};
    static double[] N115 = {-0.747182 ,-0.660786 ,0.071280};
    static double[] N116 = {0.931519 ,0.200748 ,0.303270};
    static double[] N117 = {-0.828928 ,0.313757 ,0.463071};
    static double[] N118 = {0.902554 ,-0.370967 ,0.218587};
    static double[] N119 = {-0.879257 ,-0.441851 ,0.177973};
    static double[] N120 = {0.642327 ,0.611901 ,0.461512};
    static double[] N121 = {0.964817 ,-0.202322 ,0.167910};
    static double[] N122 = {0.000000 ,1.000000 ,0.000000};
    static double[] P001 = {5.68, -300.95, 1324.70};
    static double[] P002 = {338.69, -219.63, 9677.03};
    static double[] P003 = {12.18, 474.59, 9138.14};
    static double[] P005 = {487.51, 198.05, 9350.78};
    static double[] P006 = {-457.61, 68.74, 9427.85};
    static double[] P007 = {156.52, -266.72, 10311.68};
    static double[] P008 = {-185.56, -266.51, 10310.47};
    static double[] P009 = {124.39, -261.46, 1942.34};
    static double[] P010 = {-130.05, -261.46, 1946.03};
    static double[] P011 = {141.07, -320.11, 1239.38};
    static double[] P012 = {156.48, -360.12, 2073.41};
    static double[] P013 = {162.00, -175.88, 2064.44};
    static double[] P014 = {88.16, -87.72, 2064.02};
    static double[] P015 = {-65.21, -96.13, 2064.02};
    static double[] P016 = {-156.48, -180.96, 2064.44};
    static double[] P017 = {-162.00, -368.93, 2082.39};
    static double[] P018 = {-88.16, -439.22, 2082.39};
    static double[] P019 = {65.21, -440.32, 2083.39};
    static double[] P020 = {246.87, -356.02, 2576.95};
    static double[] P021 = {253.17, -111.15, 2567.15};
    static double[] P022 = {132.34, 51.41, 2559.84};
    static double[] P023 = {-97.88, 40.44, 2567.15};
    static double[] P024 = {-222.97, -117.49, 2567.15};
    static double[] P025 = {-252.22, -371.53, 2569.92};
    static double[] P026 = {-108.44, -518.19, 2586.75};
    static double[] P027 = {97.88, -524.79, 2586.75};
    static double[] P028 = {370.03, -421.19, 3419.70};
    static double[] P029 = {351.15, -16.98, 3423.17};
    static double[] P030 = {200.66, 248.46, 3430.37};
    static double[] P031 = {-148.42, 235.02, 3417.91};
    static double[] P032 = {-360.21, -30.27, 3416.84};
    static double[] P033 = {-357.90, -414.89, 3407.04};
    static double[] P034 = {-148.88, -631.35, 3409.90};
    static double[] P035 = {156.38, -632.59, 3419.70};
    static double[] P036 = {462.61, -469.21, 4431.51};
    static double[] P037 = {466.60, 102.25, 4434.98};
    static double[] P038 = {243.05, 474.34, 4562.02};
    static double[] P039 = {-191.23, 474.40, 4554.42};
    static double[] P040 = {-476.12, 111.05, 4451.11};
    static double[] P041 = {-473.36, -470.74, 4444.78};
    static double[] P042 = {-266.95, -748.41, 4447.78};
    static double[] P043 = {211.14, -749.91, 4429.73};
    static double[] P044 = {680.57, -370.27, 5943.46};
    static double[] P045 = {834.01, 363.09, 6360.63};
    static double[] P046 = {371.29, 804.51, 6486.26};
    static double[] P047 = {-291.43, 797.22, 6494.28};
    static double[] P048 = {-784.13, 370.75, 6378.01};
    static double[] P049 = {-743.29, -325.82, 5943.46};
    static double[] P050 = {-383.24, -804.77, 5943.46};
    static double[] P051 = {283.47, -846.09, 5943.46};
    static double[] iP001 = {5.68, -300.95, 1324.70};
    static double[] iP009 = {124.39, -261.46, 1942.34};
    static double[] iP010 = {-130.05, -261.46, 1946.03};
    static double[] iP011 = {141.07, -320.11, 1239.38};
    static double[] iP012 = {156.48, -360.12, 2073.41};
    static double[] iP013 = {162.00, -175.88, 2064.44};
    static double[] iP014 = {88.16, -87.72, 2064.02};
    static double[] iP015 = {-65.21, -96.13, 2064.02};
    static double[] iP016 = {-156.48, -180.96, 2064.44};
    static double[] iP017 = {-162.00, -368.93, 2082.39};
    static double[] iP018 = {-88.16, -439.22, 2082.39};
    static double[] iP019 = {65.21, -440.32, 2083.39};
    static double[] iP020 = {246.87, -356.02, 2576.95};
    static double[] iP021 = {253.17, -111.15, 2567.15};
    static double[] iP022 = {132.34, 51.41, 2559.84};
    static double[] iP023 = {-97.88, 40.44, 2567.15};
    static double[] iP024 = {-222.97, -117.49, 2567.15};
    static double[] iP025 = {-252.22, -371.53, 2569.92};
    static double[] iP026 = {-108.44, -518.19, 2586.75};
    static double[] iP027 = {97.88, -524.79, 2586.75};
    static double[] iP028 = {370.03, -421.19, 3419.70};
    static double[] iP029 = {351.15, -16.98, 3423.17};
    static double[] iP030 = {200.66, 248.46, 3430.37};
    static double[] iP031 = {-148.42, 235.02, 3417.91};
    static double[] iP032 = {-360.21, -30.27, 3416.84};
    static double[] iP033 = {-357.90, -414.89, 3407.04};
    static double[] iP034 = {-148.88, -631.35, 3409.90};
    static double[] iP035 = {156.38, -632.59, 3419.70};
    static double[] iP036 = {462.61, -469.21, 4431.51};
    static double[] iP037 = {466.60, 102.25, 4434.98};
    static double[] iP038 = {243.05, 474.34, 4562.02};
    static double[] iP039 = {-191.23, 474.40, 4554.42};
    static double[] iP040 = {-476.12, 111.05, 4451.11};
    static double[] iP041 = {-473.36, -470.74, 4444.78};
    static double[] iP042 = {-266.95, -748.41, 4447.78};
    static double[] iP043 = {211.14, -749.91, 4429.73};
    static double[] iP044 = {680.57, -370.27, 5943.46};
    static double[] iP045 = {834.01, 363.09, 6360.63};
    static double[] iP046 = {371.29, 804.51, 6486.26};
    static double[] iP047 = {-291.43, 797.22, 6494.28};
    static double[] iP048 = {-784.13, 370.75, 6378.01};
    static double[] iP049 = {-743.29, -325.82, 5943.46};
    static double[] iP050 = {-383.24, -804.77, 5943.46};
    static double[] iP051 = {283.47, -846.09, 5943.46};
    static double[] P052 = {599.09, -300.15, 7894.03};
    static double[] P053 = {735.48, 306.26, 7911.92};
    static double[] P054 = {246.22, 558.53, 8460.50};
    static double[] P055 = {-230.41, 559.84, 8473.23};
    static double[] P056 = {-698.66, 320.83, 7902.59};
    static double[] P057 = {-643.29, -299.16, 7902.59};
    static double[] P058 = {-341.47, -719.30, 7902.59};
    static double[] P059 = {252.57, -756.12, 7902.59};
    static double[] P060 = {458.39, -265.31, 9355.44};
    static double[] P062 = {224.04, 338.75, 9450.30};
    static double[] P063 = {-165.71, 341.04, 9462.35};
    static double[] P064 = {-298.11, 110.13, 10180.37};
    static double[] P065 = {-473.99, -219.71, 9355.44};
    static double[] P066 = {-211.97, -479.87, 9355.44};
    static double[] P067 = {192.86, -491.45, 9348.73};
    static double[] P068 = {-136.29, -319.84, 1228.73};
    static double[] P069 = {1111.17, -314.14, 1314.19};
    static double[] P070 = {-1167.34, -321.61, 1319.45};
    static double[] P071 = {1404.86, -306.66, 1235.45};
    static double[] P072 = {-1409.73, -314.14, 1247.66};
    static double[] P073 = {1254.01, -296.87, 1544.58};
    static double[] P074 = {-1262.09, -291.70, 1504.26};
    static double[] P075 = {965.71, -269.26, 1742.65};
    static double[] P076 = {-900.97, -276.74, 1726.07};
    static double[] iP068 = {-136.29, -319.84, 1228.73};
    static double[] iP069 = {1111.17, -314.14, 1314.19};
    static double[] iP070 = {-1167.34, -321.61, 1319.45};
    static double[] iP071 = {1404.86, -306.66, 1235.45};
    static double[] iP072 = {-1409.73, -314.14, 1247.66};
    static double[] iP073 = {1254.01, -296.87, 1544.58};
    static double[] iP074 = {-1262.09, -291.70, 1504.26};
    static double[] iP075 = {965.71, -269.26, 1742.65};
    static double[] iP076 = {-900.97, -276.74, 1726.07};
    static double[] P077 = {1058.00, -448.81, 8194.66};
    static double[] P078 = {-1016.51, -456.43, 8190.62};
    static double[] P079 = {-1515.96, -676.45, 7754.93};
    static double[] P080 = {1856.75, -830.34, 7296.56};
    static double[] P081 = {1472.16, -497.38, 7399.68};
    static double[] P082 = {-1775.26, -829.51, 7298.46};
    static double[] P083 = {911.09, -252.51, 7510.99};
    static double[] P084 = {-1451.94, -495.62, 7384.30};
    static double[] P085 = {1598.75, -669.26, 7769.90};
    static double[] P086 = {-836.53, -250.08, 7463.25};
    static double[] P087 = {722.87, -158.18, 8006.41};
    static double[] P088 = {-688.86, -162.28, 7993.89};
    static double[] P089 = {-626.92, -185.30, 8364.98};
    static double[] P090 = {647.72, -189.46, 8354.99};
    static double[] P091 = {0.00, 835.01, 5555.62};
    static double[] P092 = {0.00, 1350.18, 5220.86};
    static double[] P093 = {0.00, 1422.94, 5285.27};
    static double[] P094 = {0.00, 1296.75, 5650.19};
    static double[] P095 = {0.00, 795.63, 6493.88};
    static double[] iP091 = {0.00, 835.01, 5555.62};
    static double[] iP092 = {0.00, 1350.18, 5220.86};
    static double[] iP093 = {0.00, 1422.94, 5285.27};
    static double[] iP094 = {0.00, 1296.75, 5650.19};
    static double[] iP095 = {0.00, 795.63, 6493.88};
    static double[] P097 = {-194.91, -357.14, 10313.32};
    static double[] P098 = {135.35, -357.66, 10307.94};
    static double[] iP097 = {-194.91, -357.14, 10313.32};
    static double[] iP098 = {135.35, -357.66, 10307.94};
    static double[] P099 = {-380.53, -221.14, 9677.98};
    static double[] P100 = {0.00, 412.99, 9629.33};
    static double[] P102 = {59.51, -412.55, 10677.58};
    static double[] iP102 = {59.51, -412.55, 10677.58};
    static double[] P103 = {6.50, 484.74, 9009.94};
    static double[] P105 = {-41.86, 476.51, 9078.17};
    static double[] P108 = {49.20, 476.83, 9078.24};
    static double[] P110 = {-187.62, -410.04, 10674.12};
    static double[] iP110 = {-187.62, -410.04, 10674.12};
    static double[] P111 = {-184.25, -318.70, 10723.88};
    static double[] iP111 = {-184.25, -318.70, 10723.88};
    static double[] P112 = {-179.61, -142.81, 10670.26};
    static double[] P113 = {57.43, -147.94, 10675.26};
    static double[] P114 = {54.06, -218.90, 10712.44};
    static double[] P115 = {-186.35, -212.09, 10713.76};
    static double[] P116 = {205.90, -84.61, 10275.97};
    static double[] P117 = {-230.96, -83.26, 10280.09};
    static double[] iP118 = {216.78, -509.17, 10098.94};
    static double[] iP119 = {-313.21, -510.79, 10102.62};
    static double[] P118 = {216.78, -509.17, 10098.94};
    static double[] P119 = {-313.21, -510.79, 10102.62};
    static double[] P120 = {217.95, 96.34, 10161.62};
    static double[] P121 = {71.99, -319.74, 10717.70};
    static double[] iP121 = {71.99, -319.74, 10717.70};
    static double[] P122 = {0.00, 602.74, 5375.84};
    static double[] iP122 = {0.00, 602.74, 5375.84};
    static double[] P123 = {-448.94, -203.14, 9499.60};
    static double[] P124 = {-442.64, -185.20, 9528.07};
    static double[] P125 = {-441.07, -148.05, 9528.07};
    static double[] P126 = {-443.43, -128.84, 9499.60};
    static double[] P127 = {-456.87, -146.78, 9466.67};
    static double[] P128 = {-453.68, -183.93, 9466.67};
    static double[] P129 = {428.43, -124.08, 9503.03};
    static double[] P130 = {419.73, -142.14, 9534.56};
    static double[] P131 = {419.92, -179.96, 9534.56};
    static double[] P132 = {431.20, -199.73, 9505.26};
    static double[] P133 = {442.28, -181.67, 9475.96};
    static double[] P134 = {442.08, -143.84, 9475.96};

    /** Constructor simply calls the fish constructor */
    public dolphin( GL gl_, GLU glu_ ) {
        super( gl_, glu_ );
      }

    void Dolphin001() throws OpenGLException {
        gl_.glNormal3dv(N071);
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P001);
            gl_.glVertex3dv(P068);
            gl_.glVertex3dv(P010);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P068);
            gl_.glVertex3dv(P076);
            gl_.glVertex3dv(P010);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P068);
            gl_.glVertex3dv(P070);
            gl_.glVertex3dv(P076);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P076);
            gl_.glVertex3dv(P070);
            gl_.glVertex3dv(P074);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P070);
            gl_.glVertex3dv(P072);
            gl_.glVertex3dv(P074);
        gl_.glEnd();
        gl_.glNormal3dv(N119);
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P072);
            gl_.glVertex3dv(P070);
            gl_.glVertex3dv(P074);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P074);
            gl_.glVertex3dv(P070);
            gl_.glVertex3dv(P076);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P070);
            gl_.glVertex3dv(P068);
            gl_.glVertex3dv(P076);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P076);
            gl_.glVertex3dv(P068);
            gl_.glVertex3dv(P010);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P068);
            gl_.glVertex3dv(P001);
            gl_.glVertex3dv(P010);
        gl_.glEnd();
      }

    void Dolphin002() throws OpenGLException { 
        gl_.glNormal3dv(N071);
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P011);
            gl_.glVertex3dv(P001);
            gl_.glVertex3dv(P009);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P075);
            gl_.glVertex3dv(P011);
            gl_.glVertex3dv(P009);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P069);
            gl_.glVertex3dv(P011);
            gl_.glVertex3dv(P075);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P069);
            gl_.glVertex3dv(P075);
            gl_.glVertex3dv(P073);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P071);
            gl_.glVertex3dv(P069);
            gl_.glVertex3dv(P073);
        gl_.glEnd();
        gl_.glNormal3dv(N119);
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P001);
            gl_.glVertex3dv(P011);
            gl_.glVertex3dv(P009);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P009);
            gl_.glVertex3dv(P011);
            gl_.glVertex3dv(P075);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P011);
            gl_.glVertex3dv(P069);
            gl_.glVertex3dv(P075);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P069);
            gl_.glVertex3dv(P073);
            gl_.glVertex3dv(P075);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P069);
            gl_.glVertex3dv(P071);
            gl_.glVertex3dv(P073);
        gl_.glEnd();
      }

    void Dolphin003() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N018);
            gl_.glVertex3dv(P018);
            gl_.glNormal3dv(N001);
            gl_.glVertex3dv(P001);
            gl_.glNormal3dv(N019);
            gl_.glVertex3dv(P019);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N019);
            gl_.glVertex3dv(P019);
            gl_.glNormal3dv(N001);
            gl_.glVertex3dv(P001);
            gl_.glNormal3dv(N012);
            gl_.glVertex3dv(P012);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N017);
            gl_.glVertex3dv(P017);
            gl_.glNormal3dv(N001);
            gl_.glVertex3dv(P001);
            gl_.glNormal3dv(N018);
            gl_.glVertex3dv(P018);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N001);
            gl_.glVertex3dv(P001);
            gl_.glNormal3dv(N017);
            gl_.glVertex3dv(P017);
            gl_.glNormal3dv(N016);
            gl_.glVertex3dv(P016);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N001);
            gl_.glVertex3dv(P001);
            gl_.glNormal3dv(N013);
            gl_.glVertex3dv(P013);
            gl_.glNormal3dv(N012);
            gl_.glVertex3dv(P012);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N001);
            gl_.glVertex3dv(P001);
            gl_.glNormal3dv(N016);
            gl_.glVertex3dv(P016);
            gl_.glNormal3dv(N015);
            gl_.glVertex3dv(P015);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N001);
            gl_.glVertex3dv(P001);
            gl_.glNormal3dv(N014);
            gl_.glVertex3dv(P014);
            gl_.glNormal3dv(N013);
            gl_.glVertex3dv(P013);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N001);
            gl_.glVertex3dv(P001);
            gl_.glNormal3dv(N015);
            gl_.glVertex3dv(P015);
            gl_.glNormal3dv(N014);
            gl_.glVertex3dv(P014);
        gl_.glEnd();
      }

    void Dolphin004() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N014);
            gl_.glVertex3dv(P014);
            gl_.glNormal3dv(N015);
            gl_.glVertex3dv(P015);
            gl_.glNormal3dv(N023);
            gl_.glVertex3dv(P023);
            gl_.glNormal3dv(N022);
            gl_.glVertex3dv(P022);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N015);
            gl_.glVertex3dv(P015);
            gl_.glNormal3dv(N016);
            gl_.glVertex3dv(P016);
            gl_.glNormal3dv(N024);
            gl_.glVertex3dv(P024);
            gl_.glNormal3dv(N023);
            gl_.glVertex3dv(P023);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N016);
            gl_.glVertex3dv(P016);
            gl_.glNormal3dv(N017);
            gl_.glVertex3dv(P017);
            gl_.glNormal3dv(N025);
            gl_.glVertex3dv(P025);
            gl_.glNormal3dv(N024);
            gl_.glVertex3dv(P024);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N017);
            gl_.glVertex3dv(P017);
            gl_.glNormal3dv(N018);
            gl_.glVertex3dv(P018);
            gl_.glNormal3dv(N026);
            gl_.glVertex3dv(P026);
            gl_.glNormal3dv(N025);
            gl_.glVertex3dv(P025);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N013);
            gl_.glVertex3dv(P013);
            gl_.glNormal3dv(N014);
            gl_.glVertex3dv(P014);
            gl_.glNormal3dv(N022);
            gl_.glVertex3dv(P022);
            gl_.glNormal3dv(N021);
            gl_.glVertex3dv(P021);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N012);
            gl_.glVertex3dv(P012);
            gl_.glNormal3dv(N013);
            gl_.glVertex3dv(P013);
            gl_.glNormal3dv(N021);
            gl_.glVertex3dv(P021);
            gl_.glNormal3dv(N020);
            gl_.glVertex3dv(P020);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N018);
            gl_.glVertex3dv(P018);
            gl_.glNormal3dv(N019);
            gl_.glVertex3dv(P019);
            gl_.glNormal3dv(N027);
            gl_.glVertex3dv(P027);
            gl_.glNormal3dv(N026);
            gl_.glVertex3dv(P026);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N019);
            gl_.glVertex3dv(P019);
            gl_.glNormal3dv(N012);
            gl_.glVertex3dv(P012);
            gl_.glNormal3dv(N020);
            gl_.glVertex3dv(P020);
            gl_.glNormal3dv(N027);
            gl_.glVertex3dv(P027);
        gl_.glEnd();
      }

    void Dolphin005() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N022);
            gl_.glVertex3dv(P022);
            gl_.glNormal3dv(N023);
            gl_.glVertex3dv(P023);
            gl_.glNormal3dv(N031);
            gl_.glVertex3dv(P031);
            gl_.glNormal3dv(N030);
            gl_.glVertex3dv(P030);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N021);
            gl_.glVertex3dv(P021);
            gl_.glNormal3dv(N022);
            gl_.glVertex3dv(P022);
            gl_.glNormal3dv(N030);
            gl_.glVertex3dv(P030);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N021);
            gl_.glVertex3dv(P021);
            gl_.glNormal3dv(N030);
            gl_.glVertex3dv(P030);
            gl_.glNormal3dv(N029);
            gl_.glVertex3dv(P029);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N023);
            gl_.glVertex3dv(P023);
            gl_.glNormal3dv(N024);
            gl_.glVertex3dv(P024);
            gl_.glNormal3dv(N031);
            gl_.glVertex3dv(P031);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N024);
            gl_.glVertex3dv(P024);
            gl_.glNormal3dv(N032);
            gl_.glVertex3dv(P032);
            gl_.glNormal3dv(N031);
            gl_.glVertex3dv(P031);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N024);
            gl_.glVertex3dv(P024);
            gl_.glNormal3dv(N025);
            gl_.glVertex3dv(P025);
            gl_.glNormal3dv(N032);
            gl_.glVertex3dv(P032);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N025);
            gl_.glVertex3dv(P025);
            gl_.glNormal3dv(N033);
            gl_.glVertex3dv(P033);
            gl_.glNormal3dv(N032);
            gl_.glVertex3dv(P032);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N020);
            gl_.glVertex3dv(P020);
            gl_.glNormal3dv(N021);
            gl_.glVertex3dv(P021);
            gl_.glNormal3dv(N029);
            gl_.glVertex3dv(P029);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N020);
            gl_.glVertex3dv(P020);
            gl_.glNormal3dv(N029);
            gl_.glVertex3dv(P029);
            gl_.glNormal3dv(N028);
            gl_.glVertex3dv(P028);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N027);
            gl_.glVertex3dv(P027);
            gl_.glNormal3dv(N020);
            gl_.glVertex3dv(P020);
            gl_.glNormal3dv(N028);
            gl_.glVertex3dv(P028);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N027);
            gl_.glVertex3dv(P027);
            gl_.glNormal3dv(N028);
            gl_.glVertex3dv(P028);
            gl_.glNormal3dv(N035);
            gl_.glVertex3dv(P035);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N025);
            gl_.glVertex3dv(P025);
            gl_.glNormal3dv(N026);
            gl_.glVertex3dv(P026);
            gl_.glNormal3dv(N033);
            gl_.glVertex3dv(P033);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N033);
            gl_.glVertex3dv(P033);
            gl_.glNormal3dv(N026);
            gl_.glVertex3dv(P026);
            gl_.glNormal3dv(N034);
            gl_.glVertex3dv(P034);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N026);
            gl_.glVertex3dv(P026);
            gl_.glNormal3dv(N027);
            gl_.glVertex3dv(P027);
            gl_.glNormal3dv(N035);
            gl_.glVertex3dv(P035);
            gl_.glNormal3dv(N034);
            gl_.glVertex3dv(P034);
        gl_.glEnd();
      }

    void Dolphin006() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N092);
            gl_.glVertex3dv(P092);
            gl_.glNormal3dv(N093);
            gl_.glVertex3dv(P093);
            gl_.glNormal3dv(N094);
            gl_.glVertex3dv(P094);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N093);
            gl_.glVertex3dv(P093);
            gl_.glNormal3dv(N092);
            gl_.glVertex3dv(P092);
            gl_.glNormal3dv(N094);
            gl_.glVertex3dv(P094);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N092);
            gl_.glVertex3dv(P092);
            gl_.glNormal3dv(N091);
            gl_.glVertex3dv(P091);
            gl_.glNormal3dv(N095);
            gl_.glVertex3dv(P095);
            gl_.glNormal3dv(N094);
            gl_.glVertex3dv(P094);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N091);
            gl_.glVertex3dv(P091);
            gl_.glNormal3dv(N092);
            gl_.glVertex3dv(P092);
            gl_.glNormal3dv(N094);
            gl_.glVertex3dv(P094);
            gl_.glNormal3dv(N095);
            gl_.glVertex3dv(P095);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N122);
            gl_.glVertex3dv(P122);
            gl_.glNormal3dv(N095);
            gl_.glVertex3dv(P095);
            gl_.glNormal3dv(N091);
            gl_.glVertex3dv(P091);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N122);
            gl_.glVertex3dv(P122);
            gl_.glNormal3dv(N091);
            gl_.glVertex3dv(P091);
            gl_.glNormal3dv(N095);
            gl_.glVertex3dv(P095);
        gl_.glEnd();
      }

    void Dolphin007() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N030);
            gl_.glVertex3dv(P030);
            gl_.glNormal3dv(N031);
            gl_.glVertex3dv(P031);
            gl_.glNormal3dv(N039);
            gl_.glVertex3dv(P039);
            gl_.glNormal3dv(N038);
            gl_.glVertex3dv(P038);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N029);
            gl_.glVertex3dv(P029);
            gl_.glNormal3dv(N030);
            gl_.glVertex3dv(P030);
            gl_.glNormal3dv(N038);
            gl_.glVertex3dv(P038);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N029);
            gl_.glVertex3dv(P029);
            gl_.glNormal3dv(N038);
            gl_.glVertex3dv(P038);
            gl_.glNormal3dv(N037);
            gl_.glVertex3dv(P037);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N028);
            gl_.glVertex3dv(P028);
            gl_.glNormal3dv(N029);
            gl_.glVertex3dv(P029);
            gl_.glNormal3dv(N037);
            gl_.glVertex3dv(P037);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N028);
            gl_.glVertex3dv(P028);
            gl_.glNormal3dv(N037);
            gl_.glVertex3dv(P037);
            gl_.glNormal3dv(N036);
            gl_.glVertex3dv(P036);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N035);
            gl_.glVertex3dv(P035);
            gl_.glNormal3dv(N028);
            gl_.glVertex3dv(P028);
            gl_.glNormal3dv(N036);
            gl_.glVertex3dv(P036);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N035);
            gl_.glVertex3dv(P035);
            gl_.glNormal3dv(N036);
            gl_.glVertex3dv(P036);
            gl_.glNormal3dv(N043);
            gl_.glVertex3dv(P043);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N034);
            gl_.glVertex3dv(P034);
            gl_.glNormal3dv(N035);
            gl_.glVertex3dv(P035);
            gl_.glNormal3dv(N043);
            gl_.glVertex3dv(P043);
            gl_.glNormal3dv(N042);
            gl_.glVertex3dv(P042);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N033);
            gl_.glVertex3dv(P033);
            gl_.glNormal3dv(N034);
            gl_.glVertex3dv(P034);
            gl_.glNormal3dv(N042);
            gl_.glVertex3dv(P042);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N033);
            gl_.glVertex3dv(P033);
            gl_.glNormal3dv(N042);
            gl_.glVertex3dv(P042);
            gl_.glNormal3dv(N041);
            gl_.glVertex3dv(P041);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N031);
            gl_.glVertex3dv(P031);
            gl_.glNormal3dv(N032);
            gl_.glVertex3dv(P032);
            gl_.glNormal3dv(N039);
            gl_.glVertex3dv(P039);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N039);
            gl_.glVertex3dv(P039);
            gl_.glNormal3dv(N032);
            gl_.glVertex3dv(P032);
            gl_.glNormal3dv(N040);
            gl_.glVertex3dv(P040);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N032);
            gl_.glVertex3dv(P032);
            gl_.glNormal3dv(N033);
            gl_.glVertex3dv(P033);
            gl_.glNormal3dv(N040);
            gl_.glVertex3dv(P040);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N040);
            gl_.glVertex3dv(P040);
            gl_.glNormal3dv(N033);
            gl_.glVertex3dv(P033);
            gl_.glNormal3dv(N041);
            gl_.glVertex3dv(P041);
        gl_.glEnd();
      }

    void Dolphin008() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N042);
            gl_.glVertex3dv(P042);
            gl_.glNormal3dv(N043);
            gl_.glVertex3dv(P043);
            gl_.glNormal3dv(N051);
            gl_.glVertex3dv(P051);
            gl_.glNormal3dv(N050);
            gl_.glVertex3dv(P050);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N043);
            gl_.glVertex3dv(P043);
            gl_.glNormal3dv(N036);
            gl_.glVertex3dv(P036);
            gl_.glNormal3dv(N051);
            gl_.glVertex3dv(P051);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N051);
            gl_.glVertex3dv(P051);
            gl_.glNormal3dv(N036);
            gl_.glVertex3dv(P036);
            gl_.glNormal3dv(N044);
            gl_.glVertex3dv(P044);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N041);
            gl_.glVertex3dv(P041);
            gl_.glNormal3dv(N042);
            gl_.glVertex3dv(P042);
            gl_.glNormal3dv(N050);
            gl_.glVertex3dv(P050);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N041);
            gl_.glVertex3dv(P041);
            gl_.glNormal3dv(N050);
            gl_.glVertex3dv(P050);
            gl_.glNormal3dv(N049);
            gl_.glVertex3dv(P049);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N036);
            gl_.glVertex3dv(P036);
            gl_.glNormal3dv(N037);
            gl_.glVertex3dv(P037);
            gl_.glNormal3dv(N044);
            gl_.glVertex3dv(P044);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N044);
            gl_.glVertex3dv(P044);
            gl_.glNormal3dv(N037);
            gl_.glVertex3dv(P037);
            gl_.glNormal3dv(N045);
            gl_.glVertex3dv(P045);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N040);
            gl_.glVertex3dv(P040);
            gl_.glNormal3dv(N041);
            gl_.glVertex3dv(P041);
            gl_.glNormal3dv(N049);
            gl_.glVertex3dv(P049);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N040);
            gl_.glVertex3dv(P040);
            gl_.glNormal3dv(N049);
            gl_.glVertex3dv(P049);
            gl_.glNormal3dv(N048);
            gl_.glVertex3dv(P048);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N039);
            gl_.glVertex3dv(P039);
            gl_.glNormal3dv(N040);
            gl_.glVertex3dv(P040);
            gl_.glNormal3dv(N048);
            gl_.glVertex3dv(P048);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N039);
            gl_.glVertex3dv(P039);
            gl_.glNormal3dv(N048);
            gl_.glVertex3dv(P048);
            gl_.glNormal3dv(N047);
            gl_.glVertex3dv(P047);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N037);
            gl_.glVertex3dv(P037);
            gl_.glNormal3dv(N038);
            gl_.glVertex3dv(P038);
            gl_.glNormal3dv(N045);
            gl_.glVertex3dv(P045);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N038);
            gl_.glVertex3dv(P038);
            gl_.glNormal3dv(N046);
            gl_.glVertex3dv(P046);
            gl_.glNormal3dv(N045);
            gl_.glVertex3dv(P045);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N038);
            gl_.glVertex3dv(P038);
            gl_.glNormal3dv(N039);
            gl_.glVertex3dv(P039);
            gl_.glNormal3dv(N047);
            gl_.glVertex3dv(P047);
            gl_.glNormal3dv(N046);
            gl_.glVertex3dv(P046);
        gl_.glEnd();
      }

    void Dolphin009() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N050);
            gl_.glVertex3dv(P050);
            gl_.glNormal3dv(N051);
            gl_.glVertex3dv(P051);
            gl_.glNormal3dv(N059);
            gl_.glVertex3dv(P059);
            gl_.glNormal3dv(N058);
            gl_.glVertex3dv(P058);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N051);
            gl_.glVertex3dv(P051);
            gl_.glNormal3dv(N044);
            gl_.glVertex3dv(P044);
            gl_.glNormal3dv(N059);
            gl_.glVertex3dv(P059);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N059);
            gl_.glVertex3dv(P059);
            gl_.glNormal3dv(N044);
            gl_.glVertex3dv(P044);
            gl_.glNormal3dv(N052);
            gl_.glVertex3dv(P052);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N044);
            gl_.glVertex3dv(P044);
            gl_.glNormal3dv(N045);
            gl_.glVertex3dv(P045);
            gl_.glNormal3dv(N053);
            gl_.glVertex3dv(P053);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N044);
            gl_.glVertex3dv(P044);
            gl_.glNormal3dv(N053);
            gl_.glVertex3dv(P053);
            gl_.glNormal3dv(N052);
            gl_.glVertex3dv(P052);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N049);
            gl_.glVertex3dv(P049);
            gl_.glNormal3dv(N050);
            gl_.glVertex3dv(P050);
            gl_.glNormal3dv(N058);
            gl_.glVertex3dv(P058);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N049);
            gl_.glVertex3dv(P049);
            gl_.glNormal3dv(N058);
            gl_.glVertex3dv(P058);
            gl_.glNormal3dv(N057);
            gl_.glVertex3dv(P057);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N048);
            gl_.glVertex3dv(P048);
            gl_.glNormal3dv(N049);
            gl_.glVertex3dv(P049);
            gl_.glNormal3dv(N057);
            gl_.glVertex3dv(P057);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N048);
            gl_.glVertex3dv(P048);
            gl_.glNormal3dv(N057);
            gl_.glVertex3dv(P057);
            gl_.glNormal3dv(N056);
            gl_.glVertex3dv(P056);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N047);
            gl_.glVertex3dv(P047);
            gl_.glNormal3dv(N048);
            gl_.glVertex3dv(P048);
            gl_.glNormal3dv(N056);
            gl_.glVertex3dv(P056);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N047);
            gl_.glVertex3dv(P047);
            gl_.glNormal3dv(N056);
            gl_.glVertex3dv(P056);
            gl_.glNormal3dv(N055);
            gl_.glVertex3dv(P055);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N045);
            gl_.glVertex3dv(P045);
            gl_.glNormal3dv(N046);
            gl_.glVertex3dv(P046);
            gl_.glNormal3dv(N053);
            gl_.glVertex3dv(P053);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N046);
            gl_.glVertex3dv(P046);
            gl_.glNormal3dv(N054);
            gl_.glVertex3dv(P054);
            gl_.glNormal3dv(N053);
            gl_.glVertex3dv(P053);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N046);
            gl_.glVertex3dv(P046);
            gl_.glNormal3dv(N047);
            gl_.glVertex3dv(P047);
            gl_.glNormal3dv(N055);
            gl_.glVertex3dv(P055);
            gl_.glNormal3dv(N054);
            gl_.glVertex3dv(P054);
        gl_.glEnd();
      }

    void Dolphin010() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N080);
            gl_.glVertex3dv(P080);
            gl_.glNormal3dv(N081);
            gl_.glVertex3dv(P081);
            gl_.glNormal3dv(N085);
            gl_.glVertex3dv(P085);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N081);
            gl_.glVertex3dv(P081);
            gl_.glNormal3dv(N083);
            gl_.glVertex3dv(P083);
            gl_.glNormal3dv(N085);
            gl_.glVertex3dv(P085);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N085);
            gl_.glVertex3dv(P085);
            gl_.glNormal3dv(N083);
            gl_.glVertex3dv(P083);
            gl_.glNormal3dv(N077);
            gl_.glVertex3dv(P077);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N083);
            gl_.glVertex3dv(P083);
            gl_.glNormal3dv(N087);
            gl_.glVertex3dv(P087);
            gl_.glNormal3dv(N077);
            gl_.glVertex3dv(P077);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N077);
            gl_.glVertex3dv(P077);
            gl_.glNormal3dv(N087);
            gl_.glVertex3dv(P087);
            gl_.glNormal3dv(N090);
            gl_.glVertex3dv(P090);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N081);
            gl_.glVertex3dv(P081);
            gl_.glNormal3dv(N080);
            gl_.glVertex3dv(P080);
            gl_.glNormal3dv(N085);
            gl_.glVertex3dv(P085);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N083);
            gl_.glVertex3dv(P083);
            gl_.glNormal3dv(N081);
            gl_.glVertex3dv(P081);
            gl_.glNormal3dv(N085);
            gl_.glVertex3dv(P085);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N083);
            gl_.glVertex3dv(P083);
            gl_.glNormal3dv(N085);
            gl_.glVertex3dv(P085);
            gl_.glNormal3dv(N077);
            gl_.glVertex3dv(P077);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N087);
            gl_.glVertex3dv(P087);
            gl_.glNormal3dv(N083);
            gl_.glVertex3dv(P083);
            gl_.glNormal3dv(N077);
            gl_.glVertex3dv(P077);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N087);
            gl_.glVertex3dv(P087);
            gl_.glNormal3dv(N077);
            gl_.glVertex3dv(P077);
            gl_.glNormal3dv(N090);
            gl_.glVertex3dv(P090);
        gl_.glEnd();
      }

    void Dolphin011() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N082);
            gl_.glVertex3dv(P082);
            gl_.glNormal3dv(N084);
            gl_.glVertex3dv(P084);
            gl_.glNormal3dv(N079);
            gl_.glVertex3dv(P079);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N084);
            gl_.glVertex3dv(P084);
            gl_.glNormal3dv(N086);
            gl_.glVertex3dv(P086);
            gl_.glNormal3dv(N079);
            gl_.glVertex3dv(P079);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N079);
            gl_.glVertex3dv(P079);
            gl_.glNormal3dv(N086);
            gl_.glVertex3dv(P086);
            gl_.glNormal3dv(N078);
            gl_.glVertex3dv(P078);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N086);
            gl_.glVertex3dv(P086);
            gl_.glNormal3dv(N088);
            gl_.glVertex3dv(P088);
            gl_.glNormal3dv(N078);
            gl_.glVertex3dv(P078);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N078);
            gl_.glVertex3dv(P078);
            gl_.glNormal3dv(N088);
            gl_.glVertex3dv(P088);
            gl_.glNormal3dv(N089);
            gl_.glVertex3dv(P089);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N088);
            gl_.glVertex3dv(P088);
            gl_.glNormal3dv(N086);
            gl_.glVertex3dv(P086);
            gl_.glNormal3dv(N089);
            gl_.glVertex3dv(P089);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N089);
            gl_.glVertex3dv(P089);
            gl_.glNormal3dv(N086);
            gl_.glVertex3dv(P086);
            gl_.glNormal3dv(N078);
            gl_.glVertex3dv(P078);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N086);
            gl_.glVertex3dv(P086);
            gl_.glNormal3dv(N084);
            gl_.glVertex3dv(P084);
            gl_.glNormal3dv(N078);
            gl_.glVertex3dv(P078);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N078);
            gl_.glVertex3dv(P078);
            gl_.glNormal3dv(N084);
            gl_.glVertex3dv(P084);
            gl_.glNormal3dv(N079);
            gl_.glVertex3dv(P079);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N084);
            gl_.glVertex3dv(P084);
            gl_.glNormal3dv(N082);
            gl_.glVertex3dv(P082);
            gl_.glNormal3dv(N079);
            gl_.glVertex3dv(P079);
        gl_.glEnd();
      }

    void Dolphin012() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N058);
            gl_.glVertex3dv(P058);
            gl_.glNormal3dv(N059);
            gl_.glVertex3dv(P059);
            gl_.glNormal3dv(N067);
            gl_.glVertex3dv(P067);
            gl_.glNormal3dv(N066);
            gl_.glVertex3dv(P066);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N059);
            gl_.glVertex3dv(P059);
            gl_.glNormal3dv(N052);
            gl_.glVertex3dv(P052);
            gl_.glNormal3dv(N060);
            gl_.glVertex3dv(P060);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N059);
            gl_.glVertex3dv(P059);
            gl_.glNormal3dv(N060);
            gl_.glVertex3dv(P060);
            gl_.glNormal3dv(N067);
            gl_.glVertex3dv(P067);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N058);
            gl_.glVertex3dv(P058);
            gl_.glNormal3dv(N066);
            gl_.glVertex3dv(P066);
            gl_.glNormal3dv(N065);
            gl_.glVertex3dv(P065);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N058);
            gl_.glVertex3dv(P058);
            gl_.glNormal3dv(N065);
            gl_.glVertex3dv(P065);
            gl_.glNormal3dv(N057);
            gl_.glVertex3dv(P057);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N056);
            gl_.glVertex3dv(P056);
            gl_.glNormal3dv(N057);
            gl_.glVertex3dv(P057);
            gl_.glNormal3dv(N065);
            gl_.glVertex3dv(P065);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N056);
            gl_.glVertex3dv(P056);
            gl_.glNormal3dv(N065);
            gl_.glVertex3dv(P065);
            gl_.glNormal3dv(N006);
            gl_.glVertex3dv(P006);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N056);
            gl_.glVertex3dv(P056);
            gl_.glNormal3dv(N006);
            gl_.glVertex3dv(P006);
            gl_.glNormal3dv(N063);
            gl_.glVertex3dv(P063);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N056);
            gl_.glVertex3dv(P056);
            gl_.glNormal3dv(N063);
            gl_.glVertex3dv(P063);
            gl_.glNormal3dv(N055);
            gl_.glVertex3dv(P055);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N054);
            gl_.glVertex3dv(P054);
            gl_.glNormal3dv(N062);
            gl_.glVertex3dv(P062);
            gl_.glNormal3dv(N005);
            gl_.glVertex3dv(P005);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N054);
            gl_.glVertex3dv(P054);
            gl_.glNormal3dv(N005);
            gl_.glVertex3dv(P005);
            gl_.glNormal3dv(N053);
            gl_.glVertex3dv(P053);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N052);
            gl_.glVertex3dv(P052);
            gl_.glNormal3dv(N053);
            gl_.glVertex3dv(P053);
            gl_.glNormal3dv(N005);
            gl_.glVertex3dv(P005);
            gl_.glNormal3dv(N060);
            gl_.glVertex3dv(P060);
        gl_.glEnd();
      }

    void Dolphin013() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N116);
            gl_.glVertex3dv(P116);
            gl_.glNormal3dv(N117);
            gl_.glVertex3dv(P117);
            gl_.glNormal3dv(N112);
            gl_.glVertex3dv(P112);
            gl_.glNormal3dv(N113);
            gl_.glVertex3dv(P113);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N114);
            gl_.glVertex3dv(P114);
            gl_.glNormal3dv(N113);
            gl_.glVertex3dv(P113);
            gl_.glNormal3dv(N112);
            gl_.glVertex3dv(P112);
            gl_.glNormal3dv(N115);
            gl_.glVertex3dv(P115);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N114);
            gl_.glVertex3dv(P114);
            gl_.glNormal3dv(N116);
            gl_.glVertex3dv(P116);
            gl_.glNormal3dv(N113);
            gl_.glVertex3dv(P113);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N114);
            gl_.glVertex3dv(P114);
            gl_.glNormal3dv(N007);
            gl_.glVertex3dv(P007);
            gl_.glNormal3dv(N116);
            gl_.glVertex3dv(P116);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N007);
            gl_.glVertex3dv(P007);
            gl_.glNormal3dv(N002);
            gl_.glVertex3dv(P002);
            gl_.glNormal3dv(N116);
            gl_.glVertex3dv(P116);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P002);
            gl_.glVertex3dv(P007);
            gl_.glVertex3dv(P008);
            gl_.glVertex3dv(P099);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P007);
            gl_.glVertex3dv(P114);
            gl_.glVertex3dv(P115);
            gl_.glVertex3dv(P008);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N117);
            gl_.glVertex3dv(P117);
            gl_.glNormal3dv(N099);
            gl_.glVertex3dv(P099);
            gl_.glNormal3dv(N008);
            gl_.glVertex3dv(P008);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N117);
            gl_.glVertex3dv(P117);
            gl_.glNormal3dv(N008);
            gl_.glVertex3dv(P008);
            gl_.glNormal3dv(N112);
            gl_.glVertex3dv(P112);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N112);
            gl_.glVertex3dv(P112);
            gl_.glNormal3dv(N008);
            gl_.glVertex3dv(P008);
            gl_.glNormal3dv(N115);
            gl_.glVertex3dv(P115);
        gl_.glEnd();
      }

    void Dolphin014() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N111);
            gl_.glVertex3dv(P111);
            gl_.glNormal3dv(N110);
            gl_.glVertex3dv(P110);
            gl_.glNormal3dv(N102);
            gl_.glVertex3dv(P102);
            gl_.glNormal3dv(N121);
            gl_.glVertex3dv(P121);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N111);
            gl_.glVertex3dv(P111);
            gl_.glNormal3dv(N097);
            gl_.glVertex3dv(P097);
            gl_.glNormal3dv(N110);
            gl_.glVertex3dv(P110);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N097);
            gl_.glVertex3dv(P097);
            gl_.glNormal3dv(N119);
            gl_.glVertex3dv(P119);
            gl_.glNormal3dv(N110);
            gl_.glVertex3dv(P110);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N097);
            gl_.glVertex3dv(P097);
            gl_.glNormal3dv(N099);
            gl_.glVertex3dv(P099);
            gl_.glNormal3dv(N119);
            gl_.glVertex3dv(P119);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N099);
            gl_.glVertex3dv(P099);
            gl_.glNormal3dv(N065);
            gl_.glVertex3dv(P065);
            gl_.glNormal3dv(N119);
            gl_.glVertex3dv(P119);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N065);
            gl_.glVertex3dv(P065);
            gl_.glNormal3dv(N066);
            gl_.glVertex3dv(P066);
            gl_.glNormal3dv(N119);
            gl_.glVertex3dv(P119);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P098);
            gl_.glVertex3dv(P097);
            gl_.glVertex3dv(P111);
            gl_.glVertex3dv(P121);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P002);
            gl_.glVertex3dv(P099);
            gl_.glVertex3dv(P097);
            gl_.glVertex3dv(P098);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N110);
            gl_.glVertex3dv(P110);
            gl_.glNormal3dv(N119);
            gl_.glVertex3dv(P119);
            gl_.glNormal3dv(N118);
            gl_.glVertex3dv(P118);
            gl_.glNormal3dv(N102);
            gl_.glVertex3dv(P102);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N119);
            gl_.glVertex3dv(P119);
            gl_.glNormal3dv(N066);
            gl_.glVertex3dv(P066);
            gl_.glNormal3dv(N067);
            gl_.glVertex3dv(P067);
            gl_.glNormal3dv(N118);
            gl_.glVertex3dv(P118);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N067);
            gl_.glVertex3dv(P067);
            gl_.glNormal3dv(N060);
            gl_.glVertex3dv(P060);
            gl_.glNormal3dv(N002);
            gl_.glVertex3dv(P002);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N067);
            gl_.glVertex3dv(P067);
            gl_.glNormal3dv(N002);
            gl_.glVertex3dv(P002);
            gl_.glNormal3dv(N118);
            gl_.glVertex3dv(P118);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N118);
            gl_.glVertex3dv(P118);
            gl_.glNormal3dv(N002);
            gl_.glVertex3dv(P002);
            gl_.glNormal3dv(N098);
            gl_.glVertex3dv(P098);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N118);
            gl_.glVertex3dv(P118);
            gl_.glNormal3dv(N098);
            gl_.glVertex3dv(P098);
            gl_.glNormal3dv(N102);
            gl_.glVertex3dv(P102);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N102);
            gl_.glVertex3dv(P102);
            gl_.glNormal3dv(N098);
            gl_.glVertex3dv(P098);
            gl_.glNormal3dv(N121);
            gl_.glVertex3dv(P121);
        gl_.glEnd();
      }

    void Dolphin015() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N055);
            gl_.glVertex3dv(P055);
            gl_.glNormal3dv(N003);
            gl_.glVertex3dv(P003);
            gl_.glNormal3dv(N054);
            gl_.glVertex3dv(P054);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N003);
            gl_.glVertex3dv(P003);
            gl_.glNormal3dv(N055);
            gl_.glVertex3dv(P055);
            gl_.glNormal3dv(N063);
            gl_.glVertex3dv(P063);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N003);
            gl_.glVertex3dv(P003);
            gl_.glNormal3dv(N063);
            gl_.glVertex3dv(P063);
            gl_.glNormal3dv(N100);
            gl_.glVertex3dv(P100);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N003);
            gl_.glVertex3dv(P003);
            gl_.glNormal3dv(N100);
            gl_.glVertex3dv(P100);
            gl_.glNormal3dv(N054);
            gl_.glVertex3dv(P054);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N054);
            gl_.glVertex3dv(P054);
            gl_.glNormal3dv(N100);
            gl_.glVertex3dv(P100);
            gl_.glNormal3dv(N062);
            gl_.glVertex3dv(P062);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N100);
            gl_.glVertex3dv(P100);
            gl_.glNormal3dv(N064);
            gl_.glVertex3dv(P064);
            gl_.glNormal3dv(N120);
            gl_.glVertex3dv(P120);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N100);
            gl_.glVertex3dv(P100);
            gl_.glNormal3dv(N063);
            gl_.glVertex3dv(P063);
            gl_.glNormal3dv(N064);
            gl_.glVertex3dv(P064);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N063);
            gl_.glVertex3dv(P063);
            gl_.glNormal3dv(N006);
            gl_.glVertex3dv(P006);
            gl_.glNormal3dv(N064);
            gl_.glVertex3dv(P064);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N064);
            gl_.glVertex3dv(P064);
            gl_.glNormal3dv(N006);
            gl_.glVertex3dv(P006);
            gl_.glNormal3dv(N099);
            gl_.glVertex3dv(P099);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N064);
            gl_.glVertex3dv(P064);
            gl_.glNormal3dv(N099);
            gl_.glVertex3dv(P099);
            gl_.glNormal3dv(N117);
            gl_.glVertex3dv(P117);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N120);
            gl_.glVertex3dv(P120);
            gl_.glNormal3dv(N064);
            gl_.glVertex3dv(P064);
            gl_.glNormal3dv(N117);
            gl_.glVertex3dv(P117);
            gl_.glNormal3dv(N116);
            gl_.glVertex3dv(P116);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N006);
            gl_.glVertex3dv(P006);
            gl_.glNormal3dv(N065);
            gl_.glVertex3dv(P065);
            gl_.glNormal3dv(N099);
            gl_.glVertex3dv(P099);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N062);
            gl_.glVertex3dv(P062);
            gl_.glNormal3dv(N100);
            gl_.glVertex3dv(P100);
            gl_.glNormal3dv(N120);
            gl_.glVertex3dv(P120);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N005);
            gl_.glVertex3dv(P005);
            gl_.glNormal3dv(N062);
            gl_.glVertex3dv(P062);
            gl_.glNormal3dv(N120);
            gl_.glVertex3dv(P120);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N005);
            gl_.glVertex3dv(P005);
            gl_.glNormal3dv(N120);
            gl_.glVertex3dv(P120);
            gl_.glNormal3dv(N002);
            gl_.glVertex3dv(P002);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N002);
            gl_.glVertex3dv(P002);
            gl_.glNormal3dv(N120);
            gl_.glVertex3dv(P120);
            gl_.glNormal3dv(N116);
            gl_.glVertex3dv(P116);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N060);
            gl_.glVertex3dv(P060);
            gl_.glNormal3dv(N005);
            gl_.glVertex3dv(P005);
            gl_.glNormal3dv(N002);
            gl_.glVertex3dv(P002);
        gl_.glEnd();
      }

    void Dolphin016() throws OpenGLException {

        gl_.glDisable( GL.GL_DEPTH_TEST );
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P123);
            gl_.glVertex3dv(P124);
            gl_.glVertex3dv(P125);
            gl_.glVertex3dv(P126);
            gl_.glVertex3dv(P127);
            gl_.glVertex3dv(P128);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P129);
            gl_.glVertex3dv(P130);
            gl_.glVertex3dv(P131);
            gl_.glVertex3dv(P132);
            gl_.glVertex3dv(P133);
            gl_.glVertex3dv(P134);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P103);
            gl_.glVertex3dv(P105);
            gl_.glVertex3dv(P108);
        gl_.glEnd();
        gl_.glEnable( GL.GL_DEPTH_TEST );
      }

    public void draw() {
        float seg0, seg1, seg2, seg3, seg4, seg5, seg6, seg7;
        float pitch, thrash, chomp;

        htail = (int)( htail - (int)( 10.0 * v ) ) % 360;

        thrash = (float)( 70.0 * v );

        seg0 = (float)( 1.0 * thrash * Math.sin((htail) * atlantis.RRAD) );
        seg3 = (float)( 1.0 * thrash * Math.sin((htail) * atlantis.RRAD) );
        seg1 = (float)( 2.0 * thrash * Math.sin((htail + 4.0) * atlantis.RRAD) );
        seg2 = (float)( 3.0 * thrash * Math.sin((htail + 6.0) * atlantis.RRAD) );
        seg4 = (float)( 4.0 * thrash * Math.sin((htail + 10.0) * atlantis.RRAD) );
        seg5 = (float)( 4.5 * thrash * Math.sin((htail + 15.0) * atlantis.RRAD) );
        seg6 = (float)( 5.0 * thrash * Math.sin((htail + 20.0) * atlantis.RRAD) );
        seg7 = (float)( 6.0 * thrash * Math.sin((htail + 30.0) * atlantis.RRAD) );

        pitch = (float)( v * Math.sin((htail + 180.0) * atlantis.RRAD) );

        if (v > 2.0) {
            chomp = -(float)( (v - 2.0) * 200.0 );
          }
        chomp = 100.0f;

        P012[1] = iP012[1] + seg5;
        P013[1] = iP013[1] + seg5;
        P014[1] = iP014[1] + seg5;
        P015[1] = iP015[1] + seg5;
        P016[1] = iP016[1] + seg5;
        P017[1] = iP017[1] + seg5;
        P018[1] = iP018[1] + seg5;
        P019[1] = iP019[1] + seg5;

        P020[1] = iP020[1] + seg4;
        P021[1] = iP021[1] + seg4;
        P022[1] = iP022[1] + seg4;
        P023[1] = iP023[1] + seg4;
        P024[1] = iP024[1] + seg4;
        P025[1] = iP025[1] + seg4;
        P026[1] = iP026[1] + seg4;
        P027[1] = iP027[1] + seg4;

        P028[1] = iP028[1] + seg2;
        P029[1] = iP029[1] + seg2;
        P030[1] = iP030[1] + seg2;
        P031[1] = iP031[1] + seg2;
        P032[1] = iP032[1] + seg2;
        P033[1] = iP033[1] + seg2;
        P034[1] = iP034[1] + seg2;
        P035[1] = iP035[1] + seg2;

        P036[1] = iP036[1] + seg1;
        P037[1] = iP037[1] + seg1;
        P038[1] = iP038[1] + seg1;
        P039[1] = iP039[1] + seg1;
        P040[1] = iP040[1] + seg1;
        P041[1] = iP041[1] + seg1;
        P042[1] = iP042[1] + seg1;
        P043[1] = iP043[1] + seg1;

        P044[1] = iP044[1] + seg0;
        P045[1] = iP045[1] + seg0;
        P046[1] = iP046[1] + seg0;
        P047[1] = iP047[1] + seg0;
        P048[1] = iP048[1] + seg0;
        P049[1] = iP049[1] + seg0;
        P050[1] = iP050[1] + seg0;
        P051[1] = iP051[1] + seg0;

        P009[1] = iP009[1] + seg6;
        P010[1] = iP010[1] + seg6;
        P075[1] = iP075[1] + seg6;
        P076[1] = iP076[1] + seg6;
    
        P001[1] = iP001[1] + seg7;
        P011[1] = iP011[1] + seg7;
        P068[1] = iP068[1] + seg7;
        P069[1] = iP069[1] + seg7;
        P070[1] = iP070[1] + seg7;
        P071[1] = iP071[1] + seg7;
        P072[1] = iP072[1] + seg7;
        P073[1] = iP073[1] + seg7;
        P074[1] = iP074[1] + seg7;
    
        P091[1] = iP091[1] + seg3;
        P092[1] = iP092[1] + seg3;
        P093[1] = iP093[1] + seg3;
        P094[1] = iP094[1] + seg3;
        P095[1] = iP095[1] + seg3;
        P122[1] = iP122[1] + seg3 * 1.5;

        P097[1] = iP097[1] + chomp;
        P098[1] = iP098[1] + chomp;
        P102[1] = iP102[1] + chomp;
        P110[1] = iP110[1] + chomp;
        P111[1] = iP111[1] + chomp;
        P121[1] = iP121[1] + chomp;
        P118[1] = iP118[1] + chomp;
        P119[1] = iP119[1] + chomp;

        try {
            gl_.glPushMatrix();

            gl_.glRotatef(pitch, 1.0f, 0.0f, 0.0f);

            gl_.glTranslatef(0.0f, 0.0f, 7000.0f);

            gl_.glRotatef(180.0f, 0.0f, 1.0f, 0.0f);

            gl_.glEnable( GL.GL_CULL_FACE );

            Dolphin014();
            Dolphin010();
            Dolphin009();
            Dolphin012();
            Dolphin013();
            Dolphin006();
            Dolphin002();
            Dolphin001();
            Dolphin003();
            Dolphin015();
            Dolphin004();
            Dolphin005();
            Dolphin007();
            Dolphin008();
            Dolphin011();
            Dolphin016();

            gl_.glDisable( GL.GL_CULL_FACE );

            gl_.glPopMatrix();
          } catch ( OpenGLException e ) {
            e.printStackTrace();
          }
      }
  }
