/**
 * $Id: fish.java,v 1.4 1998/10/19 10:40:38 descarte Exp descarte $
 *
 * Copyright (C)1997-1998 Arcane Technologies Ltd. <http://www.arcana.co.uk>
 *
 * General fields common to all piscine plapperers...
 *
 * $Log: fish.java,v $
 * Revision 1.4  1998/10/19 10:40:38  descarte
 * Made JDK-1.1 compliant by removing deprecated methods. Updated copyright.
 *
 * Revision 1.3  1998/06/07 13:53:55  descarte
 * Converted from COM.hermetica.* to com.hermetica.* hierarchy
 *
 * Revision 1.2  1998/01/04 17:31:09  descarte
 * Added default constructor for pipeline propagation.
 *
 * Revision 1.1  1997/11/05 18:57:27  descarte
 * Initial revision
 *
 */

package com.hermetica.magician.demos.atlantis;

import com.hermetica.magician.*;
import com.hermetica.vecmath.*;

public class fish {

    /** The OpenGL state machine */
    GL gl_ = null;
    GLU glu_ = null;

    /** Location of the fish in space, or, water... */
    public Vec3f position = new Vec3f();

    /** Phi angle */
    public float phi;

    /** Theta angle */
    public float theta;

    /** Psi angle */
    public float psi;

    /** Speed */
    public float v;

    /** Transformed location */
    public Vec3f tPosition = new Vec3f();

    /** htail */
    public float htail;

    /** vtail */
    public float vtail;

    /** dtheta */
    public float dtheta;

    /** spurt */
    public int spurt;

    /** attack */
    public int attack;

    /** Constructor for all fish types */
    public fish( GL gl_, GLU glu_ ) {
        this.gl_ = gl_;
        this.glu_ = glu_;
      }

    /** Transforms the fish in water */
    public void transform() {
        try {
            gl_.glTranslatef( (float)position.y, (float)position.z, -(float)position.x );
            gl_.glRotatef( (float)-psi, 0.0f, 1.0f, 0.0f );
            gl_.glRotatef( (float)theta, 1.0f, 0.0f, 0.0f );
            gl_.glRotatef( (float)-phi, 0.0f, 0.0f, 1.0f );
          } catch ( OpenGLException e ) {
            e.printStackTrace();
          }
      }

    /** Pilot method. This only overridden for sharks */
    public void pilot() {
        phi = -20.0f;
        theta = 0.0f;
        psi -= 0.5f;

        position.x += 
            (float)( whale.WHALESPEED * v * Math.cos( psi / atlantis.RAD ) *
                                      Math.cos( theta / atlantis.RAD ) );
        position.y += 
            (float)( whale.WHALESPEED * v * Math.sin( psi / atlantis.RAD ) *
                                      Math.cos( theta / atlantis.RAD ) );
        position.z += 
            (float)( whale.WHALESPEED * v * Math.sin( theta / atlantis.RAD ) );
      }
  }
