/**
 * (c) Copyright 1993, 1994, Silicon Graphics, Inc.
 * ALL RIGHTS RESERVED
 * Permission to use, copy, modify, and distribute this software for
 * any purpose and without fee is hereby granted, provided that the above
 * copyright notice appear in all copies and that both the copyright notice
 * and this permission notice appear in supporting documentation, and that
 * the name of Silicon Graphics, Inc. not be used in advertising
 * or publicity pertaining to distribution of the software without specific,
 * written prior permission.
 *
 * THE MATERIAL EMBODIED ON THIS SOFTWARE IS PROVIDED TO YOU "AS-IS"
 * AND WITHOUT WARRANTY OF ANY KIND, EXPRESS, IMPLIED OR OTHERWISE,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF MERCHANTABILITY OR
 * FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT SHALL SILICON
 * GRAPHICS, INC.  BE LIABLE TO YOU OR ANYONE ELSE FOR ANY DIRECT,
 * SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY
 * KIND, OR ANY DAMAGES WHATSOEVER, INCLUDING WITHOUT LIMITATION,
 * LOSS OF PROFIT, LOSS OF USE, SAVINGS OR REVENUE, OR THE CLAIMS OF
 * THIRD PARTIES, WHETHER OR NOT SILICON GRAPHICS, INC.  HAS BEEN
 * ADVISED OF THE POSSIBILITY OF SUCH LOSS, HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE
 * POSSESSION, USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * US Government Users Restricted Rights
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions set forth in FAR 52.227.19(c)(2) or subparagraph
 * (c)(1)(ii) of the Rights in Technical Data and Computer Software
 * clause at DFARS 252.227-7013 and/or in similar or successor
 * clauses in the FAR or the DOD or NASA FAR Supplement.
 * Unpublished-- rights reserved under the copyright laws of the
 * United States.  Contractor/manufacturer is Silicon Graphics,
 * Inc., 2011 N.  Shoreline Blvd., Mountain View, CA 94039-7311.
 *
 * OpenGL(TM) is a trademark of Silicon Graphics, Inc.
 */

/**
 * $Id: shark.java,v 1.5 1998/10/19 10:40:50 descarte Exp descarte $
 *
 * Copyright (c)1997-1998 Arcane Technologies Ltd. <http://www.arcana.co.uk>
 *
 * Java conversion
 *
 * $Log: shark.java,v $
 * Revision 1.5  1998/10/19 10:40:50  descarte
 * Made JDK-1.1 compliant by removing deprecated methods. Updated copyright.
 *
 * Revision 1.4  1998/06/07 13:53:55  descarte
 * Converted from COM.hermetica.* to com.hermetica.* hierarchy
 *
 * Revision 1.3  1998/03/30 01:08:41  descarte
 * Made draw() method public instead of private. This fouled up applets.
 *
 * Revision 1.2  1998/01/04 17:31:32  descarte
 * Added default constructor for pipeline propagation.
 *
 * Revision 1.1  1997/08/08 17:29:54  descarte
 * Initial revision
 *
 */

package com.hermetica.magician.demos.atlantis;

import com.hermetica.magician.*;
import com.hermetica.vecmath.*;

public class shark extends fish {

    /** The OpenGL state machine */
//    GL gl_ = new GL();

    /** Speed of a shark */
    public static final float SHARKSPEED = 100.0f;

    /** Size of a shark */
    public static final float SHARKSIZE = 6000;

    static double[] N002 = {0.000077 ,-0.020611 ,0.999788};
    static double[] N003 = {0.961425 ,0.258729 ,-0.093390};
    static double[] N004 = {0.510811 ,-0.769633 ,-0.383063};
    static double[] N005 = {0.400123 ,0.855734 ,-0.328055};
    static double[] N006 = {-0.770715 ,0.610204 ,-0.183440};
    static double[] N007 = {-0.915597 ,-0.373345 ,-0.149316};
    static double[] N008 = {-0.972788 ,0.208921 ,-0.100179};
    static double[] N009 = {-0.939713 ,-0.312268 ,-0.139383};
    static double[] N010 = {-0.624138 ,-0.741047 ,-0.247589};
    static double[] N011 = {0.591434 ,-0.768401 ,-0.244471};
    static double[] N012 = {0.935152 ,-0.328495 ,-0.132598};
    static double[] N013 = {0.997102 ,0.074243 ,-0.016593};
    static double[] N014 = {0.969995 ,0.241712 ,-0.026186};
    static double[] N015 = {0.844539 ,0.502628 ,-0.184714};
    static double[] N016 = {-0.906608 ,0.386308 ,-0.169787};
    static double[] N017 = {-0.970016 ,0.241698 ,-0.025516};
    static double[] N018 = {-0.998652 ,0.050493 ,-0.012045};
    static double[] N019 = {-0.942685 ,-0.333051 ,-0.020556};
    static double[] N020 = {-0.660944 ,-0.750276 ,0.015480};
    static double[] N021 = {0.503549 ,-0.862908 ,-0.042749};
    static double[] N022 = {0.953202 ,-0.302092 ,-0.012089};
    static double[] N023 = {0.998738 ,0.023574 ,0.044344};
    static double[] N024 = {0.979297 ,0.193272 ,0.060202};
    static double[] N025 = {0.798300 ,0.464885 ,0.382883};
    static double[] N026 = {-0.756590 ,0.452403 ,0.472126};
    static double[] N027 = {-0.953855 ,0.293003 ,0.065651};
    static double[] N028 = {-0.998033 ,0.040292 ,0.048028};
    static double[] N029 = {-0.977079 ,-0.204288 ,0.059858};
    static double[] N030 = {-0.729117 ,-0.675304 ,0.111140};
    static double[] N031 = {0.598361 ,-0.792753 ,0.116221};
    static double[] N032 = {0.965192 ,-0.252991 ,0.066332};
    static double[] N033 = {0.998201 ,-0.002790 ,0.059892};
    static double[] N034 = {0.978657 ,0.193135 ,0.070207};
    static double[] N035 = {0.718815 ,0.680392 ,0.142733};
    static double[] N036 = {-0.383096 ,0.906212 ,0.178936};
    static double[] N037 = {-0.952831 ,0.292590 ,0.080647};
    static double[] N038 = {-0.997680 ,0.032417 ,0.059861};
    static double[] N039 = {-0.982629 ,-0.169881 ,0.074700};
    static double[] N040 = {-0.695424 ,-0.703466 ,0.146700};
    static double[] N041 = {0.359323 ,-0.915531 ,0.180805};
    static double[] N042 = {0.943356 ,-0.319387 ,0.089842};
    static double[] N043 = {0.998272 ,-0.032435 ,0.048993};
    static double[] N044 = {0.978997 ,0.193205 ,0.065084};
    static double[] N045 = {0.872144 ,0.470094 ,-0.135565};
    static double[] N046 = {-0.664282 ,0.737945 ,-0.119027};
    static double[] N047 = {-0.954508 ,0.288570 ,0.075107};
    static double[] N048 = {-0.998273 ,0.032406 ,0.048993};
    static double[] N049 = {-0.979908 ,-0.193579 ,0.048038};
    static double[] N050 = {-0.858736 ,-0.507202 ,-0.072938};
    static double[] N051 = {0.643545 ,-0.763887 ,-0.048237};
    static double[] N052 = {0.955580 ,-0.288954 ,0.058068};
    static double[] N058 = {0.000050 ,0.793007 ,-0.609213};
    static double[] N059 = {0.913510 ,0.235418 ,-0.331779};
    static double[] N060 = {-0.807970 ,0.495000 ,-0.319625};
    static double[] N061 = {0.000000 ,0.784687 ,-0.619892};
    static double[] N062 = {0.000000 ,-1.000000 ,0.000000};
    static double[] N063 = {0.000000 ,1.000000 ,0.000000};
    static double[] N064 = {0.000000 ,1.000000 ,0.000000};
    static double[] N065 = {0.000000 ,1.000000 ,0.000000};
    static double[] N066 = {-0.055784 ,0.257059 ,0.964784};
    static double[] N069 = {-0.000505 ,-0.929775 ,-0.368127};
    static double[] N070 = {0.000000 ,1.000000 ,0.000000};
    static double[] P002 = {0.00, -36.59, 5687.72};
    static double[] P003 = {90.00, 114.73, 724.38};
    static double[] P004 = {58.24, -146.84, 262.35};
    static double[] P005 = {27.81, 231.52, 510.43};
    static double[] P006 = {-27.81, 230.43, 509.76};
    static double[] P007 = {-46.09, -146.83, 265.84};
    static double[] P008 = {-90.00, 103.84, 718.53};
    static double[] P009 = {-131.10, -165.92, 834.85};
    static double[] P010 = {-27.81, -285.31, 500.00};
    static double[] P011 = {27.81, -285.32, 500.00};
    static double[] P012 = {147.96, -170.89, 845.50};
    static double[] P013 = {180.00, 0.00, 2000.00};
    static double[] P014 = {145.62, 352.67, 2000.00};
    static double[] P015 = {55.62, 570.63, 2000.00};
    static double[] P016 = {-55.62, 570.64, 2000.00};
    static double[] P017 = {-145.62, 352.68, 2000.00};
    static double[] P018 = {-180.00, 0.01, 2000.00};
    static double[] P019 = {-178.20, -352.66, 2001.61};
    static double[] P020 = {-55.63, -570.63, 2000.00};
    static double[] P021 = {55.62, -570.64, 2000.00};
    static double[] P022 = {179.91, -352.69, 1998.39};
    static double[] P023 = {150.00, 0.00, 3000.00};
    static double[] P024 = {121.35, 293.89, 3000.00};
    static double[] P025 = {46.35, 502.93, 2883.09};
    static double[] P026 = {-46.35, 497.45, 2877.24};
    static double[] P027 = {-121.35, 293.90, 3000.00};
    static double[] P028 = {-150.00, 0.00, 3000.00};
    static double[] P029 = {-152.21, -304.84, 2858.68};
    static double[] P030 = {-46.36, -475.52, 3000.00};
    static double[] P031 = {46.35, -475.53, 3000.00};
    static double[] P032 = {155.64, -304.87, 2863.50};
    static double[] P033 = {90.00, 0.00, 4000.00};
    static double[] P034 = {72.81, 176.33, 4000.00};
    static double[] P035 = {27.81, 285.32, 4000.00};
    static double[] P036 = {-27.81, 285.32, 4000.00};
    static double[] P037 = {-72.81, 176.34, 4000.00};
    static double[] P038 = {-90.00, 0.00, 4000.00};
    static double[] P039 = {-72.81, -176.33, 4000.00};
    static double[] P040 = {-27.81, -285.31, 4000.00};
    static double[] P041 = {27.81, -285.32, 4000.00};
    static double[] P042 = {72.81, -176.34, 4000.00};
    static double[] P043 = {30.00, 0.00, 5000.00};
    static double[] P044 = {24.27, 58.78, 5000.00};
    static double[] P045 = {9.27, 95.11, 5000.00};
    static double[] P046 = {-9.27, 95.11, 5000.00};
    static double[] P047 = {-24.27, 58.78, 5000.00};
    static double[] P048 = {-30.00, 0.00, 5000.00};
    static double[] P049 = {-24.27, -58.78, 5000.00};
    static double[] P050 = {-9.27, -95.10, 5000.00};
    static double[] P051 = {9.27, -95.11, 5000.00};
    static double[] P052 = {24.27, -58.78, 5000.00};
    static double[] P058 = {0.00, 1212.72, 2703.08};
    static double[] P059 = {50.36, 0.00, 108.14};
    static double[] P060 = {-22.18, 0.00, 108.14};
    static double[] P061 = {0.00, 1181.61, 6344.65};
    static double[] P062 = {516.45, -887.08, 2535.45};
    static double[] P063 = {-545.69, -879.31, 2555.63};
    static double[] P064 = {618.89, -1005.64, 2988.32};
    static double[] P065 = {-635.37, -1014.79, 2938.68};
    static double[] P066 = {0.00, 1374.43, 3064.18};
    static double[] P069 = {0.00, -418.25, 5765.04};
    static double[] P070 = {0.00, 1266.91, 6629.60};
    static double[] P071 = {-139.12, -124.96, 997.98};
    static double[] P072 = {-139.24, -110.18, 1020.68};
    static double[] P073 = {-137.33, -94.52, 1022.63};
    static double[] P074 = {-137.03, -79.91, 996.89};
    static double[] P075 = {-135.21, -91.48, 969.14};
    static double[] P076 = {-135.39, -110.87, 968.76};
    static double[] P077 = {150.23, -78.44, 995.53};
    static double[] P078 = {152.79, -92.76, 1018.46};
    static double[] P079 = {154.19, -110.20, 1020.55};
    static double[] P080 = {151.33, -124.15, 993.77};
    static double[] P081 = {150.49, -111.19, 969.86};
    static double[] P082 = {150.79, -92.41, 969.70};
    static double[] iP002 = {0.00, -36.59, 5687.72};
    static double[] iP004 = {58.24, -146.84, 262.35};
    static double[] iP007 = {-46.09, -146.83, 265.84};
    static double[] iP010 = {-27.81, -285.31, 500.00};
    static double[] iP011 = {27.81, -285.32, 500.00};
    static double[] iP023 = {150.00, 0.00, 3000.00};
    static double[] iP024 = {121.35, 293.89, 3000.00};
    static double[] iP025 = {46.35, 502.93, 2883.09};
    static double[] iP026 = {-46.35, 497.45, 2877.24};
    static double[] iP027 = {-121.35, 293.90, 3000.00};
    static double[] iP028 = {-150.00, 0.00, 3000.00};
    static double[] iP029 = {-121.35, -304.84, 2853.86};
    static double[] iP030 = {-46.36, -475.52, 3000.00};
    static double[] iP031 = {46.35, -475.53, 3000.00};
    static double[] iP032 = {121.35, -304.87, 2853.86};
    static double[] iP033 = {90.00, 0.00, 4000.00};
    static double[] iP034 = {72.81, 176.33, 4000.00};
    static double[] iP035 = {27.81, 285.32, 4000.00};
    static double[] iP036 = {-27.81, 285.32, 4000.00};
    static double[] iP037 = {-72.81, 176.34, 4000.00};
    static double[] iP038 = {-90.00, 0.00, 4000.00};
    static double[] iP039 = {-72.81, -176.33, 4000.00};
    static double[] iP040 = {-27.81, -285.31, 4000.00};
    static double[] iP041 = {27.81, -285.32, 4000.00};
    static double[] iP042 = {72.81, -176.34, 4000.00};
    static double[] iP043 = {30.00, 0.00, 5000.00};
    static double[] iP044 = {24.27, 58.78, 5000.00};
    static double[] iP045 = {9.27, 95.11, 5000.00};
    static double[] iP046 = {-9.27, 95.11, 5000.00};
    static double[] iP047 = {-24.27, 58.78, 5000.00};
    static double[] iP048 = {-30.00, 0.00, 5000.00};
    static double[] iP049 = {-24.27, -58.78, 5000.00};
    static double[] iP050 = {-9.27, -95.10, 5000.00};
    static double[] iP051 = {9.27, -95.11, 5000.00};
    static double[] iP052 = {24.27, -58.78, 5000.00};
    static double[] iP061 = {0.00, 1181.61, 6344.65};
    static double[] iP069 = {0.00, -418.25, 5765.04};
    static double[] iP070 = {0.00, 1266.91, 6629.60};

    /** Constructor simply calls the fish constructor */
    public shark( GL gl_, GLU glu_ ) {
        super( gl_, glu_ );
      }

    void Fish001() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N005);
            gl_.glVertex3dv(P005);
            gl_.glNormal3dv(N059);
            gl_.glVertex3dv(P059);
            gl_.glNormal3dv(N060);
            gl_.glVertex3dv(P060);
            gl_.glNormal3dv(N006);
            gl_.glVertex3dv(P006);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N015);
            gl_.glVertex3dv(P015);
            gl_.glNormal3dv(N005);
            gl_.glVertex3dv(P005);
            gl_.glNormal3dv(N006);
            gl_.glVertex3dv(P006);
            gl_.glNormal3dv(N016);
            gl_.glVertex3dv(P016);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N006);
            gl_.glVertex3dv(P006);
            gl_.glNormal3dv(N060);
            gl_.glVertex3dv(P060);
            gl_.glNormal3dv(N008);
            gl_.glVertex3dv(P008);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N016);
            gl_.glVertex3dv(P016);
            gl_.glNormal3dv(N006);
            gl_.glVertex3dv(P006);
            gl_.glNormal3dv(N008);
            gl_.glVertex3dv(P008);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N016);
            gl_.glVertex3dv(P016);
            gl_.glNormal3dv(N008);
            gl_.glVertex3dv(P008);
            gl_.glNormal3dv(N017);
            gl_.glVertex3dv(P017);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N017);
            gl_.glVertex3dv(P017);
            gl_.glNormal3dv(N008);
            gl_.glVertex3dv(P008);
            gl_.glNormal3dv(N018);
            gl_.glVertex3dv(P018);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N008);
            gl_.glVertex3dv(P008);
            gl_.glNormal3dv(N009);
            gl_.glVertex3dv(P009);
            gl_.glNormal3dv(N018);
            gl_.glVertex3dv(P018);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N008);
            gl_.glVertex3dv(P008);
            gl_.glNormal3dv(N060);
            gl_.glVertex3dv(P060);
            gl_.glNormal3dv(N009);
            gl_.glVertex3dv(P009);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N007);
            gl_.glVertex3dv(P007);
            gl_.glNormal3dv(N010);
            gl_.glVertex3dv(P010);
            gl_.glNormal3dv(N009);
            gl_.glVertex3dv(P009);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N009);
            gl_.glVertex3dv(P009);
            gl_.glNormal3dv(N019);
            gl_.glVertex3dv(P019);
            gl_.glNormal3dv(N018);
            gl_.glVertex3dv(P018);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N009);
            gl_.glVertex3dv(P009);
            gl_.glNormal3dv(N010);
            gl_.glVertex3dv(P010);
            gl_.glNormal3dv(N019);
            gl_.glVertex3dv(P019);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N010);
            gl_.glVertex3dv(P010);
            gl_.glNormal3dv(N020);
            gl_.glVertex3dv(P020);
            gl_.glNormal3dv(N019);
            gl_.glVertex3dv(P019);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N010);
            gl_.glVertex3dv(P010);
            gl_.glNormal3dv(N011);
            gl_.glVertex3dv(P011);
            gl_.glNormal3dv(N021);
            gl_.glVertex3dv(P021);
            gl_.glNormal3dv(N020);
            gl_.glVertex3dv(P020);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N004);
            gl_.glVertex3dv(P004);
            gl_.glNormal3dv(N011);
            gl_.glVertex3dv(P011);
            gl_.glNormal3dv(N010);
            gl_.glVertex3dv(P010);
            gl_.glNormal3dv(N007);
            gl_.glVertex3dv(P007);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N004);
            gl_.glVertex3dv(P004);
            gl_.glNormal3dv(N012);
            gl_.glVertex3dv(P012);
            gl_.glNormal3dv(N011);
            gl_.glVertex3dv(P011);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N012);
            gl_.glVertex3dv(P012);
            gl_.glNormal3dv(N022);
            gl_.glVertex3dv(P022);
            gl_.glNormal3dv(N011);
            gl_.glVertex3dv(P011);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N011);
            gl_.glVertex3dv(P011);
            gl_.glNormal3dv(N022);
            gl_.glVertex3dv(P022);
            gl_.glNormal3dv(N021);
            gl_.glVertex3dv(P021);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N059);
            gl_.glVertex3dv(P059);
            gl_.glNormal3dv(N005);
            gl_.glVertex3dv(P005);
            gl_.glNormal3dv(N015);
            gl_.glVertex3dv(P015);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N015);
            gl_.glVertex3dv(P015);
            gl_.glNormal3dv(N014);
            gl_.glVertex3dv(P014);
            gl_.glNormal3dv(N003);
            gl_.glVertex3dv(P003);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N015);
            gl_.glVertex3dv(P015);
            gl_.glNormal3dv(N003);
            gl_.glVertex3dv(P003);
            gl_.glNormal3dv(N059);
            gl_.glVertex3dv(P059);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N014);
            gl_.glVertex3dv(P014);
            gl_.glNormal3dv(N013);
            gl_.glVertex3dv(P013);
            gl_.glNormal3dv(N003);
            gl_.glVertex3dv(P003);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N003);
            gl_.glVertex3dv(P003);
            gl_.glNormal3dv(N012);
            gl_.glVertex3dv(P012);
            gl_.glNormal3dv(N059);
            gl_.glVertex3dv(P059);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N013);
            gl_.glVertex3dv(P013);
            gl_.glNormal3dv(N012);
            gl_.glVertex3dv(P012);
            gl_.glNormal3dv(N003);
            gl_.glVertex3dv(P003);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N013);
            gl_.glVertex3dv(P013);
            gl_.glNormal3dv(N022);
            gl_.glVertex3dv(P022);
            gl_.glNormal3dv(N012);
            gl_.glVertex3dv(P012);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P071);
            gl_.glVertex3dv(P072);
            gl_.glVertex3dv(P073);
            gl_.glVertex3dv(P074);
            gl_.glVertex3dv(P075);
            gl_.glVertex3dv(P076);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P077);
            gl_.glVertex3dv(P078);
            gl_.glVertex3dv(P079);
            gl_.glVertex3dv(P080);
            gl_.glVertex3dv(P081);
            gl_.glVertex3dv(P082);
        gl_.glEnd();
      }

    void Fish002() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N013);
            gl_.glVertex3dv(P013);
            gl_.glNormal3dv(N014);
            gl_.glVertex3dv(P014);
            gl_.glNormal3dv(N024);
            gl_.glVertex3dv(P024);
            gl_.glNormal3dv(N023);
            gl_.glVertex3dv(P023);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N014);
            gl_.glVertex3dv(P014);
            gl_.glNormal3dv(N015);
            gl_.glVertex3dv(P015);
            gl_.glNormal3dv(N025);
            gl_.glVertex3dv(P025);
            gl_.glNormal3dv(N024);
            gl_.glVertex3dv(P024);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N016);
            gl_.glVertex3dv(P016);
            gl_.glNormal3dv(N017);
            gl_.glVertex3dv(P017);
            gl_.glNormal3dv(N027);
            gl_.glVertex3dv(P027);
            gl_.glNormal3dv(N026);
            gl_.glVertex3dv(P026);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N017);
            gl_.glVertex3dv(P017);
            gl_.glNormal3dv(N018);
            gl_.glVertex3dv(P018);
            gl_.glNormal3dv(N028);
            gl_.glVertex3dv(P028);
            gl_.glNormal3dv(N027);
            gl_.glVertex3dv(P027);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N020);
            gl_.glVertex3dv(P020);
            gl_.glNormal3dv(N021);
            gl_.glVertex3dv(P021);
            gl_.glNormal3dv(N031);
            gl_.glVertex3dv(P031);
            gl_.glNormal3dv(N030);
            gl_.glVertex3dv(P030);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N013);
            gl_.glVertex3dv(P013);
            gl_.glNormal3dv(N023);
            gl_.glVertex3dv(P023);
            gl_.glNormal3dv(N022);
            gl_.glVertex3dv(P022);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N022);
            gl_.glVertex3dv(P022);
            gl_.glNormal3dv(N023);
            gl_.glVertex3dv(P023);
            gl_.glNormal3dv(N032);
            gl_.glVertex3dv(P032);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N022);
            gl_.glVertex3dv(P022);
            gl_.glNormal3dv(N032);
            gl_.glVertex3dv(P032);
            gl_.glNormal3dv(N031);
            gl_.glVertex3dv(P031);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N022);
            gl_.glVertex3dv(P022);
            gl_.glNormal3dv(N031);
            gl_.glVertex3dv(P031);
            gl_.glNormal3dv(N021);
            gl_.glVertex3dv(P021);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N018);
            gl_.glVertex3dv(P018);
            gl_.glNormal3dv(N019);
            gl_.glVertex3dv(P019);
            gl_.glNormal3dv(N029);
            gl_.glVertex3dv(P029);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N018);
            gl_.glVertex3dv(P018);
            gl_.glNormal3dv(N029);
            gl_.glVertex3dv(P029);
            gl_.glNormal3dv(N028);
            gl_.glVertex3dv(P028);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N019);
            gl_.glVertex3dv(P019);
            gl_.glNormal3dv(N020);
            gl_.glVertex3dv(P020);
            gl_.glNormal3dv(N030);
            gl_.glVertex3dv(P030);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N019);
            gl_.glVertex3dv(P019);
            gl_.glNormal3dv(N030);
            gl_.glVertex3dv(P030);
            gl_.glNormal3dv(N029);
            gl_.glVertex3dv(P029);
        gl_.glEnd();
      }

    void Fish003() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N032);
            gl_.glVertex3dv(P032);
            gl_.glNormal3dv(N023);
            gl_.glVertex3dv(P023);
            gl_.glNormal3dv(N033);
            gl_.glVertex3dv(P033);
            gl_.glNormal3dv(N042);
            gl_.glVertex3dv(P042);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N031);
            gl_.glVertex3dv(P031);
            gl_.glNormal3dv(N032);
            gl_.glVertex3dv(P032);
            gl_.glNormal3dv(N042);
            gl_.glVertex3dv(P042);
            gl_.glNormal3dv(N041);
            gl_.glVertex3dv(P041);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N023);
            gl_.glVertex3dv(P023);
            gl_.glNormal3dv(N024);
            gl_.glVertex3dv(P024);
            gl_.glNormal3dv(N034);
            gl_.glVertex3dv(P034);
            gl_.glNormal3dv(N033);
            gl_.glVertex3dv(P033);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N024);
            gl_.glVertex3dv(P024);
            gl_.glNormal3dv(N025);
            gl_.glVertex3dv(P025);
            gl_.glNormal3dv(N035);
            gl_.glVertex3dv(P035);
            gl_.glNormal3dv(N034);
            gl_.glVertex3dv(P034);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N030);
            gl_.glVertex3dv(P030);
            gl_.glNormal3dv(N031);
            gl_.glVertex3dv(P031);
            gl_.glNormal3dv(N041);
            gl_.glVertex3dv(P041);
            gl_.glNormal3dv(N040);
            gl_.glVertex3dv(P040);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N025);
            gl_.glVertex3dv(P025);
            gl_.glNormal3dv(N026);
            gl_.glVertex3dv(P026);
            gl_.glNormal3dv(N036);
            gl_.glVertex3dv(P036);
            gl_.glNormal3dv(N035);
            gl_.glVertex3dv(P035);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N026);
            gl_.glVertex3dv(P026);
            gl_.glNormal3dv(N027);
            gl_.glVertex3dv(P027);
            gl_.glNormal3dv(N037);
            gl_.glVertex3dv(P037);
            gl_.glNormal3dv(N036);
            gl_.glVertex3dv(P036);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N027);
            gl_.glVertex3dv(P027);
            gl_.glNormal3dv(N028);
            gl_.glVertex3dv(P028);
            gl_.glNormal3dv(N038);
            gl_.glVertex3dv(P038);
            gl_.glNormal3dv(N037);
            gl_.glVertex3dv(P037);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N028);
            gl_.glVertex3dv(P028);
            gl_.glNormal3dv(N029);
            gl_.glVertex3dv(P029);
            gl_.glNormal3dv(N039);
            gl_.glVertex3dv(P039);
            gl_.glNormal3dv(N038);
            gl_.glVertex3dv(P038);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N029);
            gl_.glVertex3dv(P029);
            gl_.glNormal3dv(N030);
            gl_.glVertex3dv(P030);
            gl_.glNormal3dv(N040);
            gl_.glVertex3dv(P040);
            gl_.glNormal3dv(N039);
            gl_.glVertex3dv(P039);
        gl_.glEnd();
      }

    void Fish004() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N040);
            gl_.glVertex3dv(P040);
            gl_.glNormal3dv(N041);
            gl_.glVertex3dv(P041);
            gl_.glNormal3dv(N051);
            gl_.glVertex3dv(P051);
            gl_.glNormal3dv(N050);
            gl_.glVertex3dv(P050);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N041);
            gl_.glVertex3dv(P041);
            gl_.glNormal3dv(N042);
            gl_.glVertex3dv(P042);
            gl_.glNormal3dv(N052);
            gl_.glVertex3dv(P052);
            gl_.glNormal3dv(N051);
            gl_.glVertex3dv(P051);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N042);
            gl_.glVertex3dv(P042);
            gl_.glNormal3dv(N033);
            gl_.glVertex3dv(P033);
            gl_.glNormal3dv(N043);
            gl_.glVertex3dv(P043);
            gl_.glNormal3dv(N052);
            gl_.glVertex3dv(P052);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N033);
            gl_.glVertex3dv(P033);
            gl_.glNormal3dv(N034);
            gl_.glVertex3dv(P034);
            gl_.glNormal3dv(N044);
            gl_.glVertex3dv(P044);
            gl_.glNormal3dv(N043);
            gl_.glVertex3dv(P043);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N034);
            gl_.glVertex3dv(P034);
            gl_.glNormal3dv(N035);
            gl_.glVertex3dv(P035);
            gl_.glNormal3dv(N045);
            gl_.glVertex3dv(P045);
            gl_.glNormal3dv(N044);
            gl_.glVertex3dv(P044);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N035);
            gl_.glVertex3dv(P035);
            gl_.glNormal3dv(N036);
            gl_.glVertex3dv(P036);
            gl_.glNormal3dv(N046);
            gl_.glVertex3dv(P046);
            gl_.glNormal3dv(N045);
            gl_.glVertex3dv(P045);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N036);
            gl_.glVertex3dv(P036);
            gl_.glNormal3dv(N037);
            gl_.glVertex3dv(P037);
            gl_.glNormal3dv(N047);
            gl_.glVertex3dv(P047);
            gl_.glNormal3dv(N046);
            gl_.glVertex3dv(P046);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N037);
            gl_.glVertex3dv(P037);
            gl_.glNormal3dv(N038);
            gl_.glVertex3dv(P038);
            gl_.glNormal3dv(N048);
            gl_.glVertex3dv(P048);
            gl_.glNormal3dv(N047);
            gl_.glVertex3dv(P047);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N038);
            gl_.glVertex3dv(P038);
            gl_.glNormal3dv(N039);
            gl_.glVertex3dv(P039);
            gl_.glNormal3dv(N049);
            gl_.glVertex3dv(P049);
            gl_.glNormal3dv(N048);
            gl_.glVertex3dv(P048);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N039);
            gl_.glVertex3dv(P039);
            gl_.glNormal3dv(N040);
            gl_.glVertex3dv(P040);
            gl_.glNormal3dv(N050);
            gl_.glVertex3dv(P050);
            gl_.glNormal3dv(N049);
            gl_.glVertex3dv(P049);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N070);
            gl_.glVertex3dv(P070);
            gl_.glNormal3dv(N061);
            gl_.glVertex3dv(P061);
            gl_.glNormal3dv(N002);
            gl_.glVertex3dv(P002);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N061);
            gl_.glVertex3dv(P061);
            gl_.glNormal3dv(N046);
            gl_.glVertex3dv(P046);
            gl_.glNormal3dv(N002);
            gl_.glVertex3dv(P002);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N045);
            gl_.glVertex3dv(P045);
            gl_.glNormal3dv(N046);
            gl_.glVertex3dv(P046);
            gl_.glNormal3dv(N061);
            gl_.glVertex3dv(P061);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N002);
            gl_.glVertex3dv(P002);
            gl_.glNormal3dv(N061);
            gl_.glVertex3dv(P061);
            gl_.glNormal3dv(N070);
            gl_.glVertex3dv(P070);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N002);
            gl_.glVertex3dv(P002);
            gl_.glNormal3dv(N045);
            gl_.glVertex3dv(P045);
            gl_.glNormal3dv(N061);
            gl_.glVertex3dv(P061);
        gl_.glEnd();
      }

    void Fish005() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N002);
            gl_.glVertex3dv(P002);
            gl_.glNormal3dv(N044);
            gl_.glVertex3dv(P044);
            gl_.glNormal3dv(N045);
            gl_.glVertex3dv(P045);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N002);
            gl_.glVertex3dv(P002);
            gl_.glNormal3dv(N043);
            gl_.glVertex3dv(P043);
            gl_.glNormal3dv(N044);
            gl_.glVertex3dv(P044);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N002);
            gl_.glVertex3dv(P002);
            gl_.glNormal3dv(N052);
            gl_.glVertex3dv(P052);
            gl_.glNormal3dv(N043);
            gl_.glVertex3dv(P043);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N002);
            gl_.glVertex3dv(P002);
            gl_.glNormal3dv(N051);
            gl_.glVertex3dv(P051);
            gl_.glNormal3dv(N052);
            gl_.glVertex3dv(P052);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N002);
            gl_.glVertex3dv(P002);
            gl_.glNormal3dv(N046);
            gl_.glVertex3dv(P046);
            gl_.glNormal3dv(N047);
            gl_.glVertex3dv(P047);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N002);
            gl_.glVertex3dv(P002);
            gl_.glNormal3dv(N047);
            gl_.glVertex3dv(P047);
            gl_.glNormal3dv(N048);
            gl_.glVertex3dv(P048);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N002);
            gl_.glVertex3dv(P002);
            gl_.glNormal3dv(N048);
            gl_.glVertex3dv(P048);
            gl_.glNormal3dv(N049);
            gl_.glVertex3dv(P049);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N002);
            gl_.glVertex3dv(P002);
            gl_.glNormal3dv(N049);
            gl_.glVertex3dv(P049);
            gl_.glNormal3dv(N050);
            gl_.glVertex3dv(P050);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N050);
            gl_.glVertex3dv(P050);
            gl_.glNormal3dv(N051);
            gl_.glVertex3dv(P051);
            gl_.glNormal3dv(N069);
            gl_.glVertex3dv(P069);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N051);
            gl_.glVertex3dv(P051);
            gl_.glNormal3dv(N002);
            gl_.glVertex3dv(P002);
            gl_.glNormal3dv(N069);
            gl_.glVertex3dv(P069);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N050);
            gl_.glVertex3dv(P050);
            gl_.glNormal3dv(N069);
            gl_.glVertex3dv(P069);
            gl_.glNormal3dv(N002);
            gl_.glVertex3dv(P002);
        gl_.glEnd();
      }

    void Fish006() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N066);
            gl_.glVertex3dv(P066);
            gl_.glNormal3dv(N016);
            gl_.glVertex3dv(P016);
            gl_.glNormal3dv(N026);
            gl_.glVertex3dv(P026);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N015);
            gl_.glVertex3dv(P015);
            gl_.glNormal3dv(N066);
            gl_.glVertex3dv(P066);
            gl_.glNormal3dv(N025);
            gl_.glVertex3dv(P025);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N025);
            gl_.glVertex3dv(P025);
            gl_.glNormal3dv(N066);
            gl_.glVertex3dv(P066);
            gl_.glNormal3dv(N026);
            gl_.glVertex3dv(P026);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N066);
            gl_.glVertex3dv(P066);
            gl_.glNormal3dv(N058);
            gl_.glVertex3dv(P058);
            gl_.glNormal3dv(N016);
            gl_.glVertex3dv(P016);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N015);
            gl_.glVertex3dv(P015);
            gl_.glNormal3dv(N058);
            gl_.glVertex3dv(P058);
            gl_.glNormal3dv(N066);
            gl_.glVertex3dv(P066);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N058);
            gl_.glVertex3dv(P058);
            gl_.glNormal3dv(N015);
            gl_.glVertex3dv(P015);
            gl_.glNormal3dv(N016);
            gl_.glVertex3dv(P016);
        gl_.glEnd();
      }

    void Fish007() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N062);
            gl_.glVertex3dv(P062);
            gl_.glNormal3dv(N022);
            gl_.glVertex3dv(P022);
            gl_.glNormal3dv(N032);
            gl_.glVertex3dv(P032);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N062);
            gl_.glVertex3dv(P062);
            gl_.glNormal3dv(N032);
            gl_.glVertex3dv(P032);
            gl_.glNormal3dv(N064);
            gl_.glVertex3dv(P064);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N022);
            gl_.glVertex3dv(P022);
            gl_.glNormal3dv(N062);
            gl_.glVertex3dv(P062);
            gl_.glNormal3dv(N032);
            gl_.glVertex3dv(P032);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N062);
            gl_.glVertex3dv(P062);
            gl_.glNormal3dv(N064);
            gl_.glVertex3dv(P064);
            gl_.glNormal3dv(N032);
            gl_.glVertex3dv(P032);
        gl_.glEnd();
      }

    void Fish008() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N063);
            gl_.glVertex3dv(P063);
            gl_.glNormal3dv(N019);
            gl_.glVertex3dv(P019);
            gl_.glNormal3dv(N029);
            gl_.glVertex3dv(P029);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N019);
            gl_.glVertex3dv(P019);
            gl_.glNormal3dv(N063);
            gl_.glVertex3dv(P063);
            gl_.glNormal3dv(N029);
            gl_.glVertex3dv(P029);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N063);
            gl_.glVertex3dv(P063);
            gl_.glNormal3dv(N029);
            gl_.glVertex3dv(P029);
            gl_.glNormal3dv(N065);
            gl_.glVertex3dv(P065);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N063);
            gl_.glVertex3dv(P063);
            gl_.glNormal3dv(N065);
            gl_.glVertex3dv(P065);
            gl_.glNormal3dv(N029);
            gl_.glVertex3dv(P029);
        gl_.glEnd();
      }

    void Fish009() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P059);
            gl_.glVertex3dv(P012);
            gl_.glVertex3dv(P009);
            gl_.glVertex3dv(P060);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P012);
            gl_.glVertex3dv(P004);
            gl_.glVertex3dv(P007);
            gl_.glVertex3dv(P009);
        gl_.glEnd();
      }

    void Fish_1() throws OpenGLException {
        Fish004();
        Fish005();
        Fish003();
        Fish007();
        Fish006();
        Fish002();
        Fish008();
        Fish009();
        Fish001();
      }

    void Fish_2() throws OpenGLException {
        Fish005();
        Fish004();
        Fish003();
        Fish008();
        Fish006();
        Fish002();
        Fish007();
        Fish009();
        Fish001();
      }

    void Fish_3() throws OpenGLException {
        Fish005();
        Fish004();
        Fish007();
        Fish003();
        Fish002();
        Fish008();
        Fish009();
        Fish001();
        Fish006();
      }

    void Fish_4() throws OpenGLException {
        Fish005();
        Fish004();
        Fish008();
        Fish003();
        Fish002();
        Fish007();
        Fish009();
        Fish001();
        Fish006();
      }

    void Fish_5() throws OpenGLException {
        Fish009();
        Fish006();
        Fish007();
        Fish001();
        Fish002();
        Fish003();
        Fish008();
        Fish004();
        Fish005();
    }

    void Fish_6() throws OpenGLException {
        Fish009();
        Fish006();
        Fish008();
        Fish001();
        Fish002();
        Fish007();
        Fish003();
        Fish004();
        Fish005();
      }

    void Fish_7() throws OpenGLException {
        Fish009();
        Fish001();
        Fish007();
        Fish005();
        Fish002();
        Fish008();
        Fish003();
        Fish004();
        Fish006();
      }

    void Fish_8() throws OpenGLException {
        Fish009();
        Fish008();
        Fish001();
        Fish002();
        Fish007();
        Fish003();
        Fish005();
        Fish004();
        Fish006();
      }

    public void draw() {
        float[][] mat = new float[4][4];
        int n;
        double seg1, seg2, seg3, seg4, segup;
        double thrash, chomp;

        htail = (int)( htail - (int)( 5.0 * v ) ) % 360;

        thrash = 50.0 * v;

        seg1 = 0.6 * thrash * Math.sin(htail * atlantis.RRAD );
        seg2 = 1.8 * thrash * Math.sin((htail + 45.0) * atlantis.RRAD );
        seg3 = 3.0 * thrash * Math.sin((htail + 90.0) * atlantis.RRAD );
        seg4 = 4.0 * thrash * Math.sin((htail + 110.0) * atlantis.RRAD );

        chomp = 0.0;
        if ( v > 2.0) {
            chomp = -(v - 2.0) * 200.0;
          }
        P004[1] = iP004[1] + chomp;
        P007[1] = iP007[1] + chomp;
        P010[1] = iP010[1] + chomp;
        P011[1] = iP011[1] + chomp;
    
        P023[0] = iP023[0] + seg1;
        P024[0] = iP024[0] + seg1;
        P025[0] = iP025[0] + seg1;
        P026[0] = iP026[0] + seg1;
        P027[0] = iP027[0] + seg1;
        P028[0] = iP028[0] + seg1;
        P029[0] = iP029[0] + seg1;
        P030[0] = iP030[0] + seg1;
        P031[0] = iP031[0] + seg1;
        P032[0] = iP032[0] + seg1;
        P033[0] = iP033[0] + seg2;
        P034[0] = iP034[0] + seg2;
        P035[0] = iP035[0] + seg2;
        P036[0] = iP036[0] + seg2;
        P037[0] = iP037[0] + seg2;
        P038[0] = iP038[0] + seg2;
        P039[0] = iP039[0] + seg2;
        P040[0] = iP040[0] + seg2;
        P041[0] = iP041[0] + seg2;
        P042[0] = iP042[0] + seg2;
        P043[0] = iP043[0] + seg3;
        P044[0] = iP044[0] + seg3;
        P045[0] = iP045[0] + seg3;
        P046[0] = iP046[0] + seg3;
        P047[0] = iP047[0] + seg3;
        P048[0] = iP048[0] + seg3;
        P049[0] = iP049[0] + seg3;
        P050[0] = iP050[0] + seg3;
        P051[0] = iP051[0] + seg3;
        P052[0] = iP052[0] + seg3;
        P002[0] = iP002[0] + seg4;
        P061[0] = iP061[0] + seg4;
        P069[0] = iP069[0] + seg4;
        P070[0] = iP070[0] + seg4;
    
        vtail += ((dtheta - vtail) * 0.1);

        if (vtail > 0.5) {
            vtail = 0.5f;
          } else if (vtail < -0.5) {
            vtail = -0.5f;
          }
        segup = thrash * vtail;

        P023[1] = iP023[1] + segup;
        P024[1] = iP024[1] + segup;
        P025[1] = iP025[1] + segup;
        P026[1] = iP026[1] + segup;
        P027[1] = iP027[1] + segup;
        P028[1] = iP028[1] + segup;
        P029[1] = iP029[1] + segup;
        P030[1] = iP030[1] + segup;
        P031[1] = iP031[1] + segup;
        P032[1] = iP032[1] + segup;
        P033[1] = iP033[1] + segup * 5.0;
        P034[1] = iP034[1] + segup * 5.0;
        P035[1] = iP035[1] + segup * 5.0;
        P036[1] = iP036[1] + segup * 5.0;
        P037[1] = iP037[1] + segup * 5.0;
        P038[1] = iP038[1] + segup * 5.0;
        P039[1] = iP039[1] + segup * 5.0;
        P040[1] = iP040[1] + segup * 5.0;
        P041[1] = iP041[1] + segup * 5.0;
        P042[1] = iP042[1] + segup * 5.0;
        P043[1] = iP043[1] + segup * 12.0;
        P044[1] = iP044[1] + segup * 12.0;
        P045[1] = iP045[1] + segup * 12.0;
        P046[1] = iP046[1] + segup * 12.0;
        P047[1] = iP047[1] + segup * 12.0;
        P048[1] = iP048[1] + segup * 12.0;
        P049[1] = iP049[1] + segup * 12.0;
        P050[1] = iP050[1] + segup * 12.0;
        P051[1] = iP051[1] + segup * 12.0;
        P052[1] = iP052[1] + segup * 12.0;
        P002[1] = iP002[1] + segup * 17.0;
        P061[1] = iP061[1] + segup * 17.0;
        P069[1] = iP069[1] + segup * 17.0;
        P070[1] = iP070[1] + segup * 17.0;

        try {
            gl_.glPushMatrix();

            gl_.glTranslated(0.0, 0.0, -3000.0);

//            gl_.glGetFloatv(GL_MODELVIEW_MATRIX, mat );
            n = (int)( Math.random() * atlantis.RAND_MAX ) % 8;
/*            if (mat[0][2] >= 0.0) {
                n += 1;
              }
            if (mat[1][2] >= 0.0) {
                n += 2;
              }
            if (mat[2][2] >= 0.0) {
                n += 4;
              } */
            gl_.glScaled(2.0, 1.0, 1.0);
        
            gl_.glEnable( GL.GL_CULL_FACE );
            switch (n) {
                case 0:
                    Fish_1();
                    break;
                case 1:
                    Fish_2();
                    break;
                case 2:
                    Fish_3();
                    break;
                case 3:
                    Fish_4();
                    break;
                case 4:
                    Fish_5();
                    break;
                case 5:
                    Fish_6();
                    break;
                case 6:
                    Fish_7();
                    break;
                case 7:
                    Fish_8();
                    break;
              }
            gl_.glDisable( GL.GL_CULL_FACE );
    
            gl_.glPopMatrix();
          } catch ( OpenGLException e ) {
            e.printStackTrace();
          }
      }

    /** Pilot routine */
    public void pilot() {
        int sign = 1;

        float X, Y, Z, tpsi, ttheta = 0, thetal;

        tPosition.x = 60000.0f;
        tPosition.y = 0.0f;
        tPosition.z = 0.0f;

        X = tPosition.x - position.x;
        Y = tPosition.y - position.y;
        Z = tPosition.z - position.z;

        thetal = theta;

        ttheta = 
            (float)( atlantis.RAD * Math.atan( Z / ( Math.sqrt( X * X + Y * Y ) ) ) );

        if ( ttheta > theta + 0.25 ) {
            theta += 0.5;
          } else if ( ttheta < theta - 0.25 ) {
            theta -= 0.5;
          }

        if ( theta > 90.0 ) {
            theta = 90.0f;
          }

        if ( theta < -90.0 ) {
            theta = -90.0f;
          }

        dtheta = theta - thetal;

        tpsi = (float)( atlantis.RAD * Math.atan2( Y, X ) );

        attack = 0;

        if ( Math.abs( tpsi - psi ) < 10.0f ) {
            attack = 1;
          } else if ( Math.abs( tpsi - psi ) < 45.0f ) {
            if ( psi > tpsi ) {
                psi -= 0.5;
                if ( psi < -180.0f ) {
                    psi += 360.0f;
                  }
              } else if ( psi < tpsi ) {
                psi += 0.5;
                if ( psi > 180.0f ) {
                    psi -= 360.0f;
                  }
              }
          } else {
            if ( (int)( Math.random() * atlantis.RAND_MAX ) % 100 > 98 ) {
                sign = 1 - sign;
              }
            psi += sign;
            if ( psi > 180.0f ) {
                psi -= 360.0f;
              }
            if ( psi < -180.0f ) {
                psi += 360.0f;
              }
          }

        if ( attack == 1 ) {
            if ( v < 1.1f ) {
                spurt = 1;
              }
            if ( spurt == 1 ) {  
                v += 0.2f;
              }
            if ( v > 5.0f ) {
                spurt = 0;
              }

            if ( ( v > 1.0f ) && ( spurt == 0 ) ) {
                v -= 0.2f;
              }
          } else {
            if ( ( (int)( Math.random() * atlantis.RAND_MAX ) % 400 == 0 ) &&
                 ( spurt == 0 ) ) {
                spurt = 1;
              }
            if ( spurt == 1 ) {
                v += 0.05f;
              }
            if ( v > 3.0f ) {
                spurt = 0;
              }
            if ( ( v > 1.0f ) && ( spurt == 0 ) ) {
                v -= 0.05f;
              }
          }

        position.x += (float)( SHARKSPEED * v * Math.cos( psi / atlantis.RAD ) *
                                       Math.cos( theta / atlantis.RAD ) );
        position.y += (float)( SHARKSPEED * v * Math.sin( psi / atlantis.RAD ) *
                                       Math.cos( theta / atlantis.RAD ) );
        position.z += (float)( SHARKSPEED * v * Math.sin( theta / atlantis.RAD ) );
      }

    /** Avoidance routine */
    public void miss( int i, shark[] sharks ) {
        int j;
        float avoid, thetal;
        float X, Y, Z, r;

        for ( j = 0 ; j < atlantis.NUM_SHARKS ; j++ ) {
            if ( j != i ) {
                X = sharks[j].position.x -
                        sharks[i].position.x;
                Y = sharks[j].position.y -
                        sharks[i].position.y;
                Z = sharks[j].position.z -
                        sharks[i].position.z;

                r = (float)( Math.sqrt( X * X + Y * Y + Z * Z ) );

                avoid = 1.0f;
                thetal = sharks[i].theta;

                if ( r < SHARKSIZE ) {
                    if ( Z > 0.0f ) {
                        sharks[i].theta -= avoid;
                      } else {
                        sharks[i].theta += avoid;
                      }
                  }
                sharks[i].dtheta +=
                    sharks[i].theta - thetal;
              }
          }
      }
  }
