/**
 * (c) Copyright 1993, 1994, Silicon Graphics, Inc.
 * ALL RIGHTS RESERVED
 * Permission to use, copy, modify, and distribute this software for
 * any purpose and without fee is hereby granted, provided that the above
 * copyright notice appear in all copies and that both the copyright notice
 * and this permission notice appear in supporting documentation, and that
 * the name of Silicon Graphics, Inc. not be used in advertising
 * or publicity pertaining to distribution of the software without specific,
 * written prior permission.
 *
 * THE MATERIAL EMBODIED ON THIS SOFTWARE IS PROVIDED TO YOU "AS-IS"
 * AND WITHOUT WARRANTY OF ANY KIND, EXPRESS, IMPLIED OR OTHERWISE,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF MERCHANTABILITY OR
 * FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT SHALL SILICON
 * GRAPHICS, INC.  BE LIABLE TO YOU OR ANYONE ELSE FOR ANY DIRECT,
 * SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY
 * KIND, OR ANY DAMAGES WHATSOEVER, INCLUDING WITHOUT LIMITATION,
 * LOSS OF PROFIT, LOSS OF USE, SAVINGS OR REVENUE, OR THE CLAIMS OF
 * THIRD PARTIES, WHETHER OR NOT SILICON GRAPHICS, INC.  HAS BEEN
 * ADVISED OF THE POSSIBILITY OF SUCH LOSS, HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE
 * POSSESSION, USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * US Government Users Restricted Rights
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions set forth in FAR 52.227.19(c)(2) or subparagraph
 * (c)(1)(ii) of the Rights in Technical Data and Computer Software
 * clause at DFARS 252.227-7013 and/or in similar or successor
 * clauses in the FAR or the DOD or NASA FAR Supplement.
 * Unpublished-- rights reserved under the copyright laws of the
 * United States.  Contractor/manufacturer is Silicon Graphics,
 * Inc., 2011 N.  Shoreline Blvd., Mountain View, CA 94039-7311.
 *
 * OpenGL(TM) is a trademark of Silicon Graphics, Inc.
 */

/**
 * $Id: whale.java,v 1.4 1998/10/19 10:40:58 descarte Exp descarte $
 *
 * Magician conversion Copyright (c)1997-1998 Arcane Technologies Ltd. <http://www.arcana.co.uk>
 *
 * $Log: whale.java,v $
 * Revision 1.4  1998/10/19 10:40:58  descarte
 * Made JDK-1.1 compliant by removing deprecated methods. Updated copyright.
 *
 * Revision 1.3  1998/06/07 13:53:55  descarte
 * Converted from COM.hermetica.* to com.hermetica.* hierarchy
 *
 * Revision 1.2  1998/03/30 01:08:26  descarte
 * Made draw() method public instead of private. This fouled up applets.
 *
 * Revision 1.1  1998/01/04 17:31:57  descarte
 * Initial revision
 *
 */

package com.hermetica.magician.demos.atlantis;

import com.hermetica.magician.*;
import com.hermetica.vecmath.*;

public class whale extends fish {

    /** The OpenGL state machine */
//    GL gl_ = new GL();

    /** The speed of the whale */
    public static final float WHALESPEED = 250.0f;

    static double[] N001 = {0.019249 ,0.011340 ,-0.999750};
    static double[] N002 = {-0.132579 ,0.954547 ,0.266952};
    static double[] N003 = {-0.196061 ,0.980392 ,-0.019778};
    static double[] N004 = {0.695461 ,0.604704 ,0.388158};
    static double[] N005 = {0.870600 ,0.425754 ,0.246557};
    static double[] N006 = {-0.881191 ,0.392012 ,0.264251};
    static double[] N008 = {-0.341437 ,0.887477 ,0.309523};
    static double[] N009 = {0.124035 ,-0.992278 ,0.000000};
    static double[] N010 = {0.242536 ,0.000000 ,-0.970143};
    static double[] N011 = {0.588172 ,0.000000 ,0.808736};
    static double[] N012 = {0.929824 ,-0.340623 ,-0.139298};
    static double[] N013 = {0.954183 ,0.267108 ,-0.134865};
    static double[] N014 = {0.495127 ,0.855436 ,-0.151914};
    static double[] N015 = {-0.390199 ,0.906569 ,-0.160867};
    static double[] N016 = {-0.923605 ,0.354581 ,-0.145692};
    static double[] N017 = {-0.955796 ,-0.260667 ,-0.136036};
    static double[] N018 = {-0.501283 ,-0.853462 ,-0.142540};
    static double[] N019 = {0.405300 ,-0.901974 ,-0.148913};
    static double[] N020 = {0.909913 ,-0.392746 ,-0.133451};
    static double[] N021 = {0.936494 ,0.331147 ,-0.115414};
    static double[] N022 = {0.600131 ,0.793724 ,-0.099222};
    static double[] N023 = {-0.231556 ,0.968361 ,-0.093053};
    static double[] N024 = {-0.844369 ,0.525330 ,-0.105211};
    static double[] N025 = {-0.982725 ,-0.136329 ,-0.125164};
    static double[] N026 = {-0.560844 ,-0.822654 ,-0.093241};
    static double[] N027 = {0.263884 ,-0.959981 ,-0.093817};
    static double[] N028 = {0.842057 ,-0.525192 ,-0.122938};
    static double[] N029 = {0.921620 ,0.367565 ,-0.124546};
    static double[] N030 = {0.613927 ,0.784109 ,-0.090918};
    static double[] N031 = {-0.448754 ,0.888261 ,-0.098037};
    static double[] N032 = {-0.891865 ,0.434376 ,-0.126077};
    static double[] N033 = {-0.881447 ,-0.448017 ,-0.149437};
    static double[] N034 = {-0.345647 ,-0.922057 ,-0.174183};
    static double[] N035 = {0.307998 ,-0.941371 ,-0.137688};
    static double[] N036 = {0.806316 ,-0.574647 ,-0.140124};
    static double[] N037 = {0.961346 ,0.233646 ,-0.145681};
    static double[] N038 = {0.488451 ,0.865586 ,-0.110351};
    static double[] N039 = {-0.374290 ,0.921953 ,-0.099553};
    static double[] N040 = {-0.928504 ,0.344533 ,-0.138485};
    static double[] N041 = {-0.918419 ,-0.371792 ,-0.135189};
    static double[] N042 = {-0.520666 ,-0.833704 ,-0.183968};
    static double[] N043 = {0.339204 ,-0.920273 ,-0.195036};
    static double[] N044 = {0.921475 ,-0.387382 ,-0.028636};
    static double[] N045 = {0.842465 ,0.533335 ,-0.076204};
    static double[] N046 = {0.380110 ,0.924939 ,0.002073};
    static double[] N047 = {-0.276128 ,0.961073 ,-0.009579};
    static double[] N048 = {-0.879684 ,0.473001 ,-0.049250};
    static double[] N049 = {-0.947184 ,-0.317614 ,-0.044321};
    static double[] N050 = {-0.642059 ,-0.764933 ,-0.051363};
    static double[] N051 = {0.466794 ,-0.880921 ,-0.077990};
    static double[] N052 = {0.898509 ,-0.432277 ,0.076279};
    static double[] N053 = {0.938985 ,0.328141 ,0.103109};
    static double[] N054 = {0.442420 ,0.895745 ,0.043647};
    static double[] N055 = {-0.255163 ,0.966723 ,0.018407};
    static double[] N056 = {-0.833769 ,0.540650 ,0.111924};
    static double[] N057 = {-0.953653 ,-0.289939 ,0.080507};
    static double[] N058 = {-0.672357 ,-0.730524 ,0.119461};
    static double[] N059 = {0.522249 ,-0.846652 ,0.102157};
    static double[] N060 = {0.885868 ,-0.427631 ,0.179914};
    static double[] N062 = {0.648942 ,0.743116 ,0.163255};
    static double[] N063 = {-0.578967 ,0.807730 ,0.111219};
    static double[] N065 = {-0.909864 ,-0.352202 ,0.219321};
    static double[] N066 = {-0.502541 ,-0.818090 ,0.279610};
    static double[] N067 = {0.322919 ,-0.915358 ,0.240504};
    static double[] N068 = {0.242536 ,0.000000 ,-0.970143};
    static double[] N069 = {0.000000 ,1.000000 ,0.000000};
    static double[] N070 = {0.000000 ,1.000000 ,0.000000};
    static double[] N071 = {0.000000 ,1.000000 ,0.000000};
    static double[] N072 = {0.000000 ,1.000000 ,0.000000};
    static double[] N073 = {0.000000 ,1.000000 ,0.000000};
    static double[] N074 = {0.000000 ,1.000000 ,0.000000};
    static double[] N075 = {0.031220 ,0.999025 ,-0.031220};
    static double[] N076 = {0.000000 ,1.000000 ,0.000000};
    static double[] N077 = {0.446821 ,0.893642 ,0.041889};
    static double[] N078 = {0.863035 ,-0.100980 ,0.494949};
    static double[] N079 = {0.585597 ,-0.808215 ,0.062174};
    static double[] N080 = {0.000000 ,1.000000 ,0.000000};
    static double[] N081 = {1.000000 ,0.000000 ,0.000000};
    static double[] N082 = {0.000000 ,1.000000 ,0.000000};
    static double[] N083 = {-1.000000 ,0.000000 ,0.000000};
    static double[] N084 = {-0.478893 ,0.837129 ,-0.264343};
    static double[] N085 = {0.000000 ,1.000000 ,0.000000};
    static double[] N086 = {0.763909 ,0.539455 ,-0.354163};
    static double[] N087 = {0.446821 ,0.893642 ,0.041889};
    static double[] N088 = {0.385134 ,-0.908288 ,0.163352};
    static double[] N089 = {-0.605952 ,0.779253 ,-0.159961};
    static double[] N090 = {0.000000 ,1.000000 ,0.000000};
    static double[] N091 = {0.000000 ,1.000000 ,0.000000};
    static double[] N092 = {0.000000 ,1.000000 ,0.000000};
    static double[] N093 = {0.000000 ,1.000000 ,0.000000};
    static double[] N094 = {1.000000 ,0.000000 ,0.000000};
    static double[] N095 = {-1.000000 ,0.000000 ,0.000000};
    static double[] N096 = {0.644444 ,-0.621516 ,0.445433};
    static double[] N097 = {-0.760896 ,-0.474416 ,0.442681};
    static double[] N098 = {0.636888 ,-0.464314 ,0.615456};
    static double[] N099 = {-0.710295 ,0.647038 ,0.277168};
    static double[] N100 = {0.009604 ,0.993655 ,0.112063};
    static double[] iP001 = {18.74, 13.19, 3.76};
    static double[] P001 = {18.74, 13.19, 3.76};
    static double[] P002 = {0.00, 390.42, 10292.57};
    static double[] P003 = {55.80, 622.31, 8254.35};
    static double[] P004 = {20.80, 247.66, 10652.13};
    static double[] P005 = {487.51, 198.05, 9350.78};
    static double[] P006 = {-457.61, 199.04, 9353.01};
    static double[] P008 = {-34.67, 247.64, 10663.71};
    static double[] iP009 = {97.46, 67.63, 593.82};
    static double[] iP010 = {-84.33, 67.63, 588.18};
    static double[] iP011 = {118.69, 8.98, -66.91};
    static double[] P009 = {97.46, 67.63, 593.82};
    static double[] P010 = {-84.33, 67.63, 588.18};
    static double[] P011 = {118.69, 8.98, -66.91};
    static double[] iP012 = {156.48, -31.95, 924.54};
    static double[] iP013 = {162.00, 110.22, 924.54};
    static double[] iP014 = {88.16, 221.65, 924.54};
    static double[] iP015 = {-65.21, 231.16, 924.54};
    static double[] iP016 = {-156.48, 121.97, 924.54};
    static double[] iP017 = {-162.00, -23.93, 924.54};
    static double[] iP018 = {-88.16, -139.10, 924.54};
    static double[] iP019 = {65.21, -148.61, 924.54};
    static double[] iP020 = {246.87, -98.73, 1783.04};
    static double[] iP021 = {253.17, 127.76, 1783.04};
    static double[] iP022 = {132.34, 270.77, 1783.04};
    static double[] iP023 = {-97.88, 285.04, 1783.04};
    static double[] iP024 = {-222.97, 139.80, 1783.04};
    static double[] iP025 = {-225.29, -86.68, 1783.04};
    static double[] iP026 = {-108.44, -224.15, 1783.04};
    static double[] iP027 = {97.88, -221.56, 1783.04};
    static double[] iP028 = {410.55, -200.66, 3213.87};
    static double[] iP029 = {432.19, 148.42, 3213.87};
    static double[] iP030 = {200.66, 410.55, 3213.87};
    static double[] iP031 = {-148.42, 432.19, 3213.87};
    static double[] iP032 = {-407.48, 171.88, 3213.87};
    static double[] iP033 = {-432.19, -148.42, 3213.87};
    static double[] iP034 = {-148.88, -309.74, 3213.87};
    static double[] iP035 = {156.38, -320.17, 3213.87};
    static double[] iP036 = {523.39, -303.81, 4424.57};
    static double[] iP037 = {574.66, 276.84, 4424.57};
    static double[] iP038 = {243.05, 492.50, 4424.57};
    static double[] iP039 = {-191.23, 520.13, 4424.57};
    static double[] iP040 = {-523.39, 304.01, 4424.57};
    static double[] iP041 = {-574.66, -231.83, 4424.57};
    static double[] iP042 = {-266.95, -578.17, 4424.57};
    static double[] iP043 = {211.14, -579.67, 4424.57};
    static double[] iP044 = {680.57, -370.27, 5943.46};
    static double[] iP045 = {834.01, 363.09, 5943.46};
    static double[] iP046 = {371.29, 614.13, 5943.46};
    static double[] iP047 = {-291.43, 621.86, 5943.46};
    static double[] iP048 = {-784.13, 362.60, 5943.46};
    static double[] iP049 = {-743.29, -325.82, 5943.46};
    static double[] iP050 = {-383.24, -804.77, 5943.46};
    static double[] iP051 = {283.47, -846.09, 5943.46};
    static double[] P012 = {156.48, -31.95, 924.54};
    static double[] P013 = {162.00, 110.22, 924.54};
    static double[] P014 = {88.16, 221.65, 924.54};
    static double[] P015 = {-65.21, 231.16, 924.54};
    static double[] P016 = {-156.48, 121.97, 924.54};
    static double[] P017 = {-162.00, -23.93, 924.54};
    static double[] P018 = {-88.16, -139.10, 924.54};
    static double[] P019 = {65.21, -148.61, 924.54};
    static double[] P020 = {246.87, -98.73, 1783.04};
    static double[] P021 = {253.17, 127.76, 1783.04};
    static double[] P022 = {132.34, 270.77, 1783.04};
    static double[] P023 = {-97.88, 285.04, 1783.04};
    static double[] P024 = {-222.97, 139.80, 1783.04};
    static double[] P025 = {-225.29, -86.68, 1783.04};
    static double[] P026 = {-108.44, -224.15, 1783.04};
    static double[] P027 = {97.88, -221.56, 1783.04};
    static double[] P028 = {410.55, -200.66, 3213.87};
    static double[] P029 = {432.19, 148.42, 3213.87};
    static double[] P030 = {200.66, 410.55, 3213.87};
    static double[] P031 = {-148.42, 432.19, 3213.87};
    static double[] P032 = {-407.48, 171.88, 3213.87};
    static double[] P033 = {-432.19, -148.42, 3213.87};
    static double[] P034 = {-148.88, -309.74, 3213.87};
    static double[] P035 = {156.38, -320.17, 3213.87};
    static double[] P036 = {523.39, -303.81, 4424.57};
    static double[] P037 = {574.66, 276.84, 4424.57};
    static double[] P038 = {243.05, 492.50, 4424.57};
    static double[] P039 = {-191.23, 520.13, 4424.57};
    static double[] P040 = {-523.39, 304.01, 4424.57};
    static double[] P041 = {-574.66, -231.83, 4424.57};
    static double[] P042 = {-266.95, -578.17, 4424.57};
    static double[] P043 = {211.14, -579.67, 4424.57};
    static double[] P044 = {680.57, -370.27, 5943.46};
    static double[] P045 = {834.01, 363.09, 5943.46};
    static double[] P046 = {371.29, 614.13, 5943.46};
    static double[] P047 = {-291.43, 621.86, 5943.46};
    static double[] P048 = {-784.13, 362.60, 5943.46};
    static double[] P049 = {-743.29, -325.82, 5943.46};
    static double[] P050 = {-383.24, -804.77, 5943.46};
    static double[] P051 = {283.47, -846.09, 5943.46};
    static double[] P052 = {599.09, -332.24, 7902.59};
    static double[] P053 = {735.48, 306.26, 7911.92};
    static double[] P054 = {321.55, 558.53, 7902.59};
    static double[] P055 = {-260.54, 559.84, 7902.59};
    static double[] P056 = {-698.66, 320.83, 7902.59};
    static double[] P057 = {-643.29, -299.16, 7902.59};
    static double[] P058 = {-341.47, -719.30, 7902.59};
    static double[] P059 = {252.57, -756.12, 7902.59};
    static double[] P060 = {458.39, -265.31, 9355.44};
    static double[] P062 = {224.04, 438.98, 9364.77};
    static double[] P063 = {-165.71, 441.27, 9355.44};
    static double[] P065 = {-473.99, -219.71, 9355.44};
    static double[] P066 = {-211.97, -479.87, 9355.44};
    static double[] P067 = {192.86, -504.03, 9355.44};
    static double[] iP068 = {-112.44, 9.25, -64.42};
    static double[] iP069 = {1155.63, 0.00, -182.46};
    static double[] iP070 = {-1143.13, 0.00, -181.54};
    static double[] iP071 = {1424.23, 0.00, -322.09};
    static double[] iP072 = {-1368.01, 0.00, -310.38};
    static double[] iP073 = {1255.57, 2.31, 114.05};
    static double[] iP074 = {-1149.38, 0.00, 117.12};
    static double[] iP075 = {718.36, 0.00, 433.36};
    static double[] iP076 = {-655.90, 0.00, 433.36};
    static double[] P068 = {-112.44, 9.25, -64.42};
    static double[] P069 = {1155.63, 0.00, -182.46};
    static double[] P070 = {-1143.13, 0.00, -181.54};
    static double[] P071 = {1424.23, 0.00, -322.09};
    static double[] P072 = {-1368.01, 0.00, -310.38};
    static double[] P073 = {1255.57, 2.31, 114.05};
    static double[] P074 = {-1149.38, 0.00, 117.12};
    static double[] P075 = {718.36, 0.00, 433.36};
    static double[] P076 = {-655.90, 0.00, 433.36};
    static double[] P077 = {1058.00, -2.66, 7923.51};
    static double[] P078 = {-1016.51, -15.47, 7902.87};
    static double[] P079 = {-1363.99, -484.50, 7593.38};
    static double[] P080 = {1478.09, -861.47, 7098.12};
    static double[] P081 = {1338.06, -284.68, 7024.15};
    static double[] P082 = {-1545.51, -860.64, 7106.60};
    static double[] P083 = {1063.19, -70.46, 7466.60};
    static double[] P084 = {-1369.18, -288.11, 7015.34};
    static double[] P085 = {1348.44, -482.50, 7591.41};
    static double[] P086 = {-1015.45, -96.80, 7474.86};
    static double[] P087 = {731.04, 148.38, 7682.58};
    static double[] P088 = {-697.03, 151.82, 7668.81};
    static double[] P089 = {-686.82, 157.09, 7922.29};
    static double[] P090 = {724.73, 147.75, 7931.39};
    static double[] iP091 = {0.00, 327.10, 2346.55};
    static double[] iP092 = {0.00, 552.28, 2311.31};
    static double[] iP093 = {0.00, 721.16, 2166.41};
    static double[] iP094 = {0.00, 693.42, 2388.80};
    static double[] iP095 = {0.00, 389.44, 2859.97};
    static double[] P091 = {0.00, 327.10, 2346.55};
    static double[] P092 = {0.00, 552.28, 2311.31};
    static double[] P093 = {0.00, 721.16, 2166.41};
    static double[] P094 = {0.00, 693.42, 2388.80};
    static double[] P095 = {0.00, 389.44, 2859.97};
    static double[] iP096 = {222.02, -183.67, 10266.89};
    static double[] iP097 = {-128.90, -182.70, 10266.89};
    static double[] iP098 = {41.04, 88.31, 10659.36};
    static double[] iP099 = {-48.73, 88.30, 10659.36};
    static double[] P096 = {222.02, -183.67, 10266.89};
    static double[] P097 = {-128.90, -182.70, 10266.89};
    static double[] P098 = {41.04, 88.31, 10659.36};
    static double[] P099 = {-48.73, 88.30, 10659.36};
    static double[] P100 = {0.00, 603.42, 9340.68};
    static double[] P104 = {-9.86, 567.62, 7858.65};
    static double[] P105 = {31.96, 565.27, 7908.46};
    static double[] P106 = {22.75, 568.13, 7782.83};
    static double[] P107 = {58.93, 568.42, 7775.94};
    static double[] P108 = {55.91, 565.59, 7905.86};
    static double[] P109 = {99.21, 566.00, 7858.65};
    static double[] P110 = {-498.83, 148.14, 9135.10};
    static double[] P111 = {-495.46, 133.24, 9158.48};
    static double[] P112 = {-490.82, 146.23, 9182.76};
    static double[] P113 = {-489.55, 174.11, 9183.66};
    static double[] P114 = {-492.92, 189.00, 9160.28};
    static double[] P115 = {-497.56, 176.02, 9136.00};
    static double[] P116 = {526.54, 169.68, 9137.70};
    static double[] P117 = {523.49, 184.85, 9161.42};
    static double[] P118 = {518.56, 171.78, 9186.06};
    static double[] P119 = {516.68, 143.53, 9186.98};
    static double[] P120 = {519.73, 128.36, 9163.26};
    static double[] P121 = {524.66, 141.43, 9138.62};

    /** Constructor simply calls the fish constructor */
    public whale( GL gl_, GLU glu_ ) {
        super( gl_, glu_ );
      }

    void Whale001() throws OpenGLException {

        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N001);
            gl_.glVertex3dv(P001);
            gl_.glNormal3dv(N068);
            gl_.glVertex3dv(P068);
            gl_.glNormal3dv(N010);
            gl_.glVertex3dv(P010);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N068);
            gl_.glVertex3dv(P068);
            gl_.glNormal3dv(N076);
            gl_.glVertex3dv(P076);
            gl_.glNormal3dv(N010);
            gl_.glVertex3dv(P010);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N068);
            gl_.glVertex3dv(P068);
            gl_.glNormal3dv(N070);
            gl_.glVertex3dv(P070);
            gl_.glNormal3dv(N076);
            gl_.glVertex3dv(P076);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N076);
            gl_.glVertex3dv(P076);
            gl_.glNormal3dv(N070);
            gl_.glVertex3dv(P070);
            gl_.glNormal3dv(N074);
            gl_.glVertex3dv(P074);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N070);
            gl_.glVertex3dv(P070);
            gl_.glNormal3dv(N072);
            gl_.glVertex3dv(P072);
            gl_.glNormal3dv(N074);
            gl_.glVertex3dv(P074);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N072);
            gl_.glVertex3dv(P072);
            gl_.glNormal3dv(N070);
            gl_.glVertex3dv(P070);
            gl_.glNormal3dv(N074);
            gl_.glVertex3dv(P074);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N074);
            gl_.glVertex3dv(P074);
            gl_.glNormal3dv(N070);
            gl_.glVertex3dv(P070);
            gl_.glNormal3dv(N076);
            gl_.glVertex3dv(P076);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N070);
            gl_.glVertex3dv(P070);
            gl_.glNormal3dv(N068);
            gl_.glVertex3dv(P068);
            gl_.glNormal3dv(N076);
            gl_.glVertex3dv(P076);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N076);
            gl_.glVertex3dv(P076);
            gl_.glNormal3dv(N068);
            gl_.glVertex3dv(P068);
            gl_.glNormal3dv(N010);
            gl_.glVertex3dv(P010);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N068);
            gl_.glVertex3dv(P068);
            gl_.glNormal3dv(N001);
            gl_.glVertex3dv(P001);
            gl_.glNormal3dv(N010);
            gl_.glVertex3dv(P010);
        gl_.glEnd();
      }

    void Whale002() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N011);
            gl_.glVertex3dv(P011);
            gl_.glNormal3dv(N001);
            gl_.glVertex3dv(P001);
            gl_.glNormal3dv(N009);
            gl_.glVertex3dv(P009);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N075);
            gl_.glVertex3dv(P075);
            gl_.glNormal3dv(N011);
            gl_.glVertex3dv(P011);
            gl_.glNormal3dv(N009);
            gl_.glVertex3dv(P009);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N069);
            gl_.glVertex3dv(P069);
            gl_.glNormal3dv(N011);
            gl_.glVertex3dv(P011);
            gl_.glNormal3dv(N075);
            gl_.glVertex3dv(P075);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N069);
            gl_.glVertex3dv(P069);
            gl_.glNormal3dv(N075);
            gl_.glVertex3dv(P075);
            gl_.glNormal3dv(N073);
            gl_.glVertex3dv(P073);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N071);
            gl_.glVertex3dv(P071);
            gl_.glNormal3dv(N069);
            gl_.glVertex3dv(P069);
            gl_.glNormal3dv(N073);
            gl_.glVertex3dv(P073);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N001);
            gl_.glVertex3dv(P001);
            gl_.glNormal3dv(N011);
            gl_.glVertex3dv(P011);
            gl_.glNormal3dv(N009);
            gl_.glVertex3dv(P009);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N009);
            gl_.glVertex3dv(P009);
            gl_.glNormal3dv(N011);
            gl_.glVertex3dv(P011);
            gl_.glNormal3dv(N075);
            gl_.glVertex3dv(P075);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N011);
            gl_.glVertex3dv(P011);
            gl_.glNormal3dv(N069);
            gl_.glVertex3dv(P069);
            gl_.glNormal3dv(N075);
            gl_.glVertex3dv(P075);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N069);
            gl_.glVertex3dv(P069);
            gl_.glNormal3dv(N073);
            gl_.glVertex3dv(P073);
            gl_.glNormal3dv(N075);
            gl_.glVertex3dv(P075);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N069);
            gl_.glVertex3dv(P069);
            gl_.glNormal3dv(N071);
            gl_.glVertex3dv(P071);
            gl_.glNormal3dv(N073);
            gl_.glVertex3dv(P073);
        gl_.glEnd();
      }

    void Whale003() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N018);
            gl_.glVertex3dv(P018);
            gl_.glNormal3dv(N001);
            gl_.glVertex3dv(P001);
            gl_.glNormal3dv(N019);
            gl_.glVertex3dv(P019);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N019);
            gl_.glVertex3dv(P019);
            gl_.glNormal3dv(N001);
            gl_.glVertex3dv(P001);
            gl_.glNormal3dv(N012);
            gl_.glVertex3dv(P012);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N017);
            gl_.glVertex3dv(P017);
            gl_.glNormal3dv(N001);
            gl_.glVertex3dv(P001);
            gl_.glNormal3dv(N018);
            gl_.glVertex3dv(P018);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N001);
            gl_.glVertex3dv(P001);
            gl_.glNormal3dv(N017);
            gl_.glVertex3dv(P017);
            gl_.glNormal3dv(N016);
            gl_.glVertex3dv(P016);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N001);
            gl_.glVertex3dv(P001);
            gl_.glNormal3dv(N013);
            gl_.glVertex3dv(P013);
            gl_.glNormal3dv(N012);
            gl_.glVertex3dv(P012);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N001);
            gl_.glVertex3dv(P001);
            gl_.glNormal3dv(N016);
            gl_.glVertex3dv(P016);
            gl_.glNormal3dv(N015);
            gl_.glVertex3dv(P015);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N001);
            gl_.glVertex3dv(P001);
            gl_.glNormal3dv(N014);
            gl_.glVertex3dv(P014);
            gl_.glNormal3dv(N013);
            gl_.glVertex3dv(P013);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N001);
            gl_.glVertex3dv(P001);
            gl_.glNormal3dv(N015);
            gl_.glVertex3dv(P015);
            gl_.glNormal3dv(N014);
            gl_.glVertex3dv(P014);
        gl_.glEnd();
      }

    void Whale004() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N014);
            gl_.glVertex3dv(P014);
            gl_.glNormal3dv(N015);
            gl_.glVertex3dv(P015);
            gl_.glNormal3dv(N023);
            gl_.glVertex3dv(P023);
            gl_.glNormal3dv(N022);
            gl_.glVertex3dv(P022);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N015);
            gl_.glVertex3dv(P015);
            gl_.glNormal3dv(N016);
            gl_.glVertex3dv(P016);
            gl_.glNormal3dv(N024);
            gl_.glVertex3dv(P024);
            gl_.glNormal3dv(N023);
            gl_.glVertex3dv(P023);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N016);
            gl_.glVertex3dv(P016);
            gl_.glNormal3dv(N017);
            gl_.glVertex3dv(P017);
            gl_.glNormal3dv(N025);
            gl_.glVertex3dv(P025);
            gl_.glNormal3dv(N024);
            gl_.glVertex3dv(P024);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N017);
            gl_.glVertex3dv(P017);
            gl_.glNormal3dv(N018);
            gl_.glVertex3dv(P018);
            gl_.glNormal3dv(N026);
            gl_.glVertex3dv(P026);
            gl_.glNormal3dv(N025);
            gl_.glVertex3dv(P025);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N013);
            gl_.glVertex3dv(P013);
            gl_.glNormal3dv(N014);
            gl_.glVertex3dv(P014);
            gl_.glNormal3dv(N022);
            gl_.glVertex3dv(P022);
            gl_.glNormal3dv(N021);
            gl_.glVertex3dv(P021);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N012);
            gl_.glVertex3dv(P012);
            gl_.glNormal3dv(N013);
            gl_.glVertex3dv(P013);
            gl_.glNormal3dv(N021);
            gl_.glVertex3dv(P021);
            gl_.glNormal3dv(N020);
            gl_.glVertex3dv(P020);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N018);
            gl_.glVertex3dv(P018);
            gl_.glNormal3dv(N019);
            gl_.glVertex3dv(P019);
            gl_.glNormal3dv(N027);
            gl_.glVertex3dv(P027);
            gl_.glNormal3dv(N026);
            gl_.glVertex3dv(P026);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N019);
            gl_.glVertex3dv(P019);
            gl_.glNormal3dv(N012);
            gl_.glVertex3dv(P012);
            gl_.glNormal3dv(N020);
            gl_.glVertex3dv(P020);
            gl_.glNormal3dv(N027);
            gl_.glVertex3dv(P027);
        gl_.glEnd();
      }

    void Whale005() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N022);
            gl_.glVertex3dv(P022);
            gl_.glNormal3dv(N023);
            gl_.glVertex3dv(P023);
            gl_.glNormal3dv(N031);
            gl_.glVertex3dv(P031);
            gl_.glNormal3dv(N030);
            gl_.glVertex3dv(P030);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N021);
            gl_.glVertex3dv(P021);
            gl_.glNormal3dv(N022);
            gl_.glVertex3dv(P022);
            gl_.glNormal3dv(N030);
            gl_.glVertex3dv(P030);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N021);
            gl_.glVertex3dv(P021);
            gl_.glNormal3dv(N030);
            gl_.glVertex3dv(P030);
            gl_.glNormal3dv(N029);
            gl_.glVertex3dv(P029);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N023);
            gl_.glVertex3dv(P023);
            gl_.glNormal3dv(N024);
            gl_.glVertex3dv(P024);
            gl_.glNormal3dv(N031);
            gl_.glVertex3dv(P031);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N024);
            gl_.glVertex3dv(P024);
            gl_.glNormal3dv(N032);
            gl_.glVertex3dv(P032);
            gl_.glNormal3dv(N031);
            gl_.glVertex3dv(P031);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N024);
            gl_.glVertex3dv(P024);
            gl_.glNormal3dv(N025);
            gl_.glVertex3dv(P025);
            gl_.glNormal3dv(N032);
            gl_.glVertex3dv(P032);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N025);
            gl_.glVertex3dv(P025);
            gl_.glNormal3dv(N033);
            gl_.glVertex3dv(P033);
            gl_.glNormal3dv(N032);
            gl_.glVertex3dv(P032);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N020);
            gl_.glVertex3dv(P020);
            gl_.glNormal3dv(N021);
            gl_.glVertex3dv(P021);
            gl_.glNormal3dv(N029);
            gl_.glVertex3dv(P029);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N020);
            gl_.glVertex3dv(P020);
            gl_.glNormal3dv(N029);
            gl_.glVertex3dv(P029);
            gl_.glNormal3dv(N028);
            gl_.glVertex3dv(P028);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N027);
            gl_.glVertex3dv(P027);
            gl_.glNormal3dv(N020);
            gl_.glVertex3dv(P020);
            gl_.glNormal3dv(N028);
            gl_.glVertex3dv(P028);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N027);
            gl_.glVertex3dv(P027);
            gl_.glNormal3dv(N028);
            gl_.glVertex3dv(P028);
            gl_.glNormal3dv(N035);
            gl_.glVertex3dv(P035);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N025);
            gl_.glVertex3dv(P025);
            gl_.glNormal3dv(N026);
            gl_.glVertex3dv(P026);
            gl_.glNormal3dv(N033);
            gl_.glVertex3dv(P033);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N033);
            gl_.glVertex3dv(P033);
            gl_.glNormal3dv(N026);
            gl_.glVertex3dv(P026);
            gl_.glNormal3dv(N034);
            gl_.glVertex3dv(P034);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N026);
            gl_.glVertex3dv(P026);
            gl_.glNormal3dv(N027);
            gl_.glVertex3dv(P027);
            gl_.glNormal3dv(N035);
            gl_.glVertex3dv(P035);
            gl_.glNormal3dv(N034);
            gl_.glVertex3dv(P034);
        gl_.glEnd();
      }

    void Whale006() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N092);
            gl_.glVertex3dv(P092);
            gl_.glNormal3dv(N093);
            gl_.glVertex3dv(P093);
            gl_.glNormal3dv(N094);
            gl_.glVertex3dv(P094);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N093);
            gl_.glVertex3dv(P093);
            gl_.glNormal3dv(N092);
            gl_.glVertex3dv(P092);
            gl_.glNormal3dv(N094);
            gl_.glVertex3dv(P094);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N092);
            gl_.glVertex3dv(P092);
            gl_.glNormal3dv(N091);
            gl_.glVertex3dv(P091);
            gl_.glNormal3dv(N095);
            gl_.glVertex3dv(P095);
            gl_.glNormal3dv(N094);
            gl_.glVertex3dv(P094);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N091);
            gl_.glVertex3dv(P091);
            gl_.glNormal3dv(N092);
            gl_.glVertex3dv(P092);
            gl_.glNormal3dv(N094);
            gl_.glVertex3dv(P094);
            gl_.glNormal3dv(N095);
            gl_.glVertex3dv(P095);
        gl_.glEnd();
      }

    void Whale007() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N030);
            gl_.glVertex3dv(P030);
            gl_.glNormal3dv(N031);
            gl_.glVertex3dv(P031);
            gl_.glNormal3dv(N039);
            gl_.glVertex3dv(P039);
            gl_.glNormal3dv(N038);
            gl_.glVertex3dv(P038);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N029);
            gl_.glVertex3dv(P029);
            gl_.glNormal3dv(N030);
            gl_.glVertex3dv(P030);
            gl_.glNormal3dv(N038);
            gl_.glVertex3dv(P038);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N029);
            gl_.glVertex3dv(P029);
            gl_.glNormal3dv(N038);
            gl_.glVertex3dv(P038);
            gl_.glNormal3dv(N037);
            gl_.glVertex3dv(P037);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N028);
            gl_.glVertex3dv(P028);
            gl_.glNormal3dv(N029);
            gl_.glVertex3dv(P029);
            gl_.glNormal3dv(N037);
            gl_.glVertex3dv(P037);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N028);
            gl_.glVertex3dv(P028);
            gl_.glNormal3dv(N037);
            gl_.glVertex3dv(P037);
            gl_.glNormal3dv(N036);
            gl_.glVertex3dv(P036);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N035);
            gl_.glVertex3dv(P035);
            gl_.glNormal3dv(N028);
            gl_.glVertex3dv(P028);
            gl_.glNormal3dv(N036);
            gl_.glVertex3dv(P036);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N035);
            gl_.glVertex3dv(P035);
            gl_.glNormal3dv(N036);
            gl_.glVertex3dv(P036);
            gl_.glNormal3dv(N043);
            gl_.glVertex3dv(P043);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N034);
            gl_.glVertex3dv(P034);
            gl_.glNormal3dv(N035);
            gl_.glVertex3dv(P035);
            gl_.glNormal3dv(N043);
            gl_.glVertex3dv(P043);
            gl_.glNormal3dv(N042);
            gl_.glVertex3dv(P042);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N033);
            gl_.glVertex3dv(P033);
            gl_.glNormal3dv(N034);
            gl_.glVertex3dv(P034);
            gl_.glNormal3dv(N042);
            gl_.glVertex3dv(P042);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N033);
            gl_.glVertex3dv(P033);
            gl_.glNormal3dv(N042);
            gl_.glVertex3dv(P042);
            gl_.glNormal3dv(N041);
            gl_.glVertex3dv(P041);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N031);
            gl_.glVertex3dv(P031);
            gl_.glNormal3dv(N032);
            gl_.glVertex3dv(P032);
            gl_.glNormal3dv(N039);
            gl_.glVertex3dv(P039);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N039);
            gl_.glVertex3dv(P039);
            gl_.glNormal3dv(N032);
            gl_.glVertex3dv(P032);
            gl_.glNormal3dv(N040);
            gl_.glVertex3dv(P040);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N032);
            gl_.glVertex3dv(P032);
            gl_.glNormal3dv(N033);
            gl_.glVertex3dv(P033);
            gl_.glNormal3dv(N040);
            gl_.glVertex3dv(P040);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N040);
            gl_.glVertex3dv(P040);
            gl_.glNormal3dv(N033);
            gl_.glVertex3dv(P033);
            gl_.glNormal3dv(N041);
            gl_.glVertex3dv(P041);
        gl_.glEnd();
      }

    void Whale008() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N042);
            gl_.glVertex3dv(P042);
            gl_.glNormal3dv(N043);
            gl_.glVertex3dv(P043);
            gl_.glNormal3dv(N051);
            gl_.glVertex3dv(P051);
            gl_.glNormal3dv(N050);
            gl_.glVertex3dv(P050);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N043);
            gl_.glVertex3dv(P043);
            gl_.glNormal3dv(N036);
            gl_.glVertex3dv(P036);
            gl_.glNormal3dv(N051);
            gl_.glVertex3dv(P051);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N051);
            gl_.glVertex3dv(P051);
            gl_.glNormal3dv(N036);
            gl_.glVertex3dv(P036);
            gl_.glNormal3dv(N044);
            gl_.glVertex3dv(P044);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N041);
            gl_.glVertex3dv(P041);
            gl_.glNormal3dv(N042);
            gl_.glVertex3dv(P042);
            gl_.glNormal3dv(N050);
            gl_.glVertex3dv(P050);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N041);
            gl_.glVertex3dv(P041);
            gl_.glNormal3dv(N050);
            gl_.glVertex3dv(P050);
            gl_.glNormal3dv(N049);
            gl_.glVertex3dv(P049);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N036);
            gl_.glVertex3dv(P036);
            gl_.glNormal3dv(N037);
            gl_.glVertex3dv(P037);
            gl_.glNormal3dv(N044);
            gl_.glVertex3dv(P044);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N044);
            gl_.glVertex3dv(P044);
            gl_.glNormal3dv(N037);
            gl_.glVertex3dv(P037);
            gl_.glNormal3dv(N045);
            gl_.glVertex3dv(P045);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N040);
            gl_.glVertex3dv(P040);
            gl_.glNormal3dv(N041);
            gl_.glVertex3dv(P041);
            gl_.glNormal3dv(N049);
            gl_.glVertex3dv(P049);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N040);
            gl_.glVertex3dv(P040);
            gl_.glNormal3dv(N049);
            gl_.glVertex3dv(P049);
            gl_.glNormal3dv(N048);
            gl_.glVertex3dv(P048);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N039);
            gl_.glVertex3dv(P039);
            gl_.glNormal3dv(N040);
            gl_.glVertex3dv(P040);
            gl_.glNormal3dv(N048);
            gl_.glVertex3dv(P048);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N039);
            gl_.glVertex3dv(P039);
            gl_.glNormal3dv(N048);
            gl_.glVertex3dv(P048);
            gl_.glNormal3dv(N047);
            gl_.glVertex3dv(P047);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N037);
            gl_.glVertex3dv(P037);
            gl_.glNormal3dv(N038);
            gl_.glVertex3dv(P038);
            gl_.glNormal3dv(N045);
            gl_.glVertex3dv(P045);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N038);
            gl_.glVertex3dv(P038);
            gl_.glNormal3dv(N046);
            gl_.glVertex3dv(P046);
            gl_.glNormal3dv(N045);
            gl_.glVertex3dv(P045);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N038);
            gl_.glVertex3dv(P038);
            gl_.glNormal3dv(N039);
            gl_.glVertex3dv(P039);
            gl_.glNormal3dv(N047);
            gl_.glVertex3dv(P047);
            gl_.glNormal3dv(N046);
            gl_.glVertex3dv(P046);
        gl_.glEnd();
      }

    void Whale009() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N050);
            gl_.glVertex3dv(P050);
            gl_.glNormal3dv(N051);
            gl_.glVertex3dv(P051);
            gl_.glNormal3dv(N059);
            gl_.glVertex3dv(P059);
            gl_.glNormal3dv(N058);
            gl_.glVertex3dv(P058);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N051);
            gl_.glVertex3dv(P051);
            gl_.glNormal3dv(N044);
            gl_.glVertex3dv(P044);
            gl_.glNormal3dv(N059);
            gl_.glVertex3dv(P059);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N059);
            gl_.glVertex3dv(P059);
            gl_.glNormal3dv(N044);
            gl_.glVertex3dv(P044);
            gl_.glNormal3dv(N052);
            gl_.glVertex3dv(P052);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N044);
            gl_.glVertex3dv(P044);
            gl_.glNormal3dv(N045);
            gl_.glVertex3dv(P045);
            gl_.glNormal3dv(N053);
            gl_.glVertex3dv(P053);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N044);
            gl_.glVertex3dv(P044);
            gl_.glNormal3dv(N053);
            gl_.glVertex3dv(P053);
            gl_.glNormal3dv(N052);
            gl_.glVertex3dv(P052);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N049);
            gl_.glVertex3dv(P049);
            gl_.glNormal3dv(N050);
            gl_.glVertex3dv(P050);
            gl_.glNormal3dv(N058);
            gl_.glVertex3dv(P058);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N049);
            gl_.glVertex3dv(P049);
            gl_.glNormal3dv(N058);
            gl_.glVertex3dv(P058);
            gl_.glNormal3dv(N057);
            gl_.glVertex3dv(P057);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N048);
            gl_.glVertex3dv(P048);
            gl_.glNormal3dv(N049);
            gl_.glVertex3dv(P049);
            gl_.glNormal3dv(N057);
            gl_.glVertex3dv(P057);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N048);
            gl_.glVertex3dv(P048);
            gl_.glNormal3dv(N057);
            gl_.glVertex3dv(P057);
            gl_.glNormal3dv(N056);
            gl_.glVertex3dv(P056);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N047);
            gl_.glVertex3dv(P047);
            gl_.glNormal3dv(N048);
            gl_.glVertex3dv(P048);
            gl_.glNormal3dv(N056);
            gl_.glVertex3dv(P056);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N047);
            gl_.glVertex3dv(P047);
            gl_.glNormal3dv(N056);
            gl_.glVertex3dv(P056);
            gl_.glNormal3dv(N055);
            gl_.glVertex3dv(P055);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N045);
            gl_.glVertex3dv(P045);
            gl_.glNormal3dv(N046);
            gl_.glVertex3dv(P046);
            gl_.glNormal3dv(N053);
            gl_.glVertex3dv(P053);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N046);
            gl_.glVertex3dv(P046);
            gl_.glNormal3dv(N054);
            gl_.glVertex3dv(P054);
            gl_.glNormal3dv(N053);
            gl_.glVertex3dv(P053);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N046);
            gl_.glVertex3dv(P046);
            gl_.glNormal3dv(N047);
            gl_.glVertex3dv(P047);
            gl_.glNormal3dv(N055);
            gl_.glVertex3dv(P055);
            gl_.glNormal3dv(N054);
            gl_.glVertex3dv(P054);
        gl_.glEnd();
      }

    void Whale010() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N080);
            gl_.glVertex3dv(P080);
            gl_.glNormal3dv(N081);
            gl_.glVertex3dv(P081);
            gl_.glNormal3dv(N085);
            gl_.glVertex3dv(P085);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N081);
            gl_.glVertex3dv(P081);
            gl_.glNormal3dv(N083);
            gl_.glVertex3dv(P083);
            gl_.glNormal3dv(N085);
            gl_.glVertex3dv(P085);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N085);
            gl_.glVertex3dv(P085);
            gl_.glNormal3dv(N083);
            gl_.glVertex3dv(P083);
            gl_.glNormal3dv(N077);
            gl_.glVertex3dv(P077);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N083);
            gl_.glVertex3dv(P083);
            gl_.glNormal3dv(N087);
            gl_.glVertex3dv(P087);
            gl_.glNormal3dv(N077);
            gl_.glVertex3dv(P077);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N077);
            gl_.glVertex3dv(P077);
            gl_.glNormal3dv(N087);
            gl_.glVertex3dv(P087);
            gl_.glNormal3dv(N090);
            gl_.glVertex3dv(P090);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N081);
            gl_.glVertex3dv(P081);
            gl_.glNormal3dv(N080);
            gl_.glVertex3dv(P080);
            gl_.glNormal3dv(N085);
            gl_.glVertex3dv(P085);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N083);
            gl_.glVertex3dv(P083);
            gl_.glNormal3dv(N081);
            gl_.glVertex3dv(P081);
            gl_.glNormal3dv(N085);
            gl_.glVertex3dv(P085);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N083);
            gl_.glVertex3dv(P083);
            gl_.glNormal3dv(N085);
            gl_.glVertex3dv(P085);
            gl_.glNormal3dv(N077);
            gl_.glVertex3dv(P077);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N087);
            gl_.glVertex3dv(P087);
            gl_.glNormal3dv(N083);
            gl_.glVertex3dv(P083);
            gl_.glNormal3dv(N077);
            gl_.glVertex3dv(P077);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N087);
            gl_.glVertex3dv(P087);
            gl_.glNormal3dv(N077);
            gl_.glVertex3dv(P077);
            gl_.glNormal3dv(N090);
            gl_.glVertex3dv(P090);
        gl_.glEnd();
      }

    void Whale011() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N082);
            gl_.glVertex3dv(P082);
            gl_.glNormal3dv(N084);
            gl_.glVertex3dv(P084);
            gl_.glNormal3dv(N079);
            gl_.glVertex3dv(P079);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N084);
            gl_.glVertex3dv(P084);
            gl_.glNormal3dv(N086);
            gl_.glVertex3dv(P086);
            gl_.glNormal3dv(N079);
            gl_.glVertex3dv(P079);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N079);
            gl_.glVertex3dv(P079);
            gl_.glNormal3dv(N086);
            gl_.glVertex3dv(P086);
            gl_.glNormal3dv(N078);
            gl_.glVertex3dv(P078);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N086);
            gl_.glVertex3dv(P086);
            gl_.glNormal3dv(N088);
            gl_.glVertex3dv(P088);
            gl_.glNormal3dv(N078);
            gl_.glVertex3dv(P078);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N078);
            gl_.glVertex3dv(P078);
            gl_.glNormal3dv(N088);
            gl_.glVertex3dv(P088);
            gl_.glNormal3dv(N089);
            gl_.glVertex3dv(P089);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N088);
            gl_.glVertex3dv(P088);
            gl_.glNormal3dv(N086);
            gl_.glVertex3dv(P086);
            gl_.glNormal3dv(N089);
            gl_.glVertex3dv(P089);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N089);
            gl_.glVertex3dv(P089);
            gl_.glNormal3dv(N086);
            gl_.glVertex3dv(P086);
            gl_.glNormal3dv(N078);
            gl_.glVertex3dv(P078);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N086);
            gl_.glVertex3dv(P086);
            gl_.glNormal3dv(N084);
            gl_.glVertex3dv(P084);
            gl_.glNormal3dv(N078);
            gl_.glVertex3dv(P078);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N078);
            gl_.glVertex3dv(P078);
            gl_.glNormal3dv(N084);
            gl_.glVertex3dv(P084);
            gl_.glNormal3dv(N079);
            gl_.glVertex3dv(P079);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N084);
            gl_.glVertex3dv(P084);
            gl_.glNormal3dv(N082);
            gl_.glVertex3dv(P082);
            gl_.glNormal3dv(N079);
            gl_.glVertex3dv(P079);
        gl_.glEnd();
      }

    void Whale012() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N058);
            gl_.glVertex3dv(P058);
            gl_.glNormal3dv(N059);
            gl_.glVertex3dv(P059);
            gl_.glNormal3dv(N067);
            gl_.glVertex3dv(P067);
            gl_.glNormal3dv(N066);
            gl_.glVertex3dv(P066);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N059);
            gl_.glVertex3dv(P059);
            gl_.glNormal3dv(N052);
            gl_.glVertex3dv(P052);
            gl_.glNormal3dv(N060);
            gl_.glVertex3dv(P060);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N059);
            gl_.glVertex3dv(P059);
            gl_.glNormal3dv(N060);
            gl_.glVertex3dv(P060);
            gl_.glNormal3dv(N067);
            gl_.glVertex3dv(P067);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N058);
            gl_.glVertex3dv(P058);
            gl_.glNormal3dv(N066);
            gl_.glVertex3dv(P066);
            gl_.glNormal3dv(N065);
            gl_.glVertex3dv(P065);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N058);
            gl_.glVertex3dv(P058);
            gl_.glNormal3dv(N065);
            gl_.glVertex3dv(P065);
            gl_.glNormal3dv(N057);
            gl_.glVertex3dv(P057);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N056);
            gl_.glVertex3dv(P056);
            gl_.glNormal3dv(N057);
            gl_.glVertex3dv(P057);
            gl_.glNormal3dv(N065);
            gl_.glVertex3dv(P065);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N056);
            gl_.glVertex3dv(P056);
            gl_.glNormal3dv(N065);
            gl_.glVertex3dv(P065);
            gl_.glNormal3dv(N006);
            gl_.glVertex3dv(P006);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N056);
            gl_.glVertex3dv(P056);
            gl_.glNormal3dv(N006);
            gl_.glVertex3dv(P006);
            gl_.glNormal3dv(N063);
            gl_.glVertex3dv(P063);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N056);
            gl_.glVertex3dv(P056);
            gl_.glNormal3dv(N063);
            gl_.glVertex3dv(P063);
            gl_.glNormal3dv(N055);
            gl_.glVertex3dv(P055);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N054);
            gl_.glVertex3dv(P054);
            gl_.glNormal3dv(N062);
            gl_.glVertex3dv(P062);
            gl_.glNormal3dv(N005);
            gl_.glVertex3dv(P005);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N054);
            gl_.glVertex3dv(P054);
            gl_.glNormal3dv(N005);
            gl_.glVertex3dv(P005);
            gl_.glNormal3dv(N053);
            gl_.glVertex3dv(P053);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N053);
            gl_.glVertex3dv(P053);
            gl_.glNormal3dv(N005);
            gl_.glVertex3dv(P005);
            gl_.glNormal3dv(N060);
            gl_.glVertex3dv(P060);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N053);
            gl_.glVertex3dv(P053);
            gl_.glNormal3dv(N060);
            gl_.glVertex3dv(P060);
            gl_.glNormal3dv(N052);
            gl_.glVertex3dv(P052);
        gl_.glEnd();
      }

    void Whale013() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N066);
            gl_.glVertex3dv(P066);
            gl_.glNormal3dv(N067);
            gl_.glVertex3dv(P067);
            gl_.glNormal3dv(N096);
            gl_.glVertex3dv(P096);
            gl_.glNormal3dv(N097);
            gl_.glVertex3dv(P097);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N097);
            gl_.glVertex3dv(P097);
            gl_.glNormal3dv(N096);
            gl_.glVertex3dv(P096);
            gl_.glNormal3dv(N098);
            gl_.glVertex3dv(P098);
            gl_.glNormal3dv(N099);
            gl_.glVertex3dv(P099);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N065);
            gl_.glVertex3dv(P065);
            gl_.glNormal3dv(N066);
            gl_.glVertex3dv(P066);
            gl_.glNormal3dv(N097);
            gl_.glVertex3dv(P097);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N067);
            gl_.glVertex3dv(P067);
            gl_.glNormal3dv(N060);
            gl_.glVertex3dv(P060);
            gl_.glNormal3dv(N096);
            gl_.glVertex3dv(P096);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N060);
            gl_.glVertex3dv(P060);
            gl_.glNormal3dv(N005);
            gl_.glVertex3dv(P005);
            gl_.glNormal3dv(N096);
            gl_.glVertex3dv(P096);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N096);
            gl_.glVertex3dv(P096);
            gl_.glNormal3dv(N005);
            gl_.glVertex3dv(P005);
            gl_.glNormal3dv(N098);
            gl_.glVertex3dv(P098);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N006);
            gl_.glVertex3dv(P006);
            gl_.glNormal3dv(N065);
            gl_.glVertex3dv(P065);
            gl_.glNormal3dv(N097);
            gl_.glVertex3dv(P097);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N006);
            gl_.glVertex3dv(P006);
            gl_.glNormal3dv(N097);
            gl_.glVertex3dv(P097);
            gl_.glNormal3dv(N099);
            gl_.glVertex3dv(P099);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P005);
            gl_.glVertex3dv(P006);
            gl_.glVertex3dv(P099);
            gl_.glVertex3dv(P098);
        gl_.glEnd();
      }

    void Whale014() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N062);
            gl_.glVertex3dv(P062);
            gl_.glNormal3dv(N004);
            gl_.glVertex3dv(P004);
            gl_.glNormal3dv(N005);
            gl_.glVertex3dv(P005);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P006);
            gl_.glVertex3dv(P005);
            gl_.glVertex3dv(P004);
            gl_.glVertex3dv(P008);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N063);
            gl_.glVertex3dv(P063);
            gl_.glNormal3dv(N006);
            gl_.glVertex3dv(P006);
            gl_.glNormal3dv(N002);
            gl_.glVertex3dv(P002);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N002);
            gl_.glVertex3dv(P002);
            gl_.glNormal3dv(N006);
            gl_.glVertex3dv(P006);
            gl_.glNormal3dv(N008);
            gl_.glVertex3dv(P008);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N002);
            gl_.glVertex3dv(P002);
            gl_.glNormal3dv(N008);
            gl_.glVertex3dv(P008);
            gl_.glNormal3dv(N004);
            gl_.glVertex3dv(P004);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N062);
            gl_.glVertex3dv(P062);
            gl_.glNormal3dv(N002);
            gl_.glVertex3dv(P002);
            gl_.glNormal3dv(N004);
            gl_.glVertex3dv(P004);
        gl_.glEnd();
      }

    void Whale015() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N055);
            gl_.glVertex3dv(P055);
            gl_.glNormal3dv(N003);
            gl_.glVertex3dv(P003);
            gl_.glNormal3dv(N054);
            gl_.glVertex3dv(P054);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N003);
            gl_.glVertex3dv(P003);
            gl_.glNormal3dv(N055);
            gl_.glVertex3dv(P055);
            gl_.glNormal3dv(N063);
            gl_.glVertex3dv(P063);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N003);
            gl_.glVertex3dv(P003);
            gl_.glNormal3dv(N063);
            gl_.glVertex3dv(P063);
            gl_.glNormal3dv(N100);
            gl_.glVertex3dv(P100);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N003);
            gl_.glVertex3dv(P003);
            gl_.glNormal3dv(N100);
            gl_.glVertex3dv(P100);
            gl_.glNormal3dv(N054);
            gl_.glVertex3dv(P054);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N054);
            gl_.glVertex3dv(P054);
            gl_.glNormal3dv(N100);
            gl_.glVertex3dv(P100);
            gl_.glNormal3dv(N062);
        gl_.glVertex3dv(P062);
        gl_.glEnd();
            gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N100);
            gl_.glVertex3dv(P100);
            gl_.glNormal3dv(N063);
            gl_.glVertex3dv(P063);
            gl_.glNormal3dv(N002);
            gl_.glVertex3dv(P002);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glNormal3dv(N100);
            gl_.glVertex3dv(P100);
            gl_.glNormal3dv(N002);
            gl_.glVertex3dv(P002);
            gl_.glNormal3dv(N062);
            gl_.glVertex3dv(P062);
        gl_.glEnd();
      }

    void Whale016() throws OpenGLException {
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P104);
            gl_.glVertex3dv(P105);
            gl_.glVertex3dv(P106);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P107);
            gl_.glVertex3dv(P108);
            gl_.glVertex3dv(P109);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P110);
            gl_.glVertex3dv(P111);
            gl_.glVertex3dv(P112);
            gl_.glVertex3dv(P113);
            gl_.glVertex3dv(P114);
            gl_.glVertex3dv(P115);
        gl_.glEnd();
        gl_.glBegin(GL.GL_POLYGON);
            gl_.glVertex3dv(P116);
            gl_.glVertex3dv(P117);
            gl_.glVertex3dv(P118);
            gl_.glVertex3dv(P119);
            gl_.glVertex3dv(P120);
            gl_.glVertex3dv(P121);
        gl_.glEnd();
      }

    public void draw() {
        float seg0, seg1, seg2, seg3, seg4, seg5, seg6, seg7;
        float pitch, thrash, chomp;

        htail = (int)( htail - (int)( 5.0 * v ) ) % 360;

        thrash = (float)( 70.0 * v );

        seg0 = (float)( 1.5 * thrash * Math.sin((htail) * atlantis.RRAD) );
        seg1 = (float)( 2.5 * thrash * Math.sin((htail + 10.0) * atlantis.RRAD) );
        seg2 = (float)( 3.7 * thrash * Math.sin((htail + 15.0) * atlantis.RRAD) );
        seg3 = (float)( 4.8 * thrash * Math.sin((htail + 23.0) * atlantis.RRAD) );
        seg4 = (float)( 6.0 * thrash * Math.sin((htail + 28.0) * atlantis.RRAD) );
        seg5 = (float)( 6.5 * thrash * Math.sin((htail + 35.0) * atlantis.RRAD) );
        seg6 = (float)( 6.5 * thrash * Math.sin((htail + 40.0) * atlantis.RRAD) );
        seg7 = (float)( 6.5 * thrash * Math.sin((htail + 55.0) * atlantis.RRAD) );

        pitch = (float)( v * Math.sin((htail - 160.0) * atlantis.RRAD) );

        chomp = 0.0f;
        if (v > 2.0) {
            chomp = -(float)( (v - 2.0) * 200.0 );
          }

        P012[1] = iP012[1] + seg5;
        P013[1] = iP013[1] + seg5;
        P014[1] = iP014[1] + seg5;
        P015[1] = iP015[1] + seg5;
        P016[1] = iP016[1] + seg5;
        P017[1] = iP017[1] + seg5;
        P018[1] = iP018[1] + seg5;
        P019[1] = iP019[1] + seg5;
    
        P020[1] = iP020[1] + seg4;
        P021[1] = iP021[1] + seg4;
        P022[1] = iP022[1] + seg4;
        P023[1] = iP023[1] + seg4;
        P024[1] = iP024[1] + seg4;
        P025[1] = iP025[1] + seg4;
        P026[1] = iP026[1] + seg4;
        P027[1] = iP027[1] + seg4;
    
        P028[1] = iP028[1] + seg2;
        P029[1] = iP029[1] + seg2;
        P030[1] = iP030[1] + seg2;
        P031[1] = iP031[1] + seg2;
        P032[1] = iP032[1] + seg2;
        P033[1] = iP033[1] + seg2;
        P034[1] = iP034[1] + seg2;
        P035[1] = iP035[1] + seg2;
    
        P036[1] = iP036[1] + seg1;
        P037[1] = iP037[1] + seg1;
        P038[1] = iP038[1] + seg1;
        P039[1] = iP039[1] + seg1;
        P040[1] = iP040[1] + seg1;
        P041[1] = iP041[1] + seg1;
        P042[1] = iP042[1] + seg1;
        P043[1] = iP043[1] + seg1;
    
        P044[1] = iP044[1] + seg0;
        P045[1] = iP045[1] + seg0;
        P046[1] = iP046[1] + seg0;
        P047[1] = iP047[1] + seg0;
        P048[1] = iP048[1] + seg0;
        P049[1] = iP049[1] + seg0;
        P050[1] = iP050[1] + seg0;
        P051[1] = iP051[1] + seg0;
    
        P009[1] = iP009[1] + seg6;
        P010[1] = iP010[1] + seg6;
        P075[1] = iP075[1] + seg6;
        P076[1] = iP076[1] + seg6;
    
        P001[1] = iP001[1] + seg7;
        P011[1] = iP011[1] + seg7;
        P068[1] = iP068[1] + seg7;
        P069[1] = iP069[1] + seg7;
        P070[1] = iP070[1] + seg7;
        P071[1] = iP071[1] + seg7;
        P072[1] = iP072[1] + seg7;
        P073[1] = iP073[1] + seg7;
        P074[1] = iP074[1] + seg7;
    
        P091[1] = iP091[1] + seg3 * 1.1;
        P092[1] = iP092[1] + seg3;
        P093[1] = iP093[1] + seg3;
        P094[1] = iP094[1] + seg3;
        P095[1] = iP095[1] + seg3 * 0.9;
    
        P099[1] = iP099[1] + chomp;
        P098[1] = iP098[1] + chomp;
        P097[1] = iP097[1] + chomp;
        P096[1] = iP096[1] + chomp;
    
        try {
            gl_.glPushMatrix();
    
            gl_.glRotatef(pitch, 1.0f, 0.0f, 0.0f);

            gl_.glTranslatef(0.0f, 0.0f, 8000.0f);

            gl_.glRotatef(180.0f, 0.0f, 1.0f, 0.0f);

            gl_.glScalef(3.0f, 3.0f, 3.0f);

            gl_.glEnable( GL.GL_CULL_FACE );

            Whale001();
            Whale002();
            Whale003();
            Whale004();
            Whale005();
            Whale006();
            Whale007();
            Whale008();
            Whale009();
            Whale010();
            Whale011();
            Whale012();
            Whale013();
            Whale014();
            Whale015();
            Whale016();
    
            gl_.glDisable(GL.GL_CULL_FACE);

            gl_.glPopMatrix();
          } catch ( OpenGLException e ) {
            e.printStackTrace();
          }
      }
  }
