/**
 * $Id: swatchListener.java,v 1.3 1998/10/19 10:45:39 descarte Exp descarte $
 *
 * Copyright (c)1997-1998 Arcane Technologies Ltd. <http://www.arcana.co.uk>
 *
 * Public listener class for the swatch GLComponent
 *
 * $Log: swatchListener.java,v $
 * Revision 1.3  1998/10/19 10:45:39  descarte
 * Made JDK-1.1 compliant by removing deprecated methods. Updated copyright.
 *
 * Revision 1.2  1998/10/02 12:12:55  descarte
 * Changed GLComponentListener to GLEventListener
 * Altered arguments to reshape() method
 *
 * Revision 1.1  1998/03/30 12:30:09  descarte
 * Initial revision
 *
 */

package com.hermetica.magician.demos.colEdit;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import com.hermetica.magician.*;
import com.hermetica.util3d.*;

/** Listener for the swatch */
public class swatchListener implements GLEventListener, MouseListener {

    /** OpenGL pipelines */
    GL gl_ = null;
    CoreGL coregl_ = new CoreGL();

    GLU glu_ = null;
    CoreGLU coreglu_ = new CoreGLU();

    /** The currently picked pixel colour */
    private float[] pixels = { 0.0f, 0.0f, 1.0f };

    /** Initializes the component */
    public void initialize( GLDrawable component ) {

        gl_ = coregl_;
        glu_ = coreglu_;

        gl_.glShadeModel( GL.GL_FLAT );
        gl_.glClearColor( 0.0f, 0.0f, 0.0f, 1.0f );
      }

    /** Handles viewport resizing */
    public void reshape( GLDrawable component, int x, int y, int width, int height ) {
        gl_.glViewport( component, x, y, width, height );
        gl_.glMatrixMode( GL.GL_PROJECTION );
        gl_.glLoadIdentity();
        glu_.gluOrtho2D( 0.0f, 16.0f, 0.0f, 16.0f );
        gl_.glMatrixMode( GL.GL_MODELVIEW );
        gl_.glLoadIdentity();
      }
        
    /** Redisplays the swatch when required */
    public void display( GLDrawable component ) {
        gl_.glClear( GL.GL_DEPTH_BUFFER_BIT | GL.GL_COLOR_BUFFER_BIT );

        for ( int i = 0 ; i < 16 ; i++ ) {
            for ( int j = 0 ; j < 16 ; j++ ) {
                gl_.glColor3f( 0.0f, 0.0f, 
                               (float)( i + ( j * 16 ) ) / 256.0f );
                gl_.glRecti( i, j, i + 1, j + 1 );
              }
          }
      }

    /** Returns the GL instance being used by the swatch */
    public GL getGL() {
        return gl_;
      }

    /** Returns the picked pixels */
    public float[] getPixels() {
        return pixels;
      }

    /** Handles mouse events */
    /** Handles mouse clicked events */
    public void mouseClicked( MouseEvent evt ) {
        /** 
         * Since ``mouseClicked()'' is not a method defined in 
         * GLEventListener we must perform context management ourselves.
         */
        ((GLComponent)evt.getSource()).getContext().makeCurrent();

        /** Set the buffer to read the pixels from and read 'em in! */
        gl_.glReadBuffer( GL.GL_BACK );
        gl_.glReadPixels( evt.getX(), 
                          ((GLComponent)evt.getSource()).getSize().height - evt.getY() - 1, 
                          1, 1, GL.GL_RGB, GL.GL_FLOAT, pixels );

        /** Release the rendering context */
        ((GLComponent)evt.getSource()).getContext().unlock();
      }

    /** Handles mouse entered events */
    public void mouseEntered( MouseEvent evt ) {
      }

    /** Handles mouse exited events */
    public void mouseExited( MouseEvent evt ) {
      }

    /** Handles mouse pressed events */
    public void mousePressed( MouseEvent evt ) {
      }

    /** Handles mouse released events */
    public void mouseReleased( MouseEvent evt ) {
      }
  }
