/**
 * $Id: Light.java,v 1.3 1998/10/19 10:53:59 descarte Exp descarte $
 *
 * Copyright (c)1997-1998 Arcane Technologies Ltd. <http://www.arcana.co.uk>
 *
 * A light object used by the ``Spotlights'' demo
 *
 * $Log: Light.java,v $
 * Revision 1.3  1998/10/19 10:53:59  descarte
 * Made JDK-1.1 compliant by removing deprecated methods. Updated copyright.
 *
 * Revision 1.2  1998/03/30 12:07:01  descarte
 * Made variables public.
 * Made class declaration public.
 *
 * Revision 1.1  1998/03/30 12:03:21  descarte
 * Initial revision
 *
 */

package com.hermetica.magician.demos.glut;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import com.hermetica.magician.*;
import com.hermetica.util3d.*;

/** A light */
public class Light {

    /** Ambient property */
    public float[] amb = new float[4];

    /** Diffuse property */
    public float[] diff = new float[4];

    /** Specular property */
    public float[] spec = new float[4];

    /** Position */
    public float[] pos = new float[4];

    /** Direction of the spotlight */
    public float[] spotDir = new float[3];

    /** Exponential */
    public float spotExp = 0;

    /** Cut-off */
    public float spotCutoff = 0;

    /** Attenuation */
    public float[] atten = new float[3];

    /** Translation */
    public float[] trans = new float[3];

    /** Rotation */
    public float[] rot = new float[3];

    /** Swing */
    public float[] swing = new float[3];

    /** Angle of swing */
    public float[] arc = new float[3];

    /** Angle increment */
    public float[] arcIncr = new float[3];

    /** Constructor */
    public Light( float[] ambient, float[] diffuse, float[] specular,
                  float[] position, float[] direction, float exponent,
                  float cutoff, float[] attenuation, float[] translation,
                  float[] rotation, float[] swing, float[] arc,
                  float[] arcIncrement ) {
        this.amb = ambient;
        this.diff = diffuse;
        this.spec = specular;
        this.pos = position;
        this.spotDir = direction;
        this.spotExp = exponent;
        this.spotCutoff = cutoff;
        this.atten = attenuation;
        this.trans = translation;
        this.rot = rotation;
        this.swing = swing;
        this.arc = arc;
        this.arcIncr = arcIncrement;
      }
  }
