/**
 * $Id: tessdemoTesselator.java,v 1.3 1998/10/19 10:54:07 descarte Exp descarte $
 *
 * Copyright (c)1997-1998 Arcane Technologies Ltd. <http://www.arcana.co.uk>
 *
 * Tesselator class for the ``tessdemo'' demo
 *
 * $Log: tessdemoTesselator.java,v $
 * Revision 1.3  1998/10/19 10:54:07  descarte
 * Made JDK-1.1 compliant by removing deprecated methods. Updated copyright.
 *
 * Revision 1.2  1998/05/14 15:16:46  descarte
 * Removed GLComponent-based constructor.
 *
 * Revision 1.1  1998/03/30 12:19:28  descarte
 * Initial revision
 *
 */

package com.hermetica.magician.demos.glut;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import com.hermetica.magician.*;
import com.hermetica.magician.fonts.*;
import com.hermetica.util3d.*;

/** Tesselator class for tesselating the contours that we draw */
public class tessdemoTesselator extends GLUTesselator {

    /** gl is a CoreGL object declared in com.hermetica.magician.GLUTesselator */
    /** glu is a CoreGLU object declared in com.hermetica.magician.GLUTesselator */

    /** Called by the begin callback */
    public void begin( int mode ) {
        gl.glBegin( mode );
      }

    /** Called by the vertex callback */
    public void vertex( float[] data ) {
        gl.glVertex2fv( data );
      }

    /** Called by the end callback */
    public void end() {
        gl.glEnd();
      }

    /** Called by the error callback */
    public void error( int error ) {
        gl.glColor3f( 0.9f, 0.9f, 0.9f );
        gl.glRasterPos2i( 5, 5 );
        GLTimesRoman10BitmapFont font = new GLTimesRoman10BitmapFont();
        font.drawString( glu.gluErrorString( error ) );
      }

    /** Called by the edge flag callback */
    public void edgeFlag( boolean flag ) {
        gl.glEdgeFlag( ( flag ) ? (byte)GL.GL_TRUE : (byte)GL.GL_FALSE );
      }
  }
