/**
 * $Id: hudBottomLayer.java,v 1.5 1998/10/19 10:57:55 descarte Exp descarte $
 *
 * Copyright (c)1998 Arcane Technologies Ltd. <http://www.arcana.co.uk>
 *
 * Listener for the HUD demo that renders the background view
 *
 * $Log: hudBottomLayer.java,v $
 * Revision 1.5  1998/10/19 10:57:55  descarte
 * Made JDK-1.1 compliant by removing deprecated methods. Updated copyright.
 *
 * Revision 1.4  1998/10/02 12:30:08  descarte
 * Changed GLComponentListener to GLEventListener. Changed reshape() arguments.
 *
 * Revision 1.3  1998/03/24 17:07:54  descarte
 * Converted to GLDrawable interface.
 *
 * Revision 1.2  1998/03/19 22:22:59  descarte
 * Added getGL() method.
 *
 * Revision 1.1  1998/03/17 20:42:03  descarte
 * Initial revision
 *
 */

package com.hermetica.magician.demos.hud;

import com.hermetica.magician.*;

public class hudBottomLayer implements GLEventListener {

    /** Graphics pipeline */
    CoreGL gl_ = new CoreGL();

    /** Initializes the listener */
    public void initialize( GLDrawable component ) {

        /** Position of the light */
        float[] position = { 0.0f, 50.0f, -100.0f };

//        System.err.println( "Bottom:initialize()" );
        gl_.glNewList( 100, GL.GL_COMPILE );
            gl_.glDisable( GL.GL_DEPTH_TEST );
            gl_.glShadeModel( GL.GL_SMOOTH );
            gl_.glBegin( GL.GL_POLYGON );
                gl_.glColor3f( 0.0f, 0.0f, 0.0f );
                gl_.glVertex3f( -1000, 1000, -999 );
                gl_.glVertex3f( 1000, 1000, -999 );
                gl_.glColor3f( 0.0f, 0.0f, 1.0f );
                gl_.glVertex3f( 1000, -1000, -999 );
                gl_.glVertex3f( -1000, -1000, -999 );
            gl_.glEnd();
            gl_.glEnable( GL.GL_DEPTH_TEST );
        gl_.glEndList();

        /** Create a light */
        gl_.glLightfv( GL.GL_LIGHT0, GL.GL_POSITION, position );

        /** Set the clear colour */
        gl_.glClearColor( 0.0f, 0.0f, 1.0f, 1.0f );
      }

    /** Handles viewport resizing */
    public void reshape( GLDrawable component, int x, int y, int width, int height ) {
//        System.err.println( "Bottom:reshape()" );
        gl_.glViewport( component, x, y, width, height );
        gl_.glMatrixMode( GL.GL_PROJECTION );
        gl_.glLoadIdentity();
        gl_.glFrustum( -1.0, 1.0, -1.0, 1.0, 1.0, 1000 );
        gl_.glMatrixMode( GL.GL_MODELVIEW );
        gl_.glLoadIdentity();
      }
        
    /** Renders stuff */
    public void display( GLDrawable component ) {
//        System.err.println( "Bottom:display()" );
        gl_.glClear( GL.GL_DEPTH_BUFFER_BIT | GL.GL_COLOR_BUFFER_BIT );

        /** Draw the background */
        gl_.glCallList( 100 );
      }

    /** Return a GL pipeline for this listener */
    public GL getGL() {
        return gl_;
      }
  }
