/**
 * $Id: hudMiddleLayer.java,v 1.5 1998/10/19 10:57:57 descarte Exp descarte $
 *
 * Copyright (c)1998 Arcane Technologies Ltd. <http://www.arcana.co.uk>
 *
 * Listener for the HUD demo that renders the middle view ( a spinning cube )
 *
 * $Log: hudMiddleLayer.java,v $
 * Revision 1.5  1998/10/19 10:57:57  descarte
 * Made JDK-1.1 compliant by removing deprecated methods. Updated copyright.
 *
 * Revision 1.4  1998/10/02 12:30:10  descarte
 * Changed GLComponentListener to GLEventListener. Changed reshape() arguments.
 *
 * Revision 1.3  1998/03/24 17:08:06  descarte
 * Converted to GLDrawable interface.
 *
 * Revision 1.2  1998/03/19 22:23:08  descarte
 * Added getGL() method.
 *
 * Revision 1.1  1998/03/17 20:42:13  descarte
 * Initial revision
 *
 */

package com.hermetica.magician.demos.hud;

import com.hermetica.magician.*;
import com.hermetica.util3d.shapes;

public class hudMiddleLayer implements GLEventListener {

    /** Graphics pipeline */
    CoreGL gl_ = new CoreGL();

    /** The rotational angle of the cube */
    private float angle = 0.0f;

    /** Initializes the listener */
    public void initialize( GLDrawable component ) {
//        System.err.println( "Middle:initialize()" );
      }

    /** Handles viewport resizing */
    public void reshape( GLDrawable component, int x, int y, int width, int height ) {
//        System.err.println( "Middle:reshape()" );
      }
        
    /** Renders stuff */
    public void display( GLDrawable component ) {
//        System.err.println( "Middle:display()" );

        /** Enable lighting */
        gl_.glEnable( GL.GL_LIGHT0 );
        gl_.glEnable( GL.GL_LIGHTING );

        /** Enable z-buffering */
        gl_.glEnable( GL.GL_DEPTH_TEST );

        gl_.glPushMatrix();
            gl_.glLoadIdentity();
            gl_.glTranslatef( 0, 0, -200 );
            gl_.glRotatef( angle, 1, 0, 0 );
            gl_.glRotatef( angle, 0, 1, 0 );
            gl_.glRotatef( angle, 0, 0, 1 );
            shapes.solidCube( 75 );
        gl_.glPopMatrix();

        /** Disable the lighting */
        gl_.glDisable( GL.GL_LIGHT0 );
        gl_.glDisable( GL.GL_LIGHTING );

        /** Disable z-buffering */
        gl_.glDisable( GL.GL_DEPTH_TEST );

        /** Update the angle */
        angle++;
        if ( angle >= 360.0f ) {
            angle -= 360.0f;
          }
      }

    /** Return a GL pipeline for this listener */
    public GL getGL() {
        return gl_;
      }
  }
