/**
 * $Id: hudTopLayer.java,v 1.5 1998/10/19 10:57:59 descarte Exp descarte $
 *
 * Copyright (c)1998 Arcane Technologies Ltd. <http://www.arcana.co.uk>
 *
 * Listener for the HUD demo that renders the top view ( some text )
 *
 * $Log: hudTopLayer.java,v $
 * Revision 1.5  1998/10/19 10:57:59  descarte
 * Made JDK-1.1 compliant by removing deprecated methods. Updated copyright.
 *
 * Revision 1.4  1998/10/02 12:30:11  descarte
 * Changed GLComponentListener to GLEventListener. Changed reshape() arguments.
 *
 * Revision 1.3  1998/03/24 17:08:15  descarte
 * Converted to GLDrawable interface.
 *
 * Revision 1.2  1998/03/19 22:23:14  descarte
 * Added getGL() method.
 *
 * Revision 1.1  1998/03/17 20:42:23  descarte
 * Initial revision
 *
 */

package com.hermetica.magician.demos.hud;

import com.hermetica.magician.*;
import com.hermetica.magician.fonts.*;

public class hudTopLayer implements GLEventListener {

    /** Graphics pipeline */
    CoreGL gl_ = new CoreGL();
    CoreGLU glu_ = new CoreGLU();

    /** Initializes the listener */
    public void initialize( GLDrawable component ) {
//        System.err.println( "Top:initialize()" );
      }

    /** Handles viewport resizing */
    public void reshape( GLDrawable component, int x, int y, int width, int height ) {
//        System.err.println( "Top:reshape()" );
      }
        
    /** Renders stuff */
    public void display( GLDrawable component ) {
//        System.err.println( "Top:display()" );
        gl_.glEnable( GL.GL_DEPTH_TEST );
        gl_.glPushMatrix();
            gl_.glLoadIdentity();
            gl_.glColor3f( 1.0f, 1.0f, 1.0f );
            gl_.glRasterPos3i( -25, 0, -50 );
            GLTimesRoman24BitmapFont font =
                new GLTimesRoman24BitmapFont();
            font.drawString( "HUD Test" );
        gl_.glPopMatrix();
        gl_.glDisable( GL.GL_DEPTH_TEST );
      }

    /** Return a GL pipeline for this listener */
    public GL getGL() {
        return gl_;
      }
  }
