/*
 * (c) Copyright 1993, Silicon Graphics, Inc.
 * ALL RIGHTS RESERVED 
 * Permission to use, copy, modify, and distribute this software for 
 * any purpose and without fee is hereby granted, provided that the above
 * copyright notice appear in all copies and that both the copyright notice
 * and this permission notice appear in supporting documentation, and that 
 * the name of Silicon Graphics, Inc. not be used in advertising
 * or publicity pertaining to distribution of the software without specific,
 * written prior permission. 
 *
 * THE MATERIAL EMBODIED ON THIS SOFTWARE IS PROVIDED TO YOU "AS-IS"
 * AND WITHOUT WARRANTY OF ANY KIND, EXPRESS, IMPLIED OR OTHERWISE,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF MERCHANTABILITY OR
 * FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT SHALL SILICON
 * GRAPHICS, INC.  BE LIABLE TO YOU OR ANYONE ELSE FOR ANY DIRECT,
 * SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY
 * KIND, OR ANY DAMAGES WHATSOEVER, INCLUDING WITHOUT LIMITATION,
 * LOSS OF PROFIT, LOSS OF USE, SAVINGS OR REVENUE, OR THE CLAIMS OF
 * THIRD PARTIES, WHETHER OR NOT SILICON GRAPHICS, INC.  HAS BEEN
 * ADVISED OF THE POSSIBILITY OF SUCH LOSS, HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE
 * POSSESSION, USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 * US Government Users Restricted Rights 
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions set forth in FAR 52.227.19(c)(2) or subparagraph
 * (c)(1)(ii) of the Rights in Technical Data and Computer Software
 * clause at DFARS 252.227-7013 and/or in similar or successor
 * clauses in the FAR or the DOD or NASA FAR Supplement.
 * Unpublished-- rights reserved under the copyright laws of the
 * United States.  Contractor/manufacturer is Silicon Graphics,
 * Inc., 2011 N.  Shoreline Blvd., Mountain View, CA 94039-7311.
 *
 * OpenGL(TM) is a trademark of Silicon Graphics, Inc.
 */
/**
 * $Id: lamp.java,v 1.2 1998/10/19 11:03:24 descarte Exp descarte $
 *
 * Copyright (c)1997-1998 Arcane Technologies Ltd. <http://www.arcana.co.uk>
 *
 * $Log: lamp.java,v $
 * Revision 1.2  1998/10/19 11:03:24  descarte
 * Made JDK-1.1 compliant by removing deprecated methods. Updated copyright.
 *
 * Revision 1.1  1997/11/29 02:49:02  descarte
 * Initial revision
 *
 */

package com.hermetica.magician.demos.ideas;

import com.hermetica.magician.*;

public class lamp {

    public static final int MAT_HEMISPHERE = 9;

    private static float[][][] hp = {

        {
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
        },
        {
    	{0.438371f, 0.000000f, 0.898794f},
    	{0.379641f, 0.219186f, 0.898794f},
    	{0.219186f, 0.379641f, 0.898794f},
    	{0.000000f, 0.438371f, 0.898794f},
    	{-0.219186f, 0.379641f, 0.898794f},
    	{-0.379641f, 0.219186f, 0.898794f},
    	{-0.438371f, 0.000000f, 0.898794f},
    	{-0.379641f, -0.219186f, 0.898794f},
    	{-0.219186f, -0.379641f, 0.898794f},
    	{0.000000f, -0.438371f, 0.898794f},
    	{0.219186f, -0.379641f, 0.898794f},
    	{0.379641f, -0.219186f, 0.898794f},
    	{0.438371f, 0.000000f, 0.898794f},
        },
        {
    	{0.788011f, 0.000000f, 0.615662f},
    	{0.682437f, 0.394005f, 0.615662f},
    	{0.394005f, 0.682437f, 0.615662f},
    	{0.000000f, 0.788011f, 0.615662f},
    	{-0.394005f, 0.682437f, 0.615662f},
    	{-0.682437f, 0.394005f, 0.615662f},
    	{-0.788011f, 0.000000f, 0.615662f},
    	{-0.682437f, -0.394005f, 0.615662f},
    	{-0.394005f, -0.682437f, 0.615662f},
    	{0.000000f, -0.788011f, 0.615662f},
    	{0.394005f, -0.682437f, 0.615662f},
    	{0.682437f, -0.394005f, 0.615662f},
    	{0.788011f, 0.000000f, 0.615662f},
        },
        {
    	{0.978148f, 0.000000f, 0.207912f},
    	{0.847101f, 0.489074f, 0.207912f},
    	{0.489074f, 0.847101f, 0.207912f},
    	{0.000000f, 0.978148f, 0.207912f},
    	{-0.489074f, 0.847101f, 0.207912f},
    	{-0.847101f, 0.489074f, 0.207912f},
    	{-0.978148f, 0.000000f, 0.207912f},
    	{-0.847101f, -0.489074f, 0.207912f},
    	{-0.489074f, -0.847101f, 0.207912f},
    	{0.000000f, -0.978148f, 0.207912f},
    	{0.489074f, -0.847101f, 0.207912f},
    	{0.847101f, -0.489074f, 0.207912f},
    	{0.978148f, 0.000000f, 0.207912f},
        },
        {
    	{0.970296f, 0.000000f, -0.241922f},
    	{0.840301f, 0.485148f, -0.241922f},
    	{0.485148f, 0.840301f, -0.241922f},
    	{0.000000f, 0.970296f, -0.241922f},
    	{-0.485148f, 0.840301f, -0.241922f},
    	{-0.840301f, 0.485148f, -0.241922f},
    	{-0.970296f, 0.000000f, -0.241922f},
    	{-0.840301f, -0.485148f, -0.241922f},
    	{-0.485148f, -0.840301f, -0.241922f},
    	{0.000000f, -0.970296f, -0.241922f},
    	{0.485148f, -0.840301f, -0.241922f},
    	{0.840301f, -0.485148f, -0.241922f},
    	{0.970296f, 0.000000f, -0.241922f},
        },
        {
    	{0.766044f, 0.000000f, -0.642788f},
    	{0.663414f, 0.383022f, -0.642788f},
    	{0.383022f, 0.663414f, -0.642788f},
    	{0.000000f, 0.766044f, -0.642788f},
    	{-0.383022f, 0.663414f, -0.642788f},
    	{-0.663414f, 0.383022f, -0.642788f},
    	{-0.766044f, 0.000000f, -0.642788f},
    	{-0.663414f, -0.383022f, -0.642788f},
    	{-0.383022f, -0.663414f, -0.642788f},
    	{0.000000f, -0.766044f, -0.642788f},
    	{0.383022f, -0.663414f, -0.642788f},
    	{0.663414f, -0.383022f, -0.642788f},
    	{0.766044f, 0.000000f, -0.642788f},
        },
    };
    
    private static float[][][] ltp = {
         {
    	{10.000000f, 0.000000f, 1.000000f},
    	{9.659258f, -2.588191f, 1.000000f},
    	{8.660254f, -5.000000f, 1.000000f},
    	{7.071068f, -7.071068f, 1.000000f},
    	{5.000000f, -8.660254f, 1.000000f},
    	{2.588191f, -9.659258f, 1.000000f},
    	{0.000000f, -10.000000f, 1.000000f},
    	{-2.588191f, -9.659258f, 1.000000f},
        {-5.000000f, -8.660254f, 1.000000f},
    	{-7.071068f, -7.071068f, 1.000000f},
    	{-8.660254f, -5.000000f, 1.000000f},
    	{-9.659258f, -2.588191f, 1.000000f},
    	{-10.000000f, 0.000000f, 1.000000f},
    	{-9.659258f, 2.588191f, 1.000000f},
    	{-8.660254f, 5.000000f, 1.000000f},
    	{-7.071068f, 7.071068f, 1.000000f},
    	{-5.000000f, 8.660254f, 1.000000f},
    	{-2.588191f, 9.659258f, 1.000000f},
    	{0.000000f, 10.000000f, 1.000000f},
    	{2.588191f, 9.659258f, 1.000000f},
    	{5.000000f, 8.660254f, 1.000000f},
    	{7.071068f, 7.071068f, 1.000000f},
    	{8.660254f, 5.000000f, 1.000000f},
    	{9.659258f, 2.588191f, 1.000000f},
    	{10.000000f, 0.000000f, 1.000000f},
        },
    
         {
    	{10.707107f, 0.000000f, 0.707107f},
    	{10.342271f, -2.771203f, 0.707107f},
    	{9.272627f, -5.353553f, 0.707107f},
    	{7.571068f, -7.571068f, 0.707107f},
    	{5.353553f, -9.272627f, 0.707107f},
    	{2.771203f, -10.342271f, 0.707107f},
    	{0.000000f, -10.707107f, 0.707107f},
    	{-2.771203f, -10.342271f, 0.707107f},
    	{-5.353553f, -9.272627f, 0.707107f},
    	{-7.571068f, -7.571068f, 0.707107f},
    	{-9.272627f, -5.353553f, 0.707107f},
    	{-10.342271f, -2.771203f, 0.707107f},
    	{-10.707107f, 0.000000f, 0.707107f},
    	{-10.342271f, 2.771203f, 0.707107f},
    	{-9.272627f, 5.353553f, 0.707107f},
    	{-7.571068f, 7.571068f, 0.707107f},
    	{-5.353553f, 9.272627f, 0.707107f},
    	{-2.771203f, 10.342271f, 0.707107f},
    	{0.000000f, 10.707107f, 0.707107f},
    	{2.771203f, 10.342271f, 0.707107f},
    	{5.353553f, 9.272627f, 0.707107f},
    	{7.571068f, 7.571068f, 0.707107f},
    	{9.272627f, 5.353553f, 0.707107f},
    	{10.342271f, 2.771203f, 0.707107f},
    	{10.707107f, 0.000000f, 0.707107f},
        },
    
         {
    	{11.000000f, 0.000000f, 0.000000f},
    	{10.625184f, -2.847009f, 0.000000f},
    	{9.526279f, -5.500000f, 0.000000f},
    	{7.778174f, -7.778174f, 0.000000f},
    	{5.500000f, -9.526279f, 0.000000f},
    	{2.847009f, -10.625184f, 0.000000f},
    	{0.000000f, -11.000000f, 0.000000f},
    	{-2.847009f, -10.625184f, 0.000000f},
    	{-5.500000f, -9.526279f, 0.000000f},
    	{-7.778174f, -7.778174f, 0.000000f},
    	{-9.526279f, -5.500000f, 0.000000f},
    	{-10.625184f, -2.847009f, 0.000000f},
    	{-11.000000f, 0.000000f, 0.000000f},
    	{-10.625184f, 2.847009f, 0.000000f},
    	{-9.526279f, 5.500000f, 0.000000f},
    	{-7.778174f, 7.778174f, 0.000000f},
    	{-5.500000f, 9.526279f, 0.000000f},
    	{-2.847009f, 10.625184f, 0.000000f},
    	{0.000000f, 11.000000f, 0.000000f},
    	{2.847009f, 10.625184f, 0.000000f},
    	{5.500000f, 9.526279f, 0.000000f},
    	{7.778174f, 7.778174f, 0.000000f},
    	{9.526279f, 5.500000f, 0.000000f},
    	{10.625184f, 2.847009f, 0.000000f},
    	{11.000000f, 0.000000f, 0.000000f},
        },
    
         {
    	{10.707107f, 0.000000f, -0.707107f},
    	{10.342271f, -2.771203f, -0.707107f},
    	{9.272627f, -5.353553f, -0.707107f},
    	{7.571068f, -7.571068f, -0.707107f},
    	{5.353553f, -9.272627f, -0.707107f},
    	{2.771203f, -10.342271f, -0.707107f},
    	{0.000000f, -10.707107f, -0.707107f},
    	{-2.771203f, -10.342271f, -0.707107f},
    	{-5.353553f, -9.272627f, -0.707107f},
    	{-7.571068f, -7.571068f, -0.707107f},
    	{-9.272627f, -5.353553f, -0.707107f},
    	{-10.342271f, -2.771203f, -0.707107f},
    	{-10.707107f, 0.000000f, -0.707107f},
    	{-10.342271f, 2.771203f, -0.707107f},
    	{-9.272627f, 5.353553f, -0.707107f},
    	{-7.571068f, 7.571068f, -0.707107f},
    	{-5.353553f, 9.272627f, -0.707107f},
    	{-2.771203f, 10.342271f, -0.707107f},
    	{0.000000f, 10.707107f, -0.707107f},
    	{2.771203f, 10.342271f, -0.707107f},
    	{5.353553f, 9.272627f, -0.707107f},
    	{7.571068f, 7.571068f, -0.707107f},
    	{9.272627f, 5.353553f, -0.707107f},
    	{10.342271f, 2.771203f, -0.707107f},
    	{10.707107f, 0.000000f, -0.707107f},
        },
    
         {
    	{10.000000f, 0.000000f, -1.000000f},
    	{9.659258f, -2.588191f, -1.000000f},
    	{8.660254f, -5.000000f, -1.000000f},
    	{7.071068f, -7.071068f, -1.000000f},
    	{5.000000f, -8.660254f, -1.000000f},
    	{2.588191f, -9.659258f, -1.000000f},
    	{0.000000f, -10.000000f, -1.000000f},
    	{-2.588191f, -9.659258f, -1.000000f},
    	{-5.000000f, -8.660254f, -1.000000f},
    	{-7.071068f, -7.071068f, -1.000000f},
    	{-8.660254f, -5.000000f, -1.000000f},
    	{-9.659258f, -2.588191f, -1.000000f},
    	{-10.000000f, 0.000000f, -1.000000f},
    	{-9.659258f, 2.588191f, -1.000000f},
    	{-8.660254f, 5.000000f, -1.000000f},
    	{-7.071068f, 7.071068f, -1.000000f},
    	{-5.000000f, 8.660254f, -1.000000f},
    	{-2.588191f, 9.659258f, -1.000000f},
    	{0.000000f, 10.000000f, -1.000000f},
    	{2.588191f, 9.659258f, -1.000000f},
    	{5.000000f, 8.660254f, -1.000000f},
    	{7.071068f, 7.071068f, -1.000000f},
    	{8.660254f, 5.000000f, -1.000000f},
    	{9.659258f, 2.588191f, -1.000000f},
    	{10.000000f, 0.000000f, -1.000000f},
        },
    
         {
    	{9.292893f, 0.000000f, -0.707107f},
    	{8.976246f, -2.405178f, -0.707107f},
    	{8.047881f, -4.646447f, -0.707107f},
    	{6.571068f, -6.571068f, -0.707107f},
    	{4.646447f, -8.047881f, -0.707107f},
    	{2.405178f, -8.976246f, -0.707107f},
    	{0.000000f, -9.292893f, -0.707107f},
    	{-2.405178f, -8.976246f, -0.707107f},
    	{-4.646447f, -8.047881f, -0.707107f},
    	{-6.571068f, -6.571068f, -0.707107f},
    	{-8.047881f, -4.646447f, -0.707107f},
    	{-8.976246f, -2.405178f, -0.707107f},
    	{-9.292893f, 0.000000f, -0.707107f},
    	{-8.976246f, 2.405178f, -0.707107f},
    	{-8.047881f, 4.646447f, -0.707107f},
    	{-6.571068f, 6.571068f, -0.707107f},
    	{-4.646447f, 8.047881f, -0.707107f},
    	{-2.405178f, 8.976246f, -0.707107f},
    	{0.000000f, 9.292893f, -0.707107f},
    	{2.405178f, 8.976246f, -0.707107f},
    	{4.646447f, 8.047881f, -0.707107f},
    	{6.571068f, 6.571068f, -0.707107f},
    	{8.047881f, 4.646447f, -0.707107f},
    	{8.976246f, 2.405178f, -0.707107f},
    	{9.292893f, 0.000000f, -0.707107f},
        },
    
         {
    	{9.000000f, 0.000000f, 0.000000f},
    	{8.693333f, -2.329371f, 0.000000f},
    	{7.794229f, -4.500000f, 0.000000f},
    	{6.363961f, -6.363961f, 0.000000f},
    	{4.500000f, -7.794229f, 0.000000f},
    	{2.329371f, -8.693333f, 0.000000f},
    	{0.000000f, -9.000000f, 0.000000f},
    	{-2.329371f, -8.693333f, 0.000000f},
    	{-4.500000f, -7.794229f, 0.000000f},
    	{-6.363961f, -6.363961f, 0.000000f},
    	{-7.794229f, -4.500000f, 0.000000f},
    	{-8.693333f, -2.329371f, 0.000000f},
    	{-9.000000f, 0.000000f, 0.000000f},
    	{-8.693333f, 2.329371f, 0.000000f},
    	{-7.794229f, 4.500000f, 0.000000f},
    	{-6.363961f, 6.363961f, 0.000000f},
    	{-4.500000f, 7.794229f, 0.000000f},
    	{-2.329371f, 8.693333f, 0.000000f},
    	{0.000000f, 9.000000f, 0.000000f},
    	{2.329371f, 8.693333f, 0.000000f},
    	{4.500000f, 7.794229f, 0.000000f},
    	{6.363961f, 6.363961f, 0.000000f},
    	{7.794229f, 4.500000f, 0.000000f},
    	{8.693333f, 2.329371f, 0.000000f},
    	{9.000000f, 0.000000f, 0.000000f},
        },
    
         {
    	{9.292893f, 0.000000f, 0.707107f},
    	{8.976246f, -2.405178f, 0.707107f},
    	{8.047881f, -4.646447f, 0.707107f},
    	{6.571068f, -6.571068f, 0.707107f},
    	{4.646447f, -8.047881f, 0.707107f},
    	{2.405178f, -8.976246f, 0.707107f},
    	{0.000000f, -9.292893f, 0.707107f},
    	{-2.405178f, -8.976246f, 0.707107f},
    	{-4.646447f, -8.047881f, 0.707107f},
    	{-6.571068f, -6.571068f, 0.707107f},
    	{-8.047881f, -4.646447f, 0.707107f},
    	{-8.976246f, -2.405178f, 0.707107f},
    	{-9.292893f, 0.000000f, 0.707107f},
    	{-8.976246f, 2.405178f, 0.707107f},
    	{-8.047881f, 4.646447f, 0.707107f},
    	{-6.571068f, 6.571068f, 0.707107f},
    	{-4.646447f, 8.047881f, 0.707107f},
    	{-2.405178f, 8.976246f, 0.707107f},
    	{0.000000f, 9.292893f, 0.707107f},
    	{2.405178f, 8.976246f, 0.707107f},
    	{4.646447f, 8.047881f, 0.707107f},
    	{6.571068f, 6.571068f, 0.707107f},
    	{8.047881f, 4.646447f, 0.707107f},
    	{8.976246f, 2.405178f, 0.707107f},
    	{9.292893f, 0.000000f, 0.707107f},
        },
    
         {
    	{10.000000f, 0.000000f, 1.000000f},
    	{9.659258f, -2.588191f, 1.000000f},
    	{8.660254f, -5.000000f, 1.000000f},
    	{7.071068f, -7.071068f, 1.000000f},
    	{5.000000f, -8.660254f, 1.000000f},
    	{2.588191f, -9.659258f, 1.000000f},
    	{0.000000f, -10.000000f, 1.000000f},
    	{-2.588191f, -9.659258f, 1.000000f},
    	{-5.000000f, -8.660254f, 1.000000f},
    	{-7.071068f, -7.071068f, 1.000000f},
    	{-8.660254f, -5.000000f, 1.000000f},
    	{-9.659258f, -2.588191f, 1.000000f},
    	{-10.000000f, 0.000000f, 1.000000f},
    	{-9.659258f, 2.588191f, 1.000000f},
    	{-8.660254f, 5.000000f, 1.000000f},
    	{-7.071068f, 7.071068f, 1.000000f},
    	{-5.000000f, 8.660254f, 1.000000f},
    	{-2.588191f, 9.659258f, 1.000000f},
    	{0.000000f, 10.000000f, 1.000000f},
    	{2.588191f, 9.659258f, 1.000000f},
    	{5.000000f, 8.660254f, 1.000000f},
    	{7.071068f, 7.071068f, 1.000000f},
    	{8.660254f, 5.000000f, 1.000000f},
    	{9.659258f, 2.588191f, 1.000000f},
    	{10.000000f, 0.000000f, 1.000000f},
        },
    
    };

    private static float[][][] ltn = {
        {
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
    	{0.000000f, 0.000000f, 1.000000f},
	    {0.000000f, 0.000000f, 1.000000f},
	    {0.000000f, 0.000000f, 1.000000f},
        },
    
        {
	    {0.707107f, 0.000000f, 0.707107f},
	    {0.683013f, -0.183013f, 0.707107f},
	    {0.612372f, -0.353553f, 0.707107f},
	    {0.500000f, -0.500000f, 0.707107f},
	    {0.353553f, -0.612372f, 0.707107f},
	    {0.183013f, -0.683013f, 0.707107f},
	    {0.000000f, -0.707107f, 0.707107f},
	    {-0.183013f, -0.683013f, 0.707107f},
	    {-0.353553f, -0.612372f, 0.707107f},
	    {-0.500000f, -0.500000f, 0.707107f},
	    {-0.612372f, -0.353553f, 0.707107f},
	    {-0.683013f, -0.183013f, 0.707107f},
	    {-0.707107f, 0.000000f, 0.707107f},
	    {-0.683013f, 0.183013f, 0.707107f},
	    {-0.612372f, 0.353553f, 0.707107f},
	    {-0.500000f, 0.500000f, 0.707107f},
	    {-0.353553f, 0.612372f, 0.707107f},
	    {-0.183013f, 0.683013f, 0.707107f},
	    {0.000000f, 0.707107f, 0.707107f},
	    {0.183013f, 0.683013f, 0.707107f},
	    {0.353553f, 0.612372f, 0.707107f},
	    {0.500000f, 0.500000f, 0.707107f},
	    {0.612372f, 0.353553f, 0.707107f},
	    {0.683013f, 0.183013f, 0.707107f},
	    {0.707107f, 0.000000f, 0.707107f},
        },
    
        {
	    {1.000000f, 0.000000f, 0.000000f},
	    {0.965926f, -0.258819f, 0.000000f},
	    {0.866025f, -0.500000f, 0.000000f},
	    {0.707107f, -0.707107f, 0.000000f},
	    {0.500000f, -0.866025f, 0.000000f},
	    {0.258819f, -0.965926f, 0.000000f},
	    {0.000000f, -1.000000f, 0.000000f},
	    {-0.258819f, -0.965926f, 0.000000f},
	    {-0.500000f, -0.866025f, 0.000000f},
	    {-0.707107f, -0.707107f, 0.000000f},
	    {-0.866025f, -0.500000f, 0.000000f},
	    {-0.965926f, -0.258819f, 0.000000f},
	    {-1.000000f, 0.000000f, 0.000000f},
	    {-0.965926f, 0.258819f, 0.000000f},
	    {-0.866025f, 0.500000f, 0.000000f},
	    {-0.707107f, 0.707107f, 0.000000f},
	    {-0.500000f, 0.866025f, 0.000000f},
	    {-0.258819f, 0.965926f, 0.000000f},
	    {0.000000f, 1.000000f, 0.000000f},
	    {0.258819f, 0.965926f, 0.000000f},
	    {0.500000f, 0.866025f, 0.000000f},
	    {0.707107f, 0.707107f, 0.000000f},
	    {0.866025f, 0.500000f, 0.000000f},
	    {0.965926f, 0.258819f, 0.000000f},
	    {1.000000f, 0.000000f, 0.000000f},
        },
    
        {
	    {0.707107f, 0.000000f, -0.707107f},
	    {0.683013f, -0.183013f, -0.707107f},
	    {0.612372f, -0.353553f, -0.707107f},
	    {0.500000f, -0.500000f, -0.707107f},
	    {0.353553f, -0.612372f, -0.707107f},
	    {0.183013f, -0.683013f, -0.707107f},
	    {0.000000f, -0.707107f, -0.707107f},
	    {-0.183013f, -0.683013f, -0.707107f},
	    {-0.353553f, -0.612372f, -0.707107f},
	    {-0.500000f, -0.500000f, -0.707107f},
	    {-0.612372f, -0.353553f, -0.707107f},
	    {-0.683013f, -0.183013f, -0.707107f},
	    {-0.707107f, 0.000000f, -0.707107f},
	    {-0.683013f, 0.183013f, -0.707107f},
	    {-0.612372f, 0.353553f, -0.707107f},
	    {-0.500000f, 0.500000f, -0.707107f},
	    {-0.353553f, 0.612372f, -0.707107f},
	    {-0.183013f, 0.683013f, -0.707107f},
	    {0.000000f, 0.707107f, -0.707107f},
	    {0.183013f, 0.683013f, -0.707107f},
	    {0.353553f, 0.612372f, -0.707107f},
	    {0.500000f, 0.500000f, -0.707107f},
	    {0.612372f, 0.353553f, -0.707107f},
	    {0.683013f, 0.183013f, -0.707107f},
	    {0.707107f, 0.000000f, -0.707107f},
        },
    
        {
	    {0.000000f, 0.000000f, -1.000000f},
	    {0.000000f, 0.000000f, -1.000000f},
	    {0.000000f, 0.000000f, -1.000000f},
	    {0.000000f, 0.000000f, -1.000000f},
	    {0.000000f, 0.000000f, -1.000000f},
	    {0.000000f, 0.000000f, -1.000000f},
	    {0.000000f, 0.000000f, -1.000000f},
	    {0.000000f, 0.000000f, -1.000000f},
	    {0.000000f, 0.000000f, -1.000000f},
	    {0.000000f, 0.000000f, -1.000000f},
	    {0.000000f, 0.000000f, -1.000000f},
	    {0.000000f, 0.000000f, -1.000000f},
	    {0.000000f, 0.000000f, -1.000000f},
	    {0.000000f, 0.000000f, -1.000000f},
	    {0.000000f, 0.000000f, -1.000000f},
	    {0.000000f, 0.000000f, -1.000000f},
	    {0.000000f, 0.000000f, -1.000000f},
	    {0.000000f, 0.000000f, -1.000000f},
	    {0.000000f, 0.000000f, -1.000000f},
	    {0.000000f, 0.000000f, -1.000000f},
	    {0.000000f, 0.000000f, -1.000000f},
	    {0.000000f, 0.000000f, -1.000000f},
	    {0.000000f, 0.000000f, -1.000000f},
	    {0.000000f, 0.000000f, -1.000000f},
	    {0.000000f, 0.000000f, -1.000000f},
        },
    
        {
	    {-0.707107f, 0.000000f, -0.707107f},
	    {-0.683013f, 0.183013f, -0.707107f},
	    {-0.612372f, 0.353553f, -0.707107f},
	    {-0.500000f, 0.500000f, -0.707107f},
	    {-0.353553f, 0.612372f, -0.707107f},
	    {-0.183013f, 0.683013f, -0.707107f},
	    {0.000000f, 0.707107f, -0.707107f},
	    {0.183013f, 0.683013f, -0.707107f},
	    {0.353553f, 0.612372f, -0.707107f},
	    {0.500000f, 0.500000f, -0.707107f},
	    {0.612372f, 0.353553f, -0.707107f},
	    {0.683013f, 0.183013f, -0.707107f},
	    {0.707107f, 0.000000f, -0.707107f},
	    {0.683013f, -0.183013f, -0.707107f},
	    {0.612372f, -0.353553f, -0.707107f},
	    {0.500000f, -0.500000f, -0.707107f},
	    {0.353553f, -0.612372f, -0.707107f},
	    {0.183013f, -0.683013f, -0.707107f},
	    {0.000000f, -0.707107f, -0.707107f},
	    {-0.183013f, -0.683013f, -0.707107f},
	    {-0.353553f, -0.612372f, -0.707107f},
	    {-0.500000f, -0.500000f, -0.707107f},
	    {-0.612372f, -0.353553f, -0.707107f},
	    {-0.683013f, -0.183013f, -0.707107f},
	    {-0.707107f, 0.000000f, -0.707107f},
        },
    
        {
	    {-1.000000f, 0.000000f, 0.000000f},
	    {-0.965926f, 0.258819f, 0.000000f},
	    {-0.866025f, 0.500000f, 0.000000f},
	    {-0.707107f, 0.707107f, 0.000000f},
	    {-0.500000f, 0.866025f, 0.000000f},
	    {-0.258819f, 0.965926f, 0.000000f},
	    {0.000000f, 1.000000f, 0.000000f},
	    {0.258819f, 0.965926f, 0.000000f},
	    {0.500000f, 0.866025f, 0.000000f},
	    {0.707107f, 0.707107f, 0.000000f},
	    {0.866025f, 0.500000f, 0.000000f},
	    {0.965926f, 0.258819f, 0.000000f},
	    {1.000000f, 0.000000f, 0.000000f},
	    {0.965926f, -0.258819f, 0.000000f},
	    {0.866025f, -0.500000f, 0.000000f},
	    {0.707107f, -0.707107f, 0.000000f},
	    {0.500000f, -0.866025f, 0.000000f},
	    {0.258819f, -0.965926f, 0.000000f},
	    {0.000000f, -1.000000f, 0.000000f},
	    {-0.258819f, -0.965926f, 0.000000f},
	    {-0.500000f, -0.866025f, 0.000000f},
	    {-0.707107f, -0.707107f, 0.000000f},
	    {-0.866025f, -0.500000f, 0.000000f},
	    {-0.965926f, -0.258819f, 0.000000f},
	    {-1.000000f, 0.000000f, 0.000000f},
        },
    
        {
	    {-0.707107f, 0.000000f, 0.707107f},
	    {-0.683013f, 0.183013f, 0.707107f},
	    {-0.612372f, 0.353553f, 0.707107f},
	    {-0.500000f, 0.500000f, 0.707107f},
	    {-0.353553f, 0.612372f, 0.707107f},
	    {-0.183013f, 0.683013f, 0.707107f},
	    {0.000000f, 0.707107f, 0.707107f},
	    {0.183013f, 0.683013f, 0.707107f},
	    {0.353553f, 0.612372f, 0.707107f},
	    {0.500000f, 0.500000f, 0.707107f},
	    {0.612372f, 0.353553f, 0.707107f},
	    {0.683013f, 0.183013f, 0.707107f},
	    {0.707107f, 0.000000f, 0.707107f},
	    {0.683013f, -0.183013f, 0.707107f},
	    {0.612372f, -0.353553f, 0.707107f},
	    {0.500000f, -0.500000f, 0.707107f},
	    {0.353553f, -0.612372f, 0.707107f},
	    {0.183013f, -0.683013f, 0.707107f},
	    {0.000000f, -0.707107f, 0.707107f},
	    {-0.183013f, -0.683013f, 0.707107f},
	    {-0.353553f, -0.612372f, 0.707107f},
	    {-0.500000f, -0.500000f, 0.707107f},
	    {-0.612372f, -0.353553f, 0.707107f},
	    {-0.683013f, -0.183013f, 0.707107f},
	    {-0.707107f, 0.000000f, 0.707107f},
        },
    
        {
	    {0.000000f, 0.000000f, 1.000000f},
	    {0.000000f, 0.000000f, 1.000000f},
	    {0.000000f, 0.000000f, 1.000000f},
	    {0.000000f, 0.000000f, 1.000000f},
	    {0.000000f, 0.000000f, 1.000000f},
	    {0.000000f, 0.000000f, 1.000000f},
	    {0.000000f, 0.000000f, 1.000000f},
	    {0.000000f, 0.000000f, 1.000000f},
	    {0.000000f, 0.000000f, 1.000000f},
	    {0.000000f, 0.000000f, 1.000000f},
	    {0.000000f, 0.000000f, 1.000000f},
	    {0.000000f, 0.000000f, 1.000000f},
	    {0.000000f, 0.000000f, 1.000000f},
	    {0.000000f, 0.000000f, 1.000000f},
	    {0.000000f, 0.000000f, 1.000000f},
	    {0.000000f, 0.000000f, 1.000000f},
	    {0.000000f, 0.000000f, 1.000000f},
	    {0.000000f, 0.000000f, 1.000000f},
	    {0.000000f, 0.000000f, 1.000000f},
	    {0.000000f, 0.000000f, 1.000000f},
	    {0.000000f, 0.000000f, 1.000000f},
	    {0.000000f, 0.000000f, 1.000000f},
	    {0.000000f, 0.000000f, 1.000000f},
	    {0.000000f, 0.000000f, 1.000000f},
	    {0.000000f, 0.000000f, 1.000000f},
        },
    
    };

    public static void draw( GL gl_ ) {

      gl_.glCallList(MAT_HEMISPHERE);
      gl_.glEnable(GL.GL_LIGHTING);

      /* CF damn! */
      /* gl_.glEnable(GL.GL_NORMALIZE); */

    	gl_.glBegin(GL.GL_TRIANGLE_STRIP);
    	    gl_.glNormal3fv(hp[0][0]); gl_.glVertex3fv(hp[0][0]);
    	    gl_.glNormal3fv(hp[1][0]); gl_.glVertex3fv(hp[1][0]);
    	    gl_.glNormal3fv(hp[0][1]); gl_.glVertex3fv(hp[0][1]);
    	    gl_.glNormal3fv(hp[1][1]); gl_.glVertex3fv(hp[1][1]);
    	    gl_.glNormal3fv(hp[0][2]); gl_.glVertex3fv(hp[0][2]);
    	    gl_.glNormal3fv(hp[1][2]); gl_.glVertex3fv(hp[1][2]);
    	    gl_.glNormal3fv(hp[0][3]); gl_.glVertex3fv(hp[0][3]);
    	    gl_.glNormal3fv(hp[1][3]); gl_.glVertex3fv(hp[1][3]);
    	    gl_.glNormal3fv(hp[0][4]); gl_.glVertex3fv(hp[0][4]);
    	    gl_.glNormal3fv(hp[1][4]); gl_.glVertex3fv(hp[1][4]);
    	    gl_.glNormal3fv(hp[0][5]); gl_.glVertex3fv(hp[0][5]);
    	    gl_.glNormal3fv(hp[1][5]); gl_.glVertex3fv(hp[1][5]);
    	    gl_.glNormal3fv(hp[0][6]); gl_.glVertex3fv(hp[0][6]);
    	    gl_.glNormal3fv(hp[1][6]); gl_.glVertex3fv(hp[1][6]);
    	    gl_.glNormal3fv(hp[0][7]); gl_.glVertex3fv(hp[0][7]);
    	    gl_.glNormal3fv(hp[1][7]); gl_.glVertex3fv(hp[1][7]);
    	    gl_.glNormal3fv(hp[0][8]); gl_.glVertex3fv(hp[0][8]);
    	    gl_.glNormal3fv(hp[1][8]); gl_.glVertex3fv(hp[1][8]);
    	    gl_.glNormal3fv(hp[0][9]); gl_.glVertex3fv(hp[0][9]);
    	    gl_.glNormal3fv(hp[1][9]); gl_.glVertex3fv(hp[1][9]);
    	    gl_.glNormal3fv(hp[0][10]); gl_.glVertex3fv(hp[0][10]);
    	    gl_.glNormal3fv(hp[1][10]); gl_.glVertex3fv(hp[1][10]);
    	    gl_.glNormal3fv(hp[0][11]); gl_.glVertex3fv(hp[0][11]);
    	    gl_.glNormal3fv(hp[1][11]); gl_.glVertex3fv(hp[1][11]);
    	    gl_.glNormal3fv(hp[0][12]); gl_.glVertex3fv(hp[0][12]);
    	    gl_.glNormal3fv(hp[1][12]); gl_.glVertex3fv(hp[1][12]);
    	gl_.glEnd();
    
    	gl_.glBegin(GL.GL_TRIANGLE_STRIP);
    	    gl_.glNormal3fv(hp[1][0]); gl_.glVertex3fv(hp[1][0]);
    	    gl_.glNormal3fv(hp[2][0]); gl_.glVertex3fv(hp[2][0]);
    	    gl_.glNormal3fv(hp[1][1]); gl_.glVertex3fv(hp[1][1]);
    	    gl_.glNormal3fv(hp[2][1]); gl_.glVertex3fv(hp[2][1]);
    	    gl_.glNormal3fv(hp[1][2]); gl_.glVertex3fv(hp[1][2]);
    	    gl_.glNormal3fv(hp[2][2]); gl_.glVertex3fv(hp[2][2]);
    	    gl_.glNormal3fv(hp[1][3]); gl_.glVertex3fv(hp[1][3]);
    	    gl_.glNormal3fv(hp[2][3]); gl_.glVertex3fv(hp[2][3]);
    	    gl_.glNormal3fv(hp[1][4]); gl_.glVertex3fv(hp[1][4]);
    	    gl_.glNormal3fv(hp[2][4]); gl_.glVertex3fv(hp[2][4]);
    	    gl_.glNormal3fv(hp[1][5]); gl_.glVertex3fv(hp[1][5]);
    	    gl_.glNormal3fv(hp[2][5]); gl_.glVertex3fv(hp[2][5]);
    	    gl_.glNormal3fv(hp[1][6]); gl_.glVertex3fv(hp[1][6]);
    	    gl_.glNormal3fv(hp[2][6]); gl_.glVertex3fv(hp[2][6]);
    	    gl_.glNormal3fv(hp[1][7]); gl_.glVertex3fv(hp[1][7]);
    	    gl_.glNormal3fv(hp[2][7]); gl_.glVertex3fv(hp[2][7]);
    	    gl_.glNormal3fv(hp[1][8]); gl_.glVertex3fv(hp[1][8]);
    	    gl_.glNormal3fv(hp[2][8]); gl_.glVertex3fv(hp[2][8]);
    	    gl_.glNormal3fv(hp[1][9]); gl_.glVertex3fv(hp[1][9]);
    	    gl_.glNormal3fv(hp[2][9]); gl_.glVertex3fv(hp[2][9]);
    	    gl_.glNormal3fv(hp[1][10]); gl_.glVertex3fv(hp[1][10]);
    	    gl_.glNormal3fv(hp[2][10]); gl_.glVertex3fv(hp[2][10]);
    	    gl_.glNormal3fv(hp[1][11]); gl_.glVertex3fv(hp[1][11]);
    	    gl_.glNormal3fv(hp[2][11]); gl_.glVertex3fv(hp[2][11]);
    	    gl_.glNormal3fv(hp[1][12]); gl_.glVertex3fv(hp[1][12]);
    	    gl_.glNormal3fv(hp[2][12]); gl_.glVertex3fv(hp[2][12]);
    	gl_.glEnd();
    
    	gl_.glBegin(GL.GL_TRIANGLE_STRIP);
    	    gl_.glNormal3fv(hp[2][0]); gl_.glVertex3fv(hp[2][0]);
    	    gl_.glNormal3fv(hp[3][0]); gl_.glVertex3fv(hp[3][0]);
    	    gl_.glNormal3fv(hp[2][1]); gl_.glVertex3fv(hp[2][1]);
    	    gl_.glNormal3fv(hp[3][1]); gl_.glVertex3fv(hp[3][1]);
    	    gl_.glNormal3fv(hp[2][2]); gl_.glVertex3fv(hp[2][2]);
    	    gl_.glNormal3fv(hp[3][2]); gl_.glVertex3fv(hp[3][2]);
    	    gl_.glNormal3fv(hp[2][3]); gl_.glVertex3fv(hp[2][3]);
    	    gl_.glNormal3fv(hp[3][3]); gl_.glVertex3fv(hp[3][3]);
    	    gl_.glNormal3fv(hp[2][4]); gl_.glVertex3fv(hp[2][4]);
    	    gl_.glNormal3fv(hp[3][4]); gl_.glVertex3fv(hp[3][4]);
    	    gl_.glNormal3fv(hp[2][5]); gl_.glVertex3fv(hp[2][5]);
    	    gl_.glNormal3fv(hp[3][5]); gl_.glVertex3fv(hp[3][5]);
    	    gl_.glNormal3fv(hp[2][6]); gl_.glVertex3fv(hp[2][6]);
    	    gl_.glNormal3fv(hp[3][6]); gl_.glVertex3fv(hp[3][6]);
    	    gl_.glNormal3fv(hp[2][7]); gl_.glVertex3fv(hp[2][7]);
    	    gl_.glNormal3fv(hp[3][7]); gl_.glVertex3fv(hp[3][7]);
    	    gl_.glNormal3fv(hp[2][8]); gl_.glVertex3fv(hp[2][8]);
    	    gl_.glNormal3fv(hp[3][8]); gl_.glVertex3fv(hp[3][8]);
    	    gl_.glNormal3fv(hp[2][9]); gl_.glVertex3fv(hp[2][9]);
    	    gl_.glNormal3fv(hp[3][9]); gl_.glVertex3fv(hp[3][9]);
    	    gl_.glNormal3fv(hp[2][10]); gl_.glVertex3fv(hp[2][10]);
    	    gl_.glNormal3fv(hp[3][10]); gl_.glVertex3fv(hp[3][10]);
    	    gl_.glNormal3fv(hp[2][11]); gl_.glVertex3fv(hp[2][11]);
    	    gl_.glNormal3fv(hp[3][11]); gl_.glVertex3fv(hp[3][11]);
    	    gl_.glNormal3fv(hp[2][12]); gl_.glVertex3fv(hp[2][12]);
    	    gl_.glNormal3fv(hp[3][12]); gl_.glVertex3fv(hp[3][12]);
    	gl_.glEnd();
    
    	gl_.glBegin(GL.GL_TRIANGLE_STRIP);
    	    gl_.glNormal3fv(hp[3][0]); gl_.glVertex3fv(hp[3][0]);
    	    gl_.glNormal3fv(hp[4][0]); gl_.glVertex3fv(hp[4][0]);
    	    gl_.glNormal3fv(hp[3][1]); gl_.glVertex3fv(hp[3][1]);
    	    gl_.glNormal3fv(hp[4][1]); gl_.glVertex3fv(hp[4][1]);
    	    gl_.glNormal3fv(hp[3][2]); gl_.glVertex3fv(hp[3][2]);
    	    gl_.glNormal3fv(hp[4][2]); gl_.glVertex3fv(hp[4][2]);
    	    gl_.glNormal3fv(hp[3][3]); gl_.glVertex3fv(hp[3][3]);
    	    gl_.glNormal3fv(hp[4][3]); gl_.glVertex3fv(hp[4][3]);
    	    gl_.glNormal3fv(hp[3][4]); gl_.glVertex3fv(hp[3][4]);
    	    gl_.glNormal3fv(hp[4][4]); gl_.glVertex3fv(hp[4][4]);
    	    gl_.glNormal3fv(hp[3][5]); gl_.glVertex3fv(hp[3][5]);
    	    gl_.glNormal3fv(hp[4][5]); gl_.glVertex3fv(hp[4][5]);
    	    gl_.glNormal3fv(hp[3][6]); gl_.glVertex3fv(hp[3][6]);
    	    gl_.glNormal3fv(hp[4][6]); gl_.glVertex3fv(hp[4][6]);
    	    gl_.glNormal3fv(hp[3][7]); gl_.glVertex3fv(hp[3][7]);
    	    gl_.glNormal3fv(hp[4][7]); gl_.glVertex3fv(hp[4][7]);
    	    gl_.glNormal3fv(hp[3][8]); gl_.glVertex3fv(hp[3][8]);
    	    gl_.glNormal3fv(hp[4][8]); gl_.glVertex3fv(hp[4][8]);
    	    gl_.glNormal3fv(hp[3][9]); gl_.glVertex3fv(hp[3][9]);
    	    gl_.glNormal3fv(hp[4][9]); gl_.glVertex3fv(hp[4][9]);
    	    gl_.glNormal3fv(hp[3][10]); gl_.glVertex3fv(hp[3][10]);
    	    gl_.glNormal3fv(hp[4][10]); gl_.glVertex3fv(hp[4][10]);
    	    gl_.glNormal3fv(hp[3][11]); gl_.glVertex3fv(hp[3][11]);
    	    gl_.glNormal3fv(hp[4][11]); gl_.glVertex3fv(hp[4][11]);
    	    gl_.glNormal3fv(hp[3][12]); gl_.glVertex3fv(hp[3][12]);
    	    gl_.glNormal3fv(hp[4][12]); gl_.glVertex3fv(hp[4][12]);
    	gl_.glEnd();
    
    	gl_.glBegin(GL.GL_TRIANGLE_STRIP);
    	    gl_.glNormal3fv(hp[4][0]); gl_.glVertex3fv(hp[4][0]);
    	    gl_.glNormal3fv(hp[5][0]); gl_.glVertex3fv(hp[5][0]);
    	    gl_.glNormal3fv(hp[4][1]); gl_.glVertex3fv(hp[4][1]);
    	    gl_.glNormal3fv(hp[5][1]); gl_.glVertex3fv(hp[5][1]);
    	    gl_.glNormal3fv(hp[4][2]); gl_.glVertex3fv(hp[4][2]);
    	    gl_.glNormal3fv(hp[5][2]); gl_.glVertex3fv(hp[5][2]);
    	    gl_.glNormal3fv(hp[4][3]); gl_.glVertex3fv(hp[4][3]);
    	    gl_.glNormal3fv(hp[5][3]); gl_.glVertex3fv(hp[5][3]);
    	    gl_.glNormal3fv(hp[4][4]); gl_.glVertex3fv(hp[4][4]);
    	    gl_.glNormal3fv(hp[5][4]); gl_.glVertex3fv(hp[5][4]);
    	    gl_.glNormal3fv(hp[4][5]); gl_.glVertex3fv(hp[4][5]);
    	    gl_.glNormal3fv(hp[5][5]); gl_.glVertex3fv(hp[5][5]);
    	    gl_.glNormal3fv(hp[4][6]); gl_.glVertex3fv(hp[4][6]);
    	    gl_.glNormal3fv(hp[5][6]); gl_.glVertex3fv(hp[5][6]);
    	    gl_.glNormal3fv(hp[4][7]); gl_.glVertex3fv(hp[4][7]);
    	    gl_.glNormal3fv(hp[5][7]); gl_.glVertex3fv(hp[5][7]);
    	    gl_.glNormal3fv(hp[4][8]); gl_.glVertex3fv(hp[4][8]);
    	    gl_.glNormal3fv(hp[5][8]); gl_.glVertex3fv(hp[5][8]);
    	    gl_.glNormal3fv(hp[4][9]); gl_.glVertex3fv(hp[4][9]);
    	    gl_.glNormal3fv(hp[5][9]); gl_.glVertex3fv(hp[5][9]);
    	    gl_.glNormal3fv(hp[4][10]); gl_.glVertex3fv(hp[4][10]);
    	    gl_.glNormal3fv(hp[5][10]); gl_.glVertex3fv(hp[5][10]);
    	    gl_.glNormal3fv(hp[4][11]); gl_.glVertex3fv(hp[4][11]);
    	    gl_.glNormal3fv(hp[5][11]); gl_.glVertex3fv(hp[5][11]);
    	    gl_.glNormal3fv(hp[4][12]); gl_.glVertex3fv(hp[4][12]);
    	    gl_.glNormal3fv(hp[5][12]); gl_.glVertex3fv(hp[5][12]);
    	gl_.glEnd();
    
      gl_.glDisable(GL.GL_LIGHTING);
      gl_.glColor3ub((byte)255,  (byte)255,  (byte)255);
      gl_.glBegin(GL.GL_POLYGON);
      gl_.glVertex3fv(hp[5][0]);
      gl_.glVertex3fv(hp[5][1]);
      gl_.glVertex3fv(hp[5][2]);
      gl_.glVertex3fv(hp[5][3]);
      gl_.glVertex3fv(hp[5][4]);
      gl_.glVertex3fv(hp[5][5]);
      gl_.glVertex3fv(hp[5][6]);
      gl_.glVertex3fv(hp[5][7]);
      gl_.glVertex3fv(hp[5][8]);
      gl_.glVertex3fv(hp[5][9]);
      gl_.glVertex3fv(hp[5][10]);
      gl_.glVertex3fv(hp[5][11]);
      gl_.glEnd();
    
      /* CF damn! */
      /* gl_.glDisable(GL.GL_NORMALIZE); */
    
      }
  }
