/*
 * (c) Copyright 1993, Silicon Graphics, Inc.
 * ALL RIGHTS RESERVED 
 * Permission to use, copy, modify, and distribute this software for 
 * any purpose and without fee is hereby granted, provided that the above
 * copyright notice appear in all copies and that both the copyright notice
 * and this permission notice appear in supporting documentation, and that 
 * the name of Silicon Graphics, Inc. not be used in advertising
 * or publicity pertaining to distribution of the software without specific,
 * written prior permission. 
 *
 * THE MATERIAL EMBODIED ON THIS SOFTWARE IS PROVIDED TO YOU "AS-IS"
 * AND WITHOUT WARRANTY OF ANY KIND, EXPRESS, IMPLIED OR OTHERWISE,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF MERCHANTABILITY OR
 * FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT SHALL SILICON
 * GRAPHICS, INC.  BE LIABLE TO YOU OR ANYONE ELSE FOR ANY DIRECT,
 * SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY
 * KIND, OR ANY DAMAGES WHATSOEVER, INCLUDING WITHOUT LIMITATION,
 * LOSS OF PROFIT, LOSS OF USE, SAVINGS OR REVENUE, OR THE CLAIMS OF
 * THIRD PARTIES, WHETHER OR NOT SILICON GRAPHICS, INC.  HAS BEEN
 * ADVISED OF THE POSSIBILITY OF SUCH LOSS, HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE
 * POSSESSION, USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 * US Government Users Restricted Rights 
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions set forth in FAR 52.227.19(c)(2) or subparagraph
 * (c)(1)(ii) of the Rights in Technical Data and Computer Software
 * clause at DFARS 252.227-7013 and/or in similar or successor
 * clauses in the FAR or the DOD or NASA FAR Supplement.
 * Unpublished-- rights reserved under the copyright laws of the
 * United States.  Contractor/manufacturer is Silicon Graphics,
 * Inc., 2011 N.  Shoreline Blvd., Mountain View, CA 94039-7311.
 *
 * OpenGL(TM) is a trademark of Silicon Graphics, Inc.
 */
/**
 * $Id: shadow.java,v 1.2 1998/10/19 11:03:26 descarte Exp descarte $
 *
 * Copyright (c)1997-1998 Arcane Technologies Ltd. <http://www.arcana.co.uk>
 *
 * $Log: shadow.java,v $
 * Revision 1.2  1998/10/19 11:03:26  descarte
 * Made JDK-1.1 compliant by removing deprecated methods. Updated copyright.
 *
 * Revision 1.1  1997/11/29 11:58:39  descarte
 * Initial revision
 *
 */

package com.hermetica.magician.demos.ideas;

import com.hermetica.magician.*;

public class shadow {

    private static float[][] scp = {
      {1.000000f, 0.000000f, 0.000000f},	{1.000000f, 0.000000f, 5.000000f},
      {0.707107f, 0.707107f, 0.000000f},	{0.707107f, 0.707107f, 5.000000f},
      {0.000000f, 1.000000f, 0.000000f},	{0.000000f, 1.000000f, 5.000000f},
      {-0.707107f, 0.707107f, 0.000000f},	{-0.707107f, 0.707107f, 5.000000f},
      {-1.000000f, 0.000000f, 0.000000f},	{-1.000000f, 0.000000f, 5.000000f},
      {-0.707107f, -0.707107f, 0.000000f},	{-0.707107f, -0.707107f, 5.000000f},
      {0.000000f, -1.000000f, 0.000000f},	{0.000000f, -1.000000f, 5.000000f},
      {0.707107f, -0.707107f, 0.000000f},	{0.707107f, -0.707107f, 5.000000f},
      {1.000000f, 0.000000f, 0.000000f},	{1.000000f, 0.000000f, 5.000000f},
    };

    private static float[][] dcp = {
      {1.000000f, 0.000000f, 0.000000f},	{1.000000f, 0.000000f, 7.000000f},
      {0.707107f, 0.707107f, 0.000000f},	{0.707107f, 0.707107f, 7.000000f},
      {0.000000f, 1.000000f, 0.000000f},	{0.000000f, 1.000000f, 7.000000f},
      {-0.707107f, 0.707107f, 0.000000f},	{-0.707107f, 0.707107f, 7.000000f},
      {-1.000000f, 0.000000f, 0.000000f},	{-1.000000f, 0.000000f, 7.000000f},
      {-0.707107f, -0.707107f, 0.000000f},	{-0.707107f, -0.707107f, 7.000000f},
      {0.000000f, -1.000000f, 0.000000f},	{0.000000f, -1.000000f, 7.000000f},
      {0.707107f, -0.707107f, 0.000000f},	{0.707107f, -0.707107f, 7.000000f},
      {1.000000f, 0.000000f, 0.000000f},	{1.000000f, 0.000000f, 7.000000f},
    };

    private static float[][][] ep = {
      {
        {1.000000f, 0.000000f, 0.000000f},
        {0.707107f, 0.707107f, 0.000000f},
        {0.000000f, 1.000000f, 0.000000f},
        {-0.707107f, 0.707107f, 0.000000f},
        {-1.000000f, 0.000000f, 0.000000f},
        {-0.707107f, -0.707107f, 0.000000f},
        {0.000000f, -1.000000f, 0.000000f},
        {0.707107f, -0.707107f, 0.000000f},
        {1.000000f, 0.000000f, 0.000000f},
      },
  
      {
        {1.000000f, 0.019215f, 0.195090f},
        {0.707107f, 0.712735f, 0.057141f},
        {0.000000f, 1.000000f, 0.000000f},
        {-0.707107f, 0.712735f, 0.057141f},
        {-1.000000f, 0.019215f, 0.195090f},
        {-0.707107f, -0.674305f, 0.333040f},
        {0.000000f, -0.961571f, 0.390181f},
        {0.707107f, -0.674305f, 0.333040f},
        {1.000000f, 0.019215f, 0.195090f},
      },
  
      {
        {1.000000f, 0.076120f, 0.382683f},
        {0.707107f, 0.729402f, 0.112085f},
        {0.000000f, 1.000000f, 0.000000f},
        {-0.707107f, 0.729402f, 0.112085f},
        {-1.000000f, 0.076120f, 0.382683f},
        {-0.707107f, -0.577161f, 0.653282f},
        {0.000000f, -0.847759f, 0.765367f},
        {0.707107f, -0.577161f, 0.653282f},
        {1.000000f, 0.076120f, 0.382683f},
      },
  
      {
        {1.000000f, 0.168530f, 0.555570f},
        {0.707107f, 0.756468f, 0.162723f},
        {0.000000f, 1.000000f, 0.000000f},
        {-0.707107f, 0.756468f, 0.162723f},
        {-1.000000f, 0.168530f, 0.555570f},
        {-0.707107f, -0.419407f, 0.948418f},
        {0.000000f, -0.662939f, 1.111140f},
        {0.707107f, -0.419407f, 0.948418f},
        {1.000000f, 0.168530f, 0.555570f},
      },
  
      {
        {1.000000f, 0.292893f, 0.707107f},
        {0.707107f, 0.792893f, 0.207107f},
        {0.000000f, 1.000000f, 0.000000f},
        {-0.707107f, 0.792893f, 0.207107f},
        {-1.000000f, 0.292893f, 0.707107f},
        {-0.707107f, -0.207107f, 1.207107f},
        {0.000000f, -0.414214f, 1.414214f},
        {0.707107f, -0.207107f, 1.207107f},
        {1.000000f, 0.292893f, 0.707107f},
      },
      
      {
        {1.000000f, 0.444430f, 0.831470f},
        {0.707107f, 0.837277f, 0.243532f},
        {0.000000f, 1.000000f, 0.000000f},
        {-0.707107f, 0.837277f, 0.243532f},
        {-1.000000f, 0.444430f, 0.831470f},
        {-0.707107f, 0.051582f, 1.419407f},
        {0.000000f, -0.111140f, 1.662939f},
        {0.707107f, 0.051582f, 1.419407f},
        {1.000000f, 0.444430f, 0.831470f},
      },
      
      {
        {1.000000f, 0.617317f, 0.923880f},
        {0.707107f, 0.887915f, 0.270598f},
        {0.000000f, 1.000000f, 0.000000f},
        {-0.707107f, 0.887915f, 0.270598f},
        {-1.000000f, 0.617317f, 0.923880f},
        {-0.707107f, 0.346719f, 1.577161f},
        {0.000000f, 0.234633f, 1.847759f},
        {0.707107f, 0.346719f, 1.577161f},
        {1.000000f, 0.617317f, 0.923880f},
      },
      
      {
        {1.000000f, 0.804910f, 0.980785f},
        {0.707107f, 0.942859f, 0.287265f},
        {0.000000f, 1.000000f, 0.000000f},
        {-0.707107f, 0.942859f, 0.287265f},
        {-1.000000f, 0.804910f, 0.980785f},
        {-0.707107f, 0.666960f, 1.674305f},
        {0.000000f, 0.609819f, 1.961571f},
        {0.707107f, 0.666960f, 1.674305f},
        {1.000000f, 0.804910f, 0.980785f},
      },
      
      {
        {1.000000f, 1.000000f, 1.000000f},
        {0.707107f, 1.000000f, 0.292893f},
        {0.000000f, 1.000000f, 0.000000f},
        {-0.707107f, 1.000000f, 0.292893f},
        {-1.000000f, 1.000000f, 1.000000f},
        {-0.707107f, 1.000000f, 1.707107f},
        {0.000000f, 1.000000f, 2.000000f},
        {0.707107f, 1.000000f, 1.707107f},
        {1.000000f, 1.000000f, 1.000000f},
      },
  
    };

    private static void draw_single_cylinder( GL gl_ ) {
      
      gl_.glBegin(GL.GL_TRIANGLE_STRIP);
      gl_.glVertex3fv(scp[0]);
      gl_.glVertex3fv(scp[1]);
      gl_.glVertex3fv(scp[2]);
      gl_.glVertex3fv(scp[3]);
      gl_.glVertex3fv(scp[4]);
      gl_.glVertex3fv(scp[5]);
      gl_.glVertex3fv(scp[6]);
      gl_.glVertex3fv(scp[7]);
      gl_.glVertex3fv(scp[8]);
      gl_.glVertex3fv(scp[9]);
      gl_.glVertex3fv(scp[10]);
      gl_.glVertex3fv(scp[11]);
      gl_.glVertex3fv(scp[12]);
      gl_.glVertex3fv(scp[13]);
      gl_.glVertex3fv(scp[14]);
      gl_.glVertex3fv(scp[15]);
      gl_.glVertex3fv(scp[16]);
      gl_.glVertex3fv(scp[17]);
      gl_.glEnd();
    }

    private static void draw_double_cylinder( GL gl_ ) {
      
      gl_.glBegin(GL.GL_TRIANGLE_STRIP);
      gl_.glVertex3fv(dcp[0]);
      gl_.glVertex3fv(dcp[1]);
      gl_.glVertex3fv(dcp[2]);
      gl_.glVertex3fv(dcp[3]);
      gl_.glVertex3fv(dcp[4]);
      gl_.glVertex3fv(dcp[5]);
      gl_.glVertex3fv(dcp[6]);
      gl_.glVertex3fv(dcp[7]);
      gl_.glVertex3fv(dcp[8]);
      gl_.glVertex3fv(dcp[9]);
      gl_.glVertex3fv(dcp[10]);
      gl_.glVertex3fv(dcp[11]);
      gl_.glVertex3fv(dcp[12]);
      gl_.glVertex3fv(dcp[13]);
      gl_.glVertex3fv(dcp[14]);
      gl_.glVertex3fv(dcp[15]);
      gl_.glVertex3fv(dcp[16]);
      gl_.glVertex3fv(dcp[17]);
      gl_.glEnd();
    }
    
    private static void draw_elbow( GL gl_ ) {
      
      gl_.glBegin(GL.GL_TRIANGLE_STRIP);
      gl_.glVertex3fv(ep[0][0]);
      gl_.glVertex3fv(ep[1][0]);
      gl_.glVertex3fv(ep[0][1]);
      gl_.glVertex3fv(ep[1][1]);
      gl_.glVertex3fv(ep[0][2]);
      gl_.glVertex3fv(ep[1][2]);
      gl_.glVertex3fv(ep[0][3]);
      gl_.glVertex3fv(ep[1][3]);
      gl_.glVertex3fv(ep[0][4]);
      gl_.glVertex3fv(ep[1][4]);
      gl_.glVertex3fv(ep[0][5]);
      gl_.glVertex3fv(ep[1][5]);
      gl_.glVertex3fv(ep[0][6]);
      gl_.glVertex3fv(ep[1][6]);
      gl_.glVertex3fv(ep[0][7]);
      gl_.glVertex3fv(ep[1][7]);
      gl_.glVertex3fv(ep[0][8]);
      gl_.glVertex3fv(ep[1][8]);
      gl_.glEnd();
      gl_.glBegin(GL.GL_TRIANGLE_STRIP);
      gl_.glVertex3fv(ep[1][0]);
      gl_.glVertex3fv(ep[2][0]);
      gl_.glVertex3fv(ep[1][1]);
      gl_.glVertex3fv(ep[2][1]);
      gl_.glVertex3fv(ep[1][2]);
      gl_.glVertex3fv(ep[2][2]);
      gl_.glVertex3fv(ep[1][3]);
      gl_.glVertex3fv(ep[2][3]);
      gl_.glVertex3fv(ep[1][4]);
      gl_.glVertex3fv(ep[2][4]);
      gl_.glVertex3fv(ep[1][5]);
      gl_.glVertex3fv(ep[2][5]);
      gl_.glVertex3fv(ep[1][6]);
      gl_.glVertex3fv(ep[2][6]);
      gl_.glVertex3fv(ep[1][7]);
      gl_.glVertex3fv(ep[2][7]);
      gl_.glVertex3fv(ep[1][8]);
      gl_.glVertex3fv(ep[2][8]);
      gl_.glEnd();
      gl_.glBegin(GL.GL_TRIANGLE_STRIP);
      gl_.glVertex3fv(ep[2][0]);
      gl_.glVertex3fv(ep[3][0]);
      gl_.glVertex3fv(ep[2][1]);
      gl_.glVertex3fv(ep[3][1]);
      gl_.glVertex3fv(ep[2][2]);
      gl_.glVertex3fv(ep[3][2]);
      gl_.glVertex3fv(ep[2][3]);
      gl_.glVertex3fv(ep[3][3]);
      gl_.glVertex3fv(ep[2][4]);
      gl_.glVertex3fv(ep[3][4]);
      gl_.glVertex3fv(ep[2][5]);
      gl_.glVertex3fv(ep[3][5]);
      gl_.glVertex3fv(ep[2][6]);
      gl_.glVertex3fv(ep[3][6]);
      gl_.glVertex3fv(ep[2][7]);
      gl_.glVertex3fv(ep[3][7]);
      gl_.glVertex3fv(ep[2][8]);
      gl_.glVertex3fv(ep[3][8]);
      gl_.glEnd();
      gl_.glBegin(GL.GL_TRIANGLE_STRIP);
      gl_.glVertex3fv(ep[3][0]);
      gl_.glVertex3fv(ep[4][0]);
      gl_.glVertex3fv(ep[3][1]);
      gl_.glVertex3fv(ep[4][1]);
      gl_.glVertex3fv(ep[3][2]);
      gl_.glVertex3fv(ep[4][2]);
      gl_.glVertex3fv(ep[3][3]);
      gl_.glVertex3fv(ep[4][3]);
      gl_.glVertex3fv(ep[3][4]);
      gl_.glVertex3fv(ep[4][4]);
      gl_.glVertex3fv(ep[3][5]);
      gl_.glVertex3fv(ep[4][5]);
      gl_.glVertex3fv(ep[3][6]);
      gl_.glVertex3fv(ep[4][6]);
      gl_.glVertex3fv(ep[3][7]);
      gl_.glVertex3fv(ep[4][7]);
      gl_.glVertex3fv(ep[3][8]);
      gl_.glVertex3fv(ep[4][8]);
      gl_.glEnd();
      gl_.glBegin(GL.GL_TRIANGLE_STRIP);
      gl_.glVertex3fv(ep[4][0]);
      gl_.glVertex3fv(ep[5][0]);
      gl_.glVertex3fv(ep[4][1]);
      gl_.glVertex3fv(ep[5][1]);
      gl_.glVertex3fv(ep[4][2]);
      gl_.glVertex3fv(ep[5][2]);
      gl_.glVertex3fv(ep[4][3]);
      gl_.glVertex3fv(ep[5][3]);
      gl_.glVertex3fv(ep[4][4]);
      gl_.glVertex3fv(ep[5][4]);
      gl_.glVertex3fv(ep[4][5]);
      gl_.glVertex3fv(ep[5][5]);
      gl_.glVertex3fv(ep[4][6]);
      gl_.glVertex3fv(ep[5][6]);
      gl_.glVertex3fv(ep[4][7]);
      gl_.glVertex3fv(ep[5][7]);
      gl_.glVertex3fv(ep[4][8]);
      gl_.glVertex3fv(ep[5][8]);
      gl_.glEnd();
      gl_.glBegin(GL.GL_TRIANGLE_STRIP);
      gl_.glVertex3fv(ep[5][0]);
      gl_.glVertex3fv(ep[6][0]);
      gl_.glVertex3fv(ep[5][1]);
      gl_.glVertex3fv(ep[6][1]);
      gl_.glVertex3fv(ep[5][2]);
      gl_.glVertex3fv(ep[6][2]);
      gl_.glVertex3fv(ep[5][3]);
      gl_.glVertex3fv(ep[6][3]);
      gl_.glVertex3fv(ep[5][4]);
      gl_.glVertex3fv(ep[6][4]);
      gl_.glVertex3fv(ep[5][5]);
      gl_.glVertex3fv(ep[6][5]);
      gl_.glVertex3fv(ep[5][6]);
      gl_.glVertex3fv(ep[6][6]);
      gl_.glVertex3fv(ep[5][7]);
      gl_.glVertex3fv(ep[6][7]);
      gl_.glVertex3fv(ep[5][8]);
      gl_.glVertex3fv(ep[6][8]);
      gl_.glEnd();
      gl_.glBegin(GL.GL_TRIANGLE_STRIP);
      gl_.glVertex3fv(ep[6][0]);
      gl_.glVertex3fv(ep[7][0]);
      gl_.glVertex3fv(ep[6][1]);
      gl_.glVertex3fv(ep[7][1]);
      gl_.glVertex3fv(ep[6][2]);
      gl_.glVertex3fv(ep[7][2]);
      gl_.glVertex3fv(ep[6][3]);
      gl_.glVertex3fv(ep[7][3]);
      gl_.glVertex3fv(ep[6][4]);
      gl_.glVertex3fv(ep[7][4]);
      gl_.glVertex3fv(ep[6][5]);
      gl_.glVertex3fv(ep[7][5]);
      gl_.glVertex3fv(ep[6][6]);
      gl_.glVertex3fv(ep[7][6]);
      gl_.glVertex3fv(ep[6][7]);
      gl_.glVertex3fv(ep[7][7]);
      gl_.glVertex3fv(ep[6][8]);
      gl_.glVertex3fv(ep[7][8]);
      gl_.glEnd();
      gl_.glBegin(GL.GL_TRIANGLE_STRIP);
      gl_.glVertex3fv(ep[7][0]);
      gl_.glVertex3fv(ep[8][0]);
      gl_.glVertex3fv(ep[7][1]);
      gl_.glVertex3fv(ep[8][1]);
      gl_.glVertex3fv(ep[7][2]);
      gl_.glVertex3fv(ep[8][2]);
      gl_.glVertex3fv(ep[7][3]);
      gl_.glVertex3fv(ep[8][3]);
      gl_.glVertex3fv(ep[7][4]);
      gl_.glVertex3fv(ep[8][4]);
      gl_.glVertex3fv(ep[7][5]);
      gl_.glVertex3fv(ep[8][5]);
      gl_.glVertex3fv(ep[7][6]);
      gl_.glVertex3fv(ep[8][6]);
      gl_.glVertex3fv(ep[7][7]);
      gl_.glVertex3fv(ep[8][7]);
      gl_.glVertex3fv(ep[7][8]);
      gl_.glVertex3fv(ep[8][8]);
      gl_.glEnd();
    }
    
    private static void bend_forward( GL gl_ ) {
      
      gl_.glTranslatef(0.0f, 1.000000f, 0.0f);
      gl_.glRotatef ( (float)( 0.1 * (900) ), 1.0f, 0.0f, 0.0f);
      gl_.glTranslatef(0.0f, -1.000000f, 0.0f);
    }

    private static void bend_left( GL gl_ ) {
      
      gl_.glRotatef ( (float)( 0.1 * (-900) ), 0.0f, 0.0f, 1.0f);
      gl_.glTranslatef(0.0f, 1.000000f, 0.0f);
      gl_.glRotatef ( (float)( 0.1 * (900) ), 1.0f, 0.0f, 0.0f);
      gl_.glTranslatef(0.0f, -1.000000f, 0.0f);
    }

    private static void bend_right( GL gl_ ) {
    
      gl_.glRotatef ( (float)( 0.1 * (900) ), 0.0f, 0.0f, 1.0f);
      gl_.glTranslatef(0.0f, 1.000000f, 0.0f);
      gl_.glRotatef ( (float)( 0.1 * (900) ), 1.0f, 0.0f, 0.0f);
      gl_.glTranslatef(0.0f, -1.000000f, 0.0f);
    }
    
    public static void draw( GL gl_ ) {
  
      gl_.glTranslatef(5.500000f,  -3.500000f,  4.500000f);
  
      gl_.glTranslatef(0.0f,  0.0f,  -7.000000f);
      draw_double_cylinder( gl_ );
      bend_forward( gl_ );
      draw_elbow( gl_ );
      gl_.glTranslatef(0.0f,  0.0f,  -7.000000f);
      draw_double_cylinder( gl_ );
      bend_forward( gl_ );
      draw_elbow( gl_ );
      gl_.glTranslatef(0.0f,  0.0f,  -5.000000f);
      draw_single_cylinder( gl_ );
      bend_right( gl_ );
      draw_elbow( gl_ );
      gl_.glTranslatef(0.0f,  0.0f,  -7.000000f);
      draw_double_cylinder( gl_ );
      bend_forward( gl_ );
      draw_elbow( gl_ );
      gl_.glTranslatef(0.0f,  0.0f,  -7.000000f);
      draw_double_cylinder( gl_ );
      bend_forward( gl_ );
      draw_elbow( gl_ );
      gl_.glTranslatef(0.0f,  0.0f,  -5.000000f);
      draw_single_cylinder( gl_ );
      bend_left( gl_ );
      draw_elbow( gl_ );
      gl_.glTranslatef(0.0f,  0.0f,  -7.000000f);
      draw_double_cylinder( gl_ );
      bend_forward( gl_ );
      draw_elbow( gl_ );
      gl_.glTranslatef(0.0f,  0.0f,  -7.000000f);
      draw_double_cylinder( gl_ );
      bend_forward( gl_ );
      draw_elbow( gl_ );
      gl_.glTranslatef(0.0f,  0.0f,  -5.000000f);
      draw_single_cylinder( gl_ );
      bend_right( gl_ );
      draw_elbow( gl_ );
      gl_.glTranslatef(0.0f,  0.0f,  -7.000000f);
      draw_double_cylinder( gl_ );
      bend_forward( gl_ );
      draw_elbow( gl_ );
      gl_.glTranslatef(0.0f,  0.0f,  -7.000000f);
      draw_double_cylinder( gl_ );
      bend_forward( gl_ );
      draw_elbow( gl_ );
      gl_.glTranslatef(0.0f,  0.0f,  -5.000000f);
      draw_single_cylinder( gl_ );
      bend_left( gl_ );
      draw_elbow( gl_ );
      gl_.glTranslatef(0.0f,  0.0f,  -7.000000f);
      draw_double_cylinder( gl_ );
      bend_forward( gl_ );
      draw_elbow( gl_ );
      gl_.glTranslatef(0.0f,  0.0f,  -7.000000f);
      draw_double_cylinder( gl_ );
      bend_forward( gl_ );
      draw_elbow( gl_ );
      gl_.glTranslatef(0.0f,  0.0f,  -5.000000f);
      draw_single_cylinder( gl_ );
      bend_right( gl_ );
      draw_elbow( gl_ );
      gl_.glTranslatef(0.0f,  0.0f,  -7.000000f);
      draw_double_cylinder( gl_ );
      bend_forward( gl_ );
      draw_elbow( gl_ );
      gl_.glTranslatef(0.0f,  0.0f,  -7.000000f);
      draw_double_cylinder( gl_ );
      bend_forward( gl_ );
      draw_elbow( gl_ );
      gl_.glTranslatef(0.0f,  0.0f,  -5.000000f);
      draw_single_cylinder( gl_ );
      bend_left( gl_ );
      draw_elbow( gl_ );
    }
  }
