/**
 * $Id: texobj.java.stub,v 1.13 1998/10/19 11:09:49 descarte Exp descarte $
 *
 * Copyright (c)1997-1998 Arcane Technologies Ltd. <http://www.arcana.co.uk>
 *
 * Test program that tests some of GLUT
 *
 * $Log: texobj.java.stub,v $
 * Revision 1.13  1998/10/19 11:09:49  descarte
 * Made JDK-1.1 compliant by removing deprecated methods. Updated copyright.
 *
 * Revision 1.12  1998/10/02 12:37:18  descarte
 * Changed GLComponentListener to GLEventListener. Changed reshape() arguments.
 *
 * Revision 1.11  1998/04/21 15:30:07  descarte
 * Added new demoTemplate methods. Added standalone code. Added WindowListener.
 *
 * Revision 1.10  1998/03/30 11:42:56  descarte
 * Added applet resource handling.
 *
 * Revision 1.9  1998/03/28 17:07:30  descarte
 * Upgraded to Java-1.1 listeners
 * Upgraded to GLComponentFactory
 *
 * Revision 1.8  1998/03/24 17:17:37  descarte
 * Converted to new GLDrawable interface.
 *
 * Revision 1.7  1998/03/19 22:37:17  descarte
 * Added getGL() method.
 *
 * Revision 1.6  1998/02/23 22:17:28  descarte
 * Converted demo to beta 4 GLComponent structure.
 *
 * Revision 1.5  1998/01/04 19:58:10  descarte
 * Converted to new pipeline class names, ie, AbstractGL -> GL; GL -> CoreGL.
 *
 * Revision 1.4  1998/01/03 15:43:21  descarte
 * Fixed add() method for Microsoft VM. The "Center" argument was missing.
 *
 * Revision 1.3  1998/01/02 17:43:28  descarte
 * Converted demo across to GLEventListener interface.
 *
 * Revision 1.2  1997/12/23 17:23:20  descarte
 * Added layout manager to make window resize correctly under MSVM.
 *
 * Revision 1.1  1997/11/20 21:41:08  descarte
 * Initial revision
 *
 */

package com.hermetica.magician.demos.mesa;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import com.hermetica.magician.*;
import com.hermetica.util3d.*;

public class texobj extends Frame implements demoTemplate, GLEventListener, KeyListener, WindowListener {

    private static final String VERSION = new String( "$Revision: 1.13 $" );

    float angle = 0;

    int components = 3;

    CoreGL gl_ = new CoreGL();
    GLComponent glc = null;

    int[] texObj = new int[2];

    private static final int WIDTH = 300;
    private static final int HEIGHT = 300;

    /** Regulates the calling of System.exit() */
    private boolean callExit = true;

    public static void main( String argv[] ) {
        texobj d = new texobj();
        d.setTitle( d.getName() );
        System.err.println( "\n" + d.getName() + " -- " + d.getOriginalAuthor() );
        for ( int i = 0 ; i < ( d.getName().length() + d.getOriginalAuthor().length() + 4 ) ; i++ ) {
            System.err.print( "=" );
          }
        System.err.println( "\n" );
        System.err.println( d.getDescription() + "\n" );
        d.startDemo();
      }

    public texobj() {
        /**#start */
      }

    /** Set to false if the demo is to call System.exit() */
    public void setExit( boolean state ) {
        callExit = state;
      }

    /** Returns the name of the demo */
    public String getName() {
        return new String( "Texture Objects" );
      }

    /** Returns the version information of this demo */
    public String getVersion() {
        return new String( "$Id: texobj.java.stub,v 1.13 1998/10/19 11:09:49 descarte Exp descarte $" );
      }

    /** Returns a description of this demo */
    public String getDescription() {
        StringBuffer sb = new StringBuffer();
        sb.append( "This demonstration programs illustrates the use of Java\n" );
        sb.append( "arrays to specify texture-map data that can be pasted \n" );
        sb.append( "polygons drawn within OpenGL.\n\n" );
        sb.append( "Hit the ``Escape'' key to quit this demo." );
        return new String( sb );
      }

    /** Returns the width of the demo */
    public int getWidth() {
        return WIDTH;
      }

    /** Returns the height of the demo */
    public int getHeight() {
        return HEIGHT;
      }

    /** Returns the original author of this demo */
    public String getOriginalAuthor() {
        return new String( "Brian Paul <brianp@ra.avid.com>" );
      }

    public void startDemo() {

        /** Set the layout manager */
        setLayout( new BorderLayout() );

        /** Create a new frame */
        glc = GLComponentFactory.createGLComponent( WIDTH, HEIGHT );
        add( "Center", glc );
        pack(); show();

        GLCapabilities cap = glc.getContext().getCapabilities();
        cap.setColourBits( 24 );
        cap.setDepthBits( 12 );
        cap.setDoubleBuffered( GLCapabilities.DOUBLEBUFFER );

        /** Register the GLEventListener with the GLComponent */
        glc.addGLEventListener( this );

        /** Add a keyboard listener */
        glc.addKeyListener( this );

        this.addWindowListener( this );

        /** Tell the component to start processing events */
        glc.initialize();
        glc.start();
      }

    /** Initialization stuff */
    public void initialize( GLDrawable component ) {
        int width = 8,
            height = 8;

        byte tex1[] = {
            0, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 0, 1, 0, 0, 0,
            0, 0, 0, 1, 1, 0, 0, 0,
            0, 0, 0, 0, 1, 0, 0, 0,
            0, 0, 0, 0, 1, 0, 0, 0,
            0, 0, 0, 0, 1, 0, 0, 0,
            0, 0, 0, 1, 1, 1, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0
          };

        byte tex2[] = {
            0, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 2, 2, 0, 0, 0,
            0, 0, 2, 0, 0, 2, 0, 0,
            0, 0, 0, 0, 0, 2, 0, 0,
            0, 0, 0, 0, 2, 0, 0, 0,
            0, 0, 0, 2, 0, 0, 0, 0,
            0, 0, 2, 2, 2, 2, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0 
          };

        byte[][][] texture1 = new byte[width][height][components];
        byte[][][] texture2 = new byte[width][height][components];

        try {
            gl_.glEnable( GL.GL_DITHER );

            gl_.glClearColor( 0.0f, 0.0f, 0.0f, 0.0f );

            gl_.glEnable( GL.GL_TEXTURE_2D );
            gl_.glTexEnvi( GL.GL_TEXTURE_ENV, GL.GL_TEXTURE_ENV_MODE, GL.GL_DECAL );
            gl_.glHint( GL.GL_PERSPECTIVE_CORRECTION_HINT, GL.GL_FASTEST );

            gl_.glGenTextures( 2, texObj );

            gl_.glBindTexture( GL.GL_TEXTURE_2D, texObj[0] );
          } catch ( OpenGLException e ) {
            e.printStackTrace();
          }

        for ( int i = 0 ; i < height  ; i++ ) {
            for ( int j = 0 ; j < width ; j++ ) {
                if ( tex1[( i * width ) + j] != 0 ) {
                    texture1[j][i][0] = (byte)255; 
                    texture1[j][i][1] = (byte)0;
                    texture1[j][i][2] = (byte)0;
                  } else {
                    texture1[j][i][0] = (byte)255; 
                    texture1[j][i][1] = (byte)255;
                    texture1[j][i][2] = (byte)255;
                  }
              }
          }

        try {
            gl_.glTexImage2D( GL.GL_TEXTURE_2D, 0, GL.GL_RGB, width, height, 0,
                              GL.GL_RGB, GL.GL_UNSIGNED_BYTE, texture1 );
            gl_.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_MIN_FILTER,
                                GL.GL_NEAREST );
            gl_.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_MAG_FILTER,
                                GL.GL_NEAREST );
            gl_.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_WRAP_S,
                                GL.GL_REPEAT );
            gl_.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_WRAP_T,
                                GL.GL_REPEAT );

            /** Second texture */
            gl_.glBindTexture( GL.GL_TEXTURE_2D, texObj[1] );

            for ( int i = 0 ; i < height  ; i++ ) {
                for ( int j = 0 ; j < width ; j++ ) {
                    if ( tex2[( i * width ) + j] != 0 ) {
                        texture2[j][i][0] = (byte)0; 
                        texture2[j][i][1] = (byte)255;
                        texture2[j][i][2] = (byte)0;
                      } else {
                        texture2[j][i][0] = (byte)0; 
                        texture2[j][i][1] = (byte)0;
                        texture2[j][i][2] = (byte)255;
                      }
                  }
              }

            gl_.glTexImage2D( GL.GL_TEXTURE_2D, 0, GL.GL_RGB, width, height, 0,
                              GL.GL_RGB, GL.GL_UNSIGNED_BYTE, texture2 );
            gl_.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_MIN_FILTER,
                                GL.GL_NEAREST );
            gl_.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_MAG_FILTER,
                                GL.GL_NEAREST );
            gl_.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_WRAP_S,
                                GL.GL_REPEAT );
            gl_.glTexParameteri( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_WRAP_T,
                                GL.GL_REPEAT );

          } catch ( OpenGLException e ) {
            e.printStackTrace();
          }
      }

    /** Handles viewport resizing */
    public void reshape( GLDrawable component, int x, int y, int width, int height ) {
        gl_.glViewport( component, x, y, width, height );
        gl_.glMatrixMode( GL.GL_PROJECTION );
        gl_.glLoadIdentity();
        gl_.glFrustum( -2.0f, 2.0f, -2.0f, 2.0f, 6.0f, 20.0f );
        gl_.glMatrixMode( GL.GL_MODELVIEW );
        gl_.glLoadIdentity();
        gl_.glTranslatef( 0.0f, 0.0f, -8.0f );
      }

    /** Redraws the scene */
    public void display( GLDrawable component ) {
        try {
            gl_.glClear( GL.GL_COLOR_BUFFER_BIT );

            gl_.glColor3f( 1.0f, 1.0f, 1.0f );

            /** Draw first polygon */
            gl_.glPushMatrix();
            gl_.glTranslatef( -1.0f, 0.0f, 0.0f );
            gl_.glRotatef( (float)angle, 0.0f, 0.0f, 1.0f );

            gl_.glBindTexture( GL.GL_TEXTURE_2D, texObj[0] );

            gl_.glBegin( GL.GL_POLYGON );
                gl_.glTexCoord2f( 0.0f, 0.0f ); gl_.glVertex2f( -1.0f, -1.0f );
                gl_.glTexCoord2f( 1.0f, 0.0f ); gl_.glVertex2f( 1.0f, -1.0f );
                gl_.glTexCoord2f( 1.0f, 1.0f ); gl_.glVertex2f( 1.0f, 1.0f );
                gl_.glTexCoord2f( 0.0f, 1.0f ); gl_.glVertex2f( -1.0f, 1.0f );
            gl_.glEnd();
            gl_.glPopMatrix();

            /** Draw second polygon */
            gl_.glPushMatrix();
            gl_.glTranslatef( 1.0f, 0.0f, 0.0f );
            gl_.glRotatef( (float)( angle - 90.0 ), 0, 1, 0 );
            gl_.glBindTexture( GL.GL_TEXTURE_2D, texObj[1] );

            gl_.glBegin( GL.GL_POLYGON );
                gl_.glTexCoord2f( 0.0f, 0.0f ); gl_.glVertex2f( -1.0f, -1.0f );
                gl_.glTexCoord2f( 1.0f, 0.0f ); gl_.glVertex2f( 1.0f, -1.0f );
                gl_.glTexCoord2f( 1.0f, 1.0f ); gl_.glVertex2f( 1.0f, 1.0f );
                gl_.glTexCoord2f( 0.0f, 1.0f ); gl_.glVertex2f( -1.0f, 1.0f );
            gl_.glEnd();
            gl_.glPopMatrix();
          } catch ( OpenGLException e ) {
            e.printStackTrace();
          }
        angle += 2.0;
        if ( angle > 360 ) {
            angle -= 360.0;
          }
      }

    /** Returns the current GL pipeline for this listener */
    public GL getGL() {
        return gl_;
      }

    /** Handles keyboard events */
    /** Handles key pressed event */
    public void keyPressed( KeyEvent evt ) {
        if ( evt.getKeyChar() == KeyEvent.VK_ESCAPE ) {
            /** Destroy the GLContext */
            glc.destroy();
            dispose();
        if ( callExit ) {
            System.exit( 0 );
          }

          }
      }

    /** Handles key typed events */
    public void keyTyped( KeyEvent evt ) {
      }

    /** Handles key released events */
    public void keyReleased( KeyEvent evt ) {
      }

    /** WindowListener methods */
    public void windowActivated( WindowEvent evt ) {
      }

    public void windowClosed( WindowEvent evt ) {
      }

    public void windowClosing( WindowEvent evt ) {
        glc.destroy();
        dispose();
        if ( callExit ) {
            System.exit( 0 );
          }

      }

    public void windowDeactivated( WindowEvent evt ) {
      }

    public void windowDeiconified( WindowEvent evt ) {
        if ( glc.isRunning() ) {
            glc.resume();
          }
      }

    public void windowIconified( WindowEvent evt ) {
        if ( glc.isRunning() ) {
            glc.suspend();
          }
      }

    public void windowOpened( WindowEvent evt ) {
      }
    /** Applet only */
    public void stop() {
//        System.err.println( "stop() called" );
        /** Suspend the GL component only if it's driving an event loop */
        if ( glc.isRunning() ) {
            glc.suspend();
          }
      }

    /** Applet only */
    public void start() {
//        System.err.println( "start()" );
        /** Restart the GL component only if it's driving an event loop */
        if ( glc.isRunning() ) {
            glc.resume();
          }
      }

    /** Applet only */
    public void destroy() {
//        System.err.println( "destroy() called" );
        /** Destroy the GL component to free up the resources */
        glc.destroy();
      }
  }
