/* Copyright (c) Mark J. Kilgard, 1996. */

/* This program is freely distributable without licensing fees 
   and is provided without guarantee or warrantee expressed or 
   implied. This program is -not- in the public domain. */

/**
 * $Id: atomInstance.java,v 1.4 1998/10/19 11:14:58 descarte Exp descarte $
 *
 * Copyright (c)1997-1998 Arcane Technologies Ltd. <http://www.arcana.co.uk>
 *
 * Atom instance information
 *
 * $Log: atomInstance.java,v $
 * Revision 1.4  1998/10/19 11:14:58  descarte
 * Made JDK-1.1 compliant by removing deprecated methods. Updated copyright.
 *
 * Revision 1.3  1998/04/22 08:51:17  descarte
 * Added getRadius() methods.
 *
 * Revision 1.2  1998/04/22 08:38:50  descarte
 * Added accessor methods for internal data.
 *
 * Revision 1.1  1997/12/01 01:13:20  descarte
 * Initial revision
 *
 * Revision 1.1  1997/12/01 00:50:02  descarte
 * Initial revision
 *
 */

package com.hermetica.magician.demos.molview;

import java.awt.*;
import java.util.*;
import com.hermetica.magician.*;
import com.hermetica.util3d.*;

public class atomInstance {

    /** The OpenGL state machine */
    CoreGL gl_ = new CoreGL();
    CoreGLU glu_ = new CoreGLU();

    /** OpenGL rendering context */
    GLContext context = new GLContext();

    /** Name of the atom instance */
    protected String name = null;

    /** Location of the atom */
    protected float x = 0,
                    y = 0,
                    z = 0;

    /** The type of this atom */
    atomType type = null;

    /** Constructor */
    public atomInstance( String name ) {
        this.name = name;
      }

    /** Set the atom type */
    public void setType( atomType type ) {
        this.type = type;
      }

    /** Returns the atom type */
    public atomType getType() {
        return type;
      }

    /** Returns the name of the atom */
    public String getName() {
        return name;
      }

    /** Returrns the position of the atom */
    public float[] getPosition() {
        float[] tmp = new float[3];
        tmp[0] = x;
        tmp[1] = y;
        tmp[2] = z;
        return tmp;
      }

    /** Returns the radius of the atom */
    public float getRadius() {
        return type.getRadius();
      }

    /** Dumps the instance information */
    public String toString() {
        StringBuffer sb = new StringBuffer();

        sb.append( "AtomInstance: " + name + ": location ( " + x +
                   ", " + y + ", " + z + " )" );

        return sb.toString();
      }
  }
