/* Copyright (c) Mark J. Kilgard, 1996. */

/* This program is freely distributable without licensing fees 
   and is provided without guarantee or warrantee expressed or 
   implied. This program is -not- in the public domain. */

/**
 * $Id: atomType.java,v 1.3 1998/10/19 11:15:02 descarte Exp descarte $
 *
 * Copyright (c)1997-1998 Arcane Technologies Ltd. <http://www.arcana.co.uk>
 *
 * Atom type information
 *
 * $Log: atomType.java,v $
 * Revision 1.3  1998/10/19 11:15:02  descarte
 * Made JDK-1.1 compliant by removing deprecated methods. Updated copyright.
 *
 * Revision 1.2  1998/04/22 08:39:03  descarte
 * Added accessor methods.
 *
 * Revision 1.1  1997/12/01 00:50:02  descarte
 * Initial revision
 *
 */

package com.hermetica.magician.demos.molview;

import java.awt.*;
import java.util.*;
import com.hermetica.magician.*;
import com.hermetica.util3d.*;

public class atomType {

    /** The OpenGL state machine */
    CoreGL gl_ = new CoreGL();
    CoreGLU glu_ = new CoreGLU();

    /** OpenGL rendering context */
    GLContext context = new GLContext();

    /** Name of the atom type */
    String name = null;

    /** Radius of the atom type */
    float radius = 0;

    /** Colour of the atom */
    float[] colour = new float[3];

    /** Constructor */
    public atomType( String name ) {
        this.name = name;
        colour[0] = colour[1] = colour[2] = 0;
      }

    /** Set the radius */
    public void setRadius( float radius ) {
        this.radius = radius;
      }

    /** Return the radius */
    public float getRadius() {
        return radius;
      }

    /** Set the red value */
    public void setRed( float red ) {
        colour[0] = red;
      }

    /** Set the green value */
    public void setGreen( float green ) {
        colour[1] = green;
      }

    /** Set the red value */
    public void setBlue( float blue ) {
        colour[2] = blue;
      }

    /** Returns the colour */
    public float[] getColour() {
        return colour;
      }

    /** Dumps the atom type out */
    public String toString() {
        StringBuffer sb = new StringBuffer();

        sb.append( "AtomType: " + name + ": radius = " + radius +
                   ": colour ( " + colour[0] + ", " + colour[1] + ", " +
                   colour[2] + " )" );

        return sb.toString();
      }
  }
