/**
 * $Id: logo.java.stub,v 1.14 1998/10/19 11:16:41 descarte Exp descarte $
 *
 * Copyright (c)1997-1998 Arcane Technologies Ltd. <http://www.arcana.co.uk>
 *
 * $Log: logo.java.stub,v $
 * Revision 1.14  1998/10/19 11:16:41  descarte
 * Made JDK-1.1 compliant by removing deprecated methods. Updated copyright.
 *
 * Revision 1.13  1998/10/02 12:43:38  descarte
 * Changed GLComponentListener to GLEventListener. Changed reshape() arguments.
 *
 * Revision 1.12  1998/06/07 11:12:20  descarte
 * Removed spurious rotate call that skewed the viewpoint upon resizing
 * the window....
 *
 * Revision 1.11  1998/04/21 16:00:08  descarte
 * Added WindowListener.
 * Added standalone handling.
 * Added new demoTemplate methods.
 * Implemented display lists for each letter causing a considerable speed up
 * on Linux / Mesa implementations.
 *
 * Revision 1.10  1998/03/30 11:46:38  descarte
 * Added applet resource handling.
 *
 * Revision 1.9  1998/03/28 16:58:32  descarte
 * Upgraded to Java 1.1 listeners.
 * Upgraded to GLComponentFactory.
 *
 * Revision 1.8  1998/03/24 17:27:33  descarte
 * Converted to GLDrawable interface.
 *
 * Revision 1.7  1998/03/17 20:58:47  descarte
 * Converted demo from old beta 4 to new beta 4 GLComponent syntax.
 *
 * Revision 1.6  1998/02/22 16:07:07  descarte
 * Added check to see how many times the logo had ``finished''. After 32
 * iterations of that, it'll break up and restart.
 *
 * Revision 1.5  1998/02/22 10:43:02  descarte
 * Altered demo to fit into new GLComponent structure.
 *
 * Revision 1.4  1998/01/07 20:45:27  descarte
 * Added better thread handling for applets although it's still wrong.
 *
 * Revision 1.3  1998/01/06 20:43:35  descarte
 * Fixed 'add()' method to have arguments in correct order. This made the
 * Microsoft VM choke, but annoyingly, Sun's didn't! Argh!
 *
 * Revision 1.2  1998/01/01 16:36:53  descarte
 * Added GLComponent argument to GLEventListener interface methods.
 *
 * Revision 1.1  1997/12/31 23:01:59  descarte
 * Initial revision
 *
 * Revision 1.7  1997/09/02 22:43:29  descarte
 * Added GLContextException traps.
 *
 * Revision 1.6  1997/08/31 22:16:41  descarte
 * Added synchronization Object.
 *
 * Revision 1.5  1997/08/31 11:05:20  descarte
 * Added 'destroyContext()' call.
 *
 * Revision 1.4  1997/08/25 22:43:12  descarte
 * Moved demo into demoTemplate strucutre.
 *
 * Revision 1.3  1997/08/17 16:40:38  descarte
 * Added FrameRateCalculator doo-dad to see how fast it goes...
 *
 * Revision 1.2  1997/08/15 01:01:26  descarte
 * Added 'handleEvent()' method. Hit ' ' to restart and re-randomize.
 *
 * Revision 1.1  1997/08/15 00:57:05  descarte
 * Initial revision
 *
 */

package com.hermetica.magician.demos.openGL;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import com.hermetica.magician.*;
import com.hermetica.util3d.*;
import com.hermetica.util3d.*;

/**
 * Rotating OpenGL logo originally written by Henk Kok <kok@wins.uva.nl>
 * <P>
 * @author Alligator Descartes
 * @version $Id: logo.java.stub,v 1.14 1998/10/19 11:16:41 descarte Exp descarte $
 */
public class logoapp extends Applet implements demoTemplate, GLEventListener, KeyListener, WindowListener {

    /** Lighting information */
    float[] lightpos = { 1.0f, 1.0f, 1.0f, 0.0f };
    float[] lightamb = { 0.3f, 0.3f, 0.3f, 1.0f };
    float[] lightdif = { 0.8f, 0.8f, 0.8f, 1.0f };

    /** Speed of the animation */
    private float speed = 0;

    /** Progress of the animation */
    private float progress = 1;

    /** OpenGL state machine */
    GL gl_ = null;
    CoreGLU glu_ = new CoreGLU();

    /** The OpenGL component */
    GLComponent glc = null;

    /** Signifies whether the applet is stopped or started */
    private boolean appletThreadStopped = false;

    /** Frame Rate sampler */
    FrameRateComponent fpc = new FrameRateComponent();

    /** Dimensions of the OpenGL Component */
    private static final int WIDTH = 240,
                             HEIGHT = 180;
/*    private static final int WIDTH = 100,
                             HEIGHT = 75; */

    /** Tracks how often the logo has finished and auto-kicks it */
    private int finishedCount = 0;

    private int iteration = 0;

    /** Various mathematical calculation things...... */
    private static final int ACC = 8;
    private static final int ACC2 = 16;
    private static final int ACC3 = 48;
    private static final int ACC4 = 24;
    private static final float THLD = 0.6f;
    private static final float THLD2 = 0.8f;

    private static final int RAND_MAX = 2147483647;

    float[][] TRANS = new float[7][3];
    float[][] ROTAXIS = new float[7][3];
    float[] ROT = new float[7];

    float[][][] char_El = new float[ACC3 + 1][ACC][3];
    float[][][] normal_El = new float[ACC3 + 1][ACC][3];

    float[][][] char_O = new float[ACC4][ACC][3];
    float[][][] normal_O = new float[ACC4][ACC][3];

    float[][][] char_P = new float[ACC2][ACC][3];
    float[][][] normal_P = new float[ACC2][ACC][3];

    float[][][] char_G = new float[ACC4][ACC][3];
    float[][][] normal_G = new float[ACC4][ACC][3];

    float[] accSIN = new float[ACC];
    float[] accCOS = new float[ACC];

    float[] difmat4 = { 0.425f, 0.570f, 0.664f, 1.0f };
    float[] difamb4 = { 0.425f, 0.570f, 0.664f, 1.0f };
    float[] matspec4 = { 0.174f, 0.174f, 0.174f, 1.0f };

    /** Display lists for each of the letters */
    private int ellist = -1,
                olist = -1,
                plist = -1,
                elist = -1,
                nlist = -1,
                glist = -1,
                llist = -1;

    /** Regulates the calling of System.exit() */
    private boolean callExit = true;



    /** Constructor */
    public void init() {
        startDemo();
      }

    /** Set to false if the demo is to call System.exit() */
    public void setExit( boolean state ) {
        callExit = state;
      }

    /** Returns the name of the demo */
    public String getName() {
        return new String( "OpenGL Logo" );
      }

    /** Returns the version information of this demo */
    public String getVersion() {
        return new String( "$Id: logo.java.stub,v 1.14 1998/10/19 11:16:41 descarte Exp descarte $" );
      }

    /** Returns a meaningful description of this demo */
    public String getDescription() {
        StringBuffer sb = new StringBuffer();
        sb.append( "This demonstration renders a spinning and tumbling version\n" );
        sb.append( "of the OpenGL logo as designed by Silicon Graphics Incorporated.\n" );
        sb.append( "The letters randomly tumble towards the centre of the screen\n" );
        sb.append( "by ever decreasing increments until they form the logo.\n\n" );
        sb.append( "You can restart the demo at any time by hitting the spacebar\n" );
        sb.append( "or can terminate the demo by hitting the ``Escape'' key." );
        return new String( sb );
      }

    /** Returns the width of the demo */
    public int getWidth() {
        return WIDTH;
      }

    /** Returns the height of the demo */
    public int getHeight() {
        return HEIGHT;
      }

    /** Returns the original author of this demo */
    public String getOriginalAuthor() {
        return new String( "Henk Kok <kok@wins.uva.nl>" );
      }

    public void startDemo() {

        /** Set the layout manager */
        setLayout( new BorderLayout() );

        /** Create a new OpenGL machine */
        gl_ = (GL)new CoreGL();

        /** Create a new OpenGL Component */
        glc = GLComponentFactory.createGLComponent( WIDTH, HEIGHT );

        /** Stick it in the frame */
        add( "Center", glc );
        /**#layout */

        /** Setup the OpenGL rendering context capabilities */
        GLCapabilities cap = glc.getContext().getCapabilities();
        cap.setDepthBits( 12 );
        cap.setPixelType( GLCapabilities.RGBA );
        cap.setColourBits( 24 );
        cap.setDoubleBuffered( GLCapabilities.DOUBLEBUFFER );

        /** Tell the FrameRate calculator to summarize frame rates */
        fpc.setSummaryOnly( true );

        /** Register this class as a GLEventListener */
        glc.addGLEventListener( this );

        /** Register a keyboard listener */
        glc.addKeyListener( this );

        /**#windowListener */

        /** Start the GLComponent to generate and receieve events */
        glc.initialize();
        glc.start();
      }

    public void initialize( GLDrawable component ) {
        gl_.glShadeModel( GL.GL_SMOOTH );
        gl_.glEnable( GL.GL_DEPTH_TEST );
        gl_.glLightfv( GL.GL_LIGHT0, GL.GL_POSITION, lightpos );
        gl_.glLightfv( GL.GL_LIGHT0, GL.GL_AMBIENT, lightamb );
        gl_.glLightfv( GL.GL_LIGHT0, GL.GL_DIFFUSE, lightdif );
        gl_.glEnable( GL.GL_LIGHTING );
        gl_.glEnable( GL.GL_LIGHT0 );
        gl_.glColor3f( 1.0f, 1.0f, 1.0f );
        gl_.glClearColor( 1.0f, 1.0f, 1.0f, 0.0f );
        gl_.glPolygonMode( GL.GL_FRONT_AND_BACK, GL.GL_FILL );
        gl_.glEnable( GL.GL_NORMALIZE );

        gl_.glMaterialfv( GL.GL_FRONT, GL.GL_DIFFUSE, difmat4 );
        gl_.glMaterialfv( GL.GL_FRONT, GL.GL_AMBIENT, difamb4 );
        gl_.glMaterialfv( GL.GL_FRONT, GL.GL_SPECULAR, matspec4 );
        gl_.glMaterialf( GL.GL_FRONT, GL.GL_SHININESS, 35.0f );

        defLogo();

        gl_.glCullFace( GL.GL_BACK );
        gl_.glEnable( GL.GL_CULL_FACE );

        /** Randomize the motion tables */
        randomize();
      }

    /** 
     * Displays the scene. This is invoked indirectly via the 
     * GLEventListener
     */
    public void display( GLDrawable component ) {
        /** Calculate the new animation parameters */
        speed = (float)( -0.95 * speed + progress * 0.05 );
        if ( progress > 0.0f && speed < 0.0003 ) {
            speed = 0.0003f;
          }
        if ( speed > 0.01 ) {
            speed = 0.01f;
          }
        progress = progress - speed;
//        System.err.println( "Iteration: " + iteration );
        if ( progress <= 0.0 ) {
            if ( finishedCount > 32 ) {
                progress = 1;
                randomize();
                finishedCount = 0;
                iteration = 0;
              } else {
                finishedCount++;
                progress = 0.0f;
                speed = 0;
              }
          }

        /** Start the frame rate calculator */
        fpc.startSample();

        /** Clear the buffers out */
        gl_.glClear( GL.GL_COLOR_BUFFER_BIT | GL.GL_DEPTH_BUFFER_BIT );

        /** Sets the camera */
        setCamera();

        /** Draws the geometry */
        drawLogo();

/*        if ( iteration % 5 == 0 ) {
            PPMWriter writer = new PPMWriter( (GLComponent)component, "opengllogo" );
          } */

        /** Stop frame rate sample */
        fpc.stopSample();

        iteration++;
      }

    /** Handles window resizing */
    public void reshape( GLDrawable component, int x, int y, int width, int height ) {
        gl_.glViewport( component, x, y, width, height );
        gl_.glMatrixMode( GL.GL_PROJECTION );
        gl_.glLoadIdentity();
        gl_.glFrustum( -0.1333f, 0.1333f, -0.1f, 0.1f, 0.2f, 150.0f );
        gl_.glMatrixMode( GL.GL_MODELVIEW );
        gl_.glLoadIdentity();
        glu_.gluLookAt( 0, 1.5, 2, 0, 1.5, 0, 0, 1, 0 );
        gl_.glTranslatef( 0.0f, -8.0f, -45.0f );
//        gl_.glRotatef( -progress * 720, 0.0f, 1.0f, 0.0f );
      }

    /** Returns a GL pipeline from this listener */
    public GL getGL() {
        return gl_;
      }

    /** Sets the camera */
    private void setCamera() {
      }

    /** Handles keyboard events */
    /** Handles key pressed event */
    public void keyPressed( KeyEvent evt ) {
        if ( evt.getKeyChar() == KeyEvent.VK_ESCAPE ) {
            /** Destroy the GLContext */
            glc.destroy();
            /**#dispose */
          }
        if ( evt.getKeyChar() == ' ' ) {
            progress = 1;
            randomize();
            return;
          }

      }

    /** Handles key typed events */
    public void keyTyped( KeyEvent evt ) {
      }

    /** Handles key released events */
    public void keyReleased( KeyEvent evt ) {
      }

    /** Draws the logo */
    private void drawLogo() {
//            groenTexture();

        gl_.glPushMatrix();
            gl_.glTranslatef( -2.8f, 0.0f, 0.0f );
            drawPart(0);
            gl_.glTranslatef(-12.0f, 4.3f, 0.0f);
            drawPart(1);
            gl_.glTranslatef(7.3f, 0.0f, 0.0f);
            drawPart(2);
            gl_.glTranslatef(5.4f, 0.0f, 0.0f);
            drawPart(3);
            gl_.glTranslatef(5.4f, 0.0f, 0.0f);
            drawPart(4);
            gl_.glTranslatef(7.4f, 0.0f, 0.0f);
            drawPart(5);
            gl_.glTranslatef(6.8f, 0.0f, 0.0f);
            drawPart(6);
        gl_.glPopMatrix();
      }

    /** Draw a given part of the logo */
    private void drawPart( int part ) {

        gl_.glPushMatrix();
        gl_.glTranslatef( TRANS[part][0] * progress, 
                         TRANS[part][1] * progress, 
                         TRANS[part][2] * progress);

        gl_.glRotatef(ROT[part] * progress, ROTAXIS[part][0], ROTAXIS[part][1], ROTAXIS[part][2]);
        switch( part ) {
            case 0: draw_El(); break;
            case 1: draw_O(); break;
            case 2: draw_P(); break;
            case 3: draw_E(); break;
            case 4: draw_N(); break;
            case 5: draw_G(); break;
            case 6: draw_L(); break;
          }
        gl_.glPopMatrix();
      } 

    /** Returns modulus random number */
    private int rnd( int i ) {
        return (int)( Math.random() * RAND_MAX ) % i;
      }

    /** Sets up the material */
    private void groenTexture() {
      }

    /** Defines the 'O' shape */
    private void def_O() {
        float a, s, c, ln;
        int i,j,k,l,m,n;
        float dx, dy;
        float dx1, dx2, dy1, dy2, dz1, dz2;
        float[][] center_O = new float[ACC4+4][3];
        float[] width_O = new float[ACC4+4];

        for ( i = 0 ; i < ACC4 ; i++ ) {
            a = (float)( 2.0*((float) i)*Math.PI/ACC4 );
            s = (float)( 1+Math.sin(a) );
            c = (float)( Math.cos(a) );
            center_O[i][0] = (float)( c*3.8 );
            center_O[i][1] = (float)( s*3.8+(s<-1.01?-0.8:(s>1.01?0.8:0)) + 0.8 );
            center_O[i][2] = (float)( 0.0 );
            width_O[i] = (float)( 0.6 );
          }

        /** @@I should be able to generalise this... oh well */
        for ( i = 0 ; i < ACC4 ; i++ ) {
            j = (i+1)%ACC4;
            k = (i+ACC4-1)%ACC4;

            for (a=0;a<ACC;a++) {
                c = (float)( Math.cos(a*Math.PI*2.0/ACC) );
                s = (float)( Math.sin(a*Math.PI*2.0/ACC) );
                dx = center_O[j][0] - center_O[k][0];
                dy = center_O[j][1] - center_O[k][1];
                ln = (float)( Math.sqrt(dx*dx+dy*dy) );
                dx = dx/ln;
                dy = dy/ln;
                char_O[i][(int) a][0] = center_O[i][0] + width_O[i] * dy * c;
                char_O[i][(int) a][1] = center_O[i][1] - width_O[i] * dx * c;
                char_O[i][(int) a][2] = (s<-THLD?-THLD:(s>THLD?THLD:s));
              }
          }

        for (i=0;i<ACC;i++) {
            j = (i+1)%ACC;
            k = (i-1+ACC)%ACC;

            for (l=0;l<ACC4;l++) {
                m = (l+1)%ACC4;
                n = (l+ACC4-1)%ACC4;
                dx1 = char_O[m][i][0] - char_O[n][i][0];
                dy1 = char_O[m][i][1] - char_O[n][i][1];
                dz1 = char_O[m][i][2] - char_O[n][i][2];
                dx2 = char_O[l][k][0] - char_O[l][j][0];
                dy2 = char_O[l][k][1] - char_O[l][j][1];
                dz2 = char_O[l][k][2] - char_O[l][j][2];
                normal_O[l][i][0] = dy2*dz1 - dy1*dz2;
                normal_O[l][i][1] = dz2*dx1 - dz1*dx2;
                normal_O[l][i][2] = dx2*dy1 - dx1*dy2;
              }
          }
      }

    /** Defines the 'P' shape */
    private void def_P() {

        float a, s, c, ln;
        int i,j,k,l,m,n;
        float dx, dy;
        float dx1, dx2, dy1, dy2, dz1, dz2;
        float[][] center_P = new float[ACC2][3];
        float[] width_P = new float[ACC2];

        for (i=0;i<ACC2;i++) {
            a = (float)( 2.0*((float) i)*Math.PI/ACC2 );
            s = (float)( 1+Math.sin(a) );
            c = (float)( Math.cos(a) );
            center_P[i][0] = (float)( c*2.15 );
            center_P[i][1] = (float)( s*2.1 + (s<-1.01?-0.7:(s>1.01?0.7:0)) + 0.7 );
            center_P[i][2] = 0.0f;
            width_P[i] = 0.5f;
          }

        for (i=0;i<ACC2;i++) {
            j = (i+1)%ACC2;
            k = (i+ACC2-1)%ACC2;

            for (a=0;a<ACC;a++) {
                accCOS[(int) a] = c = (float)( Math.cos(a*Math.PI*2.0/ACC) );
                accSIN[(int) a] = s = (float)( Math.sin(a*Math.PI*2.0/ACC) );
                dx = center_P[j][0] - center_P[k][0];
                dy = center_P[j][1] - center_P[k][1];
                ln = (float)( Math.sqrt(dx*dx+dy*dy) );
                dx = dx/ln;
                dy = dy/ln;
                char_P[i][(int) a][0] = center_P[i][0] + width_P[i] * dy * c;
                char_P[i][(int) a][1] = center_P[i][1] - width_P[i] * dx * c;
                char_P[i][(int) a][2] = (s<-THLD?-THLD:(s>THLD?THLD:s));
              }
          }

        for (i=0;i<ACC;i++) {
            j = (i+1)%ACC;
            k = (i-1+ACC)%ACC;

            for (l=0;l<ACC2;l++) {
                m = (l+1)%ACC2;
                n = (l+ACC2-1)%ACC2;
                dx1 = char_P[m][i][0] - char_P[n][i][0];
                dy1 = char_P[m][i][1] - char_P[n][i][1];
                dz1 = char_P[m][i][2] - char_P[n][i][2];
                dx2 = char_P[l][k][0] - char_P[l][j][0];
                dy2 = char_P[l][k][1] - char_P[l][j][1];
                dz2 = char_P[l][k][2] - char_P[l][j][2];
                normal_P[l][i][0] = dy2*dz1 - dy1*dz2;
                normal_P[l][i][1] = dz2*dx1 - dz1*dx2;
                normal_P[l][i][2] = dx2*dy1 - dx1*dy2;
              }
          }
      }

    /** Defines the 'El' shape */
    private void def_El() {

        float a, s, c, ln;
        int i,j,k,l,m,n;
        float dx, dy;
        float dx1, dx2, dy1, dy2, dz1, dz2;
        float[][] center_El = new float[ACC3+3][3];
        float[] width_El = new float[ACC3+3];

        for (i=0;i<ACC3+1;i++) {
            /* a = (ACC3/24 + i*11/12)*Math.PI*2.0/ACC3; */
            a = (float)( (ACC3/8 + ((float) i)*3/4)*Math.PI*2.0/ACC3 );
            s = (float)( 1+Math.sin(a) );
            c = (float)( Math.cos(a) );
            center_El[i][0] = (float)( c*18.0 );
            center_El[i][1] = (float)( s*9.3 );
            center_El[i][2] = (float)( 0.0 );
            width_El[i] = (float)( Math.pow(3.5, Math.sin(i*Math.PI/ACC3))-0.6 );
          }

        for (i=0;i<ACC3+1;i++) {
            j = (i+1)%ACC3;
            k = (i+ACC3-1)%ACC3;

            for (a=0;a<ACC;a++) {
                c = (float)( Math.cos(a*Math.PI*2.0/ACC) );
                s = (float)( Math.sin(a*Math.PI*2.0/ACC) );
                dx = (float)( center_El[j][0] - center_El[k][0] );
                dy = (float)( center_El[j][1] - center_El[k][1] );
                ln = (float)( Math.sqrt(dx*dx+dy*dy) );
                dx = dx/ln;
                dy = dy/ln;
                char_El[i][(int) a][0] = center_El[i][0] + width_El[i] * dy * c;
                char_El[i][(int) a][1] = center_El[i][1] - width_El[i] * dx * c;
                char_El[i][(int) a][2] = (s<-THLD2?-THLD2:(s>THLD2?THLD2:s));
              }
          }

//        for (i=0;i<ACC+1;i++) {
        for ( i = 0 ; i < ACC ; i++ ) {
            j = (i+1)%ACC;
            k = (i-1+ACC)%ACC;

            for (l=0;l<ACC3;l++) {
                m = (l+1)%ACC3;
                n = (l+ACC3-1)%ACC3;
                dx1 = char_El[m][i][0] - char_El[n][i][0];
                dy1 = char_El[m][i][1] - char_El[n][i][1];
                dz1 = char_El[m][i][2] - char_El[n][i][2];
                dx2 = char_El[l][k][0] - char_El[l][j][0];
                dy2 = char_El[l][k][1] - char_El[l][j][1];
                dz2 = char_El[l][k][2] - char_El[l][j][2];
                normal_El[l][i][0] = dy2*dz1 - dy1*dz2;
                normal_El[l][i][1] = dz2*dx1 - dz1*dx2;
                normal_El[l][i][2] = dx2*dy1 - dx1*dy2;
              }
          }
      }

    /** Defines the 'G' shape */
    private void def_G() {

        float a, s, c, ln;
        int i,j,k,l,m,n;
        float dx, dy;
        float dx1, dx2, dy1, dy2, dz1, dz2;
        float[][] center_G = new float[ACC4][3];
        float[] width_G = new float[ACC4];

        for (i=0;i<ACC4;i++) {
            a = (float)( 2.0*((float) i)*Math.PI/ACC4 );
            s = (float)( 1+Math.sin(a) );
            c = (float)( Math.cos(a) );
            center_G[i][0] = (float)( c*3.8 );
            center_G[i][1] = (float)( s*3.8+(s<-1.01?-0.8:(s>1.01?0.8:0)) + 0.8 );
            center_G[i][2] = (float)( 0.0 );
            width_G[i] = (float)( 0.9 );
            if (i>ACC4*3/4) {
                width_G[i] = (float)( 0.9 - ((i-ACC4*3/4)*0.9)/ACC );
              }
          }

        for (i=0;i<ACC4;i++) {
            j = (i+1)%ACC4;
            k = (i+ACC4-1)%ACC4;

            for (a=0;a<ACC;a++) {
                c = (float)( Math.cos(a*Math.PI*2.0/ACC) );
                s = (float)( Math.sin(a*Math.PI*2.0/ACC) );
                dx = center_G[j][0] - center_G[k][0];
                dy = center_G[j][1] - center_G[k][1];
                ln = (float)( Math.sqrt(dx*dx+dy*dy) );
                dx = dx/ln;
                dy = dy/ln;
                char_G[i][(int) a][0] = center_G[i][0] + width_G[i] * dy * c;
                char_G[i][(int) a][1] = center_G[i][1] - width_G[i] * dx * c;
                char_G[i][(int) a][2] = (s<-THLD?-THLD:(s>THLD?THLD:s));
              }
          }

        for (i=0;i<ACC;i++) {
            j = (i+1)%ACC;
            k = (i-1+ACC)%ACC;
            
            for (l=0;l<ACC4;l++) {
                m = (l+1)%ACC4;
                n = (l+ACC4-1)%ACC4;
                dx1 = char_G[m][i][0] - char_G[n][i][0];
                dy1 = char_G[m][i][1] - char_G[n][i][1];
                dz1 = char_G[m][i][2] - char_G[n][i][2];
                dx2 = char_G[l][k][0] - char_G[l][j][0];
                dy2 = char_G[l][k][1] - char_G[l][j][1];
                dz2 = char_G[l][k][2] - char_G[l][j][2];
                normal_G[l][i][0] = dy2*dz1 - dy1*dz2;
                normal_G[l][i][1] = dz2*dx1 - dz1*dx2;
                normal_G[l][i][2] = dx2*dy1 - dx1*dy2;
              }
          }
      }

    /** Generate some randomized stuff */
    private void randomize() {

        int i;

        for (i=0;i<7;i++) {
            TRANS[i][0] = rnd(100)-rnd(100);
            TRANS[i][1] = rnd(100)-rnd(100);
            TRANS[i][1] = rnd(100)-rnd(100);
            ROTAXIS[i][0] = rnd(100)-rnd(100);
            ROTAXIS[i][1] = rnd(100)-rnd(100);
            ROTAXIS[i][1] = rnd(100)-rnd(100);
            ROT[i]=rnd(3600)-rnd(3600);
          }
      }

    /** Define the logo in its entirety! */
    private void defLogo() {
        def_O();
        def_P();
        def_El();
        def_G();
      }

    /** Draw the 'O' shape */
    private void draw_O() {

        int i,j,k;

        if ( olist == -1 ) {
            olist = gl_.glGenLists( 1 );
            gl_.glNewList( olist, GL.GL_COMPILE_AND_EXECUTE );

            for (i=0;i<ACC;i++) {
                k = i+1;
                if (k>=ACC) {
                    k = 0;
                  }
                gl_.glBegin( GL.GL_QUAD_STRIP );
                for (j=0;j<ACC4;j++) {
                    gl_.glNormal3d(normal_O[j][k][0], normal_O[j][k][1], normal_O[j][k][2]);
                    gl_.glVertex3d(char_O[j][k][0], char_O[j][k][1], char_O[j][k][2]);
                    gl_.glNormal3d(normal_O[j][i][0], normal_O[j][i][1], normal_O[j][i][2]);
                    gl_.glVertex3d(char_O[j][i][0], char_O[j][i][1], char_O[j][i][2]);
                  }
    
                gl_.glNormal3d(normal_O[0][k][0], normal_O[0][k][1], normal_O[0][k][2]);
                gl_.glVertex3d(char_O[0][k][0], char_O[0][k][1], char_O[0][k][2]);
                gl_.glNormal3d(normal_O[0][i][0], normal_O[0][i][1], normal_O[0][i][2]);
                gl_.glVertex3d(char_O[0][i][0], char_O[0][i][1], char_O[0][i][2]);
                gl_.glEnd();
              }
            gl_.glEndList();
          } else {
            gl_.glCallList( olist );
          }
      }

    /** Draw the 'P' shape */
    private void draw_P() {
        int i,j,k;

        if ( plist == -1 ) {
            plist = gl_.glGenLists( 1 );
            gl_.glNewList( plist, GL.GL_COMPILE_AND_EXECUTE );

            for (i=0;i<ACC;i++) {
                k = i+1;
                if (k>=ACC) {
                    k = 0;
                  }
                gl_.glBegin(GL.GL_QUAD_STRIP);
                for (j=0;j<ACC2;j++) {
                    gl_.glNormal3d(normal_P[j][k][0], normal_P[j][k][1], normal_P[j][k][2]);
                    gl_.glVertex3d(char_P[j][k][0], char_P[j][k][1], char_P[j][k][2]);
                    gl_.glNormal3d(normal_P[j][i][0], normal_P[j][i][1], normal_P[j][i][2]);
                    gl_.glVertex3d(char_P[j][i][0], char_P[j][i][1], char_P[j][i][2]);
                  }
                gl_.glNormal3d(normal_P[0][k][0], normal_P[0][k][1], normal_P[0][k][2]);
                gl_.glVertex3d(char_P[0][k][0], char_P[0][k][1], char_P[0][k][2]);
                gl_.glNormal3d(normal_P[0][i][0], normal_P[0][i][1], normal_P[0][i][2]);
                gl_.glVertex3d(char_P[0][i][0], char_P[0][i][1], char_P[0][i][2]);
                gl_.glEnd();
              }
            j = 0;

            gl_.glBegin(GL.GL_QUAD_STRIP);
            for (i=0;i<ACC;i++) {
                gl_.glNormal3d(normal_P[0][i][0], normal_P[0][i][1], normal_P[0][i][2]);
                gl_.glVertex3d(char_P[0][i][0]-4.3, -1.6, 1.0*char_P[0][i][2]);
                gl_.glVertex3d(char_P[0][i][0]-4.3, 6.0, 1.0*char_P[0][i][2]);
                }
            gl_.glNormal3d(normal_P[0][0][0], normal_P[0][0][1], normal_P[0][0][2]);
            gl_.glVertex3d(char_P[0][0][0]-4.3, -1.6, 1.0*char_P[0][0][2]);
            gl_.glVertex3d(char_P[0][0][0]-4.3, 6.0, 1.0*char_P[0][0][2]);
            gl_.glEnd();
            gl_.glEndList();
          } else {
            gl_.glCallList( plist );
          }
      }
    
    /** Draws the 'E' shape */
    private void draw_E() {
        int i,j,k;

        if ( elist == -1 ) {
            elist = gl_.glGenLists( 1 );
            gl_.glNewList( elist, GL.GL_COMPILE_AND_EXECUTE );

            for (i=0;i<ACC;i++) {
                k = i+1;
                if (k>=ACC) {
                    k = 0;
                  }
                gl_.glBegin(GL.GL_QUAD_STRIP);
                gl_.glNormal3d(normal_P[0][k][0], normal_P[0][k][1], normal_P[0][k][2]);
                gl_.glVertex3d(char_P[0][k][0], char_P[0][k][1]+0.0, char_P[0][k][2]);
                gl_.glNormal3d(normal_P[0][i][0], normal_P[0][i][1], normal_P[0][i][2]);
                gl_.glVertex3d(char_P[0][i][0], char_P[0][i][1]+0.0, char_P[0][i][2]);
    
                for (j=1;j<ACC2;j++) {
                    gl_.glNormal3d(normal_P[j][k][0], normal_P[j][k][1], normal_P[j][k][2]);
                    gl_.glVertex3d(char_P[j][k][0], char_P[j][k][1], char_P[j][k][2]);
                    gl_.glNormal3d(normal_P[j][i][0], normal_P[j][i][1], normal_P[j][i][2]);
                    gl_.glVertex3d(char_P[j][i][0], char_P[j][i][1], char_P[j][i][2]);
                    }
                gl_.glNormal3d(normal_P[0][k][0], normal_P[0][k][1], normal_P[0][k][2]);
                gl_.glVertex3d(char_P[0][k][0], char_P[0][k][1]-0.4, char_P[0][k][2]);
                gl_.glNormal3d(normal_P[0][i][0], normal_P[0][i][1], normal_P[0][i][2]);
                gl_.glVertex3d(char_P[0][i][0], char_P[0][i][1]-0.4, char_P[0][i][2]);
                gl_.glEnd();
              }
    
            gl_.glBegin(GL.GL_QUAD_STRIP);
            j = ACC2*3/4;
            for (i=0;i<ACC;i++) {
                gl_.glNormal3d(normal_P[j][i][0], normal_P[j][i][1], normal_P[j][i][2]);
                gl_.glVertex3d(-2.0, char_P[j][i][1]+2.55, 1.0*char_P[j][i][2]);
                gl_.glVertex3d(2.0,  char_P[j][i][1]+2.55, 1.0*char_P[j][i][2]);
              }
            gl_.glNormal3d(normal_P[j][0][0], normal_P[j][0][1], normal_P[j][0][2]);
            gl_.glVertex3d(-2.0, char_P[j][0][1]+2.55, 1.0*char_P[j][0][2]);
            gl_.glVertex3d(2.0,  char_P[j][0][1]+2.55, 1.0*char_P[j][0][2]);
            gl_.glEnd();
            gl_.glEndList();
          } else {
            gl_.glCallList( elist );
          }
      }

    /** Draws the 'El' shape */
    private void draw_El() {
        int i,j,k;
        if ( ellist == -1 ) {
            ellist = gl_.glGenLists( 1 );
            gl_.glNewList( ellist, GL.GL_COMPILE_AND_EXECUTE );

            for (i=0;i<ACC;i++) {
                k = i+1;
                if (k>=ACC) {
                    k = 0;
                  }
                gl_.glBegin( GL.GL_QUAD_STRIP );
                for (j=0;j<=ACC3;j++) {
                    gl_.glNormal3d(normal_El[j][k][0], normal_El[j][k][1], normal_El[j][k][2]);
                    gl_.glVertex3d(char_El[j][k][0], char_El[j][k][1], char_El[j][k][2]);
                    gl_.glNormal3d(normal_El[j][i][0], normal_El[j][i][1], normal_El[j][i][2]);
                    gl_.glVertex3d(char_El[j][i][0], char_El[j][i][1], char_El[j][i][2]);
                  }
                gl_.glEnd();
              }
            gl_.glEndList();
          } else {
            gl_.glCallList( ellist );
          }
      }

    /** Draws the 'N' shape */
    private void draw_N() {
        int i,j,k;

        if ( nlist == -1 ) {
            nlist = gl_.glGenLists( 1 );
            gl_.glNewList( nlist, GL.GL_COMPILE_AND_EXECUTE );

            for (i=0;i<ACC;i++) {
                k = i+1;
                if (k>=ACC) {
                    k = 0;
                  }
                gl_.glBegin(GL.GL_QUAD_STRIP);
                for (j=0;j<=ACC2/2;j++) {
                    gl_.glNormal3d(normal_P[j][k][0], normal_P[j][k][1], normal_P[j][k][2]);
                    gl_.glVertex3d(char_P[j][k][0], char_P[j][k][1], char_P[j][k][2]);
                    gl_.glNormal3d(normal_P[j][i][0], normal_P[j][i][1], normal_P[j][i][2]);
                    gl_.glVertex3d(char_P[j][i][0], char_P[j][i][1], char_P[j][i][2]);
                  }
                gl_.glEnd();
              }
    
            j = 0;
            gl_.glBegin(GL.GL_QUAD_STRIP);
            for (i=0;i<ACC;i++) {
                gl_.glNormal3d(normal_P[0][i][0], normal_P[0][i][1], normal_P[0][i][2]);
                gl_.glVertex3d(char_P[0][i][0]-4.3, 0.2, 1.0*char_P[0][i][2]);
                gl_.glVertex3d(char_P[0][i][0]-4.3, 6.0, 1.0*char_P[0][i][2]);
              }
            gl_.glNormal3d(normal_P[0][0][0], normal_P[0][0][1], normal_P[0][0][2]);
            gl_.glVertex3d(char_P[0][0][0]-4.3, 0.2, 1.0*char_P[0][0][2]);
            gl_.glVertex3d(char_P[0][0][0]-4.3, 6.0, 1.0*char_P[0][0][2]);
            gl_.glEnd();
            j = 0;
    
            gl_.glBegin(GL.GL_QUAD_STRIP);
            for (i=0;i<ACC;i++) {
                gl_.glNormal3d(normal_P[0][i][0], normal_P[0][i][1], normal_P[0][i][2]);
                gl_.glVertex3d(char_P[0][i][0], 0.2, 1.0*char_P[0][i][2]);
                gl_.glVertex3d(char_P[0][i][0], 3.4, 1.0*char_P[0][i][2]);
              }
            gl_.glNormal3d(normal_P[0][0][0], normal_P[0][0][1], normal_P[0][0][2]);
            gl_.glVertex3d(char_P[0][0][0], 0.2, 1.0*char_P[0][0][2]);
            gl_.glVertex3d(char_P[0][0][0], 3.4, 1.0*char_P[0][0][2]);
            gl_.glEnd();
            gl_.glEndList();
          } else {
            gl_.glCallList( nlist );
          }
      }

    /** Draws the 'G' shape */
    private void draw_G() {
        int i,j,k;
        if ( glist == -1 ) {
            glist = gl_.glGenLists( 1 );
            gl_.glNewList( glist, GL.GL_COMPILE_AND_EXECUTE );

            for (i=0;i<ACC;i++) {
                k = i+1;
                if (k>=ACC) {
                    k = 0;
                  }
                gl_.glBegin(GL.GL_QUAD_STRIP);
                gl_.glNormal3d(normal_G[0][k][0], normal_G[0][k][1], normal_G[0][k][2]);
                gl_.glVertex3d(char_G[0][k][0], char_G[0][k][1]+1.2, char_G[0][k][2]);
                gl_.glNormal3d(normal_G[0][i][0], normal_G[0][i][1], normal_G[0][i][2]);
                gl_.glVertex3d(char_G[0][i][0], char_G[0][i][1]+1.2, char_G[0][i][2]);
                for (j=1;j<ACC4;j++) {
                    gl_.glNormal3d(normal_G[j][k][0], normal_G[j][k][1], normal_G[j][k][2]);
                    gl_.glVertex3d(char_G[j][k][0], char_G[j][k][1], char_G[j][k][2]);
                    gl_.glNormal3d(normal_G[j][i][0], normal_G[j][i][1], normal_G[j][i][2]);
                    gl_.glVertex3d(char_G[j][i][0], char_G[j][i][1], char_G[j][i][2]);
                  }
                gl_.glEnd();
              }
    
            gl_.glBegin(GL.GL_QUAD_STRIP);
            j = ACC4*3/4;
            for (i=0;i<ACC;i++) {
                gl_.glNormal3d(accSIN[i], 0.0, accCOS[i] );
                gl_.glVertex3d(4.0+0.9*accSIN[i], 4.0+0.9*accSIN[i], 0.9*accCOS[i] );
                gl_.glVertex3d(4.0+0.9*accSIN[i], 0.0, 0.9*accCOS[i]);
              }
            gl_.glNormal3d(accSIN[0], 0.0, accCOS[0] );
            gl_.glVertex3d(4.0+0.9*accSIN[0], 4.0+0.9*accSIN[0], 0.9*accCOS[0] );
            gl_.glVertex3d(4.0+0.9*accSIN[0], 0.0, 0.9*accCOS[0]);
            gl_.glEnd();
    
            gl_.glBegin(GL.GL_QUAD_STRIP);
            j = ACC4*3/4;
            for (i=0;i<ACC;i++) {
                gl_.glNormal3d(0.0, accSIN[i], accCOS[i] );
                gl_.glVertex3d(4.0-0.9*accSIN[i], 4.0-0.9*accSIN[i], 0.9*accCOS[i] );
                gl_.glVertex3d(0.0, 4.0-0.9*accSIN[i], 0.9*accCOS[i]);
              }
            gl_.glNormal3d(0.0, accSIN[0], accCOS[0] );
            gl_.glVertex3d(4.0-0.9*accSIN[0], 4.0-0.9*accSIN[0], 0.9*accCOS[0] );
            gl_.glVertex3d(0.0, 4.0-0.9*accSIN[0], 0.9*accCOS[0]);
            gl_.glEnd();
    
            j = ACC4*3/4;
            gl_.glBegin(GL.GL_TRIANGLE_FAN);
            gl_.glNormal3d(-1.0, 0.0, 0.0);
            gl_.glVertex3d(0.0, 4.0, 0.0);
            for (i=0;i<ACC;i++) {
                gl_.glVertex3d(0.0, 4.0+0.9*accSIN[i], 0.9*accCOS[i]);
              }
            gl_.glVertex3d(0.0, 4.0+0.9*accSIN[0], 0.9*accCOS[0]);
            gl_.glEnd();
            gl_.glEndList();
          } else {
            gl_.glCallList( glist );
          }
      }

    /** Draws the 'L' shape */
    private void draw_L() {
        int i;

        if ( llist == -1 ) {
            llist = gl_.glGenLists( 1 );
            gl_.glNewList( llist, GL.GL_COMPILE_AND_EXECUTE );

            gl_.glBegin(GL.GL_QUAD_STRIP);
            for (i=0;i<ACC;i++) {
                gl_.glNormal3d(accSIN[i], 0.0, accCOS[i] );
                gl_.glVertex3d(0.9*accSIN[i], 9.6, 0.9*accCOS[i]);
                gl_.glVertex3d(0.9*accSIN[i], 0.9+0.9*accSIN[i], 0.9*accCOS[i] );
              }
            gl_.glNormal3d(accSIN[0], 0.0, accCOS[0] );
            gl_.glVertex3d(0.9*accSIN[0], 9.6, 0.9*accCOS[0]);
            gl_.glVertex3d(0.9*accSIN[0], 0.9+0.9*accSIN[0], 0.9*accCOS[0] );
            gl_.glEnd();
    
            gl_.glBegin(GL.GL_QUAD_STRIP);
            for (i=0;i<ACC;i++) {
                gl_.glNormal3d(0.0, accSIN[i], accCOS[i] );
                gl_.glVertex3d(0.9*accSIN[i], 0.9+0.9*accSIN[i], 0.9*accCOS[i] );
                gl_.glVertex3d(5.6, 0.9+0.9*accSIN[i], 0.9*accCOS[i]);
              }
            gl_.glNormal3d(0.0, accSIN[0], accCOS[0] );
            gl_.glVertex3d(0.9*accSIN[0], 0.9+0.9*accSIN[0], 0.9*accCOS[0] );
            gl_.glVertex3d(5.6, 0.9+0.9*accSIN[0], 0.9*accCOS[0]);
            gl_.glEnd();
    
            gl_.glBegin( GL.GL_TRIANGLE_FAN );
            gl_.glNormal3d(1.0, 0.0, 0.0);
            gl_.glVertex3d(5.6, 0.9, 0.0);
            for (i=ACC-1;i>=0;i--) {
                gl_.glVertex3d(5.6, 0.9+0.9*accSIN[i], 0.9*accCOS[i]);
              }
            gl_.glVertex3d(5.6, 0.9+0.9*accSIN[ACC-1], 0.9*accCOS[ACC-1]);
            gl_.glEnd();
            gl_.glEndList();
          } else {
            gl_.glCallList( llist );
          }
      }

    /** WindowListener methods */
    public void windowActivated( WindowEvent evt ) {
      }

    public void windowClosed( WindowEvent evt ) {
      }

    public void windowClosing( WindowEvent evt ) {
        glc.destroy();
        /**#dispose */
      }

    public void windowDeactivated( WindowEvent evt ) {
      }

    public void windowDeiconified( WindowEvent evt ) {
        if ( glc.isRunning() ) {
            glc.resume();
          }
      }

    public void windowIconified( WindowEvent evt ) {
        if ( glc.isRunning() ) {
            glc.suspend();
          }
      }

    public void windowOpened( WindowEvent evt ) {
      }
    /** Applet only */
    public void stop() {
//        System.err.println( "stop() called" );
        /** Suspend the GL component only if it's driving an event loop */
        if ( glc.isRunning() ) {
            glc.suspend();
          }
      }

    /** Applet only */
    public void start() {
//        System.err.println( "start()" );
        /** Restart the GL component only if it's driving an event loop */
        if ( glc.isRunning() ) {
            glc.resume();
          }
      }

    /** Applet only */
    public void destroy() {
//        System.err.println( "destroy() called" );
        /** Destroy the GL component to free up the resources */
        glc.destroy();
      }
  }
