/** 
 * $Id$
 *
 * Copyright (c)1997 Alligator Descartes <descarte@hermetica.com>
 *
 * Class encapsulating a paper-plane
 *
 * $Log$
 */

package com.hermetica.magician.demos;

public class plane {

    /** Speed of the plane */
    private float speed = 0;

    /** Red component of the plane's colour */
    private float red = 0;

    /** Green component of the plane's colour */
    private float green = 0;

    /** Blue component of the plane's colour */
    private float blue = 0;

    /** Theta angle of rotation */
    private float theta = 0;

    /** x location of the plane */
    private float x = 0;

    /** y location of the plane */
    private float y = 0;

    /** z location of the plane */
    private float z = 0;

    /** Angle of rotation */
    private float angle = 0;

    /** Gets the X position of the plane */
    public float getX() {
        return x;
      }
    /** Gets the Y position of the plane */
    public float getY() {
        return y;
      }

    /** Gets the Z position of the plane */
    public float getZ() {
        return z;
      }

    /** Returns the angle of the plane */
    public float getAngle() {
        return angle;
      }

    /** Gets the red component of the plane's colour */
    public float getRed() {
        return red;
      }

    /** Gets the green component of the plane's colour */
    public float getGreen() {
        return green;
      }

    /** Gets the blue component of the plane's colour */
    public float getBlue() {
        return blue;
      }

    /** Returns an RGB triple for the plane's colour */
    public String getColour() {
        return new String( red + ":" + green + ":" + blue );
      }

    /** Returns the plane's speed */
    public float getSpeed() {
        return speed;
      }

    /** Sets the colour of the plane */
    public void setColour( float red, float green, float blue ) {
        this.red = red;
        this.green = green;
        this.blue = blue;
      }

    /** Sets the speed of the plane */
    public void setSpeed( float speed ) {
        this.speed = speed;
      }

    /** Sets the theta of the plane */
    public void setTheta( float theta ) {
        this.theta = theta;
      }

    /** 
     * Updates the position of the plane by calculating the new position and
     * rotation
     */
    public void tick() {
        theta += speed;
        z = (float)( -9 + ( 4 * Math.cos( theta ) ) );
        x = (float)( 4 * Math.sin( 2 * theta ) );
        y = (float)( Math.sin( theta / 3.4 ) * 3 );
        angle = (float)( ( ( Math.atan( 2.0 ) + ( 3.14 / 2 ) ) * Math.sin( theta ) - ( 3.14 / 2 ) ) * 180 / 3.14 );
        if ( speed < 0.0 ) {
            angle += 180;
          }
      }
  }
