/*
 * Copyright (c) 1993-1997, Silicon Graphics, Inc.
 * ALL RIGHTS RESERVED 
 * Permission to use, copy, modify, and distribute this software for 
 * any purpose and without fee is hereby granted, provided that the above
 * copyright notice appear in all copies and that both the copyright notice
 * and this permission notice appear in supporting documentation, and that 
 * the name of Silicon Graphics, Inc. not be used in advertising
 * or publicity pertaining to distribution of the software without specific,
 * written prior permission. 
 *
 * THE MATERIAL EMBODIED ON THIS SOFTWARE IS PROVIDED TO YOU "AS-IS"
 * AND WITHOUT WARRANTY OF ANY KIND, EXPRESS, IMPLIED OR OTHERWISE,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF MERCHANTABILITY OR
 * FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT SHALL SILICON
 * GRAPHICS, INC.  BE LIABLE TO YOU OR ANYONE ELSE FOR ANY DIRECT,
 * SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY
 * KIND, OR ANY DAMAGES WHATSOEVER, INCLUDING WITHOUT LIMITATION,
 * LOSS OF PROFIT, LOSS OF USE, SAVINGS OR REVENUE, OR THE CLAIMS OF
 * THIRD PARTIES, WHETHER OR NOT SILICON GRAPHICS, INC.  HAS BEEN
 * ADVISED OF THE POSSIBILITY OF SUCH LOSS, HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE
 * POSSESSION, USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 * US Government Users Restricted Rights 
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions set forth in FAR 52.227.19(c)(2) or subparagraph
 * (c)(1)(ii) of the Rights in Technical Data and Computer Software
 * clause at DFARS 252.227-7013 and/or in similar or successor
 * clauses in the FAR or the DOD or NASA FAR Supplement.
 * Unpublished-- rights reserved under the copyright laws of the
 * United States.  Contractor/manufacturer is Silicon Graphics,
 * Inc., 2011 N.  Shoreline Blvd., Mountain View, CA 94039-7311.
 *
 * OpenGL(R) is a registered trademark of Silicon Graphics, Inc.
 */

/**
 * $Id: quadric.java.stub,v 1.13 1998/10/19 12:16:45 descarte Exp descarte $
 *
 * Copyright (c)1997-1998 Arcane Technologies Ltd. <http://www.arcana.co.uk>
 *
 * 'quadric' from the Red Book
 *
 * $Log: quadric.java.stub,v $
 * Revision 1.13  1998/10/19 12:16:45  descarte
 * Made JDK-1.1 compliant. Updated copyright information.
 *
 * Revision 1.12  1998/10/02 12:56:56  descarte
 * Changed GLComponentListener to GLEventListener. Changed reshape() arguments.
 *
 * Revision 1.11  1998/06/07 13:58:21  descarte
 * Converted from COM.hermetica.* to com.hermetica.* hierarchy.
 *
 * Revision 1.10  1998/03/30 11:48:18  descarte
 * Added applet resource handling.
 *
 * Revision 1.9  1998/03/29 16:14:16  descarte
 * Upgraded to Java 1.1 listeners.
 * Upgraded to GLComponentFactory.
 *
 * Revision 1.8  1998/03/24 22:57:09  descarte
 * Converted from beta 3 to beta 4. Converted to GLDrawable interface.
 *
 * Revision 1.7  1998/01/04 19:59:16  descarte
 * Converted to new pipeline class names, ie, AbstractGL -> GL; GL -> CoreGL.
 *
 * Revision 1.6  1998/01/03 16:43:52  descarte
 * Corrected 'add()' method to have explicit placement argument for MSVM port.
 *
 * Revision 1.5  1998/01/01 16:53:54  descarte
 * Converted demo across to GLEventListener interface which looks sort of
 * GLUTtonish.
 *
 * Revision 1.4  1997/09/09 14:29:17  descarte
 * Added copyright information.
 *
 * Revision 1.3  1997/09/02 23:58:27  descarte
 * Added GLContextException traps.
 *
 * Revision 1.2  1997/08/26 00:38:10  descarte
 * Moved demo to demoTemplate structure.
 *
 * Revision 1.1  1997/08/18 00:36:12  descarte
 * Initial revision
 *
 *
 */

package com.hermetica.magician.demos.redbook;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import com.hermetica.magician.*;
import com.hermetica.util3d.*;

public class quadric extends Frame implements demoTemplate, GLEventListener, KeyListener, WindowListener {

    /** The OpenGL state machine */
    private CoreGL gl_ = new CoreGL();
    private CoreGLU glu_ = new CoreGLU();

    /** The OpenGL component to render onto */
    private GLComponent glc = null;

    /** The dimensions of the component */
    private static final int WIDTH = 500,
                             HEIGHT = 500;

    /** The display list indices */
    private int startList = -1;

    /** Regulates the calling of System.exit() */
    private boolean callExit = true;

    public static void main( String argv[] ) {
        quadric d = new quadric();
        d.setTitle( d.getName() );
        System.err.println( "\n" + d.getName() + " -- " + d.getOriginalAuthor() );
        for ( int i = 0 ; i < ( d.getName().length() + d.getOriginalAuthor().length() + 4 ) ; i++ ) {
            System.err.print( "=" );
          }
        System.err.println( "\n" );
        System.err.println( d.getDescription() + "\n" );
        d.startDemo();
      }

    public quadric() {
        /**#start */
      }

    /** Set to false if the demo is to call System.exit() */
    public void setExit( boolean state ) {
        callExit = state;
      }

    /** Returns the name of the demo */
    public String getName() {
        return new String( "GLU Quadrics" );
      }

    /** Returns the version information for this demo */
    public String getVersion() {
        return new String( "$Id: quadric.java.stub,v 1.13 1998/10/19 12:16:45 descarte Exp descarte $" );
      }

    /** Returns a description for this demo */
    public String getDescription() {
        StringBuffer sb = new StringBuffer();
        sb.append( "This demonstration draws the four quadric primitives defined\n" );
        sb.append( "in the CoreGLU class, namely the Sphere, the Cylinder, the Disk and\n" );
        sb.append( "the Partial Disk. Each quadric may be rendered in wireframe\n" );
        sb.append( "or solid.\n\n" );
        sb.append( "Hit the ``Escape'' key to stop this demonstration." );
        return new String( sb );
      }

    /** Returns the width of the demo */
    public int getWidth() {
        return WIDTH;
      }

    /** Returns the height of the demo */
    public int getHeight() {
        return HEIGHT;
      }

    /** Returns the original author of this demo */
    public String getOriginalAuthor() {
        return new String( "Mason Woo, Tom Davis, Jackie Neider" );
      }

    public void startDemo() {

        /** Set the layout of the frame */
        setLayout( new BorderLayout() );

        glc = GLComponentFactory.createGLComponent( WIDTH, HEIGHT );

        /** Add the Component into the window */
        add( "Center", glc );
        pack(); show();

        /** Setup the context capabilities */
        GLCapabilities cap = glc.getContext().getCapabilities();
        cap.setDepthBits( 12 );
        cap.setPixelType( GLCapabilities.RGBA );
        cap.setColourBits( 24 );
        cap.setDoubleBuffered( GLCapabilities.DOUBLEBUFFER );

        /** Register the GLEventListener for the GLComponent */
        glc.addGLEventListener( this );

        /** Register a keyboard listener */
        glc.addKeyListener( this );

        this.addWindowListener( this );

        /** Initialize the component */
        glc.initialize();
      }

    /** Initialization stuff */
    public void initialize( GLDrawable component ) {
        gl_.glClearColor( 0.0f, 0.0f, 0.0f, 0.0f );
        gl_.glShadeModel( GL.GL_FLAT );

        /** Build some quadrics! */
        GLUQuadric qobj = glu_.gluNewQuadric();
        float mat_ambient[] = { 0.5f, 0.5f, 0.5f, 1.0f };
        float mat_specular[] = { 1.0f, 1.0f, 1.0f, 1.0f };
        float mat_shininess[] = { 50.0f };
        float light_position[] = { 1.0f, 1.0f, 1.0f, 0.0f };
        float model_ambient[] = { 0.5f, 0.5f, 0.5f, 1.0f };

        gl_.glMaterialfv( GL.GL_FRONT, GL.GL_AMBIENT, mat_ambient );
        gl_.glMaterialfv( GL.GL_FRONT, GL.GL_SPECULAR, mat_specular );
        gl_.glMaterialfv( GL.GL_FRONT, GL.GL_SHININESS, mat_shininess );
        gl_.glLightfv( GL.GL_LIGHT0, GL.GL_POSITION, light_position );
        gl_.glLightModelfv( GL.GL_LIGHT_MODEL_AMBIENT, model_ambient );

        gl_.glEnable( GL.GL_LIGHTING );
        gl_.glEnable( GL.GL_LIGHT0 );
        gl_.glEnable( GL.GL_DEPTH_TEST );

        startList = gl_.glGenLists( 4 );

        /** Define the sphere */
        glu_.gluQuadricDrawStyle( qobj, GLU.GLU_FILL );
        glu_.gluQuadricNormals( qobj, GLU.GLU_SMOOTH );
        gl_.glNewList( startList, GL.GL_COMPILE );
            glu_.gluSphere( qobj, 0.75, 15, 10 );
        gl_.glEndList();

        /** Define the cylinder */
        glu_.gluQuadricDrawStyle( qobj, GLU.GLU_FILL );
        glu_.gluQuadricNormals( qobj, GLU.GLU_FLAT );
        gl_.glNewList( startList + 1, GL.GL_COMPILE );
            glu_.gluCylinder( qobj, 0.5, 0.3, 1.0, 15, 5 );
        gl_.glEndList();

        /** Define the disk */
        glu_.gluQuadricDrawStyle( qobj, GLU.GLU_LINE );
        glu_.gluQuadricNormals( qobj, GLU.GLU_NONE );
        gl_.glNewList( startList + 2, GL.GL_COMPILE );
            glu_.gluDisk( qobj, 0.25, 1.0, 20, 4 );
        gl_.glEndList();

        /** Define the partial disk */
        glu_.gluQuadricDrawStyle( qobj, GLU.GLU_SILHOUETTE );
        glu_.gluQuadricNormals( qobj, GLU.GLU_NONE );
        gl_.glNewList( startList + 3, GL.GL_COMPILE );
            glu_.gluPartialDisk( qobj, 0.0, 1.0, 20, 4, 0.0, 225.0 );
        gl_.glEndList();
      }

    /** Reshape the viewport */
    public void reshape( GLDrawable component, int x, int y, int width, int height ) {
        /** Setup the viewport */
        gl_.glViewport( component, x, y, width, height );
        gl_.glMatrixMode( GL.GL_PROJECTION );
        gl_.glLoadIdentity();
        if ( width <= height ) {
            gl_.glOrtho( -2.5 * ( (float)height / (float)width ), 
                         2.5 * ( (float)height / (float)width ),
                         -2.5, 2.5, -10.0, 10.0 );
          } else {
            gl_.glOrtho( -2.5 * ( (float)width / (float)height ), 
                         2.5 * ( (float)width / (float)height ),
                         -2.5, 2.5, -10.0, 10.0 );
          }
        gl_.glMatrixMode( GL.GL_MODELVIEW );
        gl_.glLoadIdentity();
      }

    /** Draws the scene */
    public void display( GLDrawable component ) {
        /** Do the funky OpenGL stuff */
        gl_.glClear( GL.GL_COLOR_BUFFER_BIT | GL.GL_DEPTH_BUFFER_BIT );
        gl_.glPushMatrix();

        /** Draw the sphere */
        gl_.glEnable( GL.GL_LIGHTING );
        gl_.glShadeModel( GL.GL_SMOOTH );
        gl_.glTranslatef( -1.0f, -1.0f, 0.0f );
        gl_.glCallList( startList );

        /** Draw the cylinder */
        gl_.glShadeModel( GL.GL_FLAT );
        gl_.glTranslatef( 0.0f, 2.0f, 0.0f );
        gl_.glPushMatrix();
        gl_.glRotatef( 300.0f, 1.0f, 0.0f, 0.0f );
        gl_.glCallList( startList + 1 );
        gl_.glPopMatrix();

        /** Draw the disk */
        gl_.glDisable( GL.GL_LIGHTING );
        gl_.glColor3f( 0.0f, 1.0f, 1.0f );
        gl_.glTranslatef( 2.0f, -2.0f, 0.0f );
        gl_.glCallList( startList + 2 );

        /** Draw the partial disk */
        gl_.glColor3f( 1.0f, 1.0f, 0.0f );
        gl_.glTranslatef( 0.0f, 2.0f, 0.0f );
        gl_.glCallList( startList + 3 );

        /** Restore state */
        gl_.glPopMatrix();
      }

    /** Returns a GL pipeline from the listener */
    public GL getGL() {
        return gl_;
      }

    /** Handles keyboard events */
    /** Handles key pressed event */
    public void keyPressed( KeyEvent evt ) {
        if ( evt.getKeyChar() == KeyEvent.VK_ESCAPE ) {
            /** Destroy the GLContext */
            glc.destroy();
            dispose();
        if ( callExit ) {
            System.exit( 0 );
          }

            return;
          }
      }

    /** Handles key typed events */
    public void keyTyped( KeyEvent evt ) {
      }

    /** Handles key released events */
    public void keyReleased( KeyEvent evt ) {
      }

    /** WindowListener methods */
    public void windowActivated( WindowEvent evt ) {
      }

    public void windowClosed( WindowEvent evt ) {
      }

    public void windowClosing( WindowEvent evt ) {
        glc.destroy();
        dispose();
        if ( callExit ) {
            System.exit( 0 );
          }

      }

    public void windowDeactivated( WindowEvent evt ) {
      }

    public void windowDeiconified( WindowEvent evt ) {
        if ( glc.isRunning() ) {
            glc.resume();
          }
      }

    public void windowIconified( WindowEvent evt ) {
        if ( glc.isRunning() ) {
            glc.suspend();
          }
      }

    public void windowOpened( WindowEvent evt ) {
      }
    /** Applet only */
    public void stop() {
//        System.err.println( "stop() called" );
        /** Suspend the GL component only if it's driving an event loop */
        if ( glc.isRunning() ) {
            glc.suspend();
          }
      }

    /** Applet only */
    public void start() {
//        System.err.println( "start()" );
        /** Restart the GL component only if it's driving an event loop */
        if ( glc.isRunning() ) {
            glc.resume();
          }
      }

    /** Applet only */
    public void destroy() {
//        System.err.println( "destroy() called" );
        /** Destroy the GL component to free up the resources */
        glc.destroy();
      }
  }
