/**
 * $Id: stroke.java.stub,v 1.11 1998/10/19 12:16:50 descarte Exp descarte $
 *
 * Copyright (c)1997-1998 Arcane Technologies Ltd. <http://www.arcana.co.uk>
 *
 * 'stroke' from the Red Book
 *
 * $Log: stroke.java.stub,v $
 * Revision 1.11  1998/10/19 12:16:50  descarte
 * Made JDK-1.1 compliant. Updated copyright information.
 *
 * Revision 1.10  1998/10/02 12:57:02  descarte
 * Changed GLComponentListener to GLEventListener. Changed reshape() arguments.
 *
 * Revision 1.9  1998/06/13 08:49:49  descarte
 * Altered this back to using glCallList() instead of glCallLists(). The latter
 * appears buggy for some weird reason.
 *
 * Revision 1.8  1998/06/07 13:58:22  descarte
 * Converted from COM.hermetica.* to com.hermetica.* hierarchy.
 *
 * Revision 1.7  1998/03/30 11:48:24  descarte
 * Added applet resource handling.
 *
 * Revision 1.6  1998/03/24 22:57:14  descarte
 * Converted from beta 3 to beta 4. Converted to GLDrawable interface.
 *
 * Revision 1.5  1998/01/04 19:59:23  descarte
 * Converted to new pipeline class names, ie, AbstractGL -> GL; GL -> CoreGL.
 *
 * Revision 1.4  1998/01/03 16:43:58  descarte
 * Corrected 'add()' method to have explicit placement argument for MSVM port.
 *
 * Revision 1.3  1998/01/01 22:09:10  descarte
 * Converted demo to GLEventListener interface.
 * Added description.
 *
 * Revision 1.2  1997/11/16 17:36:16  descarte
 * Converted demo across to demoTemplate format and fixed so that it works!
 *
 * Revision 1.1  1997/08/16 15:47:55  descarte
 * Initial revision
 *
 * Revision 1.1  1997/08/16 15:12:48  descarte
 * Initial revision
 *
 *
 */

package com.hermetica.magician.demos.redbook;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import com.hermetica.magician.*;
import com.hermetica.util3d.*;

public class strokeapp extends Applet implements demoTemplate, GLEventListener, KeyListener, WindowListener {

    /** The OpenGL state machine */
    private GL gl_ = null;
    private CoreGL coregl_ = new CoreGL();
    private CoreGLU glu_ = new CoreGLU();
    private TraceGL tracegl_ = new TraceGL( coregl_ );

    /** Version information */
    public static final String VERSION = new String( "$Id: stroke.java.stub,v 1.11 1998/10/19 12:16:50 descarte Exp descarte $" );

    /** The OpenGL component to render onto */
    private GLComponent glc = null;

    /** The dimensions of the component */
    private static final int WIDTH = 440,
                             HEIGHT = 120;

    /** The strings to print */
    private static final String string1 = "A SPARE SERAPE APPEARS AS";
    private static final String string2 = "APES PREPARE RARE PEPPERS";

    /** Some font definition constants */
    private static final int PT = 1;
    private static final int STROKE = 2;
    private static final int END = 3;

    /** The generated display list base */
    int base = -1;

    /** Character definitions */
    int[][] Adata = {
        { 0, 0, PT }, { 0, 9, PT }, { 1, 10, PT }, { 4, 10, PT },
        { 5, 9, PT }, { 5, 0, STROKE }, { 0, 5, PT }, { 5, 5, END }
      };

    int[][] Edata = {
        { 5, 0, PT }, { 0, 0, PT }, { 0, 10, PT }, { 5, 10, STROKE },
        { 0, 5, PT }, { 4, 5, END }
      };

    int[][] Pdata = {
        { 0, 0, PT }, { 0, 10, PT },  { 4, 10, PT }, { 5, 9, PT }, { 5, 6, PT }, 
        { 4, 5, PT }, { 0, 5, END }
      };

    int[][] Rdata = {
        { 0, 0, PT }, { 0, 10, PT },  { 4, 10, PT }, { 5, 9, PT }, { 5, 6, PT }, 
        { 4, 5, PT }, { 0, 5, STROKE }, { 3, 5, PT }, { 5, 0, END }
      };

    int[][] Sdata = {
        { 0, 1, PT }, { 1, 0, PT }, { 4, 0, PT }, { 5, 1, PT }, { 5, 4, PT }, 
        { 4, 5, PT }, { 1, 5, PT }, { 0, 6, PT }, { 0, 9, PT }, { 1, 10, PT }, 
        { 4, 10, PT }, { 5, 9, END }
      };

    /** Regulates the calling of System.exit() */
    private boolean callExit = true;



    public void init() {
        tracegl_.setMode( TraceGL.VERBOSE );
        gl_ = coregl_;

        startDemo();
      }

    /** Set to false if the demo is to call System.exit() */
    public void setExit( boolean state ) {
        callExit = state;
      }

    /** Returns the name of the demo */
    public String getName() {
        return new String( "Stroked Fonts" );
      }

    /** Returns the version information for this demo */
    public String getVersion() {
        return new String( "$Id: stroke.java.stub,v 1.11 1998/10/19 12:16:50 descarte Exp descarte $" );
      }

    /** Returns a description for this demo */
    public String getDescription() {
        StringBuffer sb = new StringBuffer();
        sb.append( "This demonstration illustrates the use of display lists\n" );
        sb.append( "to render strings of text generated via GL_LINE_LOOPs.\n\n" );
        sb.append( "Hit the ``Escape'' key to stop this demonstration." );
        return new String( sb );
      }

    /** Returns the width of the demo */
    public int getWidth() {
        return WIDTH;
      }

    /** Returns the height of the demo */
    public int getHeight() {
        return HEIGHT;
      }

    /** Returns the original author of this demo */
    public String getOriginalAuthor() {
        return new String( "Mason Woo, Tom Davis, Jackie Neider" );
      }

    public void startDemo() {

        /** Set the layout of the frame */
        setLayout( new BorderLayout() );

        glc = GLComponentFactory.createGLComponent( WIDTH, HEIGHT );

        /** Add the Component into the window */
        add( "Center", glc );
        /**#layout */

        /** Setup the context capabilities */
        GLCapabilities cap = glc.getContext().getCapabilities();
        cap.setDepthBits( 12 );
        cap.setPixelType( GLCapabilities.RGBA );
        cap.setColourBits( 24 );
        cap.setDoubleBuffered( GLCapabilities.DOUBLEBUFFER );

        /** Register the GLEventListener with the GLComponent */
        glc.addGLEventListener( this );

        /** Register a keyboard listener */
        glc.addKeyListener( this );

        /**#windowListener */

        /** Initialize the component */
        glc.initialize();
      }

    /** Initialization stuff */
    public void initialize( GLDrawable component ) {
        try {
            /** Some misc setup */
            gl_.glClearColor( 0.0f, 0.0f, 0.0f, 0.0f );
            gl_.glShadeModel( GL.GL_FLAT );

            /** Initialize the display lists for each character */
            base = gl_.glGenLists( 128 );
            gl_.glListBase( base );
            gl_.glNewList( 'A', GL.GL_COMPILE );
                drawLetter( Adata );
            gl_.glEndList();

            gl_.glNewList( 'E', GL.GL_COMPILE );
                drawLetter( Edata );
            gl_.glEndList();

            gl_.glNewList( 'P', GL.GL_COMPILE );
                drawLetter( Pdata );
            gl_.glEndList();

            gl_.glNewList( 'R', GL.GL_COMPILE );
                drawLetter( Rdata );
            gl_.glEndList();

            gl_.glNewList( 'S', GL.GL_COMPILE );
                drawLetter( Sdata );
            gl_.glEndList();

            gl_.glNewList( ' ', GL.GL_COMPILE );
                gl_.glTranslatef( 8.0f, 0.0f, 0.0f );
            gl_.glEndList();
          } catch ( OpenGLException e ) {
            e.printStackTrace();
          }
      }

    /** Handles viewport resizing */
    public void reshape( GLDrawable component, int x, int y, int width, int height ) {
        /** Setup the viewport */
        gl_.glViewport( component, x, y, width, height );
        gl_.glMatrixMode( GL.GL_PROJECTION );
        gl_.glLoadIdentity();
        glu_.gluOrtho2D( 0.0, width, 0, height );
      }

    /** Draws a line */
    private void drawLetter( int[][] data ) throws OpenGLException {

        gl_.glBegin( GL.GL_LINE_STRIP );
            for ( int i = 0 ; i < data.length ; i++ ) {
                switch ( data[i][2] ) {
                    case PT:
                        gl_.glVertex2f( data[i][0], data[i][1] );
                        break;
                    case STROKE:
                        gl_.glVertex2f( data[i][0], data[i][1] );
                        gl_.glEnd();
                        gl_.glBegin( GL.GL_LINE_STRIP );
                        break;
                    case END:
                        gl_.glVertex2f( data[i][0], data[i][1] );
                        gl_.glEnd();
                        gl_.glTranslatef( 8.0f, 0.0f, 0.0f );
                        break;
                  }
              }
      }

    /** Prints a stroked string */
    private void printStrokedString( String str ) throws OpenGLException {
        byte[] tmpArray = str.getBytes();
        for ( int i = 0 ; i < tmpArray.length ; i++ ) {
            gl_.glCallList( (int)tmpArray[i] );
          }
//        gl_.glCallLists( tmpArray.length, GL.GL_BYTE, tmpArray );
      }

    /** Redraws the screen */
    public void display( GLDrawable component ) {
        try {
            /** Clear the buffer */
            gl_.glClear( GL.GL_COLOR_BUFFER_BIT );

            /** Render the first string */
            gl_.glColor3f( 1.0f, 1.0f, 1.0f );
            gl_.glPushMatrix();
            gl_.glScalef( 2.0f, 2.0f, 2.0f );
            gl_.glTranslatef( 10.0f, 30.0f, 0.0f );
            printStrokedString( string1 );
            gl_.glPopMatrix();

            /** Render the second string */
            gl_.glPushMatrix();
            gl_.glScalef( 2.0f, 2.0f, 2.0f );
            gl_.glTranslatef( 10.0f, 13.0f, 0.0f );
            printStrokedString( string2 );
            gl_.glPopMatrix();
          } catch ( OpenGLException e ) {
            e.printStackTrace();
          } catch ( GLContextException e2 ) {
            e2.printStackTrace();
          }
      }

    /** Returns a GL pipeline from the listener */
    public GL getGL() {
        return gl_;
      }

    /** Handles keyboard events */
    /** Handles key pressed event */
    public void keyPressed( KeyEvent evt ) {
        if ( evt.getKeyChar() == KeyEvent.VK_ESCAPE ) {
            /** Destroy the GLContext */
            glc.destroy();
            /**#dispose */
            return;
          }
      }

    /** Handles key typed events */
    public void keyTyped( KeyEvent evt ) {
      }

    /** Handles key released events */
    public void keyReleased( KeyEvent evt ) {
      }

    /** WindowListener methods */
    public void windowActivated( WindowEvent evt ) {
      }

    public void windowClosed( WindowEvent evt ) {
      }

    public void windowClosing( WindowEvent evt ) {
        glc.destroy();
        /**#dispose */
      }

    public void windowDeactivated( WindowEvent evt ) {
      }

    public void windowDeiconified( WindowEvent evt ) {
        if ( glc.isRunning() ) {
            glc.resume();
          }
      }

    public void windowIconified( WindowEvent evt ) {
        if ( glc.isRunning() ) {
            glc.suspend();
          }
      }

    public void windowOpened( WindowEvent evt ) {
      }
    /** Applet only */
    public void stop() {
//        System.err.println( "stop() called" );
        /** Suspend the GL component only if it's driving an event loop */
        if ( glc.isRunning() ) {
            glc.suspend();
          }
      }

    /** Applet only */
    public void start() {
//        System.err.println( "start()" );
        /** Restart the GL component only if it's driving an event loop */
        if ( glc.isRunning() ) {
            glc.resume();
          }
      }

    /** Applet only */
    public void destroy() {
//        System.err.println( "destroy() called" );
        /** Destroy the GL component to free up the resources */
        glc.destroy();
      }
  }
