/*
 * Copyright (c) 1993-1997, Silicon Graphics, Inc.
 * ALL RIGHTS RESERVED 
 * Permission to use, copy, modify, and distribute this software for 
 * any purpose and without fee is hereby granted, provided that the above
 * copyright notice appear in all copies and that both the copyright notice
 * and this permission notice appear in supporting documentation, and that 
 * the name of Silicon Graphics, Inc. not be used in advertising
 * or publicity pertaining to distribution of the software without specific,
 * written prior permission. 
 *
 * THE MATERIAL EMBODIED ON THIS SOFTWARE IS PROVIDED TO YOU "AS-IS"
 * AND WITHOUT WARRANTY OF ANY KIND, EXPRESS, IMPLIED OR OTHERWISE,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF MERCHANTABILITY OR
 * FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT SHALL SILICON
 * GRAPHICS, INC.  BE LIABLE TO YOU OR ANYONE ELSE FOR ANY DIRECT,
 * SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY
 * KIND, OR ANY DAMAGES WHATSOEVER, INCLUDING WITHOUT LIMITATION,
 * LOSS OF PROFIT, LOSS OF USE, SAVINGS OR REVENUE, OR THE CLAIMS OF
 * THIRD PARTIES, WHETHER OR NOT SILICON GRAPHICS, INC.  HAS BEEN
 * ADVISED OF THE POSSIBILITY OF SUCH LOSS, HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE
 * POSSESSION, USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 * US Government Users Restricted Rights 
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions set forth in FAR 52.227.19(c)(2) or subparagraph
 * (c)(1)(ii) of the Rights in Technical Data and Computer Software
 * clause at DFARS 252.227-7013 and/or in similar or successor
 * clauses in the FAR or the DOD or NASA FAR Supplement.
 * Unpublished-- rights reserved under the copyright laws of the
 * United States.  Contractor/manufacturer is Silicon Graphics,
 * Inc., 2011 N.  Shoreline Blvd., Mountain View, CA 94039-7311.
 *
 * OpenGL(R) is a registered trademark of Silicon Graphics, Inc.
 */

/**
 * $Id: torus.java.stub,v 1.13 1998/10/19 12:16:56 descarte Exp descarte $
 *
 * Copyright (c)1997-1998 Arcane Technologies Ltd. <http://www.arcana.co.uk>
 *
 * 'torus' from the Red Book
 *
 * $Log: torus.java.stub,v $
 * Revision 1.13  1998/10/19 12:16:56  descarte
 * Made JDK-1.1 compliant. Updated copyright information.
 *
 * Revision 1.12  1998/10/02 12:57:10  descarte
 * Changed GLComponentListener to GLEventListener. Changed reshape() arguments.
 *
 * Revision 1.11  1998/06/07 13:58:23  descarte
 * Converted from COM.hermetica.* to com.hermetica.* hierarchy.
 *
 * Revision 1.10  1998/03/30 11:48:30  descarte
 * Added applet resource handling.
 *
 * Revision 1.9  1998/03/29 15:44:18  descarte
 * Upgraded to Java 1.1 listeners.
 * Upgraded to GLComponentFactory.
 *
 * Revision 1.8  1998/03/24 22:57:20  descarte
 * Converted from beta 3 to beta 4. Converted to GLDrawable interface.
 *
 * Revision 1.7  1998/01/04 19:59:32  descarte
 * Converted to new pipeline class names, ie, AbstractGL -> GL; GL -> CoreGL.
 *
 * Revision 1.6  1998/01/03 16:44:04  descarte
 * Corrected 'add()' method to have explicit placement argument for MSVM port.
 *
 * Revision 1.5  1998/01/01 21:21:59  descarte
 * Converted demo to GLEventListener interface.
 *
 * Revision 1.4  1997/09/09 14:32:51  descarte
 * Added copyright information.
 *
 * Revision 1.3  1997/09/02 23:36:18  descarte
 * Added GLContextException traps.
 *
 * Revision 1.2  1997/08/25 23:54:00  descarte
 * Moved demo to demoTemplate structure.
 *
 * Revision 1.1  1997/08/16 09:54:13  descarte
 * Initial revision
 *
 *
 */

package com.hermetica.magician.demos.redbook;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import com.hermetica.magician.*;
import com.hermetica.util3d.*;

public class torus extends Frame implements demoTemplate, GLEventListener, KeyListener, WindowListener {

    /** The OpenGL state machine */
    private CoreGL gl_ = new CoreGL();
    private CoreGLU glu_ = new CoreGLU();

    /** The OpenGL component to render onto */
    private GLComponent glc = null;

    /** The dimensions of the component */
    private static final int WIDTH = 200,
                             HEIGHT = 200;

    /** Angle of rotation of the two lines */
    private int theTorus = -1;

    /** Regulates the calling of System.exit() */
    private boolean callExit = true;

    public static void main( String argv[] ) {
        torus d = new torus();
        d.setTitle( d.getName() );
        System.err.println( "\n" + d.getName() + " -- " + d.getOriginalAuthor() );
        for ( int i = 0 ; i < ( d.getName().length() + d.getOriginalAuthor().length() + 4 ) ; i++ ) {
            System.err.print( "=" );
          }
        System.err.println( "\n" );
        System.err.println( d.getDescription() + "\n" );
        d.startDemo();
      }

    public torus() {
        /**#start */
      }

    /** Set to false if the demo is to call System.exit() */
    public void setExit( boolean state ) {
        callExit = state;
      }

    /** Returns the name of the demo */
    public String getName() {
        return new String( "Torus Display List" );
      }

    /** Returns the version information of this demo */
    public String getVersion() {
        return new String( "$Id: torus.java.stub,v 1.13 1998/10/19 12:16:56 descarte Exp descarte $" );
      }

    /** Returns a description of this demo */
    public String getDescription() {
        StringBuffer sb = new StringBuffer();
        sb.append( "This demonstration creates a torus as a display list, which\n" );
        sb.append( "when the user interacts with the program, uses the faster\n" );
        sb.append( "rendering method of display list execution to redraw the torus.\n\n" );
        sb.append( "Keys:\n" );
        sb.append( "    x,X - Rotate the torus around the X-axis\n" );
        sb.append( "    y,Y - Rotate the torus around the Y-axis\n" );
        sb.append( "    i,I - Load the identity matrix\n" );
        sb.append( "    ESC - Quits this demonstration" );
        return new String( sb );
      }

    /** Returns the width of the demo */
    public int getWidth() {
        return WIDTH;
      }

    /** Returns the height of the demo */
    public int getHeight() {
        return HEIGHT;
      }

    /** Returns the original author of this demo */
    public String getOriginalAuthor() {
        return new String( "Mason Woo, Tom Davis, Jackie Neider" );
      }

    public void startDemo() {

        /** Set the layout of the frame */
        setLayout( new BorderLayout() );

        glc = GLComponentFactory.createGLComponent( WIDTH, HEIGHT );

        /** Add the Component into the window */
        add( "Center", glc );
        pack(); show();

        /** Setup the glc.getContext().capabilities */
        GLCapabilities cap = glc.getContext().getCapabilities();
        cap.setDepthBits( 12 );
        cap.setPixelType( GLCapabilities.RGBA );
        cap.setColourBits( 24 );
        cap.setDoubleBuffered( GLCapabilities.DOUBLEBUFFER );

        /** Register the GLEventListener with the GLComponent */
        glc.addGLEventListener( this );

        /** Register a keyboard listener */
        glc.addKeyListener( this );

        this.addWindowListener( this );

        /** Initialize the component */
        glc.initialize();
      }

    /** Initialization stuff */
    public void initialize( GLDrawable component ) {
        try {
            /** Generate a display list for the torus object */
            theTorus = gl_.glGenLists( 1 );
            gl_.glNewList( theTorus, GL.GL_COMPILE );
            torus( 8, 25 );
            gl_.glEndList();

            /** Some misc setup */
            gl_.glClearColor( 0.0f, 0.0f, 0.0f, 0.0f );
            gl_.glShadeModel( GL.GL_FLAT );

          } catch ( OpenGLException e ) {
            e.printStackTrace();
          }
      }

    /** Handles viewport resizing */
    public void reshape( GLDrawable component, int x, int y, int width, int height ) {
        /** Setup the viewport */
        gl_.glViewport( component, x, y, width, height );
        gl_.glMatrixMode( GL.GL_PROJECTION );
        gl_.glLoadIdentity();
        glu_.gluPerspective( 30, (float)width / (float)height, 1.0, 100.0 );
        gl_.glMatrixMode( GL.GL_MODELVIEW );
        gl_.glLoadIdentity();
        glu_.gluLookAt( 0, 0, 10, 0, 0, 0, 0, 1, 0 );
      }

    /** Draws a single line */
    public void display( GLDrawable component ) {
        try {
            /** Render a torus */
            gl_.glClear( GL.GL_COLOR_BUFFER_BIT );

            gl_.glColor3f( 1.0f, 1.0f, 1.0f );
            gl_.glCallList( theTorus );
          } catch ( OpenGLException e ) {
            e.printStackTrace();
          }
      }

    /** Returns a GL pipeline from the listener */
    public GL getGL() {
        return gl_;
      }

    /** Generates a torus */
    private synchronized void torus( int numc, int numt ) throws OpenGLException {
        int i, j, k;
        double s, t, x, y, z, twopi;

        twopi = Math.PI * 2;
        for ( i = 0 ; i < numc ; i++ ) {
            gl_.glBegin( GL.GL_QUAD_STRIP );

            for ( j = 0 ; j <= numt ; j++ ) {
                for ( k = 1 ; k >= 0 ; k-- ) {
                    s = ( i + k ) % numc + 0.5;
                    t = j % numt;

                    x = ( 1 + 0.1 * Math.cos( s * twopi / numc ) ) *
                            Math.cos( t * twopi / numt );
                    y = ( 1 + 0.1 * Math.cos( s * twopi / numc ) ) * 
                            Math.sin( t * twopi / numt );
                    z = 0.1 * Math.sin( s * twopi / numc );
                    gl_.glVertex3d( x, y, z );
                  }
              }
            gl_.glEnd();
          }
      }

    /** Handles keyboard events */
    /** Handles key pressed event */
    public void keyPressed( KeyEvent evt ) {
        if ( evt.getKeyChar() == KeyEvent.VK_ESCAPE ) {
            /** Destroy the GLContext */
            glc.destroy();
            dispose();
        if ( callExit ) {
            System.exit( 0 );
          }

          }
        if ( evt.getKeyChar() == 'x' ||
             evt.getKeyChar() == 'X' ) {
            /** Change the torus rotation */
            glc.getContext().makeCurrent();
            gl_.glRotatef( 30, 1.0f, 0.0f, 0.0f );
            glc.getContext().unlock();
            glc.repaint();
            return;
          }
        if ( evt.getKeyChar() == 'y' ||
             evt.getKeyChar() == 'Y' ) {
            /** Change the torus rotation */
            glc.getContext().makeCurrent();
            gl_.glRotatef( 30, 0.0f, 1.0f, 0.0f );
            glc.getContext().unlock();
            glc.repaint();
            return;
          }
        if ( evt.getKeyChar() == 'i' ||
             evt.getKeyChar() == 'I' ) {
            /** Change the torus rotation */
            glc.getContext().makeCurrent();
            gl_.glLoadIdentity();
            glu_.gluLookAt( 0, 0, 10, 0, 0, 0, 0, 1, 0 );
            glc.getContext().unlock();
            glc.repaint();
            return;
          }
      }

    /** Handles key typed events */
    public void keyTyped( KeyEvent evt ) {
      }

    /** Handles key released events */
    public void keyReleased( KeyEvent evt ) {
      }

    /** WindowListener methods */
    public void windowActivated( WindowEvent evt ) {
      }

    public void windowClosed( WindowEvent evt ) {
      }

    public void windowClosing( WindowEvent evt ) {
        glc.destroy();
        dispose();
        if ( callExit ) {
            System.exit( 0 );
          }

      }

    public void windowDeactivated( WindowEvent evt ) {
      }

    public void windowDeiconified( WindowEvent evt ) {
        if ( glc.isRunning() ) {
            glc.resume();
          }
      }

    public void windowIconified( WindowEvent evt ) {
        if ( glc.isRunning() ) {
            glc.suspend();
          }
      }

    public void windowOpened( WindowEvent evt ) {
      }
    /** Applet only */
    public void stop() {
//        System.err.println( "stop() called" );
        /** Suspend the GL component only if it's driving an event loop */
        if ( glc.isRunning() ) {
            glc.suspend();
          }
      }

    /** Applet only */
    public void start() {
//        System.err.println( "start()" );
        /** Restart the GL component only if it's driving an event loop */
        if ( glc.isRunning() ) {
            glc.resume();
          }
      }

    /** Applet only */
    public void destroy() {
//        System.err.println( "destroy() called" );
        /** Destroy the GL component to free up the resources */
        glc.destroy();
      }
  }
