/*
 * Copyright (c) 1993-1997, Silicon Graphics, Inc.
 * ALL RIGHTS RESERVED 
 * Permission to use, copy, modify, and distribute this software for 
 * any purpose and without fee is hereby granted, provided that the above
 * copyright notice appear in all copies and that both the copyright notice
 * and this permission notice appear in supporting documentation, and that 
 * the name of Silicon Graphics, Inc. not be used in advertising
 * or publicity pertaining to distribution of the software without specific,
 * written prior permission. 
 *
 * THE MATERIAL EMBODIED ON THIS SOFTWARE IS PROVIDED TO YOU "AS-IS"
 * AND WITHOUT WARRANTY OF ANY KIND, EXPRESS, IMPLIED OR OTHERWISE,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF MERCHANTABILITY OR
 * FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT SHALL SILICON
 * GRAPHICS, INC.  BE LIABLE TO YOU OR ANYONE ELSE FOR ANY DIRECT,
 * SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY
 * KIND, OR ANY DAMAGES WHATSOEVER, INCLUDING WITHOUT LIMITATION,
 * LOSS OF PROFIT, LOSS OF USE, SAVINGS OR REVENUE, OR THE CLAIMS OF
 * THIRD PARTIES, WHETHER OR NOT SILICON GRAPHICS, INC.  HAS BEEN
 * ADVISED OF THE POSSIBILITY OF SUCH LOSS, HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE
 * POSSESSION, USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 * US Government Users Restricted Rights 
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions set forth in FAR 52.227.19(c)(2) or subparagraph
 * (c)(1)(ii) of the Rights in Technical Data and Computer Software
 * clause at DFARS 252.227-7013 and/or in similar or successor
 * clauses in the FAR or the DOD or NASA FAR Supplement.
 * Unpublished-- rights reserved under the copyright laws of the
 * United States.  Contractor/manufacturer is Silicon Graphics,
 * Inc., 2011 N.  Shoreline Blvd., Mountain View, CA 94039-7311.
 *
 * OpenGL(R) is a registered trademark of Silicon Graphics, Inc.
 */

/**
 * $Id: unproject.java.stub,v 1.14 1998/10/19 12:16:57 descarte Exp descarte $
 *
 * Copyright (c)1997-1998 Arcane Technologies Ltd. <http://www.arcana.co.uk>
 *
 * 'unproject' from the Red Book
 *
 * $Log: unproject.java.stub,v $
 * Revision 1.14  1998/10/19 12:16:57  descarte
 * Made JDK-1.1 compliant. Updated copyright information.
 *
 * Revision 1.13  1998/10/02 12:57:11  descarte
 * Changed GLComponentListener to GLEventListener. Changed reshape() arguments.
 *
 * Revision 1.12  1998/06/07 13:58:23  descarte
 * Converted from COM.hermetica.* to com.hermetica.* hierarchy.
 *
 * Revision 1.11  1998/03/30 11:48:31  descarte
 * Added applet resource handling.
 *
 * Revision 1.10  1998/03/29 16:49:54  descarte
 * Upgraded to Java-1.1 listeners
 * Upgraded to GLComponentFactory
 *
 * Revision 1.9  1998/03/25 12:24:01  descarte
 * Fixed bug where context was not being made current prior to calling
 * mouseDown callback.
 * Renamed handleEvent() in component subclass to mouseDown()/
 *
 * Revision 1.8  1998/03/24 22:57:21  descarte
 * Converted from beta 3 to beta 4. Converted to GLDrawable interface.
 *
 * Revision 1.7  1998/01/25 14:21:04  descarte
 * Converted demo across to GLEventListener interface and moved
 * GLComponent mouse click handling into a separate component to ensure
 * mouse coordinates are correct.
 *
 * Revision 1.6  1998/01/04 19:59:33  descarte
 * Converted to new pipeline class names, ie, AbstractGL -> GL; GL -> CoreGL.
 *
 * Revision 1.5  1998/01/03 16:44:05  descarte
 * Corrected 'add()' method to have explicit placement argument for MSVM port.
 *
 * Revision 1.4  1997/09/09 14:33:12  descarte
 * Added copyright information.
 *
 * Revision 1.3  1997/09/02 23:16:52  descarte
 * Added GLContextException traps.
 *
 * Revision 1.2  1997/08/25 22:20:01  descarte
 * Moved demo into demoTemplate structure.
 *
 * Revision 1.1  1997/08/15 21:26:35  descarte
 * Initial revision
 *
 * Revision 1.1  1997/08/15 19:28:58  descarte
 * Initial revision
 *
 */

package com.hermetica.magician.demos.redbook;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import com.hermetica.magician.*;
import com.hermetica.util3d.*;

public class unproject extends Frame implements demoTemplate, GLEventListener, KeyListener, MouseListener, WindowListener {

    /** The OpenGL state machine */
    private CoreGL gl_ = new CoreGL();
    private CoreGLU glu_ = new CoreGLU();

    /** The OpenGL component to render onto */
    private GLComponent glc = null;

    /** The dimensions of the component */
    private static final int WIDTH = 500,
                             HEIGHT = 500;

    /** Regulates the calling of System.exit() */
    private boolean callExit = true;

    public static void main( String argv[] ) {
        unproject d = new unproject();
        d.setTitle( d.getName() );
        System.err.println( "\n" + d.getName() + " -- " + d.getOriginalAuthor() );
        for ( int i = 0 ; i < ( d.getName().length() + d.getOriginalAuthor().length() + 4 ) ; i++ ) {
            System.err.print( "=" );
          }
        System.err.println( "\n" );
        System.err.println( d.getDescription() + "\n" );
        d.startDemo();
      }

    public unproject() {
        /**#start */
      }

    /** Set to false if the demo is to call System.exit() */
    public void setExit( boolean state ) {
        callExit = state;
      }

    /** Returns the name of the demo */
    public String getName() {
        return new String( "Viewport Unprojection" );
      }

    /** Returns the version information about this demo */
    public String getVersion() {
        return new String( "$Id: unproject.java.stub,v 1.14 1998/10/19 12:16:57 descarte Exp descarte $" );
      }

    /** Returns the description of this demo */
    public String getDescription() {
        StringBuffer sb = new StringBuffer();
        sb.append( "This demonstration reverses the transformation matrix currently\n" );
        sb.append( "in use to project vertices into the viewport. Using this\n" );
        sb.append( "technique of ``unprojection'' via the gluUnProject() method\n" );
        sb.append( "defined in the CoreGLU class, we can, when given the window coordinates\n" );
        sb.append( "calculate the possible locations of the points in the world.\n\n" );
        sb.append( "Click anywhere on the viewport to unproject the mouse\n" );
        sb.append( "coordinates. The output will be written to System.err, so check\n" );
        sb.append( "that in your browser, or Virtual Machine.\n\n" );
        sb.append( "Hit the ``Escape'' key to destroy this demonstration." );
        return new String( sb );
      }

    /** Returns the width of the demo */
    public int getWidth() {
        return WIDTH;
      }

    /** Returns the height of the demo */
    public int getHeight() {
        return HEIGHT;
      }

    /** Returns the original author of this demo */
    public String getOriginalAuthor() {
        return new String( "Mason Woo, Tom Davis, Jackie Neider" );
      }

    public void startDemo() {

        /** Set the layout of the frame */
        setLayout( new BorderLayout() );

        glc = GLComponentFactory.createGLComponent( WIDTH, HEIGHT );

        /** Add the Component into the window */
        add( "Center", glc );
        pack(); show();

        /** Setup the context capabilities */
        GLCapabilities cap = glc.getContext().getCapabilities();
        cap.setDepthBits( 12 );
        cap.setPixelType( GLCapabilities.RGBA );
        cap.setColourBits( 24 );
        cap.setDoubleBuffered( GLCapabilities.DOUBLEBUFFER );

        /** Register the GLEventListener with the GLComponent */
        glc.addGLEventListener( this );

        /** Register a keyboard and mouse listener */
        glc.addKeyListener( this );
        glc.addMouseListener( this );

        this.addWindowListener( this );

        /** Initialize the component */
        glc.initialize();
      }

    /** Initialization stuff */
    public void initialize( GLDrawable component ) {
        gl_.glClearColor( 0.0f, 0.0f, 0.0f, 0.0f );
        gl_.glShadeModel( GL.GL_FLAT );

        /** Some basic display code to render the scene */
        gl_.glClear( GL.GL_COLOR_BUFFER_BIT );
      }

    /** Display the screen */
    public void display( GLDrawable component ) {
      }

    /** Handles viewport resizing */
    public void reshape( GLDrawable component, int x, int y, int width, int height ) {
        /** Setup the viewport */
        gl_.glViewport( component, x, y, width, height );
        gl_.glMatrixMode( GL.GL_PROJECTION );
        gl_.glLoadIdentity();
        glu_.gluPerspective( 45, (float)width / (float)height, 1.0f, 100.0f );
        gl_.glMatrixMode( GL.GL_MODELVIEW );
        gl_.glLoadIdentity();
      }

    /** Returns a GL pipeline from the listener */
    public GL getGL() {
        return gl_;
      }

    /** Handles keyboard events */
    /** Handles key pressed event */
    public void keyPressed( KeyEvent evt ) {
        if ( evt.getKeyChar() == KeyEvent.VK_ESCAPE ) {
            /** Destroy the GLContext */
            glc.destroy();
            dispose();
        if ( callExit ) {
            System.exit( 0 );
          }

            return;
          }
      }

    /** Handles key typed events */
    public void keyTyped( KeyEvent evt ) {
      }

    /** Handles key released events */
    public void keyReleased( KeyEvent evt ) {
      }

    /** Handles mouse events */
    /** Handles mouse clicked events */
    public void mouseClicked( MouseEvent evt ) {

        /** Convenience variables */
        int x = evt.getX();
        int y = evt.getY();

        /** Acquire a rendering context */
        glc.getContext().makeCurrent();

        /** Locate the corners of the viewport.... */
        double[] modelViewMatrix = new double[16];
        double[] projectionMatrix = new double[16];
        int[] viewport = new int[4];
        double[] win = new double[3];

        /** Get the various transformation matrices and viewport size */
        gl_.glGetDoublev( GL.GL_MODELVIEW_MATRIX,
                          modelViewMatrix );
        gl_.glGetDoublev( GL.GL_PROJECTION_MATRIX,
                          projectionMatrix );
        gl_.glGetIntegerv( GL.GL_VIEWPORT, viewport );

        /** Flip the y-coordinate. OpenGL and AWT are back-to-front */
        int realy = viewport[3] - y - 1;

        /** Unproject the mouse coordinates at depth == 0 */
        if ( glu_.gluUnProject( x, realy,
                                0, modelViewMatrix,
                                projectionMatrix,
                                viewport, win ) == GL.GL_FALSE ) {
            System.err.println( "unprojection of depth 0 failed!\n" );
          } else {
            System.err.println( "World coordinates at ( " + x + ", " + 
                                realy + " ) depth 0: " + win[0] + ", " 
                                + win[1] + ", " + win[2] + " )" );
          }

        /** Unproject the coordinates at depth == 1 */
        if ( glu_.gluUnProject( x, realy,
                                1, modelViewMatrix,
                                projectionMatrix, 
                                viewport, win ) == GL.GL_FALSE ) {
            System.err.println( "unprojection of depth 1 failed!\n" );
          } else {
            System.err.println( "World coordinates at ( " + x + ", " + 
                                realy + " ) depth 1: " + win[0] + ", " + 
                                win[1] + ", " + win[2] + " )" );
          }

        /** Unlock the rendering context */
        glc.getContext().unlock();
      }

    /** Handles mouse entered events */
    public void mouseEntered( MouseEvent evt ) {
      }

    /** Handles mouse exited events */
    public void mouseExited( MouseEvent evt ) {
      }

    /** Handles mouse pressed events */
    public void mousePressed( MouseEvent evt ) {
      }

    /** Handles mouse released events */
    public void mouseReleased( MouseEvent evt ) {
      }

    /** WindowListener methods */
    public void windowActivated( WindowEvent evt ) {
      }

    public void windowClosed( WindowEvent evt ) {
      }

    public void windowClosing( WindowEvent evt ) {
        glc.destroy();
        dispose();
        if ( callExit ) {
            System.exit( 0 );
          }

      }

    public void windowDeactivated( WindowEvent evt ) {
      }

    public void windowDeiconified( WindowEvent evt ) {
        if ( glc.isRunning() ) {
            glc.resume();
          }
      }

    public void windowIconified( WindowEvent evt ) {
        if ( glc.isRunning() ) {
            glc.suspend();
          }
      }

    public void windowOpened( WindowEvent evt ) {
      }
    /** Applet only */
    public void stop() {
//        System.err.println( "stop() called" );
        /** Suspend the GL component only if it's driving an event loop */
        if ( glc.isRunning() ) {
            glc.suspend();
          }
      }

    /** Applet only */
    public void start() {
//        System.err.println( "start()" );
        /** Restart the GL component only if it's driving an event loop */
        if ( glc.isRunning() ) {
            glc.resume();
          }
      }

    /** Applet only */
    public void destroy() {
//        System.err.println( "destroy() called" );
        /** Destroy the GL component to free up the resources */
        glc.destroy();
      }
  }
