/**
 * $Id: throwShapes.java.stub,v 1.4 1998/10/19 00:53:23 descarte Exp descarte $
 *
 * Copyright (c)1998 Arcane Technologies Ltd. <http://www.arcana.co.uk>
 *
 * Tests the the shapes class works.
 *
 * $Log: throwShapes.java.stub,v $
 * Revision 1.4  1998/10/19 00:53:23  descarte
 * Made JDK-1.1 compliant. Updated copyright information.
 *
 * Revision 1.3  1998/10/02 11:28:38  descarte
 * Changed GLComponentListener to GLEventListener
 * Altered arguments to reshape() method
 *
 * Revision 1.2  1998/06/08 17:56:13  descarte
 * More size corrections.
 *
 * Revision 1.1  1998/04/22 18:56:32  descarte
 * Initial revision
 *
 */

package com.hermetica.magician.demos;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import com.hermetica.magician.*;
import com.hermetica.util3d.*;

public class throwShapesapp extends Applet implements demoTemplate, GLEventListener, KeyListener, WindowListener {

    /** The OpenGL state machine */
    GL gl_ = null;
    CoreGL coregl_ = new CoreGL();

    /** The OpenGL-aware Component we are rendering into */
    GLComponent glc = null;

    /** The dimensions of the demo */
    private int WIDTH = 200,
                HEIGHT = 200;

    /** Display lists for each object */
    private int wireSphereList = -1,
                solidSphereList = -1,
                wireConeList = -1,
                solidConeList = -1,
                wireCubeList = -1,
                solidCubeList = -1,
                wireTorusList = -1,
                solidTorusList = -1,
                wireDodecahedronList = -1,
                solidDodecahedronList = -1,
                wireTeapotList = -1,
                solidTeapotList = -1,
                wireOctahedronList = -1,
                solidOctahedronList = -1,
                wireIcosahedronList = -1,
                solidIcosahedronList = -1,
                wireTetrahedronList = -1,
                solidTetrahedronList = -1;

    /** Checkbox group determining which shape is selected */
    CheckboxGroup shapeGroup = new CheckboxGroup();

    /** Checkboxes for shape selection */
    Checkbox wireSphereCheckbox = 
        new Checkbox( "Wire Sphere", shapeGroup, true );
    Checkbox solidSphereCheckbox = 
        new Checkbox( "Solid Sphere", shapeGroup, false );
    Checkbox wireConeCheckbox = 
        new Checkbox( "Wire Cone", shapeGroup, false );
    Checkbox solidConeCheckbox = 
        new Checkbox( "Solid Cone", shapeGroup, false );
    Checkbox wireCubeCheckbox = 
        new Checkbox( "Wire Cube", shapeGroup, false );
    Checkbox solidCubeCheckbox = 
        new Checkbox( "Solid Cube", shapeGroup, false );
    Checkbox wireTorusCheckbox = 
        new Checkbox( "Wire Torus", shapeGroup, false );
    Checkbox solidTorusCheckbox = 
        new Checkbox( "Solid Torus", shapeGroup, false );
    Checkbox wireDodecahedronCheckbox = 
        new Checkbox( "Wire Dodecahedron", shapeGroup, false );
    Checkbox solidDodecahedronCheckbox = 
        new Checkbox( "Solid Dodecahedron", shapeGroup, false );
    Checkbox wireTeapotCheckbox = 
        new Checkbox( "Wire Teapot", shapeGroup, false );
    Checkbox solidTeapotCheckbox = 
        new Checkbox( "Solid Teapot", shapeGroup, false );
    Checkbox wireIcosahedronCheckbox = 
        new Checkbox( "Wire Icosahedron", shapeGroup, false );
    Checkbox solidIcosahedronCheckbox = 
        new Checkbox( "Solid Icosahedron", shapeGroup, false );
    Checkbox wireOctahedronCheckbox = 
        new Checkbox( "Wire Octahedron", shapeGroup, false );
    Checkbox solidOctahedronCheckbox = 
        new Checkbox( "Solid Octahedron", shapeGroup, false );
    Checkbox wireTetrahedronCheckbox = 
        new Checkbox( "Wire Tetrahedron", shapeGroup, false );
    Checkbox solidTetrahedronCheckbox = 
        new Checkbox( "Solid Tetrahedron", shapeGroup, false );

    float angle = 0.0f;

    /** Regulates the calling of System.exit() */
    private boolean callExit = true;



    public void init() {
        gl_ = coregl_;
        startDemo();
      }

    /** Set to false if the demo is to call System.exit() */
    public void setExit( boolean state ) {
        callExit = state;
      }

    /** Returns the name of the demo */
    public String getName() {
        return new String( "Throwing Shapes!" );
      }

    public String getVersion() {
        return new String( "$Id: throwShapes.java.stub,v 1.4 1998/10/19 00:53:23 descarte Exp descarte $" );
      }

    public String getDescription() {
        StringBuffer sb = new StringBuffer();
        sb.append( "This demonstration allows you to select each of the\n" );
        sb.append( "shapes that the com.hermetica.util3d.shapes class\n" );
        sb.append( "can create with a single method invocation.\n\n" );
        sb.append( "Hit ``Escape'' to quit the demo\n" );
        return new String( sb.toString() );
      }

    /** Returns the width of the demo */
    public int getWidth() {
        return 525;
      }

    /** Returns the height of the demo */
    public int getHeight() {
        return 230;
      }

    /** Returns the original author of this demo */
    public String getOriginalAuthor() {
        return new String( "Alligator Descartes <descarte@arcana.co.uk>" );
      }

    public void startDemo() {
        setLayout( new GridBagLayout() );

        /** Create the OpenGL Component */
        glc = GLComponentFactory.createGLComponent( WIDTH, HEIGHT );

        constrain.constrain( this, glc, 0, 0, 1, 1,
                             GridBagConstraints.BOTH,
                             GridBagConstraints.CENTER,
                             1, 1, 0, 0, 0, 0 );

        /** Create the panel with Checkboxen */
        Panel checkboxPanel = new Panel();
        checkboxPanel.setLayout( new GridBagLayout() );
        constrain.constrain( checkboxPanel, wireSphereCheckbox,
                             0, 0, 1, 1 );
        constrain.constrain( checkboxPanel, solidSphereCheckbox,
                             1, 0, 1, 1 );
        constrain.constrain( checkboxPanel, wireConeCheckbox,
                             0, 1, 1, 1 );
        constrain.constrain( checkboxPanel, solidConeCheckbox,
                             1, 1, 1, 1 );
        constrain.constrain( checkboxPanel, wireCubeCheckbox,
                             0, 2, 1, 1 );
        constrain.constrain( checkboxPanel, solidCubeCheckbox,
                             1, 2, 1, 1 );
        constrain.constrain( checkboxPanel, wireTorusCheckbox,
                             0, 3, 1, 1 );
        constrain.constrain( checkboxPanel, solidTorusCheckbox,
                             1, 3, 1, 1 );
        constrain.constrain( checkboxPanel, wireDodecahedronCheckbox,
                             0, 4, 1, 1 );
        constrain.constrain( checkboxPanel, solidDodecahedronCheckbox,
                             1, 4, 1, 1 );
        constrain.constrain( checkboxPanel, wireTeapotCheckbox,
                             0, 5, 1, 1 );
        constrain.constrain( checkboxPanel, solidTeapotCheckbox,
                             1, 5, 1, 1 );
        constrain.constrain( checkboxPanel, wireIcosahedronCheckbox,
                             0, 6, 1, 1 );
        constrain.constrain( checkboxPanel, solidIcosahedronCheckbox,
                             1, 6, 1, 1 );
        constrain.constrain( checkboxPanel, wireOctahedronCheckbox,
                             0, 7, 1, 1 );
        constrain.constrain( checkboxPanel, solidOctahedronCheckbox,
                             1, 7, 1, 1 );
        constrain.constrain( checkboxPanel, wireTetrahedronCheckbox,
                             0, 8, 1, 1 );
        constrain.constrain( checkboxPanel, solidTetrahedronCheckbox,
                             1, 8, 1, 1 );

        constrain.constrain( this, checkboxPanel, 1, 0, 1, 1 );
        /**#layout */

        /** Setup the context capabilities */
        GLCapabilities cap = glc.getContext().getCapabilities();
        cap.setDepthBits( 12 );
        cap.setPixelType( GLCapabilities.RGBA );
        cap.setColourBits( 24 );
        cap.setDoubleBuffered( GLCapabilities.DOUBLEBUFFER );

        /** Add the key listener to the component */
        glc.addKeyListener( this );

        /** Add the window listener */
        /**#windowListener */

        /** Add the listener and initialize the component */
        glc.addGLEventListener( this );
        glc.initialize();
        glc.start();
      }

    public void initialize( GLDrawable component ) {

        gl_.glEnable( GL.GL_CULL_FACE );
        gl_.glDisable( GL.GL_DEPTH_TEST );

        /** Initialize the display lists */
        wireSphereList = gl_.glGenLists( 1 );
        gl_.glNewList( wireSphereList, GL.GL_COMPILE );
            gl_.glDisable( GL.GL_LIGHTING );
            shapes.wireSphere( 25.0, 16, 16 );
            gl_.glEnable( GL.GL_LIGHTING );
        gl_.glEndList();

        solidSphereList = gl_.glGenLists( 1 );
        gl_.glNewList( solidSphereList, GL.GL_COMPILE );
            shapes.solidSphere( 25.0, 16, 16 );
        gl_.glEndList();

        wireConeList = gl_.glGenLists( 1 );
        gl_.glNewList( wireConeList, GL.GL_COMPILE );
            gl_.glDisable( GL.GL_LIGHTING );
            shapes.wireCone( 25.0, 45.0, 16, 16 );
            gl_.glEnable( GL.GL_LIGHTING );
        gl_.glEndList();

        solidConeList = gl_.glGenLists( 1 );
        gl_.glNewList( solidConeList, GL.GL_COMPILE );
            shapes.solidCone( 25.0, 45.0, 16, 16 );
        gl_.glEndList();

        wireCubeList = gl_.glGenLists( 1 );
        gl_.glNewList( wireCubeList, GL.GL_COMPILE );
            gl_.glDisable( GL.GL_LIGHTING );
            shapes.wireCube( 25.0 );
            gl_.glEnable( GL.GL_LIGHTING );
        gl_.glEndList();

        solidCubeList = gl_.glGenLists( 1 );
        gl_.glNewList( solidCubeList, GL.GL_COMPILE );
            shapes.solidCube( 25.0 );
        gl_.glEndList();

        wireTorusList = gl_.glGenLists( 1 );
        gl_.glNewList( wireTorusList, GL.GL_COMPILE );
            gl_.glDisable( GL.GL_LIGHTING );
            shapes.wireTorus( 5.0, 25.0, 16, 16 );
            gl_.glEnable( GL.GL_LIGHTING );
        gl_.glEndList();

        solidTorusList = gl_.glGenLists( 1 );
        gl_.glNewList( solidTorusList, GL.GL_COMPILE );
            gl_.glEnable( GL.GL_DEPTH_TEST );
            shapes.solidTorus( 5.0, 25.0, 16, 16 );
            gl_.glDisable( GL.GL_DEPTH_TEST );
        gl_.glEndList();

        wireDodecahedronList = gl_.glGenLists( 1 );
        gl_.glNewList( wireDodecahedronList, GL.GL_COMPILE );
            gl_.glDisable( GL.GL_LIGHTING );
            gl_.glEnable( GL.GL_NORMALIZE );
            gl_.glScalef( 15.0f, 15.0f, 15.0f );
            shapes.wireDodecahedron();
            gl_.glDisable( GL.GL_NORMALIZE );
            gl_.glEnable( GL.GL_LIGHTING );
        gl_.glEndList();

        solidDodecahedronList = gl_.glGenLists( 1 );
        gl_.glNewList( solidDodecahedronList, GL.GL_COMPILE );
            gl_.glEnable( GL.GL_NORMALIZE );
            gl_.glScalef( 15.0f, 15.0f, 15.0f );
            shapes.solidDodecahedron();
            gl_.glDisable( GL.GL_NORMALIZE );
        gl_.glEndList();

        wireTeapotList = gl_.glGenLists( 1 );
        gl_.glNewList( wireTeapotList, GL.GL_COMPILE );
            gl_.glDisable( GL.GL_LIGHTING );
            shapes.wireTeapot( 25.0 );
            gl_.glEnable( GL.GL_LIGHTING );
        gl_.glEndList();

        solidTeapotList = gl_.glGenLists( 1 );
        gl_.glNewList( solidTeapotList, GL.GL_COMPILE );
            gl_.glEnable( GL.GL_DEPTH_TEST );
            gl_.glDisable( GL.GL_CULL_FACE );
            shapes.solidTeapot( 25.0 );
            gl_.glEnable( GL.GL_CULL_FACE );
            gl_.glDisable( GL.GL_DEPTH_TEST );
        gl_.glEndList();

        wireOctahedronList = gl_.glGenLists( 1 );
        gl_.glNewList( wireOctahedronList, GL.GL_COMPILE );
            gl_.glDisable( GL.GL_LIGHTING );
            gl_.glEnable( GL.GL_NORMALIZE );
            gl_.glScalef( 15.0f, 15.0f, 15.0f );
            shapes.wireOctahedron();
            gl_.glDisable( GL.GL_NORMALIZE );
            gl_.glEnable( GL.GL_LIGHTING );
        gl_.glEndList();

        solidOctahedronList = gl_.glGenLists( 1 );
        gl_.glNewList( solidOctahedronList, GL.GL_COMPILE );
            gl_.glEnable( GL.GL_NORMALIZE );
            gl_.glScalef( 15.0f, 15.0f, 15.0f );
            shapes.solidOctahedron();
            gl_.glDisable( GL.GL_NORMALIZE );
        gl_.glEndList();

        wireIcosahedronList = gl_.glGenLists( 1 );
        gl_.glNewList( wireIcosahedronList, GL.GL_COMPILE );
            gl_.glDisable( GL.GL_LIGHTING );
            gl_.glEnable( GL.GL_NORMALIZE );
            gl_.glScalef( 15.0f, 15.0f, 15.0f );
            shapes.wireIcosahedron();
            gl_.glDisable( GL.GL_NORMALIZE );
            gl_.glEnable( GL.GL_LIGHTING );
        gl_.glEndList();

        solidIcosahedronList = gl_.glGenLists( 1 );
        gl_.glNewList( solidIcosahedronList, GL.GL_COMPILE );
            gl_.glEnable( GL.GL_NORMALIZE );
            gl_.glScalef( 15.0f, 15.0f, 15.0f );
            shapes.solidIcosahedron();
            gl_.glDisable( GL.GL_NORMALIZE );
        gl_.glEndList();

        wireTetrahedronList = gl_.glGenLists( 1 );
        gl_.glNewList( wireTetrahedronList, GL.GL_COMPILE );
            gl_.glDisable( GL.GL_LIGHTING );
            gl_.glScalef( 15.0f, 15.0f, 15.0f );
            shapes.wireTetrahedron();
            gl_.glEnable( GL.GL_LIGHTING );
        gl_.glEndList();

        solidTetrahedronList = gl_.glGenLists( 1 );
        gl_.glNewList( solidTetrahedronList, GL.GL_COMPILE );
            gl_.glScalef( 15.0f, 15.0f, 15.0f );
            gl_.glEnable( GL.GL_NORMALIZE );
            shapes.solidTetrahedron();
            gl_.glDisable( GL.GL_NORMALIZE );
        gl_.glEndList();

        /** Set the clear colour */
        gl_.glClearColor( 0.0f, 0.0f, 0.0f, 1.0f );

        /** Setup the lighting */
        float mat_ambient[] = { 0.5f, 0.5f, 0.5f, 1.0f };
        float mat_specular[] = { 1.0f, 1.0f, 1.0f, 1.0f };
        float mat_shininess[] = { 50.0f };
        float light_position[] = { 1.0f, 1.0f, 1.0f, 0.0f };
        float model_ambient[] = { 0.5f, 0.5f, 0.5f, 1.0f };

        gl_.glMaterialfv( GL.GL_FRONT, GL.GL_AMBIENT, mat_ambient );
        gl_.glMaterialfv( GL.GL_FRONT, GL.GL_SPECULAR, mat_specular );
        gl_.glMaterialfv( GL.GL_FRONT, GL.GL_SHININESS, mat_shininess );
        gl_.glLightfv( GL.GL_LIGHT0, GL.GL_POSITION, light_position );
        gl_.glLightModelfv( GL.GL_LIGHT_MODEL_AMBIENT, model_ambient );

        gl_.glEnable( GL.GL_LIGHTING );
        gl_.glEnable( GL.GL_LIGHT0 );
      }

    public void reshape( GLDrawable component, int x, int y, int width, int height ) {
        gl_.glViewport( component, x, y, width, height );
        gl_.glMatrixMode( GL.GL_PROJECTION );
        gl_.glLoadIdentity();
        gl_.glFrustum( -1.0, 1.0, -1.0, 1.0, 1.0, 100 );
        gl_.glMatrixMode( GL.GL_MODELVIEW );
        gl_.glLoadIdentity();
      }
        
    public void display( GLDrawable component ) {
        gl_.glClear( GL.GL_DEPTH_BUFFER_BIT | GL.GL_COLOR_BUFFER_BIT );

        /** Store the modelview matrix */
        gl_.glPushMatrix();

        gl_.glTranslatef( 0, 0, -50 );
        gl_.glRotatef( angle, 0, 1, 0 );

        /** Draw the correct shape */
        if ( shapeGroup.getSelectedCheckbox() == wireSphereCheckbox ) {
            gl_.glCallList( wireSphereList );
          }

        if ( shapeGroup.getSelectedCheckbox() == solidSphereCheckbox ) {
            gl_.glCallList( solidSphereList );
          }

        if ( shapeGroup.getSelectedCheckbox() == wireConeCheckbox ) {
            gl_.glCallList( wireConeList );
          }

        if ( shapeGroup.getSelectedCheckbox() == solidConeCheckbox ) {
            gl_.glCallList( solidConeList );
          }

        if ( shapeGroup.getSelectedCheckbox() == wireCubeCheckbox ) {
            gl_.glCallList( wireCubeList );
          }

        if ( shapeGroup.getSelectedCheckbox() == solidCubeCheckbox ) {
            gl_.glCallList( solidCubeList );
          }

        if ( shapeGroup.getSelectedCheckbox() == wireTorusCheckbox ) {
            gl_.glCallList( wireTorusList );
          }

        if ( shapeGroup.getSelectedCheckbox() == solidTorusCheckbox ) {
            gl_.glCallList( solidTorusList );
          }

        if ( shapeGroup.getSelectedCheckbox() == wireDodecahedronCheckbox ) {
            gl_.glCallList( wireDodecahedronList );
          }

        if ( shapeGroup.getSelectedCheckbox() == solidDodecahedronCheckbox ) {
            gl_.glCallList( solidDodecahedronList );
          }

        if ( shapeGroup.getSelectedCheckbox() == wireTeapotCheckbox ) {
            gl_.glCallList( wireTeapotList );
          }

        if ( shapeGroup.getSelectedCheckbox() == solidTeapotCheckbox ) {
            gl_.glCallList( solidTeapotList );
          }

        if ( shapeGroup.getSelectedCheckbox() == wireOctahedronCheckbox ) {
            gl_.glCallList( wireOctahedronList );
          }

        if ( shapeGroup.getSelectedCheckbox() == solidOctahedronCheckbox ) {
            gl_.glCallList( solidOctahedronList );
          }

        if ( shapeGroup.getSelectedCheckbox() == wireIcosahedronCheckbox ) {
            gl_.glCallList( wireIcosahedronList );
          }

        if ( shapeGroup.getSelectedCheckbox() == solidIcosahedronCheckbox ) {
            gl_.glCallList( solidIcosahedronList );
          }

        if ( shapeGroup.getSelectedCheckbox() == wireTetrahedronCheckbox ) {
            gl_.glCallList( wireTetrahedronList );
          }

        if ( shapeGroup.getSelectedCheckbox() == solidTetrahedronCheckbox ) {
            gl_.glCallList( solidTetrahedronList );
          }

        /** Restore the modelview matrix */
        gl_.glPopMatrix();

        angle++;
        if ( angle >= 360.0f ) {
            angle -= 360.0f;
          }
      }

    public GL getGL() {
        return coregl_;
      }

    /** Handles keyboard events */
    /** Handles key pressed event */
    public void keyPressed( KeyEvent evt ) {
        if ( evt.getKeyChar() == KeyEvent.VK_ESCAPE ) {
            /** Destroy the GLContext */
            glc.destroy();
            /**#dispose */
          }
      }

    /** Handles key typed events */
    public void keyTyped( KeyEvent evt ) {
      }

    /** Handles key released events */
    public void keyReleased( KeyEvent evt ) {
      }

    /** WindowListener methods */
    public void windowActivated( WindowEvent evt ) {
      }

    public void windowClosed( WindowEvent evt ) {
      }

    public void windowClosing( WindowEvent evt ) {
        glc.destroy();
        /**#dispose */
      }

    public void windowDeactivated( WindowEvent evt ) {
      }

    public void windowDeiconified( WindowEvent evt ) {
        if ( glc.isRunning() ) {
            glc.resume();
          }
      }

    public void windowIconified( WindowEvent evt ) {
        if ( glc.isRunning() ) {
            glc.suspend();
          }
      }

    public void windowOpened( WindowEvent evt ) {
      }

    /** Applet only */
    public void stop() {
//        System.err.println( "stop() called" );
        /** Suspend the GL component only if it's driving an event loop */
        if ( glc.isRunning() ) {
            glc.suspend();
          }
      }

    /** Applet only */
    public void start() {
//        System.err.println( "start()" );
        /** Restart the GL component only if it's driving an event loop */
        if ( glc.isRunning() ) {
            glc.resume();
          }
      }

    /** Applet only */
    public void destroy() {
//        System.err.println( "destroy() called" );
        /** Destroy the GL component to free up the resources */
        glc.destroy();
      }
  }
